<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Mail;

class SendInvoiceCommand extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'Invoice:Send';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Send invoice to outlets';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $start = \Carbon\Carbon::now()->subWeek(1)->format('m-d-Y');
        $end = \Carbon\Carbon::now()->subDay(1)->format('m-d-Y');
        \App\Models\Outlet::all()
        ->map(function($el) use($start, $end){
            $controller = app()->make('\App\Http\Controllers\InvoiceController');
            $controller->callAction('exportPDF',['outletId'=>$el->id,'startDate'=>$start,'endDate'=>$end]);
        });
    }
}
