<?php namespace App\Console;

use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;

class Kernel extends ConsoleKernel {

	/**
	 * The Artisan commands provided by your application.
	 *
	 * @var array
	 */
	protected $commands = [
		'App\Console\Commands\Inspire',
                'App\Console\Commands\CancelOrderMailCommand',
                'App\Console\Commands\CancelOrderMailAdminCommand',
                'App\Console\Commands\TestCronJobCommand',
                'App\Console\Commands\SendInvoiceCommand',
	];

	/**
	 * Define the application's command schedule.
	 *
	 * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
	 * @return void
	 */
	protected function schedule(Schedule $schedule)
	{
		$schedule->command('inspire')
				 ->hourly();
		$schedule->command('CancelOrder:EmailAdmin')->dailyAt('18:00');
		$schedule->command('CancelOrder1:Email')->dailyAt('18:00');
		//$schedule->command('Invoice:Send')->weekly()->mondays()->at('10:00');
	}

    /**
     * Register the commands for the application.
     *
     * @return void
     */
    protected function commands()
    {
        $this->load(__DIR__.'/Commands');
        //require base_path('routes/console.php');
    }
}
