<?php

namespace App\Domain;

class ItemService{

	public function getItemFromOutlet($outletId, $p = false){
                $outlet = \App\Models\Outlet::find($outletId);
                $closed = $this->isVegNonvegClosed($outlet);
                $items = $outlet->items->filter(function ($item) use ($outlet, $closed) {
                    if($closed)
                        return !$this->isItemClosed ($outlet, $item);
                    return true;
                })->values();                

                return $items->map(function($item) use ($outlet, $p){
                            $x = $item;
                            $x->price = $x->sellingPrice;
                            $x->deliveryTime = $outlet->order_timing;
                            $x->minOrdAmount = $outlet->minOrderAmount;
                            if(! $p)
                                unset($x->basePrice);
                            unset($x->vendorPrice);
                            return $x;
			});
	}	

    public function isItemClosed($outlet, $item){
        if($outlet->veg_non_veg!=2){
            if($outlet->veg_non_veg==0){
                if($item->isNonVegeterian==1)
                    //return $item->visibility == 1 ? true : false;
                    return true;
            }else{
                if($item->isVegeterian==1)
                    //return $item->visibility == 1 ? true : false;
                    return true;
            }

        }
        //return $item->visibility == 1 ? true : false;
        return false;
    }
    public function isVegNonvegClosed($outlet){
        if($outlet->closingPeriod_veg_non_veg==null)
            $closingPeriods = json_decode('[]');
        else
            $closingPeriods = json_decode($outlet->closingPeriod_veg_non_veg);
        $outlet->veg_non_veg_closed = false;
        $now = \Carbon\Carbon::now();
        foreach($closingPeriods as $closingPeriod){
            if($now->greaterThanOrEqualTo(\Carbon\Carbon::createFromFormat('Y-m-d', $closingPeriod->closedFrom_veg_non_veg)->startOfDay())
                    && $now->lessThanOrEqualTo((\Carbon\Carbon::createFromFormat('Y-m-d', $closingPeriod->closedTo_veg_non_veg)->endOfDay()))){
                $outlet->veg_non_veg_closed = true;
                break;
            }
        }
        if(!$outlet->veg_non_veg_closed){
            $weekMap = [
                0 => 'SUN',
                1 => 'MON',
                2 => 'TUE',
                3 => 'WED',
                4 => 'THU',
                5 => 'FRI',
                6 => 'SAT',
            ];
            $now = \Carbon\Carbon::now();
            if($outlet->weeklyClosed_veg_non_veg=='' || $outlet->weeklyClosed_veg_non_veg==null)
                $weekly = json_decode(json_encode([]));
            else
                $weekly = json_decode($outlet->weeklyClosed_veg_non_veg);
            array_map(function($w) use($outlet,$now,$weekMap){
                if($weekMap[$now->dayOfWeek] == $w)
                    $outlet->veg_non_veg_closed = true;
            }, $weekly);
        }
        $closed = $outlet->veg_non_veg_closed;
        unset($outlet->veg_non_veg_closed);
        return $closed;
    }
}
