<?php

namespace App\Domain;

use App\Models\Station;
use Log;
use App\Models\XClient;

class PnrService
{
	private $pnr;
	private $requester;
	public function __construct()
	{
		$this->requester = \App\Models\XClient::getClient();
		#dd($this->requester);
	}

	public function getTrainPnr($pnr, $headers)
	{	
		//$api = sprintf('https://stage-ecatering.ipsator.com/api/v1/pnr/vendor?pnr=%s',$pnr);//dev
		$api = sprintf(config('constkeys.irctc_base_url').'/api/v1/pnr/vendor?pnr=%s', $pnr); //production
		#dd($trainNum);
		try {
			$res =  json_decode($this->requester->Request('GET', $api, [
				'headers' => $headers
			]));

			
			/*dd(
				$this->requester->Request('GET',$trainNum)
			);*/
			if (isset($res->result))
				return $res->result;
			return null;
		} catch (\Exception $e) {
			echo $e->getMessage();
			return null;
		}
	}

	public function getStationPnr($pnr, $headers)
	{	
		//$api = sprintf('https://stage-ecatering.ipsator.com/api/v1/pnr/vendor?pnr=%s',$pnr);//dev
		$api = sprintf(config('constkeys.irctc_base_url').'/api/v1/pnr/vendor?pnr=%s', $pnr); //production
		// dd($trainNum);
		try {
			$stations = json_decode($this->requester->Request('GET', $api, [
				'headers' => $headers
			]));
			if (isset($stations->result)) {
				$remote =  json_encode($stations->result->stations);
				$local = \App\Models\Station::all();
				return ['stations' => $this->compute($remote, $local)];
			}
			return ['stations' => []];
		} catch (\Exception $e) {
			//echo $e->getMessage();
			return ['stations' => []];
		}
	}


	public function fetchPNRData($pnr, $headers)
	{	
		
		$api = sprintf(config('constkeys.irctc_base_url').'/api/v1/pnr/vendor?pnr=%s', $pnr);
		// $api = sprintf('https://stage-ecatering.ipsator.com/api/v1/station/outlets?stationCode=NDLS time=17:18&date=2024-03-10');
		
		$status = 0;
		try {
			$result = json_decode($this->requester->Request('GET', $api, ['headers' => $headers]));
			$status = 200;
		} catch (\Exception $th) {
			$result = $th->getMessage();
			$status = 400;
		}
	
		return compact('result', 'status');
	}


	public function computeX($featureset, $against)
	{
		$raw = json_decode($featureset);
		$sd = collect(json_decode($against))->pluck('code');
		return collect($raw)->filter(function ($station) use ($sd) {
			if ($this->isSRC($station)) {
				$station->arrival = $station->departure;
				$station->schArrivalTime = $station->departure;
				$sd->contains($station->code);
			}	
			return $sd->contains($station->code);
		});
	}


	private function isSRC($station){
		return ($station->arrival == "--" || $station->schArrivalTime == "--");
	}

	public function getStationWithArrival($pnr, $headers)
	{	
		//$api = sprintf('https://stage-ecatering.ipsator.com/api/v1/pnr/vendor?pnr=%s',$pnr);//dev
		$api = sprintf(config('constkeys.irctc_base_url').'/api/v1/pnr/vendor?pnr=%s', $pnr); //production
	
		try {
			$stations = json_decode($this->requester->Request('GET', $api, [
				'headers' => $headers
			]));

			if (isset($stations->result)) {
				$remote =  json_encode($stations->result->stations);
				$local = \App\Models\Station::all();
				$stations->result->stations = $this->computeX($remote, $local);
			
				return $stations->result;
				// return ['stations' => $this->computeX($remote, $local)];
			}
			return ['stations' => []];
		} catch (\Exception $e) {
			// dd($e->getMessage());
			return ['stations' => []];
		}
	}



	public function compute($featureset, $against)
	{
		$raw = json_decode($featureset);
		$sd = json_decode($against, TRUE);
		return array_reduce($raw, function ($a, $b) use ($sd) {
			if (in_array($b->code, array_column($sd, 'code'))) {
				$c = new \stdClass;
				$c->code = $b->code;
				$c->name = $b->name;
				array_push($a, $c);
			}

			return $a;
		}, []);
	}
	public function getTrainSchArr($pnr, $date, $stCode, $headers)
	{
		$api = sprintf(config('constkeys.irctc_base_url').'/api/v1/pnr/vendor?pnr=%s', $pnr); //production
		#dd($trainNum);
		try {
			$stations = json_decode($this->requester->Request('GET', $api, [
				'headers' => $headers
			]));

			if (isset($stations) && isset($stations->result)) {
				$stations =  $stations->result->stations;

				$st = array_filter($stations, function ($st1) use ($stCode, $date) {
					return $stCode == $st1->code && $st1->arrDate == $date;
				});
				if ($st == null)
					return null;
				else {
					$key = array_keys($st)[0];
					$halt = explode(':', $st[$key]->halt);
					$halt = $halt[0] * 60 + $halt[1];
					$delivery = \Carbon\Carbon::createFromFormat('Y-m-d H:i', $date . ' ' . $st[$key]->arrival)->addSeconds($halt);
					return $delivery->format('Y-m-d H:i');
				}
			} else
				return null;
		} catch (\Exception $e) {
			echo $e->getMessage();
			return null;
		}
	}
}
