<?php
namespace App\Domain;

use Illuminate\Support\Facades\Log;

class RouteService{
	private $trainNo;
	private $url;
	private $requester;
	public function __construct(){
		$this->requester = \App\XClient::getClient();
		#dd($this->requester);
	}

	public function getTrainRoute($key, $date,$train){
		$apiKey = config('domain.API_KEY_RAILWAY');
		$trainNum = sprintf('https://api.railwayapi.com/v2/route/train/%s/apikey/%s/',$key,$train);
                //$trainNum = sprintf('http://35.200.178.249/api/train/trainsbetween?from=ERN&to=CLT&date=20190321');
		//$trainNum = sprintf('http://35.200.178.249/api/train/route?number=%s',$key);
                //$trainNum = sprintf('https://stage-ecatering.ipsator.com/api/v1/pnr/vendor?pnr=2742063381&apikey=%s',$train);
                #dd($trainNum);
		try{
                        $local = config('domain.ROUTE_LOCAL');
                        if(isset($local) && $local){
                            $route = \App\Models\TrainRoute::find($key);
                            if(!$route){
                                $remote =  json_encode(
                                        json_decode(
                                                        $this->requester->Request('GET',$trainNum)
                                                  )->route
                                                //)->Route
                                        );
                            }else
                                $remote = json_encode(json_decode($route->route)->route);

                        }else{
                            $remote =  json_encode(
                                    json_decode(
                                                    $this->requester->Request('GET',$trainNum)
                                              )->route
                                            //)->Route
                                    );
                        }
			#dd(
			#	$this->requester->Request('GET',$trainNum)
			#);
			$local = \App\Models\Station::all();
			return $this->compute($remote, $local);
		}catch(\Exception $e){

			//echo $e->getMessage();
			$local = [];
		}

		}

	public function getTrainRouteForDB($key, $train){
		$apiKey = config('domain.API_KEY_RAILWAY');
		$trainNum = sprintf('https://api.railwayapi.com/v2/route/train/%s/apikey/%s/',$train,$key);
		#dd($trainNum);
		try{
			$json = json_decode($this->requester->Request('GET',$trainNum));

			#dd(
			#	$this->requester->Request('GET',$trainNum)
			#);

			return $json;
		}catch(\Exception $e){

			echo $e->getMessage();
			$local = [];
		}

		}

	public function compute($featureset, $against){
		$raw = json_decode($featureset);
		$sd = json_decode($against,TRUE);
		return array_reduce($raw,function($a,$b) use($sd){
				if(in_array($b->station->code, array_column($sd,'code'))){
                                /*
				if(in_array($b->StationCode, array_column($sd,'code'))){
                                    $b->station = new \stdClass;
                                    $b->station->code = $b->StationCode;
                                    $b->station->name = $b->StationName;*/
				array_push($a,$b);
				}

				return $a;
				},[]);


	}

	public function getTrainSchArr($key, $date,$train, $stCode){
		$apiKey = config('domain.API_KEY_RAILWAY');
		$trainNum = sprintf('https://api.railwayapi.com/v2/route/train/%s/apikey/%s/',$key,$train);
		#dd($trainNum);
                //echo $trainNum;
		try{
                        /*
			$res =  json_decode(
						$this->requester->Request('GET',$trainNum)
					  );*/
                        $local = config('domain.ROUTE_LOCAL');
                        if(isset($local) && $local){
                            $route = \App\Models\TrainRoute::find($key);
                            if(!isset($route) || !isset($route->route)){
                                $res =  json_decode(
                                            $this->requester->Request('GET',$trainNum)
                                        );
                                Log::channel('dailyInfo')->info('res:'.$res);
                                if(!isset($res) || !isset($res->route))
                                    return null;
                            }else
                                $res = json_decode($route->route);
                        }else{
                            $res =  json_decode(
                                        $this->requester->Request('GET',$trainNum)
                                    );
                        }

            
			$route = $this->computeSchArr($res->route, $stCode, $date);

                        unset($route['lastschArr']);
                        unset($route['date']);
                        unset($route['stFound']);

                        if($this->dateAvail(end($route), $res->train->days)){

                            $st = array_filter($route,
                                            function ($item) use($stCode) {
                                                return $item->station->code === $stCode;
                                            }
                                        );
                            return $st[array_keys($st)[0]]->scharr ?? $date;
                        }
                        return false;

		}catch(\Exception $e){

			echo $e->getMessage();
			$local = [];
		}

            }

	public function computeSchArr($route, $stCode, $date){
            $route = array_reverse($route);
            $carry = array(
                'lastschArr'=>array_values(array_slice($route, -1))[0]->schdep,
                'date'=>$date,
                'stFound'=>false
            );
            return array_reduce($route, function ($carry, $st) use ($stCode){
                $currHrMin = $st->scharr;
                if($st->scharr == 'SOURCE')
                    $currHrMin = $st->schdep;

                if(!$carry['stFound']){
                    if($st->station->code == $stCode){
                        $carry['stFound'] = true;
                        $st->scharr = $carry['date'].' '.$currHrMin;
                        array_push($carry, $st);
                    }
                }else{
                    $currDate = date_parse($carry['date'].' '.$currHrMin);
                    $lastDate = date_parse($carry['date'].' '.$carry['lastschArr']);
                    if($currDate['hour']*60+$currDate['minute']>$lastDate['hour']*60+$lastDate['minute']){
                       $carry['date'] = \Carbon\Carbon::createFromFormat('Y-m-d', $carry['date'], 'Asia/Kolkata')->subDays(1)->format('Y-m-d');
                    }
                    $st->scharr = $carry['date'].' '.$currHrMin;
                    array_push($carry, $st);
                }
                $carry['lastschArr'] = $currHrMin;

                return $carry;
            }, $carry);
        }

	public function dateAvail($st, $days){
            $weekMap = [
                0 => 'SUN',
                1 => 'MON',
                2 => 'TUE',
                3 => 'WED',
                4 => 'THU',
                5 => 'FRI',
                6 => 'SAT',
            ];
            $day = $weekMap[\Carbon\Carbon::createFromFormat('Y-m-d H:i', $st->scharr, 'Asia/Kolkata')->dayOfWeek];

            $arr = array_filter(
                        $days,
                        function ($item) use($day) {
                            return $item->code === $day;
                        }
                    );
            if (    $arr[array_keys($arr)[0]]->runs == 'Y')
                    return true;

            return false;

        }
}

