<?php

namespace App\Domain;

use Illuminate\Support\Carbon;
use Log;

class StationService
{
	private $requester;
	public function __construct()
	{
		$this->requester = \App\XClient::getClient();
		#dd($this->requester);
	}


	public function getOutletsByStation($stationCode)
	{
		$currDate = \Carbon\Carbon::now();
		$stations = \App\Models\Station::where('code', $stationCode)->with('outlets')->get()[0]->outlets->map(function ($o) use ($currDate) {
            $o->tags = explode(',',$o->tags);
            $o->closingPeriod = json_decode($o->closingPeriod);
            $o->weeklyClosed = json_decode($o->weeklyClosed);
            if($o->payment_mode == 1){
                $o->prepaid = true;
            }else{
                $o->prepaid = false;
            }
			$out = (object)[
			    'id'=>$o->id ,
			    'name'=>$o->outletName,
			    'tags'=>$o->tags,
			    'openingTime'=>$o->openingTime,
			    'closingTime'=>$o->closingTime,
			    'currentTime' =>$currDate->toDateTimeString(),
			    'minOrderAmount'=>$o->minOrderAmount,
			    'order_timing'=>$o->order_timing,
			    'deliveryCost'=>$o->deliveryCost,
			    'logo'=>$o->logoImage,
			    'cutOffTime'=> $o->cancel_cut_off_time,
			    'closingSchedule'=>$o->closingPeriod,
			 //   'closingSchedule'=>json_decode($o->closingPeriod),
			    'closingPeriod' => $o->closingPeriod,
			    'weeklyClosed' => $o->weeklyClosed,
				'outletId' => $o->id,
				'outletName' => $o->outletName,
				'openingTimeStamp' => $o->openingTime,
				'closingTimeStamp' => $o->closingTime,
				'prepaid' => $o->prepaid,
				'address' => $o->address,
				'city' => $o->city,
				'state' => $o->state,
				'companyName' => $o->companyName,
				'vendorPanNumber' => $o->vendorPanNumber,
				'gstNo' => $o->gstNo,
				'fssaiNo' => $o->fssaiNo,
				'fssaiValidUpto' => $o->fssaiValidUpto,
				'logoImage' => $o->logoImage,
				'email' => $o->email,
				'mobile' => $o->mobile,
                'detailedNutritionalInfoPdf' => $o->detailedNutitionalInfoPDFURL,				
				'payment_mode' => $o->payment_mode,
				'off' => $this->isRestOff($o) /*|| in_array(substr(strtoupper($currDate->format('l')), 0, 3), json_decode($o->weeklyClosed))*/,
			];
			
			
			return $out;
		});
		if ($stations->isEmpty())
			$stations2 = [];
		else {
			$stations2 = array();
			foreach ($stations as $key => $value) {
				$stations2[] = $value;
			}
		}
		$stations = $stations2;
		return $stations;
	}
	
	
	public function getOutletsByStationV2($stationCode)
	{
		$currDate = \Carbon\Carbon::now();
		$stations = \App\Models\Station::where('code', $stationCode)->with('outlets')->get()[0]->outlets->map(function ($o) use ($currDate) {
            //$o->tags = explode(',',$o->tags);
            $o->closingPeriod = json_decode($o->closingPeriod);
            $o->weeklyClosed = json_decode($o->weeklyClosed);
            if($o->payment_mode == 1){
                $o->prepaid = true;
            }else{
                $o->prepaid = false;
            }
			$out = (object)[
			    'id'=>$o->id ,
			    'name'=>$o->outletName,
			    'tags'=>$o->tags,
			    'openingTime'=>$o->openingTime,
			    'closingTime'=>$o->closingTime,
			    'currentTime' =>$currDate->toDateTimeString(),
			    'minOrderAmount'=>$o->minOrderAmount,
			    'order_timing'=>$o->order_timing,
			    'deliveryCost'=>$o->deliveryCost,
			    'logo'=>$o->logoImage,
			    'cutOffTime'=> $o->cancel_cut_off_time,
			    'closingSchedule'=>$o->closingPeriod,
			 //   'closingSchedule'=>json_decode($o->closingPeriod),
			    'closingPeriod' => $o->closingPeriod,
			    'weeklyClosed' => $o->weeklyClosed,
				'outletId' => $o->id,
				'outletName' => $o->outletName,
				'openingTimeStamp' => 0, //$o->openingTime,
				'closingTimeStamp' => 0, //$o->closingTime,
				'prepaid' => $o->prepaid,
				'address' => $o->address,
				'city' => $o->city,
				'state' => $o->state,
				'companyName' => $o->companyName,
				'vendorPanNumber' => $o->vendorPanNumber,
				'gstNo' => $o->gstNo,
				'fssaiNo' => $o->fssaiNo,
				'fssaiValidUpto' => $o->fssaiValidUpto,
				'logoImage' => $o->logoImage,
				'email' => $o->email,
				'mobile' => $o->mobile,
                'detailedNutritionalInfoPdf' => $o->detailedNutitionalInfoPDFURL,				
				'payment_mode' => $o->payment_mode,
				'off' => $this->isRestOff($o) /*|| in_array(substr(strtoupper($currDate->format('l')), 0, 3), json_decode($o->weeklyClosed))*/,
			];
			
			
			return $out;
		});
		if ($stations->isEmpty())
			$stations2 = [];
		else {
			$stations2 = array();
			foreach ($stations as $key => $value) {
				$stations2[] = $value;
			}
		}
		$stations = $stations2;
		return $stations;
	}

	public function getOutlet($id)
	{
		$currDate = \Carbon\Carbon::now();
                //$here = \App\Station::where('code', $stationCode)->with('outlets')->get();
                //print_r($here);
                //Log::channel('dailyInfo')->info('data:'.print_r($outlet, true));
		$o = \App\Models\Outlet::where('id', $id)->first();
            $o->tags = explode(',',$o->tags);
            $o->closingPeriod = json_decode($o->closingPeriod);
            $o->weeklyClosed = json_decode($o->weeklyClosed);
            if($o->payment_mode == 1){
                $o->prepaid = true;
            }else{
                $o->prepaid = false;
            }
                $out = (object)[
				'outletId' => $o->id,
				'outletName' => $o->outletName,
				'order_timing' => $o->order_timing,
				'minOrderAmount' => $o->minOrderAmount,
				'openingTime' => $o->openingTime,
				'closingTime' => $o->closingTime,
				'deliveryCost' => $o->deliveryCost,
				'prepaid' => $o->prepaid,
				'address' => $o->address,
				'city' => $o->city,
				'state' => $o->state,
				'companyName' => $o->companyName,
				'vendorPanNumber' => $o->vendorPanNumber,
				'gstNo' => $o->gstNo,
				'fssaiNo' => $o->fssaiNo,
				'fssaiValidUpto' => $o->fssaiValidUpto,
				'closingPeriod' => $o->closingPeriod,
				'weeklyClosed' => $o->weeklyClosed,
				'logoImage' => $o->logoImage,
				'email' => $o->email,
				'mobile' => $o->mobile,
                'detailedNutritionalInfoPdf' => $o->detailedNutitionalInfoPDFURL,				
				//'tags' => $o->tags,
				//'currentTime' => $currDate->toDateTimeString(),
				//'payment_mode' => $o->payment_mode,
				//'cutOffTime' => $o->cancel_cut_off_time,
				//'closingSchedule' => json_decode($o->closingPeriod),
				//'off' => $this->isRestOff($o) || in_array(substr(strtoupper($currDate->format('l')), 0, 3), json_decode($o->weeklyClosed)),
                ];

		return array($out);
	}

	private static function calculateHitSchedule($schedule, $date){
		$hit = false;
		
		foreach ($schedule as $key=> $value) {
			list($from, $to) = $value;
			if($date->between($from, $to)){
				$hit = true;
				break;
			}
		}

		return $hit;
	}


	private static function dropClosedRestraunts($outlet, $eta){
		list($date, $time, $_) = preg_split("/\s/", $eta);

		$_pickTrue = function($value){ return $value == true;};
		$_pickFalse = function($value){ return $value == false;};
		/* opening/closing dates and estimated arrival time */

		$_opening = Carbon::createFromFormat('Y-m-d H:i', sprintf("%s %s", $date, $outlet->openingTime));
		try {
			$_closing = Carbon::createFromFormat('Y-m-d H:i', sprintf("%s %s", $date, $outlet->closingTime));
		} catch (\Throwable $th) {
			list ($hh, $mm) = preg_split("/\:/", $outlet->closingTime);
			$_closing = Carbon::createFromFormat('Y-m-d H:i', sprintf("%s %s", $date, sprintf("%s:%s", trim($hh), trim($mm))));
		}
		
		$_eta =    Carbon::createFromFormat('Y-m-d H:i', sprintf("%s %s", $date, $time));
       // $endTime=strtotime("-10 minutes",strtotime($time));
        $endTime=strtotime("-".$outlet->cutOffTime." minutes",strtotime($time));
		   $apapaTime=date('H:i', $endTime);
		     $_cls =    Carbon::createFromFormat('Y-m-d H:i', sprintf("%s %s", $date, $apapaTime));
		      $_current_time=date('Y-m-d H:i');
		    // die;
		       //echo $_eta;
		   //    die;
		      // echo "<br>";
		 // echo $_eta;
		 // echo "<br>";
		 // echo $_opening;
		 // echo "<br>";
		 // echo $_cls;
		 // echo "<br>";
		 // echo $_closing;
		 // die;
          
		 $a1= $_eta->between($_opening, $_closing);
		 if($_current_time <= $_cls)
		 {
		 	$a2=1;
		 }
		 else
		 {
		 $a2=0;	
		 }
		 
		  if($eta >= $_current_time)
		 {
		 	$a3=1;
		 }
		 else
		 {
		 $a3=0;	
		 }
		 
		 $result=$a2*$a1*$a3;
		 
		
		/* eta DAY */
		$_day = strtoupper(substr($_opening->format('l'), 0, 3));
		
		/* schedule dates */

		$_schedules = array_map(function($sch){
			return [
				Carbon::createFromFormat('Y-m-d', $sch->closedFrom),
				Carbon::createFromFormat('Y-m-d', $sch->closedTo),
			];
		}, $outlet->closingSchedule); 

		$_summary = [
			$_pickFalse($result),
			$_pickTrue(count($outlet->weeklyClosed) > 0 ? in_array($_day, $outlet->weeklyClosed) : false),
			$_pickTrue(self::calculateHitSchedule($_schedules, $_eta))
		];

		$_resultShouldNotBePositive = !($_summary[0] || $_summary[1] || $_summary[2]);
		return ['open' => $_resultShouldNotBePositive, 'reason' => [
			'TT' => $_summary[0],
			'WKL' => $_summary[1],
			'SCH' => $_summary[2],
		], 'eta' => $_eta->format('Y-m-d H:i')];
	}


	public function getOutletsByStationXX($stationCode, $eta)
	{

		$currDate = \Carbon\Carbon::now()->setTimezone('Asia/Kolkata');
		$stations = \App\Models\Station::where('code', $stationCode)->first()->outlets->map(function ($o) use ($currDate) {
			$out = [
				'id' => $o->id,
				'name' => $o->outletName,
				'tags' => $o->tags,
				'openingTime' => $o->openingTime,
				'closingTime' => $o->closingTime,
				'currentTime' => $currDate,
				'minOrderAmount' => $o->minOrderAmount,
				'order_timing' => $o->order_timing,
				'deliveryCost' => $o->deliveryCost,
				'logo' => $o->logoImage,
				'cutOffTime' => $o->cancel_cut_off_time,
				'closingSchedule' => json_decode($o->closingPeriod),
				'weeklyClosed' => json_decode($o->weeklyClosed),
			];




			if ($o->payment_mode == 1) {
				$out['payment'] = true;
			}else{
				$out['payment'] = false;
			}

			return $out;
		})->map(function($outlet) use($eta){
			$mapper = self::dropClosedRestraunts((object)$outlet, $eta);
			
			return (object)array_merge($outlet, $mapper);
		})->filter(function($r) {
			return $r->open != false;
		});

		return $stations;
	}
	public function isRestOff($outlet)
	{
		$cp = json_encode($outlet->closingPeriod);
		$closingPeriods = json_decode($cp);
		$closed = false;
		$now = \Carbon\Carbon::now();
		foreach ($closingPeriods as $closingPeriod) {
			if (
				$now->greaterThanOrEqualTo((\Carbon\Carbon::createFromFormat('Y-m-d', $closingPeriod->closedFrom)->startOfDay()))
				&& $now->lessThanOrEqualTo((\Carbon\Carbon::createFromFormat('Y-m-d', $closingPeriod->closedTo)->endOfDay()))
			) {
				$closed = true;
				break;
			}
		}
		return $closed;
	}


	public function getLiveStatus($key, $train, $station)
	{
		$apiKey = config('domain.API_KEY_RAILWAY');
		$date = \Carbon\Carbon::today()->format('d-m-Y');
		$liveStatus = sprintf('https://api.railwayapi.com/v2/live/train/%s/station/%s/date/%s/apikey/%s/', $train, $station, $date, $key);

		try {
			$status =  json_decode(
				$this->requester->Request('GET', $liveStatus)
			)->route;
			foreach ($status as $el) {
				if ($el->station->code == $station)
					return $el->scharr_date . ' ' . $el->scharr;
			}

			return false;
		} catch (\Exception $e) {

			echo $e->getMessage();
			$local = [];
		}
	}
}
