<?php

namespace App\Events;

use App\Events\Event;
use App\Models\VendorOrder;
use Illuminate\Queue\SerializesModels;

class OrderCreatedEvent extends Event
{
    use SerializesModels;

    public $id;
    public $user_id;
    /**
     * Create a new event instance.
     *
     * @return void
     */
    public function __construct($order)
    {
        $this->id = $order->orderId;
        $this->user_id = $order->user_id;
    }

    /**
     * Get the channels the event should be broadcast on.
     *
     * @return array
     */
    public function broadcastOn()
    {   
        //return ['private-my-channel'];
        return ['private-order.'.$this->user_id];
    }

    public function broadcastAs()
    {
        return 'created';
    }
}
