<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\WithTitle;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\AfterSheet;
use Maatwebsite\Excel\Concerns\WithEvents;

class CancelOrderSheet implements FromArray, WithTitle, WithEvents,WithHeadings, ShouldAutoSize
{
    protected $orders;

    public function __construct(array $orders)
    {
        $this->orders = $orders;
    }

    public function registerEvents(): array
    {
        return [
            BeforeExport::class  => function(BeforeExport $event) {
                $event->writer->setTitle('Cancelled Order');
                $event->writer->setCreator('Admin OLF Stores');
                $event->writer->setCompany('Olf Stores');
                $event->writer->setDescription('Cancelled Orders for today');            
            },            
            AfterSheet::class    => function(AfterSheet $event) {
                $event->sheet->setOrientation(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::ORIENTATION_LANDSCAPE);
                $length = sizeof($this->invoices)-5;
                $event->sheet->getStyle('K'.$length.':O'.$length)->applyFromArray([
                        'borders' => [
                            'outline' => [
                                'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THICK,
                                'color' => ['argb' => 'FFFF0000'],
                            ],
                        ],
                        'font' => [
                            'bold' => true,
                        ]
                    ]
                );
            },
        ];
    }    
    public function array(): array
    {
        return $this->orders;
    }

    /**
     * @return string
     */
    public function title(): string
    {
        return 'Sheet1';
    }
    public function headings(): array
    {
        return ['Serial No.','Order Id','Outlet Name','Delivery Station','Order Status','Reason'];
    }

}