<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace App\Exports;

use Illuminate\Support\Facades\Log;
use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\WithTitle;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\AfterSheet;
use Maatwebsite\Excel\Concerns\WithEvents;



class InvoicesSheet implements FromArray, WithTitle, WithEvents, WithHeadings, ShouldAutoSize
{
    protected $invoices;

    public function __construct(array $invoices)
    {
        
        
       $this->invoices = $invoices;
        
    }

    public function registerEvents(): array
    {
        return [
            BeforeExport::class  => function (BeforeExport $event) {
                $event->writer->setTitle('Payments');
                $event->writer->setCreator('Admin OLF Stores');
                $event->writer->setCompany('Olf Stores');
                $event->writer->setDescription('invoice');
            },
            AfterSheet::class    => function (AfterSheet $event) {
                $event->sheet->setOrientation(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::ORIENTATION_LANDSCAPE);

                $sheet = $event->sheet;
                $rows = sizeof($this->invoices) + 1;
                //$sheet->setCellValue('N'.$rows, 'Total Debit');
                $event->sheet->cell('N' . $rows, function ($cell) {
                    $cell->setValue('Total Debit');
                });

                $sheet->mergeCells('N' . $rows . ':O' . $rows);
                $sheet->setCellValue('Q' . $rows, $totalAmount['debit']);

                $sheet->setCellValue('N' . ++$rows, 'Total Credit');
                $sheet->mergeCells('N' . $rows . ':O' . $rows);
                $sheet->setCellValue('R' . $rows, $totalAmount['credit']);

                $sheet->setCellValue('N' . ++$rows, 'Total Commision');
                $sheet->mergeCells('N' . $rows . ':O' . $rows);
                $sheet->mergeCells('P' . $rows . ':Q' . $rows);
                $sheet->setCellValue('P' . $rows, $totalAmount['commision']);

                $sheet->setCellValue('N' . ++$rows, 'GST @ 18%');
                $sheet->mergeCells('N' . $rows . ':O' . $rows);
                $sheet->mergeCells('P' . $rows . ':Q' . $rows);
                $sheet->setCellValue('P' . $rows, $totalAmount['totalGst']);

                $sheet->setCellValue('N' . ++$rows, 'Net Payable Amount');
                $sheet->mergeCells('N' . $rows . ':O' . $rows);
                $sheet->mergeCells('P' . $rows . ':Q' . $rows);
                $sheet->setCellValue('P' . $rows, $totalAmount['total']);
            },
        ];
    }
    public function array(): array
    {
        return $this->invoices;
    }

    /**
     * @return string
     */
    public function title(): string
    {
        return 'Sheet1';
    }
    public function headings(): array
    {
        return ['Serial No.', 'Order Id', 'Outlet Name', 'Customer', 'Item', 'Delivery Date', 'Delivery Station', 'Transaction Type', 'Order Status', 'Vendor Payment', 'Vendor Collection', 'GST', 'Debit', 'Credit', 'Commision'];
    }
}
