<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\Exportable;
use Maatwebsite\Excel\Concerns\WithTitle;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\AfterSheet;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Concerns\WithColumnFormatting;
use PhpOffice\PhpSpreadsheet\Style\NumberFormat;
use Log;

class MenuItemSheet implements FromArray, WithTitle, WithColumnFormatting, WithEvents,WithHeadings, ShouldAutoSize
{
    use Exportable;
    protected $menu_items;

    public function __construct(array $menu_items)
    {
        $this->menu_items = $menu_items;
    }
    public function registerEvents(): array
    {
        return [
            BeforeExport::class  => function(BeforeExport $event) {
                $event->writer->setTitle('Payments');
                $event->writer->setCreator('Admin OLF Stores');
                $event->writer->setCompany('Olf Stores');
                $event->writer->setDescription('invoice');            
            },            
            AfterSheet::class    => function(AfterSheet $event) {
            }
        ];
    }    
    public function array(): array
    {
        return $this->menu_items;
    }

    /**
     * @return string
     */
    public function title(): string
    {
        return 'Sheet1';
    }
    public function headings(): array
    {
        return ['id','itemName','basePrice','description','openingTime','closingTime','tax','sellingPrice','vendorPrice','isVegeterian','isNonVegeterian','tags','cuisine','foodType'];
    }

    public function columnFormats(): array
    {
        return [
            'E' => NumberFormat::FORMAT_DATE_TIME3,
            'F' => NumberFormat::FORMAT_DATE_TIME3,
        ];
    }

}