<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\Exportable;
use Maatwebsite\Excel\Concerns\WithTitle;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\AfterSheet;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Concerns\WithColumnFormatting;
use PhpOffice\PhpSpreadsheet\Style\NumberFormat;
use Log;

class OrderExcelSheet implements FromArray, WithTitle, WithColumnFormatting, WithEvents,WithHeadings, ShouldAutoSize
{
    use Exportable;
    protected $orders;

    public function __construct(array $orders)
    {
        $this->orders = $orders;
    }
    public function registerEvents(): array
    {
        return [
            BeforeExport::class  => function(BeforeExport $event) {
                $event->writer->setTitle('Payments');
                $event->writer->setCreator('Admin OLF Stores');
                $event->writer->setCompany('Olf Stores');
                $event->writer->setDescription('invoice');            
            },            
            AfterSheet::class    => function(AfterSheet $event) {
            }
        ];
    }    
    public function array(): array
    {
        return $this->orders;
    }

    /**
     * @return string
     */
    public function title(): string
    {
        return 'Sheet1';
    }
    public function headings(): array
    {
        return ['orderId','customer','item','station','paymentType','status','amountPayable','customerMobile','outletName','deliveryDate','vendorOrder'];
    }

    public function columnFormats(): array
    {
        return [
            'K' => NumberFormat::FORMAT_DATE_TIME3,
        ];
    }

}