<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\WithTitle;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\AfterSheet;
use Maatwebsite\Excel\Concerns\WithEvents;

class SalesReportSheet implements FromArray, WithTitle, WithEvents,WithHeadings, ShouldAutoSize
{
    protected $orders;

    public function __construct(array $orders)
    {
        $this->orders = $orders;
    }

    public function registerEvents(): array
    {
        return [
            BeforeExport::class  => function(BeforeExport $event) {
                $event->writer->setTitle('Sales Report');
                $event->writer->setCreator('Admin OLF Stores');
                $event->writer->setCompany('Olf Stores');
                $event->writer->setDescription('Sales Report');            
            },  

            AfterSheet::class    => function(AfterSheet $event) {

                $event->sheet->setOrientation(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::ORIENTATION_LANDSCAPE);
            },
        ];
    }    

    public function array(): array
    {    
        $i = 0;
        foreach ($this->orders as &$ordData) {
            $ordData = array_merge(['srno' => ++$i], $ordData);
        }
        unset($ordData); // unset the reference to avoid potential side effects
    
        return $this->orders;
    }

    /**
     * @return string
     */
    public function title(): string
    {
        return 'Sheet1';
    }
    public function headings(): array
    {
        return ['Serial No.','Rest Name','Pan Number','GST Number','Total Sales/Base Price','Vendor Total/ Total Purchase/Vendor Price','OLF Margin/Comission'];
    }

}