<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace App\Extensions;
use Illuminate\Auth\GuardHelpers;
use Illuminate\Contracts\Auth\Guard;
use Illuminate\Contracts\Auth\UserProvider;
use Illuminate\Http\Request;
use Log;
class AccessTokenGuard implements Guard
{
	use GuardHelpers;
	private $inputKey = '';
	private $storageKey = '';
	private $request;
	public function __construct (UserProvider $provider, Request $request, $configuration,$hash = false) {
        //Log::channel('dailyInfo')->info('message response:123*');
                $this->hash = $hash;
		$this->provider = $provider;
		$this->request = $request;
		// key to check in request
		//$this->inputKey = isset($configuration['input_key']) ? $configuration['input_key'] : 'access_token';
                $this->inputKey = 'api_token';
		// key to check in database
		//$this->storageKey = isset($configuration['storage_key']) ? $configuration['storage_key'] : 'access_token';
                $this->storageKey = 'access_token';
	}
	public function user () {
		if (!is_null($this->user)) {
			return $this->user;
		}
		$user = null;
		// retrieve via token
		$token = $this->getTokenForRequest();
		if (!empty($token)) {
			// the token was found, how you want to pass?
			$user = $this->provider->retrieveByToken($this->storageKey, $this->hash ? hash('sha256', $token) : $token);
		}
		return $this->user = $user;
	}
	/**
	 * Get the token for the current request.
	 * @return string
	 */
	public function getTokenForRequest () {
		$token = $this->request->query($this->inputKey);
		if (empty($token)) {
			$token = $this->request->input($this->inputKey);
		}
		if (empty($token)) {
			$token = $this->request->bearerToken();
		}
		return $token;
	}
	/**
	 * Validate a user's credentials.
	 *
	 * @param  array $credentials
	 *
	 * @return bool
	 */
	public function validate (array $credentials = []) {
		if (empty($credentials[$this->inputKey])) {
			return false;
		}
		$credentials = [ $this->storageKey => $credentials[$this->inputKey] ];
		if ($this->provider->retrieveByCredentials($credentials)) {
			return true;
		}
		return false;
	}
}