<?php namespace App\Http\Controllers;

use App\Http\Requests;
use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

class AdminController extends Controller {
    public function __construct()
    {
        $this->middleware('auth', ['except' => ['index','show']]);
        $this->middleware('role:admin', ['except' => ['index','show']]);
        $this->middleware('auth', ['only' => ['index','show']]);
        $this->middleware('role:admin', ['only' => ['index','show']]);
    }
    public function activate($id) {
        $user = \App\Models\User::find($id);
        $user->active = 1;
        $user->save();

        return redirect('backend/admins');
    }

	public function index() {
        $admins = \App\Models\User::where('role','=','admin')->get();
        return view('backend/admins.index', compact(['admins']));
    }

    public function show($id) {
        $admin = \App\Models\User::find($id);
        return view('backend/admins.show', compact('admin'));
    }


    public function create() {
        return view('backend/admins.create');
    }

    public function store(Request $request) {
        $this->validate($request, [
        ]);
        if (\App\Models\User::whereEmail($request->email)->get()->count()) {
            session()->flash('error', 'Duplicate Entry For email field.');
            return redirect()->back()->withInput(Input::all());
        }
       
        $data = $request->only(['first_name', 'last_name', 'email', 'passwrod', 'mobile', 'dob',
            'address']);
        $data['password'] = bcrypt($data['passwrod']);
        $data['role'] = 'admin';
        $data['active']= 1;
        $user = \App\Models\User::create($data);
        $user_role = \App\Models\Role::where('slug',$data['role'])->first();
        $user->roles()->attach($user_role);
        session()->flash('success', 'Your Admin created successfully.');
        return redirect()->back();
    }

    public function edit($id) {
        $admin = \App\Models\User::find($id);
        return view('backend/admins.update', compact('admin'));
    }

  public function update(Request $request, $id) {
        $this->validate($request, [
        ]);
        $faq = \App\Models\User::find($id);
        $faq->updateOld($request->all());
        session()->flash('success', 'Your Admin  Updated successfully.');
        return redirect()->back();
    }

    public function destroy($id) {
        $admin = \App\Models\User::find($id)->delete();
        session()->flash('success', 'Admin deleted successfully.');
        return redirect()->back();
    }

}
