<?php namespace App\Http\Controllers;

use App\Http\Requests;
use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

class AgentController extends Controller {
    public function __construct()
    {
        $this->middleware('auth', ['except' => ['index','show']]);
        $this->middleware('role:admin', ['except' => ['index','show']]);
        $this->middleware('auth', ['only' => ['index','show']]);
        $this->middleware('role:admin', ['only' => ['index','show']]);
    }
    public function activate($id) {
        $user = \App\Models\User::find($id);
         $user->active = $user->active == 1 ? 0:1;
        $user->save();

        return redirect('backend/agents');
    }

	public function index() {
	    $agents = \App\Models\User::where('role','=','agent')->orWhere('role','=','manager')->get();
        return view('backend/agents.index', compact(['agents']));
    }

    public function show($id) {
        $agent = \App\Models\User::find($id);
        return view('backend/agents.show', compact('agent'));
    }


    public function create() {
        return view('backend/agents.create');
    }

   
   public function store(Request $request) {
        $this->validate($request, [
        ]);
        if (\App\Models\User::whereEmail($request->email)->get()->count()) {
            session()->flash('error', 'Duplicate Entry For email field.');
            return redirect()->back()->withInput();
        }
       
        $data = $request->only(['first_name', 'last_name', 'email', 'passwrod', 'mobile', 'dob',
            'address', 'role']);
        $data['password'] = bcrypt($data['passwrod']);
        $data['active']= $request->role !="vendor" ? 1 : 0;

        $user = \App\Models\User::create($data);
        $mobiles = explode(',', $user->mobile);
        $first = 1;
        foreach ($mobiles as $mobile) {
            if($first)
                $user->mobiles()->create(['mobile'=>$mobile, 'role'=>1]);
            else
                $user->mobiles()->create(['mobile'=>$mobile]);
            $first = 0;
        }
        $user_role = \App\Models\Role::where('slug',$data['role'])->first();
        $user->roles()->attach($user_role);

        session()->flash('success', 'Your User created successfully.');
        return redirect()->back();
    }
    

    public function edit($id) {
        $agent = \App\Models\User::find($id);
        return view('backend/agents.update', compact('agent'));
    }

  public function update(Request $request, $id) {
        $this->validate($request, [
        ]);
        $faq = \App\Models\User::find($id);
        $faq->updateOld($request->all());
        session()->flash('success', 'Your Agent  Updated successfully.');
        return redirect()->back();
    }

    public function destroy($id) {
        $agent = \App\Models\User::find($id)->delete();
        session()->flash('success', 'Agent deleted successfully.');
        return redirect()->back();
    }

}
