<?php

namespace App\Http\Controllers\Auth;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Foundation\Auth\AuthenticatesUsers;
use Illuminate\Support\Facades\Auth;
use Log;
class LoginController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Login Controller
    |--------------------------------------------------------------------------
    |
    | This controller handles authenticating users for the application and
    | redirecting them to your home screen. The controller uses a trait
    | to conveniently provide its functionality to your applications.
    |
    */

    use AuthenticatesUsers{
        logout as performLogout;
    }

    /**
     * Where to redirect users after login.
     *
     * @var string
     */
    protected $redirectTo = '/home';
    public $loginPath = '/auth/login';
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('guest', ['except' => 'logout']);
    }
    public function logout(Request $request)
    {
        $count = 0;
        if(Auth::user()!=null)
            $count = $count+1;
        if(Auth::guard('order')->user()!=null)
            $count = $count+1;
        if(Auth::guard('vendororder')->user()!=null)
            $count = $count+1;
        if(Auth::guard('memoryuser')->user()!=null)
            $count = $count+1;
        $valueApi = 0;
        if($request->session()->has('api')){
            Log::channel('dailyInfo')->info('api set in session:');
            $valueApi = $request->session()->pull('api', 0);
        }
        $this->guard()->logout();
        if($count==1){
            Log::channel('dailyInfo')->info('--invalidating session:');
            //$request->session()->invalidate();
        }
        Log::channel('dailyInfo')->info('value api:'.$valueApi.'--');
        if($valueApi)
            return response()->json([
                    'status' => 'success',
                ], 200);

        return redirect('auth/login');

        //return $this->loggedOut($request) ?: redirect('/');
    }
/*    
    public function logout(Request $request)
    {
        $this->performLogout($request);
        $user = Auth::guard('vendororder')->user();
        $user1 = Auth::guard('order')->user();
        $user2 = Auth::guard('memoryuser')->user();
        $loggedOut = false;
        if ($user != null) {
            Auth::guard('vendororder')->logout();
        }else {
            if($user1!=null){
                Auth::guard('order')->logout();
            }else if($user2!=null){
                Auth::guard('memoryuser')->logout();
            }
        }
        
        return redirect('auth/login');
    }
 * 
 */
    public function authenticated(Request $request, $user)
    { 
        if (!$user->active) {
            auth()->logout();
            return back()->with('warning', 'Your account is under review. Please wait until your account is verified.');
        }

        return redirect()->intended($this->redirectPath());
    }
    public function loginApi(Request $request)
    {
            $request->session()->put('api', 1);
            $request->session()->save();
		if(Auth::check()){
            return response()->json([
                    'status' => 'success',
                ], 200);
		}
        $this->validateLogin($request);

        // If the class is using the ThrottlesLogins trait, we can automatically throttle
        // the login attempts for this application. We'll key this by the username and
        // the IP address of the client making these requests into this application.
        if ($this->hasTooManyLoginAttempts($request)) {
            $this->fireLockoutEvent($request);

            return response()->json([
                    'status' => 'error',
                    'message' => 'Too many login attempts.'
                ], 401);
        }

        if ($this->attemptLogin($request)) {
            return response()->json([
                    'status' => 'success',
                ], 200);
        }

        // If the login attempt was unsuccessful we will increment the number of attempts
        // to login and redirect the user back to the login form. Of course, when this
        // user surpasses their maximum number of attempts they will get locked out.
        $this->incrementLoginAttempts($request);

        return response()->json([
                'status' => 'error',
                'message' => 'Credentials do not match our database.'
            ], 200);
    }

    public function checkLogin(Request $request)
    {
        if(Auth::check()){
            return response()->json([
                    'status' => 'success',
                    'logged' => 1
                ], 200);
        }
        return response()->json([
            'status' => 'success',
            'logged' => 0
        ], 200);
    }
}
