<?php

namespace App\Http\Controllers\Auth;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Validator;
use App\Models\User;
use App\Models\Token;
use Illuminate\Support\Facades\Auth;
use Log;

class OrderApiLoginController extends Controller
{
  private $apiToken = null;

  function __constuct()
  {
    $this->apiToken = uniqid(base64_encode(str_random(60)));
  }
  public function getToken($apiToken)
  {
    if ($apiToken != null)
      return hash('sha256', $apiToken);;

    return $apiToken;
  }

  public function saveToken($apiToken, $user)
  {
    $postArray = ['api_token' => $this->getToken($apiToken)];
    $user->api_token = $this->getToken($apiToken);
    //Log::channel('dailyInfo')->info('user'.print_r($user,true));
    return $user->save();
  }
  public function removeToken($apiToken, $user)
  {
    return $this->saveToken(null, $user);
  }

  public function getTokenUser($token)
  {
    $user = \App\Models\Order::where('api_token', $this->getToken($token))->first();
    if (!$user)
      $user = \App\Models\VendorOrder::where('api_token', $this->getToken($token))->first();
    if (!$user)
      $user = \App\Models\MemoryUser::where('api_token', $this->getToken($token))->first();

    return $user;
  }

  public function sendOtp(Request $request)
  {
    if (!$request->has('mobile')) {
      return json_encode(array('status' => 'failure', 'msg' => "input parameters missing"));
    } else {
      //Auth::logout();
      //put in session
      $mobile = $request->input('mobile');
      $otp = $this->generateOTP($mobile);
      $message = 'your otp for signing is ' . $otp . 'on https://olfstores.com';
      ob_start();
      $this->sendMessage($message, $mobile, env('LOGIN_OTP_TEMLPLATE_ID', NULL));
      $res = ob_get_clean();
      if ($request->has('mobile')) {
        $vo = \App\Models\VendorOrder::latest($mobile);
      }
      if ($vo != null) {
        $orderUpdated = \App\Models\Order::where('customerMobile', $mobile)->update(['password' => null]);
        $vendorOrderUpdated = \App\Models\VendorOrder::where('customerMobile', $mobile)->update(['password' => null]);

        $vo->password = \Illuminate\Support\Facades\Hash::make($otp);
        $vo->save();
      } else {
        $memoryUser = \App\Models\MemoryUser::where('mobile', $mobile)->first();
        if ($memoryUser == null) {
          \App\Models\MemoryUser::create(['password' => \Illuminate\Support\Facades\Hash::make($otp), 'mobile' => $mobile, 'memory' => 1]);
        } else {
          $memoryUser->password = \Illuminate\Support\Facades\Hash::make($otp);
          $memoryUser->save();
        }
      }
      return json_encode(array('status' => 'success', 'message' => 'otp sent successfully'));
    }
  }

  private function sendMessage($string, $numbers, $DLT_TE_ID = null)
  {
    $key = "191164Aup6j2p05a4cb419";
    $url = sprintf('https://api.msg91.com/api/sendhttp.php?authkey=%s&mobiles=%s&route=%s&sender=%s&message=%s&country=%s', $key, $numbers, '4', urlencode('OLFSTR'), urlencode($string), '91');
    if ($DLT_TE_ID != null) {
      $url = $url . sprintf('&DLT_TE_ID=%s', $DLT_TE_ID);
    }
    $curl = curl_init();

    curl_setopt_array($curl, array(
      CURLOPT_URL => "http://api.msg91.com/api/v2/sendsms",
      CURLOPT_URL => $url,
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      //CURLOPT_CUSTOMREQUEST => "POST",
      CURLOPT_CUSTOMREQUEST => "GET",
      //CURLOPT_POSTFIELDS => json_encode($data),
      CURLOPT_SSL_VERIFYHOST => 0,
      CURLOPT_SSL_VERIFYPEER => 0,
      /*
                                    CURLOPT_HTTPHEADER => array(
                                            "content-type: application/json"
                                            ),*/
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    /*if ($err) {
			echo "cURL Error #:" . $err;
		} else {
			echo $response;
		}*/
    print_r($response);
  }

  public function generateOTP($mobile)
  {
    if ($mobile == "9755901495")
      $otp = 123456;
    else
      $otp = mt_rand(100000, 999999);
    return $otp;
  }

  public function postLogin(Request $request)
  {
    $this->apiToken = str_random(60);
    // Validations
    $rules = [
      'mobile' => 'required',
      'otp' => 'required|min:6'
    ];
    $validator = Validator::make($request->all(), $rules);
    if ($validator->fails()) {
      // Validation failed
      return response()->json([
        'status' => 'error',
        'message' => $validator->getMessageBag()->getMessages(),
      ]);
    } else {
      // Fetch User
      $vo = \App\Models\VendorOrder::latest($request->mobile);
      if ($vo == null) {
        $vo = \App\Models\MemoryUser::where('mobile', $request->mobile)->first();
      }
      $user = $vo;
      if ($user) {
        // Verify the password
        if (password_verify($request->otp, $user->password)) {
          // Update Token
          $postArray = ['api_token' => $this->apiToken];
          $login = $this->saveToken($this->apiToken, $user);

          if ($login) {
            $user->password = null;
            $user->save();
            return response()->json([
              'status' => 'success',
              'api_token' => $this->apiToken,
            ]);
          }
        } else {
          return response()->json([
            'status' => 'error',
            'message' => 'Invalid Password',
          ]);
        }
      } else {
        return response()->json([
          'status' => 'error',
          'message' => 'User not found',
        ]);
      }
    }
  }


  //logout

  public function postLogout(Request $request)
  {
    //$token = $request->header('Authorization');
    $token = $request->query('api_token');
    $user = $this->getTokenUser($token);
    if ($user) {
      if (get_class($user) == 'App\MemoryUser')
        $logout = $user->delete();
      else
        $logout = $this->removeToken($token, $user);
      if ($logout) {
        return response()->json([
          'status' => 'success',
          'message' => 'User Logged Out',
        ]);
      }
    } else {
      return response()->json([
        'status' => 'error',
        'message' => 'User not found',
      ]);
    }
  }
  public function getAuthUser()
  {
    return Auth::guard('apiorder')->user();
  }
  public function isLoggedIn(Request $request)
  {
    $user = $this->getAuthUser();
    if ($user) {
      return response()->json([
        'status' => 'success',
        'logged' => 1
      ], 200);
    }
    return response()->json([
      'status' => 'success',
      'logged' => 0
    ], 200);
  }
}
