<?php

namespace App\Http\Controllers\Auth;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Foundation\Auth\AuthenticatesUsers;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facade\Log;

class VendorOrderLoginController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Login Controller
    |--------------------------------------------------------------------------
    |
    | This controller handles authenticating users for the application and
    | redirecting them to your home screen. The controller uses a trait
    | to conveniently provide its functionality to your applications.
    |
    */

    use AuthenticatesUsers{
        logout as performLogout;
    }

    /**
     * Where to redirect users after login.
     *
     * @var string
     */
    protected $redirectTo = '/customer/home';
    public $loginPath = '/customer/login';
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function logout(Request $request)
    {
        $count = 0;
        if(Auth::user()!=null)
            $count = $count+1;
        if(Auth::guard('order')->user()!=null)
            $count = $count+1;
        if(Auth::guard('vendororder')->user()!=null)
            $count = $count+1;
        if(Auth::guard('memoryuser')->user()!=null)
            $count = $count+1;
        $this->guard()->logout();
        if($count==1){
           
           // $request->session()->invalidate();
        }

        return json_encode(array('status'=>'success','msg'=>"logged out successfully"));

        //return $this->loggedOut($request) ?: redirect('/');
    }
    /*
    public function performLogout(Request $request)
    {
        $this->guard('vendororder')->logout();
        Auth::logout();
        return json_encode(array('status'=>'success','msg'=>"logged out successfully"));
    }
     * 
     */
    
    public function __construct()
    {
        $this->middleware('guest:vendororder')->except('logout');
    }
    public function showLoginForm()
    {
        return view('auth.login.order');
    }
    public function username()
    {
        return 'orderId';
    }
    protected function guard()
    {
        return Auth::guard('vendororder');
    }
    protected function loggedOut(Request $request)
    {
        return json_encode(array('status'=>'success','msg'=>"logged out successfully"));
    }
    public function loginApi(Request $request)
    {
        $credentials = $request->only('orderId', 'password');
        if (Auth::guard('vendororder')->attempt($credentials)) {
            return response()->json([
                    'msg'=>"login successful",
                    'status' => 'success',
                ], 200);
        }
        return response()->json([
                'status' => 'error',
                'message' => 'Credentials do not match our database.'
            ], 200);
        /*
        //Auth::login($request);
		if(Auth::check()){
            return response()->json([
                    'status' => 'success',
                ], 200);
		}

        $this->validateLogin($request);

        // If the class is using the ThrottlesLogins trait, we can automatically throttle
        // the login attempts for this application. We'll key this by the username and
        // the IP address of the client making these requests into this application.
        if ($this->hasTooManyLoginAttempts($request)) {
            $this->fireLockoutEvent($request);

            return response()->json([
                    'status' => 'error',
                    'message' => 'Too many login attempts.'
                ], 401);
        }

        if (Auth::attempt($credentials)) {
            return response()->json([
                    'msg'=>"login successful",
                    'status' => 'success',
                ], 200);
        }

        // If the login attempt was unsuccessful we will increment the number of attempts
        // to login and redirect the user back to the login form. Of course, when this
        // user surpasses their maximum number of attempts they will get locked out.
        $this->incrementLoginAttempts($request);

        return response()->json([
                'status' => 'error',
                'message' => 'Credentials do not match our database.'
            ], 200);
         * 
         */
    }
    
    public function home()
    {
        $redirect = session()->has('items') ? route('cart.confirm'): url()->current();
        return json_encode(array('status'=>'success','msg'=>"login successful", 'redirect' => $redirect));//,'balance'=>$user->balance));
    }
    protected function credentials(Request $request)
    {
        return $request->only($this->username(), 'password');
    }
}
