<?php namespace App\Http\Controllers;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Exception;
use Pusher;
use Auth;

class ChannelController extends Controller {

	public function __construct(){
            $this->pusher = new Pusher( config('broadcasting.PUSHER_APP_KEY'), config('broadcasting.PUSHER_APP_SECRET'), config('broadcasting.PUSHER_APP_ID'),
                                array('cluster' => config('broadcasting.PUSHER_APP_CLUSTER'), 'encrypted' => true) );
	}

        public function authorizeUser(Request $request) {
            if (!Auth::check()) {
                return new Response('Forbidden', 403);
            }

            echo $this->pusher->socket_auth(
                $request->input('channel_name'),
                $request->input('socket_id')
            );
        }
}