<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace App\Http\Controllers;

use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Validator;
use Auth;
use Log;
use TCPDF;

define('K_PATH_IMAGES', storage_path().'/app/images/');
class MYPDF extends TCPDF {

    //Page header
    private $startDate;
    private $name;
    private $email;
    private $mobile;
    
    public function __construct($orientation='P', $unit='mm', $format='A4', $unicode=true, $encoding='UTF-8', $diskcache=false, $startDate, $name, $email, $mobile) {
        parent::__construct($orientation, $unit, $format, $unicode, $encoding, $diskcache);
        $this->startDate = $startDate;
        $this->name = $name;
        $this->email = $email;
        $this->mobile = $mobile;
        
    }
    public function Header() {
        // Logo
        parent::Header();
        /*
        $image_file = 'images/tcpdf_logo.jpg'; // *** Very IMP: make sure this image is available on given path on your server
        $this->Image($image_file,15,6,30);
        // Set font
        $this->SetFont('helvetica', 'C', 12);

        // Line break
        $this->Ln();        
        $this->Cell(294, 15, 'ABC test company', 0, false, 'C', 0, '', 0, false, 'M', 'M');
        $this->Ln(5);        
        $this->Cell(300, 0, 'Company tag line here', 0, false, 'C', 0, '', 0, false, 'M', 'M');
        // We need to adjust the x and y positions of this text ... first two parameters
         * 
         */

    }

    // Page footer
    public function Footer() {
        //parent::Footer();
        // Position at 25 mm from bottom
        $this->SetY(-15);
        // Set font
        $this->SetFont('helvetica', 'I', 8);

        //$this->Cell(0, 0, 'This Agreement Created on '.$this->startDate->format('M d,Y').' was agreed and digitally signed by '.$this->name.' using '.$this->email.' and as notified on', 0, 0, 'C');
        //$this->Ln();
        //$this->Cell(0,0,$this->mobile, 0, false, 'C', 0, '', 0, false, 'T', 'M');
        
        //$this->Cell(0,0,$this->mobile.' Accepted Date/Time: '.$this->startDate->format('M d,Y'), 0, false, 'C', 0, '', 0, false, 'T', 'M');
        $this->writeHTML('<p></p>', 0, false, false, false, 'C');
        $this->writeHTML('<span>This Agreement Created on <b>'.$this->startDate->format('M d,Y').'</b> was agreed and digitally signed by <b>'.$this->name.'</b> using <b>'.$this->email.'</b> and as notified on </span>', 0, false, false, false, 'C');
        $this->writeHTML('<p></p>', 0, false, false, false, 'C');
        $this->writeHTML('<span><b>'.$this->mobile.'</b> Accepted Date/Time: <b>'.$this->startDate->format('M d,Y').'</b></span>', 0, false, false, false, 'C');
        //$this->writeHTMLCell($w, $h, $x, $y, $html, $border, $ln);
        // Page number
        $this->Ln();
        $this->Cell(0, 0, 'Page '.$this->getAliasNumPage().'/'.$this->getAliasNbPages(), 0, false, 'C', 0, '', 0, false, 'T', 'M');
    }
}
class DocumentSignController extends Controller {
    public function __construct()
    {
    }

    public function sendOtp(Request $request) {
        $user = Auth::guard('api_mobile')->user();
        if (!$user||!$request->has('mobile')) {
            return json_encode(array('status' => 'error', 'message' => "Input parameters missing"));
        } else {
            $mobile = $request->input('mobile');
            if(explode(',', $user->mobile)[0]!=$mobile)
                  return json_encode(array('status' => 'error', 'message' => 'mobile number is invalid'));
            /*
            if(!in_array($mobile, explode(',', $user->mobile)))
                  return json_encode(array('status' => 'error', 'message' => 'mobile number is invalid'));
             *
             */
            $otp = $this->generateOTP();
            $message = 'your otp for signing is '.$otp.', on https://olfstores.com';
            ob_start();
            $this->sendMessage($message,$mobile, env('LOGIN_OTP_TEMLPLATE_ID', NULL));
            $res = ob_get_clean();
            if(!$user->documentSign){
                $user->documentSign()->create(['otp'=>\Illuminate\Support\Facades\Hash::make($otp)]);
            }else{
                $user->documentSign->otp = \Illuminate\Support\Facades\Hash::make($otp);
                //Log::channel('dailyInfo')->info('input'.$user->documentSign->otp);
                $user->documentSign->save();
            }
            return json_encode(array('status' => 'success', 'message' => 'otp sent successfully'));
        }
    }

	private function sendMessage($string, $numbers, $DLT_TE_ID=null){
            $key = "191164Aup6j2p05a4cb419";
            $url = sprintf('https://api.msg91.com/api/sendhttp.php?authkey=%s&mobiles=%s&route=%s&sender=%s&message=%s&country=%s',$key,$numbers,'4',urlencode('OLFSTR'),urlencode($string),'91');

            if(isset($DLT_TE_ID)){
                $url = $url.sprintf('&DLT_TE_ID=%s', $DLT_TE_ID);
            }
            
            $curl = curl_init();

            curl_setopt_array($curl, array(
                                    CURLOPT_URL => "http://api.msg91.com/api/v2/sendsms",
                                    CURLOPT_URL => $url,
                                    CURLOPT_RETURNTRANSFER => true,
                                    CURLOPT_ENCODING => "",
                                    CURLOPT_MAXREDIRS => 10,
                                    CURLOPT_TIMEOUT => 30,
                                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                                    //CURLOPT_CUSTOMREQUEST => "POST",
                                    CURLOPT_CUSTOMREQUEST => "GET",
                                    //CURLOPT_POSTFIELDS => json_encode($data),
                                    CURLOPT_SSL_VERIFYHOST => 0,
                                    CURLOPT_SSL_VERIFYPEER => 0,
                /*
                                    CURLOPT_HTTPHEADER => array(
                                            "content-type: application/json"
                                            ),*/
                                    ));

		$response = curl_exec($curl);
		$err = curl_error($curl);

		curl_close($curl);

		/*if ($err) {
			echo "cURL Error #:" . $err;
		} else {
			echo $response;
		}*/
		print_r($response);
	}

    public function generateOTP(){
        $otp = mt_rand(100000,999999);
        return $otp;
    }

    public function verifyOtp(Request $request)
    {
        try {
                    // Validations
        $rules = [
          'mobile'=>'required',
          'otp'=>'required|min:6'
        ];
        $validator = Validator::make($request->all(), $rules);
        if ($validator->fails()) {
          // Validation failed
          return response()->json([
            'status' => 'error',
            'message' => $validator->messages(),
          ]);
        } else {
          $user = Auth::guard('token')->user();
          
          if($user) {
            if(explode(',',$user->mobile)[0]!=$request->mobile)
                return response()->json([
                  'status' => 'error',
                  'message' => 'mobile invalid',
                ]);

            // Verify the otp
            //Log::channel('dailyInfo')->info('input'.strlen(\Illuminate\Support\Facades\Hash::make($request->otp)).'***********'.strlen($user->documentSign->otp));
            if( password_verify($request->otp, $user->documentSign->otp) ) {
                $user->documentSign->signed = 1;
                $user->documentSign->otp = null;
                $user->documentSign->save();

                return response()->json([
                  'status' => 'success',
                ]);
            } else {
              return response()->json([
                'status' => 'error',
                'message' => 'Invalid otp',
              ]);
            }
          } else {
            return response()->json([
              'status' => 'error',
              'message' => 'Please login',
            ]);
          }
        }
        }catch(\Exception $e){
            
            Log::channel('dailyInfo')->info($e);
            return response()->json([
                'status' => 'error',
                'message' => 'Internal Error Please try after some time'
                ]);
        }
    }


    public function isSigned(Request $request)
    {
        $user = Auth::guard('api_mobile')->user();
        if(!$user)
            $user = Auth::guard('api')->user();

        if($user->documentSign&&$user->documentSign->signed){
            return response()->json([
                    'status' => 'success',
                    'signed' => 1
                ], 200);
        }
        return response()->json([
            'status' => 'success',
            'signed' => 0
        ], 200);
    }
    public function sign(Request $request)
    {
        $user = Auth::guard('api_mobile')->user();
        if(!$user)
            $user = Auth::guard('api')->user();

        if($user->documentSign&&$user->documentSign->signed){
            return response()->json([
                    'status' => 'success',
                    'signed' => 1,
                    'message' => 'document already signed'
                ], 200);
        }
        $user->documentSign->signed = 1;
        if($user->documentSign->save()){
            $startDate = \Carbon\Carbon::now();
            $this->email(array('pdf'=>$this->writeAgreementPdf($startDate)), $startDate);
            return response()->json([
                'status' => 'success',
                'signed' => 1,
                'ownerName' => $user->first_name.' '.$user->last_name,
                'lockin' => 6,
                'startDate' => $startDate->format('Y-m-d'),
                'endDate' => $startDate->addYear()->subDay()->format('Y-m-d'),
                'headline' => 'Terms and Conditions',
                'subtext' => $this->getSubtext(Auth::guard('api_mobile')->user()->outlets->first()),
                'text' => $this->getText(Auth::guard('api_mobile')->user()->outlets->first()),
            ], 200);
        }
        return response()->json([
                'status' => 'failure',
                'message' => 'error signing the document'
            ], 200);
    }
    
    public function getHeadline()
    {
        return 'I.	Terms and Conditions';
    }
    public function getSubtext($outlet)
    {
        $user = Auth::guard('api_mobile')->user();
        
        return 'The agreement (“Agreement”) is entered on Dec 23, 2019 (“Signing Date”) by and between OLF STORES AND TECHNOLGIES PVTD LTD, a company registered under the Companies Act, 2013, having its registered office at Krishna Niwas Hills View Colony DD Nagar Gate Number 2 Maharajpura, Gwalior 474020 and '.$outlet->outletName.', being a registered Company, having its registered office at '.$outlet->city.' , '.$outlet->state.'.
            Whereas the Restaurant is in the business of food delivery (“Business”) situated at '.$outlet->city.' , '.$outlet->state.'  under the name and style of '.$outlet->outletName.' since. The restaurant has all necessary legal statutory rights, permissions, approvals, consents and permits for operating the Business as per local, state and central laws.
Details of the Restaurant as provided 
';
    }
    public function getText($outlet)
    {
        $user = Auth::guard('api_mobile')->user();
        return 'Name of the Restaurant : '.$outlet->outletName.'
Legal Entity Name : '.$outlet->companyName.'
Restaurant Address : '.$outlet->address.'
Owner Name : '.$user->first_name.' '.$user->last_name.'
Contact Number : '.$user->mobile.'
Restaurant Opening Time : '.$outlet->openingTime.'
Restaurant Closing Time : '.$outlet->closingTime.'
Delivery Time : '.$outlet->order_timing.'
Min Order Amount : '.$outlet->minOrderAmount.'
Delivery Charges : '.$outlet->deliveryCost.'
FSSAI License : '.$outlet->fssaiNo.'
FSSAI Expiry : '.$outlet->fssaiValidUpto.'
GST Number : '.$outlet->gstNo.'
Agreement Start Date : '.\Carbon\Carbon::now()->format("Y / m / d").'
Agreement End Date : after 1 year
Lock – in Period: 2 months

1.	“OLF “ Appointed above mentioned restaurant as its vendor partner for the areas.
2.	Restaurant has agreed to provide delivery of foods to the customer during the time and the period more particularly as specified above in page no.1 of this agreement.
3.	It is mutually agreed and understood that restaurant shall give at least 3 days prior notice to the OLF in case Restaurant intended to suspended for a particular period /date.  It is further agreed that in case of failure on the part of Restaurant to give prior intimation in this regard then all orders forwarded to the restaurant by OLF during said period shall be treated as non delivery of order and Restaurant shall be liable to pay charges as specified in Penalties to the present agreement.

4.	ThattheOLF STORESshallimmediatelyonreceiptoforderoftheitems
forward the same to the Restaurant along with following details:

a)	Name of thecustomer
b)	Details/ Place ofdelivery
c)	Expected time of delivery ofitem
d)	Price to be charged from the Customer in respect of eachitem
5.	That the Restaurant shall on receipt of order from the OLF STORES shall contact and co-ordinate with the customer at its own cost to ensure timely and effective delivery of food to thecustomer.
6.	That the Restaurant has agreed to implement all basic food safety standards and hygiene during preparation, packing, storage, delivering the food to thecustomers.
7.	That the Restaurant has agreed and assured the OLF STORES to deliver the orders placed upon it to the customers of the OLF STORES at the place, time and price specified by the OLF STORES.
8.	That it has been mutually agreed that time is the essence of each and every delivery and the Restaurant shall make best of its endeavor to make timely delivery to the respective customers of the  OLF STORES.
 
9.	It is mutually agreed and understood that for each non-delivery of the order placed by the customer of the OLF STORES, the Restaurant shall be liable to pay charges to the OLF STORES as specified inCommercial Termsto this present agreement.
10.	That Restaurant shall follow in strict sense all the standards relating to quality of food to be supplied to the Customer / passenger as prescribed by the OLF STORES from time totime.
11.	That Restaurant shall follow in strict sense the display / final product presentation guidelines prescribed by the OLF STORES from time totime.
12.	That Restaurant agrees to use standard Packaging Material i.e. Sealing Machine, Plates (Thali / Mini Thali / Combo), Lid, Roll, Kit, Delivery Bag etc. or any other thing as specified by the OLF STORES from time to time
13.	That Restaurant being Vendor, the OLF STORES in addition to comprehensive support including SMS/ EMAIL/ VOICE CON-CALL Support for Order Fulfillment shall also provide Priority Vendor Assistance Helpline to the Restaurant.
14.	That it is mutually agreed and understood between the parties that for every complaint with respect to quality of food supplied by Restaurant / complaints with respect to service including untimely deliveries / wrong delivery etc., the Restaurant shall be liable to pay charges to the OLF STORES andOLF STORES reserves the right to take the Partner out of its network and / or penalize ,if quality and Vendor feedback is lacking acceptable parameters as specified inCommercial Termsas specified to present agreement.
15.	That it is mutually agreed that after receiving the order from the OLF STORES, if the Restaurant on contacting the customer founds the order to be fake or the customer is not contactable, then the Restaurant shall immediately inform about the same to the Key Account Manager and Vendor Support of the OLF STORES vide email and Tele Call. On said information the OLF STORES shall verify the same and intimate its decision to the Restaurant. It is mutually agreed that every decision of the OLF STORES in this regard shall be final and binding upon the Restaurant.
16.	That the Restaurant shall follow and carry out promotional activities as prescribed by the OLF STORES from time totime.
 
17.	That the Restaurant at all time during the tenure of the present agreement shall maintain bank account active for carrying out transactions with the OLF STORES.
18.	That it has been mutually agreed that the Restaurant during the tenure of present agreement shall not charge from the customers any other price over and above the price specified by the OLF STORES.
19.	That the Restaurant shall deploy the dedicated delivery boys (presentable and trained) for delivering orders to customers of OLF STORES.
20.	That the Restaurant shall have computer and printer installed for carrying out transactions and operations with the OLF STORES.
21.	That the Restaurant agrees to resort to emails for order communication rather than on SMS or Voice Calls from the OLF STORES.
22.	That the Restaurant shall also provide smart phone with active internet connection to the relevant contact person / delivery boys for better ordercommunication.
23.	That the Restaurant agrees to follow Operations SOP / guidelines given by the OLF STORES from time totime.
24.	That the Restaurant has agreed to employ educated and tech savvy staff for better co-ordination with the OLF STORES and itscustomers.
25.	That it is mutually agreed between the parties that the Restaurant shall comply with all laws, rules, regulations, bye-laws etc. including but not limited to provisions of Food Safety & Standards Act of India while performing his obligations under the presentagreement.
26.	That Restaurant has assured the OLF STORES that he has and shall maintain all necessary licenses / permissions to run its said business during the tenure of the present agreement. The Restaurant has further agreed to indemnify and keep OLF STORES indemnified of any loss suffered by the OLF STORES on saidaccount.
27.	That Restaurant has agreed to work diligently and efficiently to protect and promote the interest of the OLF STORES and shall not cause any act which causes any harm to the business / reputation of the OLF STORES. The Restaurant has further agreed to indemnify and keep OLF STORES indemnifiedof any loss suffered by the OLF STORES on saidaccount.
 
28.	That Restaurant shall not transfer, assign his rights or appoint sub-vendors under the present agreement in any mannerwhatsoever.
29.	That the Restaurant hereby agrees and confirms that neither he has nor he will enter into any another business substantially similar to or competitive with the business of the OLF STORES.
30.	That the Restaurantalso agrees to be Dummy Named as “As mentioned above” for the Customer, Website, Android APP, OLF STORES company penal, Any third party penal process and for the official communication of the OLF STORES. In case of any legal disputes both actual name as well as Dummy name of the vendor will beconsidered.


II.	INDEMNIFICATION

Both the parties to the present agreement agree to indemnify and hold the other harmless from anyand all claims, liabilities, damages, taxes, fines, repayment obligations, or expenses, including court costs and reasonable attorney fees (collectively, “Claims”), arising from any act or omission by the indemnifying party or its employees or agents (excepting the indemnified party), or from the indemnifying party’s material breach of thisAgreement.



















III.	COMMERCIALTERMS
1.	That it is agreed that invoice will be generated weekly/monthly basis. If invoice payment is pending from Restaurant end Restaurant is liable to make the payment within 3 days of receipt of invoice via registered email address provided at the time of tie up or change upon request
2.	It is mutually agreed by the Restaurant and OLF STORESthatif payment is pending from OLF STORES end, OLF STORES will make the payment on monthly basis as date decided by OLF STORES in the Bank Account of Restaurant
3.	Penalty would be charged on Vendor Partner based on complaint received by the customer and will be in the ratio of the compensation has been given to thecustomer.
4.	That it is further agreed that the parties shall reconcile their respective account on weekly / monthly basis.
5.	That it has been specifically agreed between the parties that the OLF STORES shall be liable to pay taxes, charges etc. only on the commission part towards each and every delivery and Restaurant shall be solely and individually responsible for all taxes, charges etc. levi-able including but not limited to GST on delivery of food by Restaurant to the Customer/passenger. All such other taxes, charges etc shall be solely borne by the Restaurant and the Restaurant shall keep the OLF STORES indemnified of any such charge, if levied upon the OLF STORES.


IV.	SEVERABILITY

In the event that any of the provisions of this Agreement shall be held by a court or other tribunal of competent jurisdiction to be illegal, invalid, or unenforceable, then such provisions shall be limited or eliminated to the minimum extent necessary so that this Agreement shall otherwise remain in full force and effect.

This Agreement contains the entire and complete terms and conditions agreed upon by the Parties, and supersede any and all prior understandings, promises, representations, and agreements, oral or written, with respect to the subject matter of this Agreement. No modification, change, or waiver of any term of this Agreement shall be valid unless agreed by an authorized representative of both the Parties as per mutual consent.


V.	TERMINATION:
Either Party may terminate this Agreement with a prior written notice of thirty (30) days to the other party. However in cases of violation of terms of agreement by the Second Party, the First Party reserves the right to terminate the agreement without notice period.
It is mutually agreed that the First Party shall on expiry / termination of present agreement shall refund the refundable deposit / balance in current account to the Second Party after deducting its dues, if any. In case the dues are found to be more than the amount of refundable security than the Second Party has agreed to clear the same within 15 days from the date of intimation by First Party to the Second Party.

It is mutually agreed that the First Party reserves its right to terminate the present agreement and penalize the Second Party in case quality and customer feedback lacks beyond acceptable parameters.
It is mutually agreed that the present agreement shall stands automatically terminated without any notice on either of the parties closes down / wind up / dissolve their respective business or either of the parties stops providing the services covered under the present agreement or either of the parties being found to be involved in illegal activities.
VI.	NOTICES

All notices / intimations / updation as required under the present agreement shall be sent at following email id:
OLF STORES	:sVendorsupport@olfstores.com



VII.	FORCE MAJEURE
Neither party to the present agreement shall be responsible to other for any delay caused in performance or non performance due to any causes in the nature of Act of God, War, War like conditions, hostility, riots, civil commotions, floods, fire, earthquake or any other causes or circumstances of whatsoever nature beyond the reasonable control of the parties hereto.



VIII.	GOVERNING LAW, DISPUTE RESOLUTION ANDJURISDICTION

The formation, validity, interpretation, execution, termination of and settlement of disputes which arise under this Agreement shall be governed by and construed in accordance with the laws of India.
In the event of any claim, difference, dispute or controversy arising between the Parties under this Agreement or out of or in connection with this Agreement, including without limitation, the execution, validity, enforcement, breach, performance, interpretation, implementation, alleged material breach, termination or expiration of this Agreement, the Parties shall continue performance of their obligations under this Agreement and shall avoid any action which might hinder the proper performance of the Parties obligations hereunder. Further, the Parties shall sincerely endeavour to resolve the dispute amicably by discussions. However, if the dispute cannot be resolved within thirty (30) days of date of issuance of notice by the party raising the dispute to the Party/Parties, such dispute shall be finally settled, as per the provisions of the Indian Arbitration and Conciliation Act, 1996, by a sole arbitrator to be appointed by the First Party. Official language of the arbitration shall be English and the place of arbitration proceedings shall be Gwalior only. The arbitral award shall be binding on the Parties. The Parties agree that the arbitrator shall also have the power to decide on the costs and reasonable expenses (including reasonable fees of its counsel) incurred in the arbitration and award interest up to the date of the payment of theaward.
';
        
    }
    public function getHtml($startDate)
    {
        return $this->getTextHtml($startDate);
    }
    public function getTextHtml($startDate)
    {
        $user = Auth::guard('api_mobile')->user();
        $outlet = $user->outlets->first();
        $subText = $this->getSubtext($outlet);
        return view('backend.html.document_sign', compact('user','outlet','subText','startDate'))->render();
    }
    
    public function writeAgreementPdf($startDate)
    {
        $user = Auth::guard('api_mobile')->user();
        $outlet = Auth::guard('api_mobile')->user()->outlets->first();
        $outletName = $outlet->outletName;
        
        $pdf = new MYPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false, $startDate, $user->first_name.''.$user->last_name, $user->email, explode(',',$user->mobile)[0]);
        $pdf->SetCreator('Olf Stores');
        $pdf->SetAuthor('Olf Stores');
        $pdf->SetTitle('Olf Vendor Agreement');
        $pdf->SetSubject('Terms & Conditions');
        $pdf->SetKeywords('Agreement, terms, conditions');

        // set default header data
        $logo = 'R.jpg';
        $logoWidth = 15;
        $pdf->SetHeaderData($logo, $logoWidth, 'OLF STORES', 'Krishna Nivas, Hills View Colony, DD Nagar, Gate No. 2, Maharajpura Gwalior'."\nhttps://olfstores.com", array(0,64,255), array(0,64,128));
        //$pdf->setFooterData(array(0,64,0), array(0,64,128));
        $pdf->setFooterData('here', array(0,64,128));
        // set header and footer fonts
        $pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
        $pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

        // set default monospaced font
        $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

        // set margins
        $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
        $pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
        $pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

        // set auto page breaks
        $pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

        // set image scale factor
        $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

        // set some language-dependent strings (optional)
        if (@file_exists(dirname(__FILE__).'/lang/eng.php')) {
            require_once(dirname(__FILE__).'/lang/eng.php');
            $pdf->setLanguageArray($l);
        }

        // ---------------------------------------------------------

        // set default font subsetting mode
        $pdf->setFontSubsetting(true);

        // Set font
        // dejavusans is a UTF-8 Unicode font, if you only need to
        // print standard ASCII chars, you can use core fonts like
        // helvetica or times to reduce file size.
        //$pdf->SetFont('dejavusans', '', 14, '', true);

        // Add a page
        // This method has several options, check the source code documentation for more information.
        $pdf->AddPage();

        // set text shadow effect
        $pdf->setTextShadow(array('enabled'=>true, 'depth_w'=>0.2, 'depth_h'=>0.2, 'color'=>array(196,196,196), 'opacity'=>1, 'blend_mode'=>'Normal'));

        // Set some content to print
        $html = '<p>'.$this->getHtml($startDate).'</p>';
        $pdf->writeHTML($html, true, 0, true, 0);
        $fileName = storage_path() . '/app/'.$outletName.'_Olf Vendor Agreement.pdf';
        $pdf->Output($fileName, 'F');
        
        return $fileName;
    }

    private function email($data, $startDate){
        $pdf = $data['pdf'];
        $y = Auth::guard('api_mobile')->user();
        $x= $y->outlets->first();
        $customerName = $y->first_name.' '.$y->last_name;
        $signingDate = $startDate->format('Y-m-d');
        //Log::channel('dailyInfo')->info('--------------Testing----------------------'.print_r($data,true));
		\Mail::send('mail.document_signed',
			  compact('pdf','customerName','signingDate'),
			   function ($message) use($pdf,$x,$y){
					$message->from('account@olfstores.com', 'OLF STORE');
					$message->sender('account@olfstores.com','OLF STORE');
					$message->to($y->email, $x->outletName);
					$message->bcc(['sanjayjdn@gmail.com','dharam@olfstores.com']);
					$message->subject('Olf Vendor Agreement, Terms and conditions');
                                        $message->attach($pdf, []);
					$message->priority(3);
				});
    }
}
