<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

/*

| "page" | "1" | 
| "size" | "10" | 
| "complainFromDate" | "2019-09-18 06:07 IST" | 
| "complainToDate" | "2019-09-19 06:07 IST" | 
| "paymentType" | "PRE_PAID" | 
| "stationCode" | "PUNE" | 
| "orderId" | "30396956" | 
| "complaintId" | "30426710" | 
| "complaintType" | "FOOD_QUALITY" | 

*/

/*
https://www.olfstores.com/manager/feedback?page=1&size=10&complainFromDate=2019-09-18&complainToDate=2019-09-18&paymentType=PRE_PAID&stationCode=PUNE&orderId=303956&complaintId=3042610&complainType=FOOD_QUALITY
*/

class FeedbackController extends Controller
{
    
    
    
    private function getAssets() {
    
    return [
    config('constkeys.irctc_base_url')."/api/v1/feedback",
    config('constkeys.irctc_token')
     ];
    }
    
    
    private function getStagging(){
    return [
    config('constkeys.irctc_base_url')."/api/v1/feedback",
    config('constkeys.irctc_token')
    ];
    }
    
    private function getUrlCreds(){
     $debug = false;
     return $debug ? $this->getStagging() : $this->getAssets();
    }
    
    public function index(Request $request){
    
     $data_ = $request->query();
     $data_['page'] = $data_['page'] ?? 1;
     $data_['size'] = $data_['size'] ?? 30;
     
     $qs = http_build_query($data_);
     
     $url = $this->getURLCreds()[0].'?'.$qs;
     
     $ch = curl_init();
     
     curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
     curl_setopt($ch, CURLOPT_URL, $url);
     curl_setopt($ch, CURLOPT_HTTPHEADER, array('Authorization: ' . $this->getURLCreds()[1]));
     
     $data = curl_exec($ch);

     
     curl_close($ch);
     
     return response($data)
            ->header('Content-Type', 'application/json');  
    }
    
    public function feedback_view(){
        return view('backend.feedbacks.index');
    }
    
    
    public function exportCSV(Request $request){
    
     $data_ = $request->query();
     $data_['page'] = $data_['page'] ?? 1;
     $data_['size'] = $data_['size'] ?? 500;
     
     $qs = http_build_query($data_);
     
     $url = $this->getURLCreds()[0].'?'.$qs;
     
     $ch = curl_init();
     
     curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
     curl_setopt($ch, CURLOPT_URL, $url);
     curl_setopt($ch, CURLOPT_HTTPHEADER, array('Authorization: ' . $this->getURLCreds()[1]));
     
     $data = curl_exec($ch);

     
     curl_close($ch);
     
     $_data = json_decode($data, true);
     $_result = $_data['result'];
     
     $_uncleaned = $_result['feedbacks'];
     
     $_cleaned = array_map(function($entry){
        return array_map(function($_e){
            if($_e == null)
                return "";
              return $_e;
        }, $entry);
     }, $_uncleaned);
     
     
     $_delimeter = ";";
     $_filename = sprintf("export_%s.csv", \Carbon\Carbon::now());
     
     header("Content-type: application/csv");
     header("Content-Disposition: attachment; filename={$_filename}");
     $fp = fopen('php://output', 'w');

    fputcsv($fp, array_keys($_cleaned[0]));
    foreach ($_cleaned as $row) {
        fputcsv($fp, $row);
    }
    
    fclose($fp);
     
    

      
    }
    
    
    private function queryReports($crit = []){
    
    
    
         $data_ = $crit;
         $data_['page'] = $data_['page'] ?? 1;
         $data_['size'] = $data_['size'] ?? 1000;
                 
         $qs = http_build_query($data_);
         
         $url = $this->getURLCreds()[0].'?'.$qs;
         
         $ch = curl_init();
         
         curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
         curl_setopt($ch, CURLOPT_URL, $url);
         curl_setopt($ch, CURLOPT_HTTPHEADER, array('Authorization: ' . $this->getURLCreds()[1]));
         
         $data = curl_exec($ch);

         
         curl_close($ch);
         
     $_data = json_decode($data);
     
     return $_data;
    }
    
    public function exportReports(Request $request){
    
     
    /*
     $_result = $_data['result'];
     
     $_uncleaned = $_result['feedbacks'];
     
     $_cleaned = array_map(function($entry){
        return array_map(function($_e){
            if($_e == null)
                return "";
              return $_e;
        }, $entry);
     }, $_uncleaned);
     
     
     $_delimeter = ";";
     $_filename = sprintf("report_%s.csv", \Carbon\Carbon::now());
     
     header("Content-type: application/csv");
     header("Content-Disposition: attachment; filename={$_filename}");
     $fp = fopen('php://output', 'w');

    fputcsv($fp, array_keys($_cleaned[0]));
    foreach ($_cleaned as $row) {
        fputcsv($fp, $row);
    }
    
    fclose($fp);
     
    */
    
    
    
    $_14d = $this->queryReports([
        'complainFromDate'=> \Carbon\Carbon::now()->subDays(29)->format('Y-m-d H:i')." IST"
    ]);
     
    $data = collect($_14d->result->feedbacks)
                    ->map(function($a){
                        $a->check = \Carbon\Carbon::parse($a->createdAt)->timezone('Asia/Kolkata');
                        $a->createdAt = \Carbon\Carbon::parse($a->createdAt)->timezone('Asia/Kolkata')->format('Y-m-d H:i');
                        
                        return $a;
                    })->groupBy('outletName')->map(function($col){
                        return [
                        '__7' => $this->calculateRating($col->where('check', '>=', \Carbon\Carbon::now()->subDays(7))),
                        '__14' => $this->calculateRating($col->where('check', '>=', \Carbon\Carbon::now()->subDays(14))),
                        '__a' => $this->calculateRating($col),
                        '__7c' => $this->calculatePercentage($col->where('check', '>=', \Carbon\Carbon::now()->subDays(14))),
                        '__14c'=> $this->calculatePercentage($col->where('check', '>=', \Carbon\Carbon::now()->subDays(14))),
                        '__ac' => $this->calculatePercentage($col)
                        ];
                    });
                    
                    
             
                     
                    
    
     if(array_key_exists('exports',$request->query())){
     
    $_delimeter = ";";
     $_filename = sprintf("report_%s.csv", \Carbon\Carbon::now());
     
     header("Content-type: application/csv");
     header("Content-Disposition: attachment; filename={$_filename}");
     $fp = fopen('php://output', 'w');

    fputcsv($fp, ['Outlet', 'Avg (7 days)', 'Avg (14 days)', 'Avg (30 days)', 'Complain % (7 days)','Complain % (14 days)' , 'Complain % (30 days)']);
    foreach ($data as $key => $value) {
        fputcsv($fp, [$key, $value['__7'][0], $value['__14'][0], $value['__a'][0], $value['__7c'][0], $value['__14c'][0], $value['__ac'][0]]);
    }
    
    fclose($fp);
     
        
     }else{
        return view('backend.feedbacks.reports', compact('data'));
     }

      
    }
    
    private function calculatePercentage($col){
        
        $pMap = ['#006400','green','yellow','orange','red'];
        
        $complaints =  $col->filter(function($rec){
            return $rec->complain;
        });
        
        $totalfeedbacksCount = $col->count();
        
        $totalComplainCount = $complaints->count();
        
        if($totalComplainCount <1 || $totalfeedbacksCount < 1)
            return 0;
         $result =  round(($totalComplainCount / $totalfeedbacksCount) * 100, 2); 
         
         return [
              $result,
              $this->calcColor($result/10, ($pMap)),
        ];
    } 
    
    private function calculateRating($coll){
        
            $pMap = ['#006400','green','yellow','orange','red'];
            
            $ratings = $coll->pluck('starRating')->filter(function($a){
                  return $a !== null;
             });
                        
            $count = $ratings->count();
            $sum  = $ratings->sum();
            
            $result = round($count > 0 ? $sum / $count : $count, 2);
            
            return [
                $result,
                $this->calcColor($result, array_reverse($pMap))
            ];
                      
    }
    
    private function calcColor($value, $colorMap){
        
        if($value == 0){
            return '#f00';
        } 
        
        if($this->in_range(1,2.0, $value)){
            return $colorMap[0];
        }
     else if($this->in_range(2.1 , 4.0 , $value)){
            return $colorMap[1];
        } else if($this->in_range(4.1, 6.0, $value)){
            return $colorMap[2];
        } else if($this->in_range(6.1, 8.0, $value)){
            return $colorMap[3];
        } else {
            return $colorMap[4];
        }
        
    }
    
    private function in_range($min, $max, $value){
        
        return ($min >= $value) && ($value <= $max);
        
    }
    
}
