<?php namespace App\Http\Controllers;

use App\Http\Requests;
use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

class FrontendController extends Controller {

	/**
	 * Display a listing of the resource.
	 *
	 * @return Response
	 */
	public function processSearch(Request $request){
		$type= $request->input('type');
		switch ($type) {
			case 'train':
				return view('frontend.searchByTrain');

			case 'byPNR':
				# code...
				return view('frontend.searchByPNR');
			
			case 'byStation':
				# code...
				return view('frontend.searchByStation');			

		}
		
	}


	public function vendorMenu(Request $request, $id="1")
	{
		return view('frontend.menu',['id'=>'id']);
	}
	
	public function vendorLogin(Request $request){
	    
	    $validator = \Validator::make($request->all(),[
	        'email'=>'required|email',
	        'password'=>'required'
	    ]);
	    
	    
	       
	   if ($validator->fails()) {
            return response()->json($validator->errors(), 422);
        }
        
        if(auth()->attempt($validator->getData())){
            $u = auth()->user();
            $data = [
                'id'=>$u->id,
                'email'=>$u->email,
                'outlet'=> $u->profile,
                'contact'=>$u->mobile
            ];
            
            return response()->json(compact('data'), 200);
        }else{
            return response()->json(['message'=>'Login Failure.. Invalid Credentials'], 400);
        }
      

	  
	}
	

	public function vendorLogout(){
	    if(auth()->check()){
	        auth()->logout();
	        return response()->json(['message'=>'Already Logged out'], 200);
	    }else{
	        return response()->json(['message'=>'Logged out Successfully'], 200);
	    }
	}
	
	public function isLoggedIn(){
	      return response()->json(['status'=>auth()->check()], 200);
	}
}
