<?php

namespace App\Http\Controllers;

use App\Jobs\NotifyVendorJob;
use App\Models\Order;
use App\Models\VendorOrder;
use Illuminate\Http\Request;
use Auth;
use Exception;
use Log;
use App\Services\WaService;
use Illuminate\Support\Facades\Mail;

class HomeController extends Controller {

	/*
	|--------------------------------------------------------------------------
	| Home Controller
	|--------------------------------------------------------------------------
	|
	| This controller renders your application's "dashboard" for users that
	| are authenticated. Of course, you are free to change or remove the
	| controller as you wish. It is just here to get your app started!
	|
	*/

	/**
	 * Create a new controller instance.
	 *
	 * @return void
	 */
	public function __construct()
	{
		$this->middleware('auth');
	}

	/**
	 * Show the application dashboard to the user.
	 *
	 * @return Response
	 */
	public function index()
	{
            /*
            $user = Auth::guard('vendororder')->user();
            $user1 = Auth::guard('order')->user();
            $user2 = Auth::guard('memoryuser')->user();
            $loggedOut = false;
            if ($user != null) {
                Auth::guard('vendororder')->logout();
                $loggedOut = true;
            }else {
                if($user1!=null){
                    Auth::guard('order')->logout();
                    $loggedOut = true;
                }else if($user2!=null){
                    Auth::guard('memoryuser');
                    $loggedOut = true;
                }
            }
             *
             */

        // if(Auth::user()->hasRole('admin'))
		return redirect('home/admin');
        //     else if(Auth::user()->hasRole('radmin'))
		// return redirect('home/radmin');
        //     else if(Auth::user()->hasRole('vendor'))
		// return redirect('home/vendor');
        //     else if(Auth::user()->hasRole('agent'))
		// return redirect('home/admin');
		//   else if(Auth::user()->hasRole('manager'))
		// return redirect('home/admin');
        //     else if(Auth::user()->hasRole('user'))
		// return redirect('home/user');

        // return view('home');
	}

	public function admin(Request $request)
	{   
        if (hasPermission(['view-order-history'])){

            $confdOrders = app(OutletController::class)->getOrderStats($request);
            $today = \Carbon\Carbon::today()->startOfDay()->format("m/d/Y");
            $request->merge(['date' => $today, 'object' => true]);
            $controller = app()->make('\App\Http\Controllers\OrderController');
            //app()->call([$controller, 'orders'], $arguments);
            //$orders = []; //$controller->callAction('orders',[$request,'none','none']);
            // $orders = $controller->callAction('orders',[$request,'none','json']);
     
            $orders = $controller->callAction('orders',[$request,'none','none']);
           
            //Log::channel('dailyInfo')->info('orders'.print_r($orders,true));
            //Log::channel('dailyInfo')->info($confdOrders);
      
            $start=$confdOrders[5];
            $end=$confdOrders[6];
            $orders=$orders;
        }
        else{

            $start=null;
            $end=null;
            $orders=null;
            $confdOrders=null;
        }

        return view('backend.admins.home',['confdOrders'=>$confdOrders,'start'=>$start,'end'=>$end,'orders'=>$orders]);
    }

	public function vendor(Request $request)
	{
            if(!$request->has('outletId')){
                $out = \App\Models\Outlet::where('user_id',auth()->user()->id)->first();
                $outletId = $out->id;
                $request->request->add(['outletId', $outletId]);
            }else{
                $outletId = $request->input('outletId');
            }
            $confdOrders = app(OutletController::class)->getOrderStats($request);
            //Log::channel('dailyInfo')->info($confdOrders);
            return view('backend.vendors.home',['confdOrders'=>$confdOrders,'outletId'=>$outletId,'start'=>$confdOrders[5],'end'=>$confdOrders[6]]);
        }
	public function radmin(Request $request)
	{
            return view('backend.radmins.home');
        }
	public function agent(Request $request)
	{
            return view('backend.agents.home');
        }
	public function user(Request $request)
	{
            return view('backend.users.home');
    }


    private function sendVendorEmail($data)
	{	
		$aggrigator = json_decode($data['aggregatorDetails']);

		$delivery = json_decode($data['deliveryDetails']);
		$customerIRCTC = json_decode($data['customerDetails']);
		$pricing = json_decode($data['priceDetails']);
		$items = json_decode($data['orderItems']);
		$orderId = $data['orderId'];
		$bookingDate = $data['bookingDate'];
		$deliveryDate = $data['deliveryDate'];
		$paymentType = $data['paymentType'];


		if (array_key_exists('comment', $data))
			$comment = $data['comment'];
		else
			$comment = '';


		try {
			Mail::send(
				'mail.irctc_vendor_email',
				compact('aggrigator', 'delivery', 'customerIRCTC', 'items', 'orderId', 'bookingDate', 'deliveryDate', 'paymentType', 'pricing', 'comment'),
				function ($message) use ($customerIRCTC, $aggrigator, $orderId) {
					$x = \App\Models\Outlet::find($aggrigator->outletId);
					$y = \App\Models\User::find($x->user_id);
					$message->from('no-reply@olfstores.com', 'OLF STORE');
					$message->sender('no-reply@olfstores.com', 'OLF STORE');
					$message->to($y->email, $x->outletName);
					//$message->cc($customerIRCTC->email, $customerIRCTC->customerName);
					$message->bcc('sanjayjdn@gmail.com', 'Sanjay Jadon');
					$message->subject('ORDER ID:' . $orderId);
					$message->priority(3);
				}
			);
		} catch (\Throwable $th) {
			throw $th;
		}
	}


    public function NotifyVendor($orderid,$order_source){

        if($order_source=="OLF"){
            
            try{

                $order = \App\Models\VendorOrder::where('orderId', $orderid)->first();
                dispatch(new NotifyVendorJob($order));

                return back()->with('success', 'Notification send to vendor successfully.');
            }
            catch(Exception $e){

                return back()->with('error', 'Notification send failed.');
            }
           
        }
        else{

            try{

                $order = \App\Models\Order::where('orderId', $orderid)->first()->toArray(); 

                $this->sendVendorEmail($order);
                
                return back()->with('success', 'Notification send to vendor successfully.');
            
            }
            catch(Exception $e){
                dd($e->getMessage());
                return back()->with('error', 'Notification send failed.');
            }

        }
    }


}
