<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Http\Requests;
use File;
use Log;

class ImportDataController extends Controller{

    public function index($outletId){
        return view('imports.menus.index',compact('outletId'));
    }

    public function import(Request $request, $outletId)
    {
        if($request->filled('export')&&$request->input('export')==1)
            $export = 1;
        else
            $export = 0;
            
        if($export==0){
            $item = new \App\Imports\MenuItem;
            $item->setOutlet($outletId);
            $item->import($request->file('csv_file')); 

            session()->flash('success', 'Import successful.');
            return redirect()->back();
        }else
            return $this->exportMenuItem($request, $outletId);
    }

    public function exportMenuItem(Request $request, $outletId)
    {
        $outlet = \App\Models\Outlet::find($outletId);
        $items = $outlet->menu->items->toArray();
        $items = $outlet->menu->items->map(function ($item){
            $excelDateValue = \PhpOffice\PhpSpreadsheet\Shared\Date::dateTimeToExcel(\Carbon\Carbon::createFromFormat('H:m',$item['openingTime'])->setDate(1970, 1, 1));
            //$excelDateValue = \PhpOffice\PhpSpreadsheet\Shared\Date::dateTimeToExcel(new \DateTime($item['openingTime']));
            $item['openingTime'] = $excelDateValue;
            $excelDateValue1 = \PhpOffice\PhpSpreadsheet\Shared\Date::dateTimeToExcel(\Carbon\Carbon::createFromFormat('H:m',$item['closingTime'])->setDate(1970, 1, 1));
            //$excelDateValue1 = \PhpOffice\PhpSpreadsheet\Shared\Date::PHPToExcel(\Carbon\Carbon::createFromFormat('H:m',$item['closingTime']));
            $item['closingTime'] = $excelDateValue1;
            unset($item['itemId']);
            unset($item['menu_id']);
            unset($item['outlet_id']);
            unset($item['options']);
            unset($item['baseOption']);
            unset($item['image']);
            unset($item['created_at']);
            unset($item['updated_at']);
            return $item;
        });
        $export = new \App\Exports\MenuItemExcel($items->toArray());
        $excelFile = 'menuitems_'.$outlet->outletName.'-'. \Carbon\Carbon::now()->format('Y-M-d').'.xlsx';
        \Excel::store($export, $excelFile);
        $headers = [
              'Content-Type' => 'application/vnd.ms-excel; charset=utf-8',
           ];
        return response()->download(storage_path().'/app/'.$excelFile, $excelFile, $headers);
    }

    public function importDeliveryBoy(Request $request, $outletId)
    {
        $item = new \App\Imports\DeliveryBoy;
        $item->setClassName1('DeliveryBoy');
        $item->setOutlet($outletId);
        $item->import($request->file('csv_file'));    
        
        session()->flash('success', 'Import successful.');
        return redirect()->back();
    }
}
