<?php

namespace App\Http\Controllers;

use App\Exports\ConsolidatedReport;
use Illuminate\Http\Request;

use App\Http\Requests;
use App\Models\Outlet;
use File;
use Mail;
use BeyondCode\Vouchers\Models\Voucher;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;
use Illuminate\Support\Facades\Log;
use DB;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Worksheet\HeaderFooter;
use PhpOffice\PhpSpreadsheet\Worksheet\HeaderFooterDrawing;
use PhpOffice\PhpSpreadsheet\Worksheet\PageSetup;
define('K_PATH_IMAGES', $_SERVER['DOCUMENT_ROOT'].'/trains/storage/app/images/');

use TCPDF;
use ZipArchive;

class InvoiceController extends Controller
{

    public function index($outletId)
    {
        return view('backend.invoice.index', compact('outletId'));
    }
    public function index1($outletId)
    {   
        $outlet = \App\Models\Outlet::find($outletId);
        switch ($outlet->invoice_frequency) {
            case 0:
                $endDate = '';
                break;
            case 1:
                $endDate = $outlet->startDate->addDays(6)->format('m/d/Y');
                break;
            case 2:
                $endDate = $outlet->startDate->addMonth()->subDay()->format('m/d/Y');
                break;
            default:
                $endDate = '';
        }
        $invoices = $outlet->invoices;
        foreach ($invoices as $invoice);
        if (!isset($invoice)) {
            $invoice = new \stdClass();
            $invoice->payable = 0;
            $invoice->previous_balance = 0;
            $invoice->amount_paid = 0;
        }
    
        return view('backend.invoice.index1', ['outletId' => $outletId, 'invoices' => $outlet->invoices, 'invoice1' => $invoice, 'startDate' =>date('m/d/Y', strtotime($outlet->startDate)), 'frequency' => $outlet->invoice_frequency, 'endDate' => $endDate]);
    }
    public function index2(Request $request, $start = 1, $end = 50, $total = null)
    {
        switch ($request->method()) {
            case 'POST':
                $startDate = $request->input('startDate');
                $endDate = $request->input('startDate');
                if ($request->submit == "next") {
                    $start += 50;
                    $end = $start + 50 - 1;
                } else if ($request->submit == "previous") {
                    $start -= 50;
                    $end = $start + 50 - 1;
                }
                break;

            case 'GET':
                $startDate = null;
                $endDate = null;

                break;

            default:
                // invalid request
                break;
        }
        if ($start == 1)
            $total = \App\Models\Outlet::count();
        if ($end > $total)
            $end = $total;
        if ($start > $total)
            $outlets = null;
        else
            $outlets = \App\Models\Outlet::skip($start - 1)->take($end - $start + 1)->get();
        $pageCount = (int)($total / 50) + 1;
        $outlets = $outlets->map(function ($outlet) {
            foreach ($outlet->invoices as $invoice);
            if (!isset($invoice)) {
                $outlet->currentInvoice1 = 0;
                $outlet->openingBalance1 = $outlet->openingBalance;
            } else {
                $outlet->currentInvoice1 = $invoice->payable;
                $outlet->openingBalance1 = $invoice->previous_balance;
            }
            $outlet->total1 = $outlet->openingBalance1 + $outlet->currentInvoice1;
            return $outlet;
        });

        return view('backend.invoice.index2', ['outlets' => $outlets, 'pageCount' => $pageCount, 'start' => $start, 'end' => $end, 'total' => $total, 'startDate' => $startDate, 'endDate' => $endDate]);
    }
    public function getOrder($orderId, $vendorOrder)
    {
        if ($vendorOrder) {
            $order = \App\Models\VendorOrder::where('orderId', $orderId)->first();
            $order = \App\Models\VendorOrder::where('orderId', $orderId)->first();

            $deliveryDetails = new \stdClass;
            $deliveryDetails->pnr = $order->pnr;
            $deliveryDetails->trainNo = $order->trainNo;
            $deliveryDetails->trainName = $order->trainName;
            $deliveryDetails->station = $order->stationName;
            $deliveryDetails->stationCode = $order->stationCode;
            $deliveryDetails->berth = $order->berth;
            $deliveryDetails->coach = $order->coach;
            $deliveryDetails->ETA = $order->deliveryDate;
            $order->deliveryDetails = json_encode($deliveryDetails);

            $order->customerDetails = json_decode($order->customer);
            $order->customerDetails->customerName = $order->customerDetails->fullName;
            $order->customerDetails = json_encode($order->customerDetails);

            $priceDetails = new \stdClass;
            $priceDetails->totalAmount = $order->totalAmount;
            $order->priceDetails = json_encode($priceDetails);

            $order->outletDetails = \App\Models\Outlet::find($order->outlet);
            $order->outletDetails->deliveryBoys1 = $order->outletDetails->deliveryBoys;
            if ($order->deliveryBoy != null) {
                $deliveryBoy = \App\Models\DeliveryBoy::find($order->deliveryBoy);
                $order->deliveryBoyName = $deliveryBoy->first_name . ' ' . $deliveryBoy->last_name;
            } else
                $order->deliveryBoyName = '';
            $order->vendorOrder = true;
        } else {
            $order = \App\Models\Order::where('orderId', $orderId)->first();
            $deliveryDetails = json_decode($order->deliveryDetails);
            $order->outletDetails = \App\Models\Outlet::find($order->outlet_id);
            $order->outletDetails->deliveryBoys1 = $order->outletDetails->deliveryBoys;
            if ($order->deliveryBoy != null) {
                $deliveryBoy = \App\Models\DeliveryBoy::find($order->deliveryBoy);
                $order->deliveryBoyName = $deliveryBoy->first_name . ' ' . $deliveryBoy->last_name;
            } else
                $order->deliveryBoyName = '';
            $order->vendorOrder = false;
        }
        $order->aggregatorDetails = json_decode($order->aggregatorDetails);
        $order->customerDetails = json_decode($order->customerDetails);
        $order->priceDetails = json_decode($order->priceDetails);
        $order->orderItems = json_decode($order->orderItems);

        return $order;
    }

    public function updatePaymentStatus(Request $request)
    {
        if ($request->has('orderId') && $request->has('paymentType')) {
            $orderId = $request->input('orderId');
            $paymentStatus = $request->input('paymentType');
            $paymentReason = $request->input('paymentReason');
            $vendorOrder = $request->input('vendorOrder');

            if ($vendorOrder)
                $order = \App\Models\VendorOrder::where('orderId', $orderId)->first();
            else
                $order = \App\Models\Order::where('orderId', $orderId)->first();
            if (!$order)
                response(['message' => 'order not found'], 200);
            $order->paymentType = $paymentStatus;
            $order->paymentReason = '';
            if ($request->has('paymentReason'))
                $order->paymentReason = $paymentReason;

            $invoiceItem = \App\Models\InvoiceItem::where('orderId', $orderId)->first();
            if ($invoiceItem) {
                $invoice = \App\Models\Invoice::find($invoiceItem->invoice_id);
                $invoiceItem->trasactionType = $paymentStatus;
                $lastInvoice = false;
                
                $outlet = Outlet::find($order->outlet_id);

                foreach ($outlet->invoices as $invoice1);
                if (isset($invoice1) && $invoice->id == $invoice1->id) {
                    $lastInvoice = true;
                }

                if ($invoiceItem->trasactionType == 'PRE_PAID') {
                    $invoiceItem->debit += $invoiceItem->credit;
                    $invoice->totalDebit += $invoiceItem->credit;
                    $invoice->payable += $invoiceItem->credit;
                    $invoice->online_payments -= $invoiceItem->credit;
                    if ($lastInvoice)
                        $outlet->openingBalance += $invoiceItem->credit;
                    $invoiceItem->credit = 0;
                } else {
                    $invoiceItem->credit += $invoiceItem->debit;
                    $invoice->totalCredit += $invoiceItem->debit;
                    $invoice->payable -= $invoiceItem->debit;
                    $invoice->online_payments += $invoiceItem->debit;
                    if ($lastInvoice)
                        $outlet->openingBalance -= $invoiceItem->debit;
                    $invoiceItem->debit = 0;
                }
                $invoiceItem->save();
                $invoice->save();
                $outlet->save();
            }
            $order->save();
            return response()->json(['status' => 0, 'order' => $this->getOrder($orderId, $vendorOrder), 'message' => 'Order payment type updated successfully'], 200);
        }
        return response()->json(['status' => 1, 'message' => 'request parameters missing'], 200);
    }
    public function excelAllOutletsExcel(Request $request)
    {

        // Execute the query used to retrieve the data. In this example
        // we're joining hypothetical users and payments tables, retrieving
        // the payments table's primary key, the user's first and last name,
        // the user's e-mail address, the amount paid, and the payment
        // timestamp.

        // Define the Excel spreadsheet headers
        //$paymentsArray[] = ['Serial No.','Order Id','Outlet Name','Customer','Item','Delivery Date','Delivery Station','Transaction Type','Order Status','Vendor Payment','Vendor Collection','GST','Debit','Credit','Commision'];
        //$header = ['Outlet Name', 'Start Date', 'Opening Balance', 'Current Invoice', 'Total Outstanding'];
        // Convert each member of the returned collection into an array,
        // and append it to the payments array.
        $outlets = \App\Models\Outlet::all()->map(function ($outlet) {
            foreach ($outlet->invoices as $invoice);
            $outlet1 = array();
            //$outlet1[] = $header;
            $outlet1['Outlet Name'] = $outlet->outletName;
            $outlet1['Start Date'] = $outlet->startDate;
            $outlet1['Opening Balance'] = $invoice->previous_balance;
            $outlet1['Current Invoice'] = $invoice->payable;
            $outlet1['Total Outstanding'] = $invoice->previous_balance + $invoice->payable;
            return $outlet1;
        })->toArray();

        //print_r($invoice);
        // Generate and return the spreadsheet
        $export = new \App\Exports\InvoicesExcelAllOutlets($outlets);
        $excelFile = $this->sanitizeFilename('outlets-invoices-' . \Carbon\Carbon::now()->format('Y-M-d')) . '.xlsx';
        \Excel::store($export, $excelFile);
        $headers = [
            'Content-Type' => 'application/vnd.ms-excel; charset=utf-8',
        ];

        return response()->download(storage_path() . '/app/' . $excelFile, $excelFile, $headers);
    }
    public function generateInvoiceAll(Request $request)
    {
        $selectAll = $request->input('outlet_id_select');
        if (!isset($selectAll))
            return redirect()->back();
        //$selectAll = Input::get('outlet_id_select');

        $outlet_ids = $request->input('outlet_id');
        $startDate = $request->input('startDate');
        $endDate = $request->input('endDate');

        //$outlet_ids = Input::get('outlet_id');
        $sel_outlet_ids = array();
        $i = 0;
        foreach ($selectAll as $select) {
            $this->getInvoice3($select, $startDate, $endDate);
            $i++;
        }
        session()->flash('success', 'Invoice generated successfully.');
        return redirect()->back();
        //return response(['status'=>'success'],200);

    }
    public function getInvoice3($outletId, $startDate, $endDate)
    {
        try {
            //$this->authorize('pol_view_invoice', \App\Outlet::find($outlet));
            $outlet = \App\Models\Outlet::find($outletId);
            if (\Carbon\Carbon::createFromFormat('m/d/Y', $startDate)->startOfDay()->gt(\Carbon\Carbon::now())) {
                session()->flash('success', 'Invoice can\'t be generated for future date.');
                return redirect()->back();
            }
            $orders = $this->calculateInvoice($this->getCostPrice($outletId, $startDate, $endDate));
            $invoice = $this->cleanInvoiceFields($orders);
            $debitError = false;
            $creditError = false;
            $totalDebit = collect($invoice)->sum(function ($ii) {
                if (isset($ii->debit) && $ii->debit != '')
                    return $ii->debit;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $totalCredit = collect($invoice)->sum(function ($ii) {
                if (isset($ii->credit) && $ii->credit != '')
                    return $ii->credit;
                else {
                    $creditError = true;
                    return 0;
                }
            });
            $totalCommision = collect($invoice)->sum(function ($ii) {
                if (isset($ii->commision) && $ii->commision != '')
                    return $ii->commision;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $totalGst1 = collect($invoice)->sum(function ($ii) {
                if (isset($ii->gst) && $ii->gst != '')
                    return $ii->gst;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $onlinePayment = collect($invoice)->sum(function ($ii) {
                if (isset($ii->onlinePayment) && $ii->onlinePayment != '')
                    return $ii->onlinePayment;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            
            $totalAmount = ($totalDebit - $totalCredit) + ($totalCommision * 0.18);
            #$totalAmount = round(($totalDebit - $totalCredit) - $totalGst1);
            
            $totalGst = $totalCommision * 0.18;
            
            $error = '';
            
            if ($debitError)
                $error .= 'debit error ';
            if ($creditError)
                $error .= 'debit error';
            $totalAmount1 = array(
                'debit' => $totalDebit,
                'credit' => $totalCredit,
                'commision' => $totalCommision,
                'totalGst' => $totalGst,
                'totalGst1' => $totalGst1,
                'onlinePayment' => $onlinePayment,
                'total' => floatval($totalAmount- $totalGst1)
            );
            //$this->excel($invoice, $totalAmount, $debit, $credit, $error);
            $outletName = $outlet->outletName;
            $openingBalance = $outlet->openingBalance;
            foreach ($outlet->invoicesStartDate as $invoiceD);
            if (isset($invoiceD))
                $invoiceD->delete();
            else {
                foreach ($outlet->invoices as $invoice23);
                if (isset($invoice23)) {
                    if (!isset($invoice23->payments) || $invoice23->payments->count() == 0)
                        $openingBalance = $invoice23->payable + $invoice23->previous_balance - $invoice23->amount_paid;
                    $openingBalance1 = $openingBalance;
                }
            }
            $row = ['date' => \Carbon\Carbon::now(), 'period_start' => \Carbon\Carbon::createFromFormat('m/d/Y', $startDate, 'Asia/Kolkata'), 'period_end' => \Carbon\Carbon::createFromFormat('m/d/Y', $endDate, 'Asia/Kolkata'), 'outlet_id' => $outletId, 'outlet_name' => $outletName, 'gstin_outlet' => $outlet->gstNo, 'commision' => $totalAmount1['commision'], 'igst' => $totalAmount1['totalGst'], 'month_payable' => round($totalAmount1['commision'] + $totalAmount1['totalGst'] + $totalAmount1['totalGst1']), 'previous_balance' => $openingBalance, 'online_payments' => $totalAmount1['onlinePayment'], 'payable' => round($totalAmount1['commision'] + $totalAmount1['totalGst'] + $totalAmount1['totalGst1'] - $totalAmount1['onlinePayment']), 'total_debit' => $totalAmount1['debit'], 'total_credit' => $totalAmount1['credit']];
            
            
            $invoice1 = $outlet->invoices()->firstOrCreate($row);
            foreach ($invoice as $item) {
                unset($item->serialNo);
                unset($item->outletName);
                unset($item->onlinePayment);
                $invoice1->items()->firstOrCreate(get_object_vars($item));
            }
            $outlet->startDate = \Carbon\Carbon::createFromFormat('m/d/Y', $endDate, 'Asia/Kolkata')->addDay()->startOfDay();
            if (isset($openingBalance1))
                $outlet->openingBalance = $openingBalance;
            //\App\Outlet::where('id',$outlet->outletId)->update(['startDate'=>\Carbon\Carbon::createFromFormat('m/d/Y', $startDate, 'Asia/Kolkata')->startOfDay()]);
            $outlet->save();
        } catch (\Exception $e) {
            dd($e);
            return response(['message' => 'invalid request'], 200);
        }
    }
    public function setFrequency(Request $request, $outletId)
    {
        if (!isset($outletId) || !$request->filled('invoice_frequency')) {
            session()->flash('error', 'Request input parameters are missing.');
            return redirect()->back();
        }
        $outlet = \App\Models\Outlet::find($outletId);
        $outlet->invoice_frequency = $request->input('invoice_frequency') - 1;
        $outlet->save();
        session()->flash('success', 'Invoice frequency set successfully for ' . $outlet->outletName);
        return redirect()->back();
    }
    public function delete(Request $request, $invoiceId)
    {
        if (!isset($invoiceId)) {
            session()->flash('error', 'Request input parameters are missing.');
            return redirect()->back();
        }
        $invoice = \App\Models\Invoice::find($invoiceId);
        if ($invoice->payments->count() != 0) {
            session()->flash('error', 'Invoice has a amount paid, cant be deleted');
            return redirect()->back();
        }
        $outlet = \App\Models\Outlet::find($invoice->outlet_id);
        $outlet->startDate = $invoice->period_start;
        $outlet->save();
        $invoice->delete();
        session()->flash('success', 'Invoice deleted successfully');
        return redirect()->back();
    }
    public function getInvoice1($outletId, $startDate, $endDate, $store)
    {
        try {
            $orders = $this->calculateInvoice($this->getCostPrice($outletId, $startDate, $endDate));
            $invoice = $this->cleanInvoiceFields($orders);
            $debitError = false;
            $creditError = false;
            $totalDebit = collect($invoice)->sum(function ($ii) {
                if (isset($ii->debit) && $ii->debit != '')
                    return $ii->debit;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $totalCredit = collect($invoice)->sum(function ($ii) {
                if (isset($ii->credit) && $ii->credit != '')
                    return $ii->credit;
                else {
                    $creditError = true;
                    return 0;
                }
            });
            $totalCommision = collect($invoice)->sum(function ($ii) {
                if (isset($ii->commision) && $ii->commision != '')
                    return $ii->commision;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $totalGst1 = collect($invoice)->sum(function ($ii) {
                if (isset($ii->gst) && $ii->gst != '')
                    return $ii->gst;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $onlinePayment = collect($invoice)->sum(function ($ii) {
                if (isset($ii->onlinePayment) && $ii->onlinePayment != '')
                    return $ii->onlinePayment;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $totalAmount = round($totalDebit - $totalCredit + $totalCommision * 0.18);
            $totalGst = $totalCommision * 0.18;
            $error = '';
            if ($debitError)
                $error .= 'debit error ';
            if ($creditError)
                $error .= 'debit error';
            $totalAmount1 = array(
                'debit' => $totalDebit,
                'credit' => $totalCredit,
                'commision' => $totalCommision,
                'totalGst' => $totalGst,
                'totalGst1' => $totalGst1,
                'onlinePayment' => $onlinePayment,
                'total' => $totalAmount+$totalGst1
            );
            //$this->excel($invoice, $totalAmount, $debit, $credit, $error);
            if ($request->filled('redirect') && $request->input('redirect') == true)
                return $totalAmount1;

            else $this->excel($invoice, $totalAmount1, $store);
        } catch (\Exception $e) {
            dd($e);
            return response(['message' => 'invalid request'], 200);
        }
    }
    public function sendInvoiceTest(Request $request)
    {
        $start = \Carbon\Carbon::now()->subWeek(1)->format('m/d/Y');
        $end = \Carbon\Carbon::now()->subDay(1)->format('m/d/Y');
        $request->request->add(['outletId' => 4, 'startDate' => $start, 'endDate' => $end]);
        //$controller = app()->make('\App\Http\Controllers\InvoiceController');
        return $this->exportPDF($request);
        //$controller->callAction('exportPDF',$request);
        /*
        \App\Outlet::all()
        ->map(function($el)use($start,$end){
            $controller = app()->make('\App\Http\Controllers\InvoiceController');
            $controller->callAction('exportPDF',['outletId'=>$el->id,'startDate'=>$start,'endDate'=>$end]);
        });
         *
         */
    }

    public function getInvoice(Request $request)
    {
        try {
            //$this->authorize('pol_view_invoice', \App\Outlet::find($outlet));
            $input = $request->all();

            if ($request->filled('outletId'))
                $outletId = $request->input('outletId');
            else
                $outletId = null;
            $outlet = \App\Models\Outlet::find($outletId);
            if ($request->filled('regenerate')) {
                $invoice34 = \App\Models\Invoice::find($request->input('id'));
                $startDate = \Carbon\Carbon::createFromFormat('Y-m-d', $invoice34->period_start)->format('m/d/Y');
                $endDate = \Carbon\Carbon::createFromFormat('Y-m-d', $invoice34->period_end)->format('m/d/Y');
            } else {
                $startDate = $outlet->startDate->format('m/d/Y');
                switch ($outlet->invoice_frequency) {
                    case 0:
                        $endDate = $request->input('endDate');
                        break;
                    case 1:
                        $endDate = $outlet->startDate->addDays(6)->format('m/d/Y');
                        break;
                    case 2:
                        $endDate = $outlet->startDate->addMonth()->subDay()->format('m/d/Y');
                        break;
                    default:
                        $endDate = $request->input('endDate');
                }
            }
            if (\Carbon\Carbon::createFromFormat('m/d/Y', $startDate)->startOfDay()->gt(\Carbon\Carbon::now())) {
                session()->flash('success', 'Invoice can\'t be generated for future date.');
                return redirect()->back();
            }

            $orders = $this->calculateInvoice($this->getCostPrice($outletId, $startDate, $endDate));
            $invoice = $this->cleanInvoiceFields($orders);
            
            
            /* $_invoiceDetails = $this->invoices = collect($invoice)->map(function ($_invoice) {
                $tempered = $_invoice;

                 if ($_invoice->transactionType == 'PRE_PAID') {  
                    $tempered->credit = $_invoice->vendorPayment;
                 }else if($_invoice->transactionType == 'CASH_ON_DELIVERY'){
                     $tempered->debit = ($tempered->debit + $tempered->gst);
                 }
                return $tempered;
            });
 */
          //  $invoice = $_invoiceDetails;
    
            $debitError = false;
            $creditError = false;
            $totalDebit = collect($invoice)->sum(function ($ii) {
                if (isset($ii->debit) && $ii->debit != '')
                    return $ii->debit;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $totalCredit = collect($invoice)->sum(function ($ii) {
                if (isset($ii->credit) && $ii->credit != '')
                    return $ii->credit;
                else {
                    $creditError = true;
                    return 0;
                }
            });
            $totalCommision = collect($invoice)->sum(function ($ii) {
                if (isset($ii->commision) && $ii->commision != '')
                    return $ii->commision;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $totalGst1 = collect($invoice)->sum(function ($ii) {
                if (isset($ii->gst) && $ii->gst != '')
                    return $ii->gst;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $onlinePayment = collect($invoice)->sum(function ($ii) {
                if (isset($ii->onlinePayment) && $ii->onlinePayment != '')
                    return $ii->onlinePayment;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $totalAmount = round($totalDebit - $totalCredit + $totalCommision * 0.18);
            $totalGst = $totalCommision * 0.18;
            $error = '';
            if ($debitError)
                $error .= 'debit error ';
            if ($creditError)
                $error .= 'debit error';
            $totalAmount1 = array(
                'debit' => $totalDebit,
                'credit' => $totalCredit,
                'commision' => $totalCommision,
                'totalGst' => $totalGst,
                'totalGst1' => $totalGst1,
                'onlinePayment' => $onlinePayment,
                'total' => $totalAmount
            );

            Log::info($totalAmount);
            Log::info($totalAmount1);
            Log::info($totalDebit - $totalCredit + $totalCommision * 0.18);
            //$this->excel($invoice, $totalAmount, $debit, $credit, $error);
            if ($request->filled('redirect') && $request->input('redirect') == true) {
                if ($request->filled('store') && $request->input('store') == 'true')
                    return $this->excel($invoice, $totalAmount1, 1);
                else
                    return $totalAmount1;
            }
            $outletName = $outlet->outletName;
            if ($request->filled('regenerate')) {
                $openingBalance = $invoice34->previous_balance;
                $invoice34->delete();
            } else {
                $openingBalance = $outlet->openingBalance;
                foreach ($outlet->invoicesStartDate as $invoiceD);
                if (isset($invoiceD))
                    $invoiceD->delete();
                else {
                    foreach ($outlet->invoices as $invoice23);
                    if (isset($invoice23)) {
                        if (!isset($invoice23->payments) || $invoice23->payments->count() == 0)
                            $openingBalance = $invoice23->payable + $invoice23->previous_balance - $invoice23->amount_paid;
                        $openingBalance1 = $openingBalance;
                    }
                }
            }
            /* $row = ['date' => \Carbon\Carbon::now(), 'period_start' => \Carbon\Carbon::createFromFormat('m/d/Y', $startDate, 'Asia/Kolkata'), 'period_end' => \Carbon\Carbon::createFromFormat('m/d/Y', $endDate, 'Asia/Kolkata'), 'outlet_id' => $outletId, 'outlet_name' => $outletName, 'gstin_outlet' => $outlet->gstNo, 'commision' => $totalAmount1['commision'], 'igst' => $totalAmount1['totalGst'], 'month_payable' => $totalAmount1['commision'] + $totalAmount1['totalGst'], 'previous_balance' => $openingBalance, 'online_payments' => $totalAmount1['onlinePayment'], 'payable' => round($totalAmount1['commision'] + $totalAmount1['totalGst'] - $totalAmount1['onlinePayment']), 'total_debit' => $totalAmount1['debit'], 'total_credit' => $totalAmount1['credit']];
            */

            $row = [
                'date' => \Carbon\Carbon::now(),
                'period_start' => \Carbon\Carbon::createFromFormat('m/d/Y', $startDate, 'Asia/Kolkata'), 
                'period_end' => \Carbon\Carbon::createFromFormat('m/d/Y', $endDate, 'Asia/Kolkata'), 
                'outlet_id' => $outletId, 
                'outlet_name' => $outletName, 
                'gstin_outlet' => $outlet->gstNo, 
                'commision' => $totalAmount1['commision'], 
                'igst' => $totalAmount1['totalGst'], 
                'gst1' => $totalAmount1['totalGst1'], 
                'month_payable' => $totalAmount1['commision'] + $totalAmount1['totalGst'], 'previous_balance' => $openingBalance,
                'online_payments' => $totalAmount1['onlinePayment'], 
                'payable' => round($totalAmount1['total']), 
                'total_debit' => $totalAmount1['debit'],
                'total_credit' => $totalAmount1['credit']
            ];
           
            $invoice1 = $outlet->invoices()->firstOrCreate($row);

            foreach ($invoice as $item) {
                unset($item->serialNo);
                unset($item->outletName);
                unset($item->onlinePayment);
                try {
                    $invoice1->items()->firstOrCreate(get_object_vars($item));
                } catch (\Exception $e) {
                    dd(get_object_vars($item));
                }
            }
            if (!$request->filled('regenerate')) {
                $outlet->startDate = \Carbon\Carbon::createFromFormat('m/d/Y', $endDate, 'Asia/Kolkata')->addDay()->startOfDay();
                if (isset($openingBalance1))
                    $outlet->openingBalance = $openingBalance;
                //\App\Outlet::where('id',$outlet->outletId)->update(['startDate'=>\Carbon\Carbon::createFromFormat('m/d/Y', $startDate, 'Asia/Kolkata')->startOfDay()]);
                $outlet->save();
            } else {
                session()->flash('success', 'Invoice regenerated successfully.');
                return redirect()->back();
            }
            session()->flash('success', 'Invoice generated successfully.');
            return redirect()->back();
            return response(['status' => 'success'], 200);
        } catch (\Exception $e) {
            dd($e);
            return response(['message' => 'invalid request'], 200);
        }
    }
    public function getInvoice2(Request $request)
    {
        try {
            //$this->authorize('pol_view_invoice', \App\Outlet::find($outlet));
            $input = $request->all();
            if ($request->filled('outletId'))
                $outletId = $request->input('outletId');
            else
                $outletId = null;
            $startDate = $request->input('startDate');
            $endDate = $request->input('endDate');

            $orders = $this->calculateInvoice($this->getCostPrice($outletId, $startDate, $endDate));
            $invoice = $this->cleanInvoiceFields($orders);
            $debitError = false;
            $creditError = false;
            $totalDebit = collect($invoice)->sum(function ($ii) {
                if (isset($ii->debit) && $ii->debit != '')
                    return $ii->debit;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $totalCredit = collect($invoice)->sum(function ($ii) {
                if (isset($ii->credit) && $ii->credit != '')
                    return $ii->credit;
                else {
                    $creditError = true;
                    return 0;
                }
            });
            $totalCommision = collect($invoice)->sum(function ($ii) {
                if (isset($ii->commision) && $ii->commision != '')
                    return $ii->commision;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $totalGst1 = collect($invoice)->sum(function ($ii) {
                if (isset($ii->gst) && $ii->gst != '')
                    return $ii->gst;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $onlinePayment = collect($invoice)->sum(function ($ii) {
                if (isset($ii->onlinePayment) && $ii->onlinePayment != '')
                    return $ii->onlinePayment;
                else {
                    $debitError = true;
                    return 0;
                }
            });
            $totalAmount = round(($totalDebit - $totalCredit) + ($totalCommision * 0.18));
            $totalGst = $totalCommision * 0.18;
            $error = '';
            if ($debitError)
                $error .= 'debit error ';
            if ($creditError)
                $error .= 'debit error';
            $totalAmount1 = array(
                'debit' => $totalDebit,
                'credit' => $totalCredit,
                'commision' => $totalCommision,
                'totalGst' => $totalGst,
                'totalGst1' => $totalGst1,
                'onlinePayment' => $onlinePayment,
                'total' => $totalAmount
            );
            //$this->excel($invoice, $totalAmount, $debit, $credit, $error);
            if ($request->filled('redirect') && $request->input('redirect') == true) {
                if ($request->filled('store') && $request->input('store') == 'true')
                    return $this->excel2($invoice, $totalAmount1, 1);
                else
                    return $totalAmount1;
            }
            $file = $this->excel2($invoice, $totalAmount1, 0);
            $headers = [
                'Content-Type' => 'application/vnd.ms-excel; charset=utf-8',
            ];

            return response()->download(storage_path() . '/app/' . $file, $file, $headers);
        } catch (\Exception $e) {
            dd($e);
            return response(['message' => 'invalid request'], 200);
        }
    }

    public function excel2($invoice, $totalAmount, $store)
    {

        // Execute the query used to retrieve the data. In this example
        // we're joining hypothetical users and payments tables, retrieving
        // the payments table's primary key, the user's first and last name,
        // the user's e-mail address, the amount paid, and the payment
        // timestamp.

        $paymentsArray = [];

        // Define the Excel spreadsheet headers
        //$paymentsArray[] = ['Serial No.','Order Id','Outlet Name','Customer','Item','Delivery Date','Delivery Station','Transaction Type','Order Status','Vendor Payment','Vendor Collection','GST','Debit','Credit','Commision'];

        // Convert each member of the returned collection into an array,
        // and append it to the payments array.
        $invoice = json_decode(json_encode($invoice), true);
        foreach ($invoice as $payment) {
            if (isset($payment['onlinePayment']))
                unset($payment['onlinePayment']);
            $paymentsArray[] = $payment;
        }
        $paymentsArray[] = [''];
        $paymentsArray[] = ['', '', '', '', '', '', '', '', '', '', 'Total Debit', '', $totalAmount['debit']];
        $paymentsArray[] = ['', '', '', '', '', '', '', '', '', '', 'Total Credit', '', '', $totalAmount['credit']];
        $paymentsArray[] = ['', '', '', '', '', '', '', '', '', '', 'Total Commision', '', '', '', $totalAmount['commision']];
        $paymentsArray[] = ['', '', '', '', '', '', '', '', '', '', 'GST @ 18%', $totalAmount['totalGst']];
        $paymentsArray[] = ['', '', '', '', '', '', '', '', '', '', 'Net Payable Amount', $totalAmount['total']];

        //print_r($invoice);
        // Generate and return the spreadsheet
        $export = new \App\Exports\InvoicesExcel($paymentsArray);
        $excelFile = $this->sanitizeFilename('payments_' . $paymentsArray[0]['outletName'] . '-' . \Carbon\Carbon::now()->format('Y-M-d')) . '.xlsx';
        /*
        $excel = \Excel::store('payments_'.$paymentsArray[0]['outletName'].'-'. \Carbon\Carbon::now()->format('Y-M-d'), function($excel) use($paymentsArray,$totalAmount) {

            // Set the spreadsheet title, creator, and description
            $excel->setTitle('Payments');
            $excel->setCreator('Admin OLF Stores')->setCompany('Olf Stores');
            $excel->setDescription('invoice');

            // Build the spreadsheet, passing in the payments array
            $excel->sheet('sheet1', function($sheet) use ($paymentsArray,$totalAmount) {
                $sheet->fromArray($paymentsArray, null, 'A1', false, false);
                $rows = sizeof($paymentsArray)+1;
                $sheet->setCellValue('N'.$rows, 'Total Debit');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->setCellValue('Q'.$rows, $totalAmount['debit']);

                $sheet->setCellValue('N'.++$rows, 'Total Credit');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->setCellValue('R'.$rows, $totalAmount['credit']);

                $sheet->setCellValue('N'.++$rows, 'Total Commision');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->mergeCells('P'.$rows.':Q'.$rows);
                $sheet->setCellValue('P'.$rows, $totalAmount['commision']);

                $sheet->setCellValue('N'.++$rows, 'GST @ 18%');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->mergeCells('P'.$rows.':Q'.$rows);
                $sheet->setCellValue('P'.$rows, $totalAmount['totalGst']);

                $sheet->setCellValue('N'.++$rows, 'Net Payable Amount');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->mergeCells('P'.$rows.':Q'.$rows);
                $sheet->setCellValue('P'.$rows, $totalAmount['total']);
            });

        });
        *
         *
         */

        //if($store==1){
        \Excel::store($export, $excelFile);
        return $excelFile;
        //}else
        //\Excel::download($export, $excelFile);

    }

    public function excel($invoice, $totalAmount, $store)
    {

        // Execute the query used to retrieve the data. In this example
        // we're joining hypothetical users and payments tables, retrieving
        // the payments table's primary key, the user's first and last name,
        // the user's e-mail address, the amount paid, and the payment
        // timestamp.

        $paymentsArray = [];

        // Define the Excel spreadsheet headers
        //$paymentsArray[] = ['Serial No.','Order Id','Outlet Name','Customer','Item','Delivery Date','Delivery Station','Transaction Type','Order Status','Vendor Payment','Vendor Collection','GST','Debit','Credit','Commision'];

        // Convert each member of the returned collection into an array,
        // and append it to the payments array.
        $invoice = json_decode(json_encode($invoice), true);
        foreach ($invoice as $payment) {
            if (isset($payment['onlinePayment']))
                unset($payment['onlinePayment']);
            $paymentsArray[] = $payment;
        }
        $paymentsArray[] = [''];
        $paymentsArray[] = ['', '', '', '', '', '', '', '', '', '', 'Total Debit', '', $invoice->total_debit];
        $paymentsArray[] = ['', '', '', '', '', '', '', '', '', '', 'Total Credit', '', '', $invoice->total_credit];
        $paymentsArray[] = ['', '', '', '', '', '', '', '', '', '', 'Total Commision', '', '', '', $invoice->commision];
        $paymentsArray[] = ['', '', '', '', '', '', '', '', '', '', 'GST @ 18%', $invoice->igst];
        $paymentsArray[] = ['', '', '', '', '', '', '', '', '', '', 'Net Payable Amount', $invoice->payable];

        //print_r($invoice);
        // Generate and return the spreadsheet
        $export = new \App\Exports\InvoicesExcel($paymentsArray);
        $excelFile = $this->sanitizeFilename('payments_' . $paymentsArray[0]['outletName'] . '-' . \Carbon\Carbon::now()->format('Y-M-d')) . '.xlsx';
        /*
        $excel = \Excel::store('payments_'.$paymentsArray[0]['outletName'].'-'. \Carbon\Carbon::now()->format('Y-M-d'), function($excel) use($paymentsArray,$totalAmount) {

            // Set the spreadsheet title, creator, and description
            $excel->setTitle('Payments');
            $excel->setCreator('Admin OLF Stores')->setCompany('Olf Stores');
            $excel->setDescription('invoice');

            // Build the spreadsheet, passing in the payments array
            $excel->sheet('sheet1', function($sheet) use ($paymentsArray,$totalAmount) {
                $sheet->fromArray($paymentsArray, null, 'A1', false, false);
                $rows = sizeof($paymentsArray)+1;
                $sheet->setCellValue('N'.$rows, 'Total Debit');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->setCellValue('Q'.$rows, $totalAmount['debit']);

                $sheet->setCellValue('N'.++$rows, 'Total Credit');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->setCellValue('R'.$rows, $totalAmount['credit']);

                $sheet->setCellValue('N'.++$rows, 'Total Commision');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->mergeCells('P'.$rows.':Q'.$rows);
                $sheet->setCellValue('P'.$rows, $totalAmount['commision']);

                $sheet->setCellValue('N'.++$rows, 'GST @ 18%');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->mergeCells('P'.$rows.':Q'.$rows);
                $sheet->setCellValue('P'.$rows, $totalAmount['totalGst']);

                $sheet->setCellValue('N'.++$rows, 'Net Payable Amount');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->mergeCells('P'.$rows.':Q'.$rows);
                $sheet->setCellValue('P'.$rows, $totalAmount['total']);
            });

        });
        *
         *
         */

        //if($store==1){
        \Excel::store($export, $excelFile);
        return $excelFile;
        //}else
        //\Excel::download($export, $excelFile);

    }
    public function excel1($invoice, $store = null)
    {
        $paymentsArray = [];

        // Define the Excel spreadsheet headers
        //$paymentsArray[] = ['Serial No.','Order Id','Outlet Name','Customer','Item','Delivery Date','Delivery Station','Transaction Type','Order Status','Vendor Payment','Vendor Collection','GST','Debit','Credit','Commision'];

        // Convert each member of the returned collection into an array,
        // and append it to the payments array.
        $paymentsArray1 = [];
        $paymentsArray1[] = [''];
        $paymentsArray1[] = ['', '', '', '', '', '', '', '', '', '', 'Total Debit', '', $invoice->total_debit];
        $paymentsArray1[] = ['', '', '', '', '', '', '', '', '', '', 'Total Credit', '', '', $invoice->total_credit];
        $paymentsArray1[] = ['', '', '', '', '', '', '', '', '', '', 'Total Commision', '', '', '', $invoice->commision];
        $paymentsArray1[] = ['', '', '', '', '', '', '', '', '', '', 'GST @ 18%', $invoice->igst];
        $paymentsArray1[] = ['', '', '', '', '', '', '', '', '', '', 'Net Payable Amount', $invoice->payable];
        $outletName = $invoice->outlet_name;
        $invoice = json_decode(json_encode($invoice->items), true);
        
        foreach ($invoice as $payment) {
            if (isset($payment['onlinePayment']))
                unset($payment['onlinePayment']);
            if (isset($payment['created_at']))
                unset($payment['created_at']);
            if (isset($payment['updated_at']))
                unset($payment['updated_at']);
            $paymentsArray[] = $payment;
        }
        $paymentsArray = array_merge($paymentsArray, $paymentsArray1);
        
        //print_r($invoice);
        // Generate and return the spreadsheet
        $export = new \App\Exports\InvoicesExcel($paymentsArray);
        $excelFile = preg_replace('/[^a-z0-9]+/', '-', strtolower('payments_' . $outletName . '-' . \Carbon\Carbon::now()->format('Y-M-d'))) . '.xlsx';
        /*
        $excel = \Excel::store('payments_'.$paymentsArray[0]['outletName'].'-'. \Carbon\Carbon::now()->format('Y-M-d'), function($excel) use($paymentsArray,$totalAmount) {

            // Set the spreadsheet title, creator, and description
            $excel->setTitle('Payments');
            $excel->setCreator('Admin OLF Stores')->setCompany('Olf Stores');
            $excel->setDescription('invoice');

            // Build the spreadsheet, passing in the payments array
            $excel->sheet('sheet1', function($sheet) use ($paymentsArray,$totalAmount) {
                $sheet->fromArray($paymentsArray, null, 'A1', false, false);
                $rows = sizeof($paymentsArray)+1;
                $sheet->setCellValue('N'.$rows, 'Total Debit');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->setCellValue('Q'.$rows, $totalAmount['debit']);

                $sheet->setCellValue('N'.++$rows, 'Total Credit');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->setCellValue('R'.$rows, $totalAmount['credit']);

                $sheet->setCellValue('N'.++$rows, 'Total Commision');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->mergeCells('P'.$rows.':Q'.$rows);
                $sheet->setCellValue('P'.$rows, $totalAmount['commision']);

                $sheet->setCellValue('N'.++$rows, 'GST @ 18%');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->mergeCells('P'.$rows.':Q'.$rows);
                $sheet->setCellValue('P'.$rows, $totalAmount['totalGst']);

                $sheet->setCellValue('N'.++$rows, 'Net Payable Amount');
                $sheet->mergeCells('N'.$rows.':O'.$rows);
                $sheet->mergeCells('P'.$rows.':Q'.$rows);
                $sheet->setCellValue('P'.$rows, $totalAmount['total']);
            });

        });
        *
         *
         */

        //if($store==1){
        \Excel::store($export, $excelFile);
        return $excelFile;
        //}else
        //\Excel::download($export, $excelFile);

    }
    public function balance()
    {
        try {
            //$toArray = \Excel::import(File::get('PaymentsheetAug\'19.xlsx'),'PaymentsheetAug\'19.xlsx');
            //$data = (new \App\Imports\FormulaImport)->toArray('PaymentsheetAug\'19.xlsx');
            $data = (new \App\Imports\FormulaImport)->toArray('Payment sheet Aug\'19.xlsx');
            //Log::channel('dailyInfo')->info('array:'.print_r($data,true));
            /*
            \Excel::import(File::get('PaymentsheetAug\'19.xlsx'), function ($reader) {

                foreach ($reader->toArray() as $row) {
                    Log::channel('dailyInfo')->info(print_r($row,true));
                }
            });
             *
             */
            \Session::flash('success', 'Users uploaded successfully.');
            return redirect(route('users.index'));
        } catch (\Exception $e) {
            \Session::flash('error', $e->getMessage());
            return redirect(route('users.index'));
        }
    }
    private function email($data)
    {
        $excel = $data['excel'];
        $pdf = $data['pdf'];
        //Log::channel('dailyInfo')->info('--------------Testing----------------------'.print_r($data,true));
        $amounts = (object)array(
            'debit' => $data['amounts']['debit'],
            'credit' => $data['amounts']['credit'],
            'commision' => $data['amounts']['commision'],
            'totalGst' => $data['amounts']['totalGst'],
            #'totalGst1' => $data['amounts']['totalGst1'],
            'onlinePayment' => $data['amounts']['onlinePayment'],
            'total' => $data['amounts']['total'],
            'openingBalance' => $data['amounts']['openingBalance'],
            'outstanding' => $data['amounts']['total'] + $data['amounts']['openingBalance'],
        );
        $month = \Carbon\Carbon::createFromFormat('m/d/Y', $data['startDate'])->format('M \'Y');
        $diff = \Carbon\Carbon::createFromFormat('m/d/Y', $data['endDate'])->diffInDays(\Carbon\Carbon::createFromFormat('m/d/Y', $data['startDate']));
        $month = 'month of ' . $month;
        if ($diff < 8)
            $month = $month . ', week ' . (\Carbon\Carbon::createFromFormat('m/d/Y', $data['startDate'])->weekNumberInMonth + 1);
        Mail::send(
            'mail.email_invoice',
            compact('amounts', 'month'),
            function ($message) use ($data, $excel, $pdf) {
                $x = \App\Models\Outlet::find($data['outletId']);
                $y = \App\Models\User::find($x->user_id);
                $message->from('no-reply@olfstores.com', 'OLF STORE');
                $message->sender('no-reply@olfstores.com', 'OLF STORE');
                $message->to($y->email, $x->outletName);
                //$message->to('ajay.kumar.khatri24@gmail.com', 'ajay');
                $message->bcc(['sanjayjdn@gmail.com', 'dharam@olfstores.com']);
                $message->subject('Invoice for the, Period ' . \Carbon\Carbon::createFromFormat('m/d/Y', $data['startDate'])->format('D M j') . '-' . \Carbon\Carbon::createFromFormat('m/d/Y', $data['endDate'])->format('D M j') . ' \'' . \Carbon\Carbon::createFromFormat('m/d/Y', $data['startDate'])->format('Y'));
                $message->attach($excel, []);
                $message->attach($pdf, []);
                $message->priority(3);
            }
        );
    }
    public function pay(Request $request)
    {
        if (!$request->filled('amount') || !$request->filled('outletId')) {
            session()->flash('error', 'Required parameters are missing from the request.');
            return redirect()->back();
        }
        $amount = $request->input('amount');
        $outlet = \App\Models\Outlet::find($request->input('outletId'));
        $total = sizeof($outlet->invoices);
        $i = 0;
        foreach ($outlet->invoices as $invoice);
        if (!isset($invoice)) {
            session()->flash('error', 'Please generate an invoice.');
            return redirect()->back();
        }
        //$invoice = \App\Invoice::find($invoiceId);
        $invoice->amount_paid += $amount;
        if (($invoice->previous_balance + $invoice->payable - $invoice->amount_paid) > 0)
            $status = 'PARTIALLY_PAID';
        else
            $status = 'PAID';

        $row = ['date' => \Carbon\Carbon::now(), 'previous' => $outlet->openingBalance, 'paid' => $amount, 'outlet_id' => $outlet->outletId, 'invoice_id' => $invoice->id, 'outlet_name' => $outlet->outletName, 'status' => $status];
        $payment = $outlet->payments()->firstOrCreate($row);
        $invoice->save();
        $outlet->openingBalance = $invoice->previous_balance + $invoice->payable - $invoice->amount_paid;
        $outlet->save();
        session()->flash('success', 'Payment successful.');
        return redirect()->back();
    }
    public function paid(Request $request, $invoiceId)
    {
        if (!isset($invoiceId)) {
            session()->flash('error', 'Required parameters are missing from the request.');
            return redirect()->back();
        }
        $invoice = \App\Models\Invoice::find($invoiceId);
        $invoice->status = 'PAID';
        $invoice->save();
        session()->flash('success', 'Invoice status set to \'PAID\' successfully.');
        return redirect()->back();
    }
    public function sanitizeFilename($filename)
    {
        return preg_replace('/[^a-z0-9]+/', '-', strtolower($filename));
    }

    public function downloadInvoices(Request $request)
    {

        $selectAll = $request->input('outlet_id_select');
        if (!isset($selectAll))
            return redirect()->back();
        $files = array();
        foreach ($selectAll as $outletId) {
            Log::channel('dailyInfo')->info('outletId:' . $outletId);
            $request->request->add(['outletId' => $outletId, 'no_excel' => true, 'back' => false]);
            $files[] = $this->exportPDF($request)['pdf'];
            Log::channel('dailyInfo')->info('files:' . print_r($files, true));
        }

        $zip = new ZipArchive();
        $zip_name = preg_replace('/[^a-z0-9]+/', '-', strtolower(\Carbon\Carbon::now()->format('m-d-Y') . '_' . 'outlet_invoices')) . '.zip'; // Zip name
        $zip->open(storage_path() . '/app/' . $zip_name,  ZipArchive::CREATE);
        foreach ($files as $file) {
            $path = $file;
            Log::channel('dailyInfo')->info('input' . $path);
            if (file_exists($path)) {
                $zip->addFromString(basename($path),  file_get_contents($path));
            } else {
                echo "file does not exist";
            }
        }
        $zip->close();
        $headers = [
            'Content-Type' => 'application/octet-stream',
            'Content-Transfer-Encoding' => 'binary',
            'Content-Length' => filesize(storage_path() . '/app/' . $zip_name),
            'Content-Disposition' => "attachment; filename=\"" . basename(storage_path() . '/app/' . $zip_name) . "\""
        ];
        $file = storage_path() . '/app/' . $zip_name;
        return response()->download(storage_path() . '/app/' . $zip_name, $zip_name, $headers);
    }
    public function sendInvoice(Request $request)
    {
        $selectAll = $request->input('outlet_id_select');
        if (!isset($selectAll))
            return redirect()->back();

        foreach ($selectAll as $outletId) {
            $request->request->add(['outletId' => $outletId, 'send' => true, 'back' => false]);
            $this->exportPDF($request);
        }

        return redirect()->back();
    }
    public function exportPDF(Request $request)
    {   
        // dd($request->all());
        ini_set('memory_limit', '-1');
        $outletId = $request->input('outletId');
        $outlet = \App\Models\Outlet::find($outletId);
        $outletName = $outlet->outletName;

        if ($request->filled('regenerate')) {
            $invoice12 = \App\Models\Invoice::find($request->input('id'));
            $closingBalance = $invoice12->openingBalance;
            //$invoice12 = $invoice12->items;
        } else {
            $closingBalance = $outlet->openingBalance;
            foreach ($outlet->invoices as $invoice12);
        }
        $totalGst1 = collect($invoice12->items)->sum(function ($ii) {
            if (isset($ii->gst) && $ii->gst != '')
                return $ii->gst;
            else {
                $debitError = true;
                return 0;
            }
        });
        
        if (!isset($invoice12)) {
            if (!$request->filled('back'))
                return redirect()->back();
            return;
        }
        $items = $invoice12->items->map(function ($i, $j) use ($outletName) {
            $i->id = $j + 1;
            $i->invoice_id = $outletName;
            return $i;
        });
        $invoice12->items = $items;
        $pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
        //$invoiceId = $invoice12->id;
        $invoice12->outletName = $outletName;
        //unset($invoice12->id);
        
        if (!$request->filled('no_excel')) {
            $excel = $this->excel1($invoice12);
        }
        //$invoice->id = $invoiceId;
        // set document information
        $pdf->SetCreator('Olf Stores & Technologies Pvt. Ltd');
        $pdf->SetAuthor('Olf Stores & Technologies Pvt. Ltd');
        $pdf->SetTitle('Invoice');
        $pdf->SetSubject('Payment Invoice');
        $pdf->SetKeywords('Invoice, Payment');

        // set default header data
        $logo = 'R.jpg';
        $logoWidth = 15;

        $pdf->SetHeaderData($logo, $logoWidth, 'OLF Stores & Technologies Pvt. Ltd', 'Krishna Nivas, Hills View Colony, DD Nagar, Gate No. 2, Maharajpura Gwalior' . "\nhttps://olfstores.com", array(255, 165, 0), array(255, 165, 0));
        $pdf->setFooterData(array(0, 64, 0), array(255, 165, 0));

        // set header and footer fonts
        $pdf->setHeaderFont(array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
        $pdf->setFooterFont(array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

        // set default monospaced font
        $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

        // set margins
        $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
        $pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
        $pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

        // set auto page breaks
        $pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

        // set image scale factor
        $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

        // set some language-dependent strings (optional)
        if (@file_exists(dirname(__FILE__) . '/lang/eng.php')) {
            require_once(dirname(__FILE__) . '/lang/eng.php');
            $pdf->setLanguageArray($l);
        }

        // ---------------------------------------------------------

        // set default font subsetting mode
        $pdf->setFontSubsetting(true);

        // Set font
        // dejavusans is a UTF-8 Unicode font, if you only need to
        // print standard ASCII chars, you can use core fonts like
        // helvetica or times to reduce file size.
        //$pdf->SetFont('dejavusans', '', 14, '', true);

        // Add a page
        // This method has several options, check the source code documentation for more information.
        $pdf->AddPage();

        // set text shadow effect
        $pdf->setTextShadow(array('enabled' => true, 'depth_w' => 0.2, 'depth_h' => 0.2, 'color' => array(196, 196, 196), 'opacity' => 1, 'blend_mode' => 'Normal'));

        // Set some content to print
        $html = '<style>
                span {font-size:12px;}
                tr {height:14px;}
                .table1 td, .table1 th {text-align:center}
            </style>
            <h6 style="font-size:16px;text-align:center;">Tax Invoice</h6>
            <table cellspacing="0" cellpadding="0" border="0"style="font-size:12px;line-height:16px">
                <tbody>
                    <tr>
                    <td></td>
                    </tr>
                </tbody>
            </table>
            <table style="font-size:12px;line-height:22px;">
                <tbody>
                    <tr>
                        <td>OLF Stores & Technologies Pvt. Ltd</td>
                        <td>Invoice Number:&nbsp;' . $invoice12->id . '</td>
                    </tr>
                    <tr>
                        <td>Krishna Nivas, Hills View Colony,</td>
                        <td>Invoice Date:&nbsp;' . \Carbon\Carbon::now()->format('m/d/Y') . '</td>
                    </tr>
                    <tr>
                        <td>Dd Nagar, Gate No. 2, Maharajpura,</td>
                        <td>Invoice Period:&nbsp;' . $invoice12->period_start . '&nbsp;-&nbsp;' . $invoice12->period_end . '</td>
                    </tr>
                    <tr>
                        <td>Gwalior</td>
                        <td>Outlet Name:&nbsp;' . $outletName . '</td>
                    </tr>
                    <tr>
                        <td>Madhya Pradesh - 474020</td>
                        <td>GSTIN :&nbsp;' . $outlet->gstNo . '</td>
                    </tr>
                    <tr>
                        <td>GSTIN : 23AACCO8285A1ZN</td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0"style="font-size:12px;line-height:24px">
                <tbody>
                    <tr>
                    <td></td>
                    </tr>
                </tbody>
            </table>
            <table class="table1" cellspacing="0" cellpadding="0" border="1" style="font-size:12px;line-height:22px;">
                <thead style="text-align:center;background-color:#eee;font-weight:bold;">
                    <tr>
                        <th style="width:20%;">S.No.</th>
                        <th style="width:50%;">Particulars</th>
                        <th style="width:30%;">Amount</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td style="width:20%;">1</td>
                        <td style="width:50%;font-weight:bold;">TOTAL COMMISSION</td>
                        <td style="width:30%;">Rs.' . $invoice12->commision . '</td>
                    </tr>
                    <tr>
                        <td style="width:20%;">2</td>
                        <td style="width:50%;">Add: IGST @ 18% </td>
                        <td style="width:30%;">Rs.' . $invoice12->igst . '</td>
                    </tr>
                    <tr>
                        <td style="width:20%;">3</td>
                        <td style="width:50%;font-weight:bold;">TOTAL PAYABLE FOR THE MONTH</td>
                        <td style="width:30%;">Rs.' . ($invoice12->commision + $invoice12->igst) . '</td>
                    </tr>
                    <tr>
                        <td style="width:20%;">4</td>
                        <td style="width:50%;font-weight:bold;">*Add: Previous Month Balance</td>
                        <td style="width:30%;">Rs.' . $invoice12->previous_balance . '</td>
                    </tr>
                    <tr>
                        <td style="width:20%;">5</td>
                        <td style="width:50%;">*Less: Online Payments received</td>
                        <td style="width:30%;">Rs.' . $invoice12->online_payments . '</td>
                    </tr>
                    <tr>
                        <td style="width:20%;">6</td>
                        <td style="width:50%;">Add: GST Collected at Source @5%</td>
                        <td style="width:30%;">Rs.' . $totalGst1 . '</td>
                    </tr>
                    <tr>
                        <td style="width:20%;">7</td>
                        <td style="width:50%;font-weight:bold;">NET PAYABLE AMOUNT</td>
                        <td style="width:30%;">Rs.' . round($invoice12->payable + $invoice12->previous_balance) . '</td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;line-height:26px;">
                <tbody>
                    <tr>
                        <td>*Refer to account statement and order sheet for details.</td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;">
                <tbody>
                    <tr>
                        <td></td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;line-height:26px;">
                <tbody>
                    <tr>
                        <td></td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
            <table width="220" cellspacing="0" cellpadding="0" border="1" height="1" style="font-size:12px;line-height:1px;">
                <tbody>
                    <tr>
                    <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;line-height:22px;">
                <tbody>
                    <tr>
                        <td>Bank account details for payments are as follows:-</td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0"style="font-size:12px;">
                <tbody>
                    <tr>
                    <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;line-height:22px;">
                <tbody>
                    <tr>
                        <td>A/C Name</td>
                        <td>: OLF Strores & Technologies Pvt. Ltd</td>
                    </tr>
                    <tr>
                        <td>A/C Number</td>
                        <td>: 10190006635575</td>
                    </tr>
                    <tr>
                        <td>IFSC Code</td>
                        <td>: BDBL0001765</td>
                    </tr>
                    <tr>
                        <td>Bank</td>
                        <td>: Bandhan Bank</td>
                    </tr>
                    <tr>
                        <td>Branch</td>
                        <td>: City Center Gwalior</td>
                    </tr>
                    <tr>
                        <td>City</td>
                        <td>: GWALIOR</td>
                    </tr>
                    <tr>
                        <td>Account Type</td>
                        <td>: CURRENT</td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0"style="font-size:12px;">
                <tbody>
                    <tr>
                    <td></td>
                    </tr>
                    <tr>
                    <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;line-height:13px;">
                <tbody>
                    <tr>
                        <td>This is a computer generated invoice and requires no signature.</td>
                    </tr>
                    <tr>
                        <td>You may write to us at account@olfstores.com www.olfstores.com E&OE</td>
                    </tr>
                </tbody>
            </table>
';

        $pdf->writeHTML($html, true, 0, true, 0);
        $fileName = storage_path() . '/app/' . preg_replace('/[^a-z0-9]+/', '-', strtolower(\Carbon\Carbon::now()->format('m-d-Y') . '_' . $outletName . '_invoice')) . '.pdf';
        $files = array();
        $files[] = $fileName;
        if (!$request->filled('no_excel'))
            $files[] = storage_path() . '/app/' . $excel;
        $pdf->Output($fileName, 'F');

        $amounts = array(
            'debit' => $invoice12->total_debit,
            'credit' => $invoice12->total_credit,
            'commision' => $invoice12->commision,
            'totalGst' => $totalGst1,
            'onlinePayment' => $invoice12->online_payments,
            'total' => $invoice12->payable,
            'openingBalance' => $invoice12->previous_balance - $invoice12->amount_paid
        );
        if ($request->filled('no_excel'))
            $data = ['amounts' => $amounts, 'outletId' => $outletId, 'pdf' => $fileName, 'startDate' =>  \Carbon\Carbon::createFromFormat('Y-m-d', $invoice12->period_start)->format('m/d/Y'), 'endDate' => \Carbon\Carbon::createFromFormat('Y-m-d', $invoice12->period_end)->format('m/d/Y')];
        else
            $data = ['amounts' => $amounts, 'outletId' => $outletId, 'excel' => storage_path() . '/app/' . $excel, 'pdf' => $fileName, 'startDate' =>  \Carbon\Carbon::createFromFormat('Y-m-d', $invoice12->period_start)->format('m/d/Y'), 'endDate' => \Carbon\Carbon::createFromFormat('Y-m-d', $invoice12->period_end)->format('m/d/Y')];


        if ($request->filled('send')) {
            $this->email($data);
        }
        if ($request->filled('no_excel'))
            return $data;
        $zip = new ZipArchive();
        $zip_name = preg_replace('/[^a-z0-9]+/', '-', strtolower(\Carbon\Carbon::now()->format('m-d-Y') . '_' . $outletName)) . '.zip'; // Zip name
        $zip->open(storage_path() . '/app/' . $zip_name,  ZipArchive::CREATE);
        foreach ($files as $file) {
            $path = $file;
            Log::channel('dailyInfo')->info('input' . $path);
            if (file_exists($path)) {
                $zip->addFromString(basename($path),  file_get_contents($path));
            } else {
                echo "file does not exist";
            }
        }
        $zip->close();
        $headers = [
            'Content-Type' => 'application/octet-stream',
            'Content-Transfer-Encoding' => 'binary',
            'Content-Length' => filesize(storage_path() . '/app/' . $zip_name),
            'Content-Disposition' => "attachment; filename=\"" . basename(storage_path() . '/app/' . $zip_name) . "\""
        ];
        $file = storage_path() . '/app/' . $zip_name;
        //session()->flash('success', 'Invoice sent successfully.');
        if ($request->filled('send')) {
            session()->flash('success', 'Invoice sent successfully.');
            if (!$request->filled('back'))
                return redirect()->back();
        }
        return response()->download(storage_path() . '/app/' . $zip_name, $zip_name, $headers);
    }
    public function exportPDF2(Request $request)
    {
        $data = (new \App\Imports\FormulaImport)->toArray('Payment sheet Aug\'19.xlsx');
        $keys = array_keys($data);
        $outletId = $request->input('outletId');
        $outlet = \App\Outlet::find($outletId);
        $outletName = \App\Outlet::find($outletId)->outletName;
        //$data = array_column($data[$keys[sizeof($keys)-1]], 2, 11);
        foreach ($data[$keys[sizeof($keys) - 1]] as $el) {
            if ($el[2] == $outletId)
                $closingBalance = $el[12];
        }
        $pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
        $request->merge(['redirect' => true]);
        $amounts = $this->getInvoice2($request);
        $request->merge(['store' => 'true']);
        $excel = $this->getInvoice2($request);

        $amounts['openingBalance'] = $closingBalance;
        // set document information
        $pdf->SetCreator('Olf Stores');
        $pdf->SetAuthor('Olf Stores');
        $pdf->SetTitle('Invoice');
        $pdf->SetSubject('Payment Invoice');
        $pdf->SetKeywords('Invoice, Payment');

        // set default header data
        $logo = 'R.jpg';
        $logoWidth = 15;
        $pdf->SetHeaderData($logo, $logoWidth, 'OLF STORES', 'Krishna Nivas, Hills View Colony, DD Nagar, Gate No. 2, Maharajpura Gwalior' . "\nhttps://olfstores.com", array(0, 64, 255), array(0, 64, 128));
        $pdf->setFooterData(array(0, 64, 0), array(0, 64, 128));

        // set header and footer fonts
        $pdf->setHeaderFont(array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
        $pdf->setFooterFont(array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

        // set default monospaced font
        $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

        // set margins
        $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
        $pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
        $pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

        // set auto page breaks
        $pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

        // set image scale factor
        $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

        // set some language-dependent strings (optional)
        if (@file_exists(dirname(__FILE__) . '/lang/eng.php')) {
            require_once(dirname(__FILE__) . '/lang/eng.php');
            $pdf->setLanguageArray($l);
        }

        // ---------------------------------------------------------

        // set default font subsetting mode
        $pdf->setFontSubsetting(true);

        // Set font
        // dejavusans is a UTF-8 Unicode font, if you only need to
        // print standard ASCII chars, you can use core fonts like
        // helvetica or times to reduce file size.
        //$pdf->SetFont('dejavusans', '', 14, '', true);

        // Add a page
        // This method has several options, check the source code documentation for more information.
        $pdf->AddPage();

        // set text shadow effect
        $pdf->setTextShadow(array('enabled' => true, 'depth_w' => 0.2, 'depth_h' => 0.2, 'color' => array(196, 196, 196), 'opacity' => 1, 'blend_mode' => 'Normal'));

        // Set some content to print
        $html = '<style>
                span {font-size:12px;}
                tr {height:14px;}
                .table1 td, .table1 th {text-align:center}
            </style>
            <h6 style="font-size:16px;text-align:center;">Tax Invoice</h6>
            <table cellspacing="0" cellpadding="0" border="0"style="font-size:12px;line-height:16px">
                <tbody>
                    <tr>
                    <td></td>
                    </tr>
                </tbody>
            </table>
            <table style="font-size:12px;line-height:22px;">
                <tbody>
                    <tr>
                        <td>OLF STORE</td>
                        <td>Invoice Number:&nbsp;</td>
                    </tr>
                    <tr>
                        <td>Krishna Nivas, Hills View Colony,</td>
                        <td>Invoice Date:&nbsp;' . \Carbon\Carbon::now()->format('m/d/Y') . '</td>
                    </tr>
                    <tr>
                        <td>Dd Nagar, Gate No. 2, Maharajpura,</td>
                        <td>Invoice Period:&nbsp;' . $request->input('startDate') . '&nbsp;-&nbsp;' . $request->input('endDate') . '</td>
                    </tr>
                    <tr>
                        <td>Gwalior</td>
                        <td>Outlet Name:&nbsp;' . $outletName . '</td>
                    </tr>
                    <tr>
                        <td>Madhya Pradesh - 474020</td>
                        <td>GSTIN :&nbsp;' . $outlet->gstNo . '</td>
                    </tr>
                    <tr>
                        <td>GSTIN : 23AUXPJ4868L1ZR</td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0"style="font-size:12px;line-height:24px">
                <tbody>
                    <tr>
                    <td></td>
                    </tr>
                </tbody>
            </table>
            <table class="table1" cellspacing="0" cellpadding="0" border="1" style="font-size:12px;line-height:22px;">
                <thead style="text-align:center;background-color:#eee;font-weight:bold;">
                    <tr>
                        <th>S.No.</th>
                        <th>Particulars</th>
                        <th>Amount</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td>1</td>
                        <td style="font-weight:bold;">TOTAL COMMISSION</td>
                        <td>Rs.' . $amounts['commision'] . '</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>Add: IGST @ 18% </td>
                        <td>Rs.' . $amounts['totalGst'] . '</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td style="font-weight:bold;">TOTAL PAYABLE FOR THE MONTH</td>
                        <td>Rs.' . ($amounts['commision'] + $amounts['totalGst']) . '</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td style="font-weight:bold;">*Add: Previous Month Balance</td>
                        <td>Rs.' . $closingBalance . '</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>*Less: Online Payments received</td>
                        <td>Rs.' . $amounts['onlinePayment'] . '</td>
                    </tr>
                    <tr>
                        <td style="width:20%;">6</td>
                        <td style="width:50%;">Add: GST Collected at Source @5%</td>
                        <td style="width:30%;">Rs.' . $amounts['totalGst1'] . '</td>
                    </tr>
                    <tr>
                        <td>7</td>
                        <td style="font-weight:bold;">NET PAYABLE AMOUNT</td>
                        <td>Rs.' . round($amounts['commision'] + $amounts['totalGst'] - $amounts['onlinePayment'] + $closingBalance + $amounts['totalGst1']) . '</td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;line-height:26px;">
                <tbody>
                    <tr>
                        <td>*Refer to account statement and order sheet for details.</td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;">
                <tbody>
                    <tr>
                        <td></td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;line-height:26px;">
                <tbody>
                    <tr>
                        <td></td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
            <table width="220" cellspacing="0" cellpadding="0" border="1" height="1" style="font-size:12px;line-height:1px;">
                <tbody>
                    <tr>
                    <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;line-height:22px;">
                <tbody>
                    <tr>
                        <td>Bank account details for payments are as follows:-</td>
                        <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0"style="font-size:12px;">
                <tbody>
                    <tr>
                    <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;line-height:22px;">
                <tbody>
                    <tr>
                        <td>A/C Name</td>
                        <td>: OLF STORES</td>
                    </tr>
                    <tr>
                        <td>A/C Number</td>
                        <td>: </td>
                    </tr>
                    <tr>
                        <td>IFSC Code</td>
                        <td>: BDBL0001765</td>
                    </tr>
                    <tr>
                        <td>Bank</td>
                        <td>: Bandhan Bank </td>
                    </tr>
                    <tr>
                        <td>Branch</td>
                        <td>: City Center Gwalior</td>
                    </tr>
                    <tr>
                        <td>City</td>
                        <td>: GWALIOR</td>
                    </tr>
                    <tr>
                        <td>Account Type</td>
                        <td>: CURRENT</td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0"style="font-size:12px;">
                <tbody>
                    <tr>
                    <td></td>
                    </tr>
                    <tr>
                    <td></td>
                    </tr>
                </tbody>
            </table>
            <table cellspacing="0" cellpadding="0" border="0" style="font-size:12px;line-height:13px;">
                <tbody>
                    <tr>
                        <td>This is a computer generated invoice and requires no signature.</td>
                    </tr>
                    <tr>
                        <td>You may write to us at account@olfstores.com www.olfstores.com E&OE</td>
                    </tr>
                </tbody>
            </table>
';

        $pdf->writeHTML($html, true, 0, true, 0);
        $fileName = storage_path() . '/app/' . $this->sanitizeFilename(\Carbon\Carbon::now()->format('m-d-Y') . '_' . $outletName . '_invoice') . '.pdf';
        $files = array();
        $files[] = $fileName;
        $files[] = storage_path() . '/app/' . $excel;
        $pdf->Output($fileName, 'F');
        $data = ['amounts' => $amounts, 'outletId' => $outletId, 'excel' => storage_path() . '/app/' . $excel, 'pdf' => $fileName, 'startDate' => $request->input('startDate'), 'endDate' => $request->input('endDate')];
        //$this->email($data);
        $zip = new ZipArchive();
        $zip_name = $this->sanitizeFilename(\Carbon\Carbon::now()->format('m-d-Y') . '_' . $outletName) . ".zip"; // Zip name
        $zip->open(storage_path() . '/app/' . $zip_name,  ZipArchive::CREATE);
        foreach ($files as $file) {
            $path = $file;
            if (file_exists($path)) {
                $zip->addFromString(basename($path),  file_get_contents($path));
            } else {
                echo "file does not exist";
            }
        }
        $zip->close();
        $headers = [
            'Content-Type' => 'application/octet-stream',
            'Content-Transfer-Encoding' => 'binary',
            'Content-Length' => filesize(storage_path() . '/app/' . $zip_name),
            'Content-Disposition' => "attachment; filename=\"" . basename(storage_path() . '/app/' . $zip_name) . "\""
        ];
        $file = storage_path() . '/app/' . $zip_name;

        return response()->download(storage_path() . '/app/' . $zip_name, $zip_name, $headers);
    }
    public function exportPDF1()
    {
        /*
       return Excel::create('itsolutionstuff_example', function($excel) use ($data) {
            $excel->sheet('mySheet', function($sheet) use ($data)
        {
                    $sheet->fromView($data);
        });
       })->download("pdf");*/
        $spreadsheet = new Spreadsheet();

        // Set document properties
        $spreadsheet->getProperties()->setCreator('Maarten Balliauw')
            ->setLastModifiedBy('Maarten Balliauw')
            ->setTitle('Office 2007 XLSX Test Document')
            ->setSubject('Office 2007 XLSX Test Document')
            ->setDescription('Test document for Office 2007 XLSX, generated using PHP classes.')
            ->setKeywords('office 2007 openxml php')
            ->setCategory('Test result file');

        $spreadsheet->getActiveSheet()
            ->getHeaderFooter()
            ->setOddHeader('&L&G&C&HPlease treat this document as confidential!');
        $spreadsheet->getActiveSheet()
            ->getHeaderFooter()
            ->setOddFooter('&L&B' . $spreadsheet->getProperties()->getTitle() . '&RPage &P of &N');
        $spreadsheet->getActiveSheet()->setTitle('Printing');
        $writer = \PhpOffice\PhpSpreadsheet\IOFactory::createWriter($spreadsheet, 'Tcpdf');
        $writer->save("invoices.pdf");
        /*
        $headers = [
              'Content-Type' => 'application/pdf',
           ];
         *
         */

        //return response()->download('invoices.pdf', 'invoices.pdf', $headers);
        //return \Excel::download(new \App\Exports\InvoicePdf, 'invoices.pdf');

    }
    protected function getCostPrice($outlet, $start, $end)
    {

        try {
            $start = \Carbon\Carbon::createFromFormat('m/d/Y', $start, 'Asia/Kolkata')->startOfDay(); //->subHour(8);
            $end = \Carbon\Carbon::createFromFormat('m/d/Y', $end, 'Asia/Kolkata')->endOfDay();
            $outletIds = array();
            if ($outlet == null) {
                $whereO = \App\Models\Order::where(function ($q) use ($start, $end) {
                    $q->where('deliveryDateTime', '>=', $start)->where('deliveryDateTime', '<=', $end);
                });
                $whereV = \App\Models\VendorOrder::where(function ($q) use ($start, $end) {
                    $q->where('deliveryDateTime', '>=', $start)->where('deliveryDateTime', '<=', $end);
                });
            } else {
                $out = \App\Models\Outlet::find($outlet);
                $whereO = $out->orders()
                    ->where(function ($q) use ($start, $end) {
                        $q->where('deliveryDateTime', '>=', $start)->where('deliveryDateTime', '<=', $end);
                    });
                $whereV = $out->vendor_orders()
                    ->where(function ($q) use ($start, $end) {
                        $q->where('deliveryDateTime', '>=', $start)->where('deliveryDateTime', '<=', $end);
                    });
            }
            $orders = $whereO->get()->map(function ($f) use ($outletIds) {
                if (!in_array($f->outletId, $outletIds))
                    $outletIds[] = $f->outletId;
                $f->gst = json_decode($f->priceDetails)->gst;
                return $f;
            });
            $vendorOrders = $whereV->get()->map(function ($f) use ($outletIds) {
                if (!in_array($f->outlet, $outletIds))
                    $outletIds[] = $f->outlet;
                $x = $f;
                $deliveryDetails = new \stdClass;
                $deliveryDetails->pnr = $x->pnr;
                $deliveryDetails->trainNo = $x->trainNo;
                $deliveryDetails->trainName = $x->trainName;
                $deliveryDetails->station = $x->stationName;
                $deliveryDetails->stationCode = $x->stationCode;
                $deliveryDetails->berth = $x->berth;
                $deliveryDetails->coach = $x->coach;
                $deliveryDetails->ETA = $x->deliveryDate;
                $x->deliveryDetails = json_encode($deliveryDetails);

                try {
                    if (get_class($f) == "App\VendorOrder") {
                        $x->customerDetails = json_decode($x->customer);
                    } else {
                        $x->customerDetails = json_decode($x->customerDetails);
                    }

                    $x->customerDetails->customerName = $x->customerDetails->fullName;
                    $x->customerDetails = json_encode($x->customerDetails);
                } catch (\Exception $e) {
                    Log::info($x->toArray());
                }
                $priceDetails = new \stdClass;
                $priceDetails->amountPayable = $x->amountPayable;
                $x->priceDetails = json_encode($priceDetails);

                return $x;
            });
            $orders = $orders->toBase()->merge($vendorOrders);
            if ($outlet == null) {
                $items = array();
                if (sizeof($outletIds) > 0) {
                    $wOutlets = \App\Models\Outlet::where('id', $outletIds[0]);
                    $count = 0;
                    foreach ($outletIds as $outletId) {
                        if ($count != 0)
                            $wOutlets->orWhere('id', $outletId);
                        $count++;
                    }
                    $wOutlets->get()->map(function ($ot) use ($items) {
                        array_merge($ot->menu->items->toArray(), $items);
                    });
                    $items = array_column($items, 'vendorPrice', 'id');
                }
            } else {
                $items = array_column($out->menu->items->toArray(), 'vendorPrice', 'id');
            }
            $orders = $orders->map(function ($f) use ($items) {
                $x = $f;
                $orderItems = collect(json_decode($x->orderItems))->map(function ($oi) use ($items) {
                    if (isset($items[$oi->itemId])){
                        try {
                            $oi->costPrice = $items[$oi->itemId];
                        } catch (\Throwable $th) {
                            dd($oi);
                        }
                    }
                    return $oi;
                });
                $itemsDesc = $orderItems->map(function ($i) {
                    return ' ' . $i->quantity . ' ' . (property_exists($i, 'itemName') ? $i->itemName : '');
                });
                $collection = collect($itemsDesc);
                $x->item = trim(implode(',', $collection->toArray()));
                $x->orderItems = $orderItems;
                //$x->outletDetails = $out;
                if (isset($x->outlet_id))
                    $x->outletDetails = \App\Models\Outlet::find($x->outlet_id);
                else {
                    $x->outletDetails = \App\Models\Outlet::find($x->outlet);
                }

                try {
                    if (get_class($x) == "\App\Models\VendorOrder")
                        $x->customerName = json_decode($x->customer)->fullName;
                } catch (\Exception $e) {
                    dd($x);
                }

                $x->deliveryStation = json_decode($x->deliveryDetails)->stationCode;

                return $x;
            });

            
            return $orders;
            //return view('backend.orders.index',compact('orders'));

        } catch (\Exception $e) {
            dd($e);
            Log::channel('dailyInfo')->error($e);
            return response(['message' => 'invalid request'], 200);
        }
    }

    protected function calculateInvoice($orders)
    {
        try {
            $orders = $orders->map(function ($f) {
                $x = $f;
                $unavailable = false;
                $subtotal = collect($x->orderItems)->sum(function ($item) {
                    if (isset($item->costPrice) && $item->costPrice != 'N.A.' && $item->costPrice != '') {
                        return $item->costPrice * $item->quantity;
                    }
                    $unavailable = true;
                });
                if ($unavailable)
                    $x->costPrice = 'N.A.';
                else
                    $x->costPrice = $subtotal;
                if ($x->paymentType == 'PRE_PAID')
                    $x->onlinePayment = json_decode($x->priceDetails)->amountPayable;
                else
                    $x->onlinePayment = '';

                return $x;
            });

            return $orders;
        } catch (\Exception $e) {
            return response(['message' => 'invalid request'], 200);
        }
    }
    public function cleanInvoiceFields($invoice)
    {
        $invoice = $invoice->map(function ($o, $i) {
            $invoiceItem = new \stdClass;
            $invoiceItem->serialNo = $i + 1;
            $invoiceItem->orderId = $o->orderId;
            if (isset($o->outletDetails->outletName))
                $invoiceItem->outletName = $o->outletDetails->outletName;
            else
                $invoiceItem->outletName = 'not found';


            if (get_class($o) == "App\Models\Order") {
                $invoiceItem->customer = json_decode($o->customerDetails)->customerName;
            } else if (get_class($o) == "App\Models\VendorOrder") {
                try {
                    $parsed = json_decode($o->customer);
                    if ($parsed != null) {
                        $invoiceItem->customer = $parsed->fullName;
                    }
                } catch (\Exception $e) {
                    dd($e);
                }
            }
            $invoiceItem->item = $o->item;
            $invoiceItem->deliveryDate = $o->deliveryDate;
            $invoiceItem->deliveryStation = $o->deliveryStation;
            $invoiceItem->transactionType = $o->paymentType;
            $invoiceItem->orderStatus = $o->status;
            $invoiceItem->vendorPayment = $o->costPrice;
            $invoiceItem->vendorCollection = $o->amountPayable;
            $invoiceItem->gst = $o->gst;

            $invoiceItem->debit = '';
            $invoiceItem->credit = '';
            if ($invoiceItem->vendorPayment != 'N.A.') {
                if ($invoiceItem->orderStatus == 'ORDER_CANCELLED') {
                    $invoiceItem->vendorPayment = 0;
                    $invoiceItem->vendorCollection = 0;
                    $invoiceItem->gst = 0;
                    $invoiceItem->commision = 0;
                    if ($o->paymentType == 'PRE_PAID')
                        $invoiceItem->onlinePayment = 0;
                } else if ($invoiceItem->orderStatus == 'ORDER_UNDELIVERED') {
                    $invoiceItem->vendorPayment = 0;
                    $invoiceItem->vendorCollection = 100;
                    $invoiceItem->gst = 0;
                    # changed at 16:28 - 07/04/2020 by Ankit
                    $invoiceItem->debit = 100;

                    $invoiceItem->commision = 100;
                    if ($o->paymentType == 'PRE_PAID')
                        $invoiceItem->onlinePayment = 0;
                } else if ($invoiceItem->orderStatus == 'ORDER_PARTIALLY_DELIVERED') {
                    $invoiceItem->commision = $invoiceItem->vendorPayment * 0.5;
                    $invoiceItem->vendorPayment = $invoiceItem->vendorPayment * 0.5;
                    
                    
                    if ($o->paymentType == 'PRE_PAID'){
                        $invoiceItem->onlinePayment = $o->onlinePayment;
                        $invoiceItem->debit = $invoiceItem->vendorPayment;
                    }
                    else if($o->paymentType == 'CASH_ON_DELIVERY'){
                        $invoiceItem->credit = $invoiceItem->vendorPayment;
                    }
                } else {
                    $invoiceItem->commision = ($invoiceItem->vendorCollection - $invoiceItem->vendorPayment) - $invoiceItem->gst;
                    if ($o->paymentType == 'PRE_PAID')
                        $invoiceItem->onlinePayment = $o->onlinePayment;
                }

                if ($o->paymentType == 'CASH_ON_DELIVERY')
                    $invoiceItem->debit = ($invoiceItem->vendorCollection - $invoiceItem->vendorPayment); 
                else if ($o->paymentType == 'PRE_PAID')
                    $invoiceItem->credit = $invoiceItem->vendorPayment;
            }
            //$invoiceItem->bookedBy = 'N.A.'; //todo
            return $invoiceItem;
        });
        //Log::channel('dailyInfo')->error('invoice' . print_r($invoice, true));
        return $invoice;
    }

    public function saveRoutesDB()
    {
        set_time_limit(0);
        $apiKey = '7pcxxqlfes';
        $client = new \App\Domain\RouteService();
        $filename = base_path("TrainsInfo.js");
        $fileResource  = fopen($filename, "r");
        if (file_exists($filename) && is_readable($filename)) {
            $fileResource  = fopen($filename, "r");
            if ($fileResource && ($line = fgets($fileResource)) !== false) {
                while (($line = fgets($fileResource)) !== false) {
                    $train = substr($line, 1, strrpos($line, ' -') - 1);
                    //\App\TrainRoute::updateOrCreate(array('train'=>$train,'route'=>$client->getTrainRouteForDB($apiKey,$train)));
                    $route = \App\Models\TrainRoute::firstOrNew([
                        'train' => $train
                    ]);
                    try {
                        $res = $client->getTrainRouteForDB($apiKey, $train);
                        if (isset($res)) {
                            if (property_exists($res, 'route')) {
                                $route->route = json_encode($res);
                                $route->response_code = $res->response_code;
                                $route->status = 1;
                                //echo $route->response_code;
                            } else {
                                if (property_exists($res, 'response_code'))
                                    $route->response_code = $res->response_code;
                                $route->status = 0;
                            }
                        } else {
                            $route->status = 0;
                        }
                        //break;
                    } catch (\Exception $e) {
                        $route->status = 0;
                    }
                    $route->save();
                }
                fclose($fileResource);
            }
        }
    }
    public function updateRoutesDB()
    {
        set_time_limit(0);
        $apiKey = '7pcxxqlfes';
        $client = new \App\Domain\RouteService();
        $trains = \App\Models\TrainRoute::where(function ($q) {
            $q->where('status', 0);
        })->orWhere(function ($q) {
            $q->where('response_code', 502);
        })->get()->map(function ($el) use ($client, $apiKey) {
            $route = \App\Models\TrainRoute::firstOrNew([
                'train' => $el->train
            ]);
            try {
                $res = $client->getTrainRouteForDB($apiKey, $route->train);
                if (isset($res)) {
                    if (property_exists($res, 'route')) {
                        $route->route = json_encode($res);
                        $route->response_code = $res->response_code;
                        $route->status = 1;
                        //echo $route->response_code;
                    } else {
                        if (property_exists($res, 'response_code'))
                            $route->response_code = $res->response_code;
                        $route->status = 0;
                    }
                } else {
                    $route->status = 0;
                }
            } catch (\Exception $e) {
                echo $e->getMessage();
                $route->status = 0;
            }
            $route->save();
        });
    }

    public function updateRoutesDB1()
    {
        set_time_limit(0);
        $apiKey = '7pcxxqlfes';
        $client = new \App\Domain\RouteService();
        $trains = \App\Models\TrainRoute::all()
            ->map(function ($el) use ($client, $apiKey) {
                $route = \App\Models\TrainRoute::firstOrNew([
                    'train' => $el->train
                ]);
                try {
                    if (is_array(json_decode($route->route))) {
                        $res = $client->getTrainRouteForDB($apiKey, $route->train);
                        if (isset($res)) {
                            if (property_exists($res, 'route')) {
                                $route->route = json_encode($res);
                                $route->response_code = $res->response_code;
                                $route->status = 1;
                                //echo $route->response_code;
                            } else {
                                if (property_exists($res, 'response_code'))
                                    $route->response_code = $res->response_code;
                                $route->status = 0;
                            }
                        } else {
                            $route->status = 0;
                        }
                    }
                } catch (\Exception $e) {
                    echo $e->getMessage();
                    $route->status = 0;
                }
                $route->save();
            });
    }

    # unusable
    public function updateGSTSellingPrice()
    {
        set_time_limit(0);
        $totalRows = \App\MenuItem::count();
        $row = 1;
        $batch = 100;
        while ($row < $totalRows) {
            \App\Models\MenuItem::skip($row - 1)->take($batch)->get()
                ->map(function ($el) {
                    try {
                        $el->tax = round($el->basePrice * 0.05);
                        $el->basePrice = $el->vendorPrice * 0.45;
                        unset($el->vendorPrice);
                        $el->sellingPrice = $el->basePrice + $el->tax;
                        $el->save();
                    } catch (\Exception $e) {
                        echo $el->id . ', error:' . $e->getMessage();
                    }
                });
            $row += $batch;
        }
        return response("GST selling price updated successfully", 200);
    }


    public function setDeliveryDate()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        \App\Models\Order::all()
            ->map(function ($el) {
                //try{
                $date = str_replace(' IST', '', $el->deliveryDate);
                //$el->deliveryDateTime = \Carbon\Carbon::createFromFormat('m/d/Y H:i IST',$el->deliveryDate);
                $el->deliveryDateTime = \Carbon\Carbon::createFromFormat('m-d-Y H:i', $date);
                $el->save();
                //}catch(\Exception $e){
                //echo $el->orderId.', error:'.$e->getMessage();
                //}
            });
    }
    public function setCustomerMobile()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        \App\Models\Order::all()
            ->map(function ($el) {
                //try{
                $customerMobile = json_decode($el->customerDetails)->mobile;
                //$el->deliveryDateTime = \Carbon\Carbon::createFromFormat('m/d/Y H:i IST',$el->deliveryDate);
                if (!isset($el->customerMobile) || $el->customerMobile == '') {
                    $el->customerMobile = $customerMobile;
                    $el->save();
                }
                //}catch(\Exception $e){
                //echo $el->orderId.', error:'.$e->getMessage();
                //}
            });
    }
    public function setCustomerMobileVendor()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        \App\Models\VendorOrder::all()
            ->map(function ($el) {
                //try{
                $customerMobile = json_decode($el->customer)->mobile;
                //$el->deliveryDateTime = \Carbon\Carbon::createFromFormat('m/d/Y H:i IST',$el->deliveryDate);
                if (!isset($el->customerMobile) || $el->customerMobile == '') {
                    $el->customerMobile = $customerMobile;
                    $el->save();
                }
                //}catch(\Exception $e){
                //echo $el->orderId.', error:'.$e->getMessage();
                //}
            });
    }
    public function setOrderLinks()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        $res = DB::select(DB::raw("select created_at, orderId, vendor, mobile, previous_type, previous_id, next_type, next_id from ((SELECT orderId,CONVERT(customermobile,UNSIGNED INTEGER) AS mobile, vendor, created_at, previous_type, previous_id, next_type, next_id  FROM `orders`) union all (SELECT orderId,CONVERT(customermobile,UNSIGNED INTEGER) AS mobile, vendor, created_at, previous_type, previous_id, next_type, next_id FROM `vendor_orders`)) a order by mobile,created_at"));
        //Log::channel('dailyInfo')->info('sms response:'.print_r($res,true));
        $prev = null;
        if (isset($res) && isset($res[0])) {
            foreach ($res as $el) {
                if ($prev != null && $prev->mobile == $el->mobile) {
                    if ($prev->vendor)
                        $prevModel = \App\Models\VendorOrder::where('orderId', $prev->orderId)->first();
                    else
                        $prevModel = \App\Models\Order::where('orderId', $prev->orderId)->first();
                    if ($el->vendor)
                        $thisModel = \App\Models\VendorOrder::where('orderId', $el->orderId)->first();
                    else
                        $thisModel = \App\Models\Order::where('orderId', $el->orderId)->first();
                    $prevModel->next_type = get_class($thisModel);
                    if ($thisModel->vendor)
                        $prevModel->next_id = $thisModel->id;
                    else
                        $prevModel->next_id = $thisModel->orderId;

                    $thisModel->previous_type = get_class($prevModel);
                    if ($prevModel->vendor)
                        $thisModel->previous_id = $prevModel->id;
                    else
                        $thisModel->previous_id = $prevModel->orderId;

                    $prevModel->save();
                    $thisModel->save();
                }
                $prev = $el;
            }
        }
    }

    public function setEarnings()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        \App\Models\Order::all()
            ->map(function ($el) {
                //try{

                $outlet = \App\Models\Outlet::find($el->outlet_id);
                if (isset($outlet->menu)) {
                    $items = array_column($outlet->menu->items->toArray(), 'vendorPrice', 'id');
                    $orderItems = collect(json_decode($el->orderItems, true))->map(function ($oi) use ($items) {
                        if (isset($items[$oi['itemId']]))
                            $oi['costPrice'] = $items[$oi['itemId']];
                        return $oi;
                    });
                    $unavailable = false;
                    $subtotal1 = collect($orderItems)->sum(function ($item) {
                        if (isset($item['costPrice']) && $item['costPrice'] != 'N.A.' && $item['costPrice'] != '') {
                            return $item['costPrice'] * $item['quantity'];
                        }
                        $unavailable = true;
                    });
                    if ($unavailable)
                        $el['vendorPayment'] = 0;
                    else
                        $el->vendorPayment = $el->amountPayable - $subtotal1;

                    $el->save();
                    //}catch(\Exception $e){
                    //echo $el->orderId.', error:'.$e->getMessage();
                    //}
                }
            });
    }
    public function setEarningsVendor()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        \App\Models\VendorOrder::all()
            ->map(function ($el) {
                //try{

                $outlet = \App\Models\Outlet::find($el->outlet);
                if (isset($outlet->menu)) {
                    $items = array_column($outlet->menu->items->toArray(), 'vendorPrice', 'id');
                    $orderItems = collect(json_decode($el->orderItems, true))->map(function ($oi) use ($items) {
                        if (isset($items[$oi['itemId']]))
                            $oi['costPrice'] = $items[$oi['itemId']];
                        return $oi;
                    });
                    $unavailable = false;
                    $subtotal1 = collect($orderItems)->sum(function ($item) {
                        if (isset($item['costPrice']) && $item['costPrice'] != 'N.A.' && $item['costPrice'] != '') {
                            return $item['costPrice'] * $item['quantity'];
                        }
                        $unavailable = true;
                    });
                    if ($unavailable)
                        $el['vendorPayment'] = 0;
                    else
                        $el->vendorPayment = $el->amountPayable - $subtotal1;

                    $el->save();
                    //}catch(\Exception $e){
                    //echo $el->orderId.', error:'.$e->getMessage();
                    //}
                }
            });
    }
    public function setDeliveryDateVendor()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        \App\Models\VendorOrder::all()
            ->map(function ($el) {
                //try{
                $date = str_replace(' IST', '', $el->deliveryDate);
                //$el->deliveryDateTime = \Carbon\Carbon::createFromFormat('m/d/Y H:i IST',$el->deliveryDate);
                $el->deliveryDateTime = \Carbon\Carbon::createFromFormat('Y-m-d H:i', $date);
                $el->save();
                //}catch(\Exception $e){
                //echo $el->orderId.', error:'.$e->getMessage();
                //}
            });
    }

    public function updateMenuItems()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        \App\Models\Menu::all()
            ->map(function ($el) {
                //try{
                $outletId = $el->outlet_id;
                $el->items
                    ->map(function ($e) use ($outletId) {
                        $e->outlet_id = $outletId;
                        $e->save();
                    });
                //}catch(\Exception $e){
                //echo $el->orderId.', error:'.$e->getMessage();
                //}
            });
    }
    public function updateClosingPeriod()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        \App\Models\Outlet::all()
            ->map(function ($el) {
                //try{
                $el->weeklyClosed = json_encode(array());
                $el->closingPeriod = json_encode(array());
                $el->save();
                //}catch(\Exception $e){
                //echo $el->orderId.', error:'.$e->getMessage();
                //}
            });
    }
    public function setActive()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        \App\Models\Outlet::all()
            ->map(function ($el) {
                //try{
                $el->active = 1;
                $el->save();
                //}catch(\Exception $e){
                //echo $el->orderId.', error:'.$e->getMessage();
                //}
            });
    }
    public function setUserMobile()
    {
        \App\Models\user::all()
            ->map(function ($el) {
                if (!empty($el->mobile)) {
                    $mobiles = explode(',', $el->mobile);
                    $first = 1;
                    foreach ($mobiles as $mobile) {
                        if ($first)
                            $el->mobiles()->create(['mobile' => $mobile, 'role' => 1]);
                        else
                            $el->mobiles()->create(['mobile' => $mobile]);
                        $first = 0;
                    }
                }
            });
    }
    public function setVendorRoles()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        $user_role = \App\Models\Role::where('slug', 'vendor')->first();
        \App\Models\User::where('role', 'vendor')->get()
            ->map(function ($el) use ($user_role) {
                //try{
                if (sizeof($el->roles) == 0)
                    $el->roles()->attach($user_role);
                //}catch(\Exception $e){
                //echo $el->orderId.', error:'.$e->getMessage();
                //}
            });
    }

    public function voucher()
    {
        echo \Carbon\Carbon::now()->toDateString();
        $discount = \App\Models\Discount::where(function ($q) {
            $q->where('validFrom', '<=', \Carbon\Carbon::now()->toDateString())
                ->where('validTo', '>=', \Carbon\Carbon::now()->toDateString());
        })->first();
        if ($discount != null)
            print_r($discount);
    }
    public function setAmountPayable()
    {
        set_time_limit(0);
        ini_set('memory_limit', '-1');
        \App\Models\Order::all()
            ->map(function ($el) {
                //try{
                $payable = json_decode($el->priceDetails)->amountPayable;
                //$el->deliveryDateTime = \Carbon\Carbon::createFromFormat('m/d/Y H:i IST',$el->deliveryDate);
                $el->amountPayable = $payable;
                $el->save();
                //}catch(\Exception $e){
                //echo $el->orderId.', error:'.$e->getMessage();
                //}
            });
    }
    public function createMemoryUsersTable()
    {
        Schema::create('tmp_users', function (Blueprint $table) {
            $table->increments('id');
            $table->string('mobile', 10);
            $table->boolean('memory');
            $table->string('password', 60);
            $table->string('remember_token', 100);
            $table->timestamps();
        });
    }

    public function consolidatedReports(Request $request)
    {
        $d1 = $request->query('start', false);
        $d2 = $request->query('end', false);

        if ($d1 & $d2) {
            $exc3l = new ConsolidatedReport($d1, $d2);
            return $exc3l->download('consolidated_report.xlsx');
        } else {
            echo sprintf("<p>%s</p>", "Start and End Date are Required to process Consolidated Reports");
        }
    }


    public function serveConsolidated()
    {
        return view('backend.reports.consolidated');
    }
}
