<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Http\Requests;
use Log;
class MenuItemController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index($outletId)
    {
        $menuItems = \App\Models\Outlet::find($outletId)->items->toArray();
        //Log::channel('dailyInfo')->info(print_r($menuItems,true));
        return view('backend.menus.items',['items'=>$menuItems,'outletId'=>$outletId,'info'=>null]);
    }
    
    
    public function idx($outletId)
    {
        $outlet = \App\Models\Outlet::find($outletId);
        $menuItems = $outlet->items->toArray();
        return view('backend.menus.updateList',['items'=>$menuItems,'outletId'=>$outletId,'info'=>$outlet->outletName]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request,$outletId)
    {
        
        if(!($request->has('update')||$request->has('delete')||$request->has('id'))){
            return view('backend.menus.items',['items'=>\App\Models\Outlet::find($outletId)->items->toArray(),'outletId'=>$outletId,'info'=>'either update or delete']);
        }
        $info = null;
        if($request->has('delete')&&$request->input('delete')=='delete'&&$request->has('id')){
            \App\Models\MenuItem::find($request->input('id'))->delete();
            session()->flash('success', 'Menu item deleted successfully');
            $info = 'Menu item deleted successfully';
        }else if($request->has('update')&&$request->input('update')=='update'&&$request->has('id')){
            $fields = $request->all();
            $fields['image'] ='';
            //unset($fields['id']);
            unset($fields['update']);
            \App\Models\MenuItem::find($request->input('id'))->update($fields);
            $info = 'Menu item updated successfully';
            session()->flash('success', 'Menu item updated successfully');
        }
        return view('backend.menus.items',['items'=>\App\Models\Outlet::find($outletId)->items->toArray(),'outletId'=>$outletId,'info'=>$info]);
    }
        
    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
    public function deleteAll($outletId)
    {
        $deleted = \App\Models\MenuItem::where('outlet_id', $outletId)->delete();
        session()->flash('success', 'Menu items deleted successfully');
        return redirect()->to('manager/outlets/list/menuitems/'.$outletId)->send();
    }
}
