<?php namespace App\Http\Controllers;

use App\Http\Requests;
use App\Http\Controllers\Controller;

use Illuminate\Http\Request;
use App\Domain\StationService;
use App\Domain\ItemService;
use App\Domain\RouteService;
use Log;

class OrderCreationController extends Controller {

	/**
	 * Display a listing of the resource.
	 *
	 * @return Response
	 */
	public function index()
	{
		//
	}

	/**
	 *hook Statiom Servie here Once all done
	 * @return Response
	 */
	public function getStations($trainNo)
	{
	   //$stations =  \App\Station::all();
	   $client = new \App\Domain\RouteService();
	   //$client =  \App\XClient::getClient();
	   $apiKey = '7pcxxqlfes' ;//|| config('API_AILWAY_KEY');

	   $date = \Carbon\Carbon::now()->format('d-m-Y');
	   $stations = $client->getTrainRoute($trainNo,$date,$apiKey);
	   $stationMap = collect($stations)->map(function($s){
				$st = new \stdClass;
				$st->name = $s->station->name;
				$st->code = $s->station->code;
				$st->departure = $s->schdep;
				$st->arrival = $s->scharr;
				$stations = new \App\Domain\StationService();
		        $restros = $stations->getOutletsByStation($st->code);
				$st->restraunt = $restros;
				return $st;
			})->filter(function($stn){
			    return collect($stn->restraunt)->count() > 0;
			})->flatten();
	   //dd($requestdata);
	   //return response()->json(compact('trainNo','stationService','requestdata'));
	   return response()->json(['stations'=>$stationMap],200);
	}

	public function getPnrStations($pnr)
	{
	   $client = new \App\Domain\PnrService();
	   $train = $client->getTrainPnr($pnr,[
                                            //'Authorization'=>'80d171c2-8bef-4b02-884f-fabffc769776' //dev
                                            'Authorization'=>config('constkeys.irctc_token') //prod
                                        ]);
                                        
	   return response()->json($train,200);
	}
	
	public function getPnrStations1($pnr)
	{
	   $client = new \App\Domain\PnrService();
	   $stations = $client->getStationPnr($pnr,[
                                            //'Authorization'=>'80d171c2-8bef-4b02-884f-fabffc769776' //dev
                                            'Authorization'=>config('constkeys.irctc_token') //prod
                                        ]);
	   return response()->json($stations,200);
	}
	public function getTrainName($train)
	{
	   $client = new \App\Domain\RouteService();
	   $res = $client->getTrainName('7pcxxqlfes',$train);
	   return response()->json($res,200);
	}
	public function checkTrain($train,$station,$booking,$delivery,$order_timing)
	{
	   //$stations =  \App\Station::all();
            $apiKey = '7pcxxqlfes' ;
            $stService = new \App\Domain\StationService();
            $arr = $stService->getLiveStatus($apiKey,$train,$station);
            echo $arr;
            $date = \Carbon\Carbon::createFromFormat('d M Y H:i', $arr);
            return $delivery->moreThan($date) || ($booking->addMinutes(int($order_timing))->lessThanOrEqualTo($date) && $delivery->lessThanOrEqualTo($date));
        }

        /**
	 * Store a newly created resource in storage.
	 *
	 * @return Response
	 */
	public function getRestros($code)
	{
		$stations = new \App\Domain\StationService();
		$restros = $stations->getOutletsByStation($code);
		return response()->json(compact('restros'),200);
	}

	/**
	 * Display the specified resource.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function getItems($id)
	{
		$i= new ItemService();
		$items = $i->getItemFromOutlet($id);
		return response()->json(compact('items'),200);
	}


	public function getSchArrival($trainNo, $date, $stCode)
	{
	   $client = new \App\Domain\RouteService();
	   $apiKey = '7pcxxqlfes' ;//|| config('API_AILWAY_KEY');

	   return $client->getTrainSchArr($trainNo,$date,$apiKey, $stCode);
        }

	public function getSchArrivalPnr($pnr,$date,$stCode)
	{
	   $client = new \App\Domain\PnrService();
	   Log::channel('dailyInfo')->info("pnr234:".$pnr);
	   return $client->getTrainSchArr($pnr,$date,$stCode,['Authorization'=>config('constkeys.irctc_token')]);
        }
	/**
	 * Show the form for editing the specified$stCode resource.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function getOrderForm($id)
	{
		//
	}

	/**
	 * Update the specified resource in storage.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function getCheckout($id)
	{
		//
	}

	/**
	 * Remove the specified resource from storage.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function destroy($id)
	{
		//
	}
	
	
	function validateStation($station, $rest){
	    
	    $now = \Carbon\Carbon::now();
	   // return $station;
	    $arrivalDateTimeAtStation = \Carbon\Carbon::createFromFormat("Y-m-d H:i", $station->arrDate." ".$station->arrival ?? $station->schArrivalTime);
	    
	    $depDateTimeAtStation = \Carbon\Carbon::createFromFormat("Y-m-d H:i", $station->arrDate." ".$station->departure);
	    
	    $openingDateTimeAtStation = \Carbon\Carbon::createFromFormat("Y-m-d H:i", $station->arrDate." ".$rest->openingTime);
	    
	    $closingDateTimeAtStation = \Carbon\Carbon::createFromFormat("Y-m-d H:i", $station->arrDate." ".$rest->closingTime);
	    $cutoffDateTimeAtStation = $arrivalDateTimeAtStation->subMinutes($rest->cutOffTime);
	    $openAccToRoutine = $cutoffDateTimeAtStation->between($openingDateTimeAtStation,$closingDateTimeAtStation);
	    $serviceAvailable = $rest->off;
	    
	    if($serviceAvailable){
	        return [false,"Service Temporary Not Available",$arrivalDateTimeAtStation->format('Y-m-d'),$arrivalDateTimeAtStation, $depDateTimeAtStation];
	    }
	    
	    
	    
	    if($now->greaterThan($arrivalDateTimeAtStation)){
	        return [false,"Train Schedule departed",$arrivalDateTimeAtStation->format('Y-m-d'),$arrivalDateTimeAtStation, $depDateTimeAtStation];
	    }
	    
	    
	    if(!$openAccToRoutine){
	        return [false,"Restraunt is Closed",$arrivalDateTimeAtStation->format('Y-m-d') ,$arrivalDateTimeAtStation, $depDateTimeAtStation];
	    }
	    
            /*
	    if(
	        ($arrivalDateTimeAtStation->lessThan( $arrivalDateTimeAtStation->addMinutes(intval($rest->order_timing))))
	    ){
	        return [false,"Train departed.",$arrivalDateTimeAtStation->format('Y-m-d'),$arrivalDateTimeAtStation, $depDateTimeAtStation];
	    }
             * 
             */
	    if(
	        ($arrivalDateTimeAtStation->lessThan( $now->addMinutes(intval($rest->order_timing))))
	    ){
	        return [false,"Train departed.",$arrivalDateTimeAtStation->format('Y-m-d'),$arrivalDateTimeAtStation, $depDateTimeAtStation];
	    }
	    
	    return [true, "Service Available",$arrivalDateTimeAtStation->format('Y-m-d'),$arrivalDateTimeAtStation, $depDateTimeAtStation];
	}
	
	public function pnrToRestraunts($pnr)
	{
	   $client = new \App\Domain\PnrService();
	   $clientx = new \App\Domain\RouteService();
	   $train = $client->getTrainPnr($pnr,['Authorization'=>config('constkeys.irctc_token')]);
	  
	   $apiKey = '7pcxxqlfes' ;//|| config('API_AILWAY_KEY');
	   $date = \Carbon\Carbon::now()->format('d-m-Y');
	   #$stations = $clientx->getTrainRoute($train->trainInfo->trainNo,$date,$apiKey);
	   
	   if($train == null){
	       return response()->json(["message" => "IRCTC API Error"], 400);
	   }
        $data = $train->stations;
        
        
        
         $train->stations = collect($data)->map(function($s) use($date){
         $st = $s;
         $stations = new \App\Domain\StationService();
		 $restros = $stations->getOutletsByStationV2($s->code);
		 $st->restraunt = [];
		 
		 foreach($restros as $rest){
		     try{
		         list($canOrder,$status, $bookingDate, $arr,$dep) = $this->validateStation($st,$rest);
		         $x = $rest;
                 $x->deliveryAvailable = compact('canOrder', 'status', 'bookingDate','arr' ,'dep');
                 if($canOrder)
                    array_push($st->restraunt,$x);
                 
		     }catch(\Exception $e){
		         
		     }
		 }
		 return $st;
		 
       })->filter(function($st){
			    return collect($st->restraunt)->count() > 0;
			})->flatten();;
	   return response()->json($train,200);
	}

}
