<?php
namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Log;
use Auth;
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of OrderEditController
 *
 * @author ASG INFOTECH
 */
class OrderEditController extends Controller {
        public function orderUpdate(Request $request, $orderId)
        {
            try{
                //$this->authorize('pol_update_order', \App\Order::where('orderId',$orderId));
                $fields = $request->all();
                if (!isset($orderId)||!$request->has('status')||!$request->has('vendor')) {
                    return json_encode(array('status' => 'failure', 'msg' => "input parameters missing"));
                }
                $statusArr = array('ORDER_PREPARED','ORDER_OUT_FOR_DELIVERY','ORDER_PARTIALLY_DELIVERED','ORDER_UNDELIVERED','ORDER_DELIVERED','ORDER_CANCELLED');
                if(!in_array($fields['status'], $statusArr))
                    return json_encode(array('status' => 'failure', 'msg' => "invalid status"));
                
                $vendorOrder = $fields['vendor'];
                unset($fields['vendor']);
                unset($fields['__api']);
                unset($fields['api_token']);
                if($vendorOrder)
                    $checkOrder = \App\Models\VendorOrder::where('orderId',$orderId)->first();
                else
                    $checkOrder = \App\Models\Order::where('orderId',$orderId)->first();
                if($checkOrder->status=='ORDER_CANCELLED'
                        || $checkOrder->status=='ORDER_DELIVERED'
                        || $checkOrder->status=='ORDER_UNDELIVERED')
                    return response()->json(['status'=>"failure", 'message'=>'Status is '.$checkOrder->status],200);
                    
                    
                $fields['requestor_user_id'] = Auth::guard('api_mobile')->user()->id;
                if($fields['status']=='ORDER_CANCELLED'){
                    $fields['pending_status'] = $fields['status'];
                    $fields['status_status'] = 'PENDING';
                    unset($fields['status']);
                    if($vendorOrder){
                        $update = \App\Models\VendorOrder::where('orderId',$orderId)->update($fields);
                        $order = \App\Models\VendorOrder::where('orderId',$orderId)->first();
                        $order = $this->formatVendorOrder($order);
                    }else{
                        $update = \App\Models\Order::where('orderId',$orderId)->update($fields);
                        $order = \App\Models\Order::where('orderId',$orderId)->first();
                        $order = $this->formatOrder($order);
                    }
                }else{
                    $fields['status_status'] = null;
                    $fields['pending_status'] = null;
                    if($vendorOrder){
                        $order = \App\Models\VendorOrder::where('orderId',$orderId)->first();
                        if($order->status_history==null)
                            $status_history = '';
                        else
                            $status_history = $order->status_history;
                        $fields['status_history'] = $status_history.'->'.$fields['status'];
                        $update = \App\Models\VendorOrder::where('orderId',$orderId)->update($fields);
                        $order = \App\Models\VendorOrder::where('orderId',$orderId)->first();
                        $order = $this->formatVendorOrder($order);
                    }else{
                        $order = \App\Models\Order::where('orderId',$orderId)->first();
                        if($order->status_history==null)
                            $status_history = '';
                        else
                            $status_history = $order->status_history;
                        $fields['status_history'] = $status_history.'->'.$fields['status'];
                        $update = \App\Models\Order::where('orderId',$orderId)->update($fields);
                        $order = \App\Models\Order::where('orderId',$orderId)->first();
                        $order = $this->formatOrder($order);
                    }
                }
                $order->aggregatorDetails = json_decode($order->aggregatorDetails);
                $order->customerDetails = json_decode($order->customerDetails);
                $order->priceDetails = json_decode($order->priceDetails);
                $order->orderItems = json_decode($order->orderItems);

                if($update){
                    return response()->json(["status"=>"success", "order"=>$order],200);
                }
                return response()->json(['status'=>"failure", 'message'=>'Updation failed'],200);
            }catch(\Exception $e){
                return response()->json(['status'=>"failure", 'message'=>'Updation failed'],501);
            }

        }
        public function formatOrder($order)
        {
            $deliveryDetails = json_decode($order->deliveryDetails);
            $order->outletDetails = \App\Models\Outlet::find($order->outlet_id);
            $order->vendorOrder = false;
            return $order;
        }
        public function formatVendorOrder($order)
        {
            $deliveryDetails = new \stdClass;
            $deliveryDetails->pnr = $order->pnr;
            $deliveryDetails->trainNo = $order->trainNo;
            $deliveryDetails->trainName = $order->trainName;
            $deliveryDetails->station = $order->stationName;
            $deliveryDetails->stationCode = $order->stationCode;
            $deliveryDetails->berth = $order->berth;
            $deliveryDetails->coach = $order->coach;
            $deliveryDetails->ETA = $order->deliveryDate;
            $order->deliveryDetails = json_encode($deliveryDetails);

            $order->customerDetails = json_decode($order->customer);
            $order->customerDetails->customerName = $order->customerDetails->fullName;
            $order->customerDetails = json_encode($order->customerDetails);

            $priceDetails = new \stdClass;
            $priceDetails->totalAmount = $order->totalAmount;
            $order->priceDetails = json_encode($priceDetails);

            $order->outletDetails = \App\Models\Outlet::find($order->outlet);
            $order->vendorOrder = true;
            
            return $order;
        }
}
