<?php

namespace App\Http\Controllers;

use App\Domain\PnrService;
use App\Models\Station;
use Illuminate\Http\Request;
// use GuzzleHttp\Client;
use App\XClient;

class PNRController extends Controller
{
    private $service;

    function __construct(PnrService $service)
    {
        $this->service = $service;
    }

    public function fetchPNRStatus(Request $request)
    { 
        $codes = [];
        $result = null;
        $pnr = null;
        if ($request->method() == 'POST') {
            $pnr = $request->input('pnr');
            $codes = Station::all()->pluck('code')->map(function ($s) {
                return trim($s);
            })->toArray();

            $result = $this->service->fetchPNRData($pnr, ['Authorization' => config('constkeys.irctc_token')])['result'];
            
            if ($result == null) {
                session()->flash('pnrMessage', 'PNR Number not found');
            }
    
        }

        return view('v2.pages.pnr_status', compact('result', 'codes', 'pnr'));
    }



    private function renderPage()
    {
    }

    private function fetchPage($code)
    {
    }
}
