<?php

namespace App\Http\Controllers;

use App\Models\PageMeta;
use Illuminate\Http\Request;

class PageMetaController extends Controller
{
    public function index()
    {       
        $this->authorize('page-seo-meta-list');
        $MetaDataObj = PageMeta::all();

        return view('backend.PageMeta.index', compact('MetaDataObj'));
    }


    public function edit($id)
    {       
        $this->authorize('page-seo-meta-edit');
        $data = PageMeta::find($id);

        return response()->json($data,200);
    }

    public function update(Request $request)
    {
        $this->authorize('page-seo-meta-edit');
        $totalData =[];

        $file = $request->file('meta_image');
        if(isset($file)){
        $fileName = date('Ymdhis').$file->getClientOriginalName();
         $destinationPath = public_path('assets/img');
         $file->move($destinationPath,$fileName);
           $link = '/assets/img/'.$fileName;
           $totalData['meta_image'] = $link;
        }

        $totalData['meta_title'] = $request->meta_title;
        $totalData['meta_description'] = $request->meta_description;

        PageMeta::where('id',$request->meta_id)->update($totalData);

        return response()->json([],200);

    }
}
