<?php
namespace App\Http\Controllers;

use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;


class SlideshowController extends Controller{
    public function index(){
        $images = DB::table('slideshows')->get();
        return view('slideshows.index',compact('images'));
    }
    
    public function api(){
        $images = DB::table('slideshows')->get()->map(function($img){
            $x = $img;
            $x->url = "http://olfstores.com/slider/".$img->name;
            $x->active = $x->active ==1 ? true :false;
            return $x;
            
        });
        return response()->json(compact('images'));
    }
    
    public function store(Request $request){
      if($request->hasFile('file')){
            $extn =  $request->file('file')->getClientOriginalExtension();
            $fileName = "slide"."_".time().".".$extn;
            $request->file('file')->move(public_path('/slider'),$fileName);
            DB::table('slideshows')->insert([
                'name'=>$fileName,
                'active'=>1
            ]);
            
            return response()->json(['message'=> 'OK']); 
      }  
    }
    
    public function remove(Request $request, $id){
        $file = DB::table('slideshows')->where('id', $id)->get()[0];
        DB::table('slideshows')->where('id', $id)->delete();
        unlink(public_path('/slider').'/'.$file->name);
        return response()->json(['message'=>"File Deleted"], 200);
    }
    
    public function toggleActive(Request $request, $id){
         $file = DB::table('slideshows')->where('id', $id)->get()[0];
         $status = $file->active ==1 ? true:false;
         DB::table('slideshows')->where('id', $id)->update(['active'=> !$status]);
        return response()->json(['message'=>"File Status Changed"], 200);
    }
}