<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\StationMeta;
use App\Models\Station;

class StationMetaController extends Controller
{
    public function index()
    {
        $stat = Station::all();
        $meta_ids = StationMeta::with('station')->get()->pluck('station');
    
        $ids = [];

        foreach ($meta_ids as $meta) {
            if(!empty($meta))
            array_push($ids, $meta->code);
        }

        $stations = StationMeta::with('station')->get();
        return view('backend/meta/index', compact('stations', 'stat', 'ids'));
    }


    public function create(Request $request)
    {


        $data = $request->all();

        StationMeta::create(['meta' => $data['meta'], 'description' => trim($data['description']), 'station_id' => $data['station']]);
        return redirect()->back();
    }


    public function edit(Request $request, $id)
    {

        $data = StationMeta::find($id);

        if ($data == null) {
            return redirect()->back();
        }


        return view('backend/meta/edit', compact('data'));
    }

    public function patch(Request $request, $id)
    {
        $data = StationMeta::find($id);
        $data->description = $request->input('description');
        $data->meta = trim($request->input('meta'));
        $data->save();

        return redirect()->route('metaList');
    }
}
