<?php namespace App\Http\Controllers;

use App\Http\Requests;
use App\Http\Controllers\Controller;

use Illuminate\Http\Request;
use Log;

class VendorController extends Controller {
    public function __construct()
    {
        
    }
    public function activate($id) {
        $user = \App\Models\User::find($id);
        $user->active = 1;
        $user->save();

        return redirect('backend/vendors');
    }

public function index() {
        //$vendors = \App\User::where('role','=','vendor')->get();
        $vendors = \App\Models\Role::where('slug','vendor')->first()->users->load('outlets')->toArray();
        return view('backend/vendors.index', compact(['vendors']));
    }

    public function show($id) {
        $vendor = \App\Models\User::find($id);
        return view('backend/vendors.show', compact('vendor'));
    }


    public function create() {
        return view('backend/vendors.create');
    }

   public function store(Request $request) {
        $this->validate($request, [
        ]);
        if (\App\Models\User::whereEmail($request->email)->get()->count()) {
            session()->flash('error', 'Duplicate Entry For email field.');
            return redirect()->back()->withInput(Input::all());
        }

        $data = $request->only(['first_name', 'last_name', 'email', 'passwrod', 'mobile', 'dob',
            'address']);
        $data['password'] = bcrypt($data['passwrod']);
        $data['role'] = 'vendor';
        $data['active']= 0;
        $user = \App\Models\User::create($data);

        $mobiles = explode(',', $user->mobile);
        $first = 1;
        foreach ($mobiles as $mobile) {
            if($first)
                $user->mobiles()->create(['mobile'=>$mobile, 'role'=>1]);
            else
                $user->mobiles()->create(['mobile'=>$mobile]);
            $first = 0;
        }
        
        $user_role = \App\Models\Role::where('slug',$data['role'])->first();
        $user->roles()->attach($user_role);

        session()->flash('success', 'Your Vendors created successfully.');
        return redirect()->back();
    }

    public function edit($id) {
        $vendor = \App\Models\User::find($id);
        return view('backend/vendors.update', compact('vendor'));
    }

  public function update(Request $request, $id) {
        $this->validate($request, [
        ]);
        $faq = \App\Models\User::find($id);
        $faq->updateOld($request->all());
        session()->flash('success', 'Your Vendor  Updated successfully.');
        return redirect()->back();
    }

    public function destroy($id) {
        $vendor = \App\Models\User::find($id)->delete();
        session()->flash('success', 'Vendor deleted successfully.');
        return redirect()->back();
    }



    public function editAjax(Request $request) {
       
        $vendor = \App\Models\User::findOrFail($request->vendor_id);

        if(!empty($vendor)){
        $html_data= view('backend/vendors.vendor_edit', compact('vendor'))->render();

        return response()->json(['status'=>200,'html'=>$html_data]);
        }
        else{

            return response()->json(['status'=>201,'html'=>""]);
        }
    }

}
