<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class VoucherController extends Controller
{
    public function __construct()
    {
    }
    
    public function vouchersGeneral(Request $request, $start=1, $end=50, $total=null)
    {
        $method = $request->input("method");
        $methodActual = $request->method();
        if(isset($method) && $method=="GET")
            $methodActual = $method;
        switch ($methodActual) {
            case 'POST':
                if($request->submit == "next"){
                    $start += 50;
                    $end = $start+50-1;
                }else if($request->submit == "previous"){
                    $start -= 50;
                    $end = $start+50-1;
                }
                break;


            default:
                // invalid request
                break;
        }        
        $total = \BeyondCode\Vouchers\Models\Voucher::where('type', "1")->count();
        Log::channel('dailyInfo')->info('total'.$total);
        
        if($end>$total)
            $end = $total;
        if($start>$total)
            $vouchers = null;
        else    
            $vouchers = \BeyondCode\Vouchers\Models\Voucher::where('type', 1)->skip($start-1)->take($end-$start+1)->get();

        
    
        $pageCount = (int)($total/50)+1;
        return view('backend/vouchers.index', ['vouchers'=>$vouchers, 'pageCount'=>$pageCount, 'start'=>$start, 'end'=>$end, 'total'=>$total]);
    }

    public function voucher(Request $request)
    {
        $method = $request->method();
        switch($method){
            case 'GET':
                return view('backend/vouchers.create', ['code' => "", 'data' => "", 'expires' => ""]);

            case 'POST':
               
                if(!$request->has('code') || !$request->has('data') || !$request->has('expires')){
                    return view('backend/vouchers.create', ['code' => $request->input('code'), 'data' => $request->input('data'), 'expires' => $request->input('expires')]);
                }
                $voucher = array();
                $voucher['code'] = $request->input('code');
                $voucher['data'] = json_encode($request->input('data'));
                //$voucher['expires_at'] = now()->addHours((int)$request->input('expires'));
                $voucher['expires_at'] = date('Y-m-d',strtotime($request->input('expires')));
                
                $vc = new \BeyondCode\Vouchers\Models\Voucher();
                $vc->fill($voucher);
                $vc->type = "1";

                $vc->save();

                $request->request->add(['method' => 'GET']);
                return $this->vouchersGeneral($request);
        }
                    
    }
    
    public function delete($id)
    {
        $voucher = \BeyondCode\Vouchers\Models\Voucher::find($id);
        $result = false;
        if(isset($voucher))
            $result = $voucher->delete();
        
        return view('backend/vouchers.delete', ['result'=>$result]);
   }
}
