<?php namespace App\Http;

use Illuminate\Foundation\Http\Kernel as HttpKernel;

class Kernel extends HttpKernel {

	/**
	 * The application's global HTTP middleware stack.
	 *
	 * @var array
	 */
	protected $middleware = [

        \Illuminate\Foundation\Http\Middleware\CheckForMaintenanceMode::class,
        \App\Http\Middleware\IsLoggedMiddleware::class,
        \App\Http\Middleware\TrustProxies::class,
        \Illuminate\Http\Middleware\HandleCors::class,
        \App\Http\Middleware\PreventRequestsDuringMaintenance::class,
        \Illuminate\Foundation\Http\Middleware\ValidatePostSize::class,
        \App\Http\Middleware\TrimStrings::class,
        \Illuminate\Foundation\Http\Middleware\ConvertEmptyStringsToNull::class,
    ];


	/**
	 * The application's route middleware.
	 *
	 * @var array
	 */
	protected $middlewareAliases = [
		'auth' => 'App\Http\Middleware\Authenticate',
		'auth.basic' => 'Illuminate\Auth\Middleware\AuthenticateWithBasicAuth',
        'can' => '\Illuminate\Auth\Middleware\Authorize',
    	'guest' => 'App\Http\Middleware\RedirectIfAuthenticated',
		'hydrogen'=> 'App\Http\Middleware\ReverseMiddileware',
		'cors'=> 'App\Http\Middleware\Cors',
        'role'=> 'App\Http\Middleware\RoleMiddleware',
        'csrf'=> 'App\Http\Middleware\VerifyCsrfToken',
        'customToken'=> 'App\Http\Middleware\APITokenMiddleware.php',
        'bindings' => \Illuminate\Routing\Middleware\SubstituteBindings::class,
        'throttle' => \Illuminate\Routing\Middleware\ThrottleRequests::class,
        'formatting' =>'App\Http\Middleware\FieldFormatterMiddleware',
        'coupon' =>'App\Http\Middleware\CouponMiddleware',
        'wallet' =>'App\Http\Middleware\WalletMiddleware',
        'pricing' =>'App\Http\Middleware\PricingMiddleware',
        'orderValidator' =>'App\Http\Middleware\OrderValidatorMiddleware',
        'postProcessor' =>'App\Http\Middleware\PostProcessingMiddleware',
        // 'permissionChecker'=>'\App\Http\Middleware\GateDefineMiddleware::class'
	];


 /**
     * The application's route middleware groups.
     *
     * @var array
     */
    protected $middlewareGroups = [
        'web' => [
            \Illuminate\Cookie\Middleware\EncryptCookies::class,
            \Illuminate\Cookie\Middleware\AddQueuedCookiesToResponse::class,
            \Illuminate\Session\Middleware\StartSession::class,
            //\Illuminate\Session\Middleware\AuthenticateSession::class,
            \Illuminate\View\Middleware\ShareErrorsFromSession::class,
            //\App\Http\Middleware\VerifyCsrfToken::class,
            \Illuminate\Routing\Middleware\SubstituteBindings::class,
            \App\Http\Middleware\PermissionMiddleware::class,
            
        ],
        'api' => [
            'throttle:60,1',
            'bindings',
        ],
    ];

 /**
     * The priority-sorted list of middleware.
     *
     * This forces non-global middleware to always be in the given order.
     *
     * @var array
     */
    // protected $middlewarePriority = [
    //     \Illuminate\Session\Middleware\StartSession::class,
    //     \Illuminate\View\Middleware\ShareErrorsFromSession::class,
    //     \App\Http\Middleware\Authenticate::class,
    //     \Illuminate\Session\Middleware\AuthenticateSession::class,
    //     \Illuminate\Routing\Middleware\SubstituteBindings::class,
    //     \Illuminate\Auth\Middleware\Authorize::class,
    // ];
}
