<?php

namespace App\Http\Middleware;
use Illuminate\Http\Response;
use Closure;
use Illuminate\Support\Facades\Log;
class Extractor{
        
        
    function __construct($array){
       //dd($array); 
            $this->claimType = "NO_CLAIM";
            
            foreach($array as $field=>$value){
                $this->$field = $value['value'];
                
                if(is_array($value['value']) && !in_array($field ,['outlet'])){
                    $values = array_map(function($d){
                        return (object)$d;
                    },$value['value']);
                 
                   $this->$field = $values;   
                }else{
                    $this->$field = $value['value'];    
                }
                
            }
            
            $this->attachOutlet();
            $this->addVendorDetails();
            $this->addCustomerDetails();
            $this->addBookingDate();
            
            $this->discountAmount  = 0;
            $this->amountPayable = 0;
            $this->totalAmount = 0;
            $this->gst = 0;
            
            $this->expandItems();
            
            $this->calculateAmtPayable();
        
            
        }
        
    function addBookingDate(){
        $date = \Carbon\Carbon::now()->setTimezone('Asia/Kolkata')->format('Y-m-d H:i');
	    $this->bookingDate = "$date IST";
    }
        
    function attachOutlet(){
    
        $outlet = \App\Models\Outlet::find($this->outlet['id']);
        $_outlet =  (object)[
            'id'=>$outlet->id,
        	'name'=> $outlet->outletName,
        	'city'=>$outlet->city,
        	'address'=>$outlet->address,
        	'fssaiNumber'=> $outlet->fssaiNo,
        	'gstNumber'=>$outlet->gstNo,
        	'fssaiCutOffDate'=>$outlet->fssaiValidUpto." IST",
        	'state'=>$outlet->state,
        	'contactNumbers'=>$outlet->mobile,
        	'relationshipManagerName'=>"Sanjay Jadoun",
        	'relationshipManagerPhone'=>$outlet->mobile,
        	'relationshipManagerEmail'=>'olfstores@gmail.com',
        	'pinCode'=>'474011',
            'deliveryCost'=>$outlet->deliveryCost,
            'prepaid'=>$outlet->payment_mode
        ];
        
        $_outlet->order_timing = $this->outlet['order_timing'];
        
        $this->outlet = $_outlet;
    }
    
    
    function addVendorDetails(){
        
        $this->vendorPaymentType = $this->paymentType;
        $this->vendorOrderId = strrev(
            sprintf("%d", date_timestamp_get(
                 date_create()
                ))
            );
        $this->deliveryCharge = intval($this->outlet->deliveryCost);
    }
    
    function addCustomerDetails(){
            $this->customer = (object)[
        		'fullName'=>    $this->fullName  ,
        		'email'=>       $this->email ,
        		'mobile'=>      $this->mobile
	        ];
	     
	     
	     unset($this->fullName);
	     unset($this->email);
	     unset($this->mobile);
	     
	     
    }
    
    function removeClaimType(){
        unset($this->claimType);
        unset($this->foodType);
    }

    function expandItems(){
        $this->orderItems = array_map(function($item){
            $basePrice = $item->price/1.05;
            return [
                    "itemId"=> $item->id,
                    "itemName"=> $item->itemName,
                    "description"=> $item->description,
                    "basePrice"=>$basePrice,
                    "sellingPrice"=> $item->price,
                    "taxRate"=> $item->price-$basePrice,
                    "isVegetarian"=> $item->isVegeterian == 1? true:false,
                    "quantity"=> $item->quantity,
                    "option"=> null,
                    "foodType"=> $item->foodType,
            ];
        },$this->orderItems);
        
        
        $this->calculateGst();
        $this->calculateTotal();
        
    }

    function removeCoupon(){
        if(property_exists($this,'coupon'))
            unset($this->coupon);
    } 
    
    function calculateGst(){
        $this->gst = collect($this->orderItems)->sum(function($item){
            return $item['taxRate'] * $item['quantity'];
        });
    }
    
    function calculateTotal(){
        $this->totalAmount = collect($this->orderItems)->sum(function($item){
            return $item['sellingPrice']* $item['quantity'];
        });
    }
    
    function calculateAmtPayable(){
        $this->amountPayable = ($this->totalAmount + $this->deliveryCharge) - $this->discountAmount;
    }
    
    function getAmtPayable(){
        return $this->amountPayable;
    }
    
    
    public function setDiscount($amount){
        $this->discountAmount = $amount;
    }
    
    public function removeClaims(){
        if(property_exists($this,'claimType'))
            unset($this->claimType);
    }
    
     public function setPaymentType($str){
        if(property_exists($this,'paymentType'))
            $this->paymentType = $str;
    }
}
    
class FieldFormatterMiddleware
{
    
    
    public function handle($request, Closure $next)
    {
        try{
            $rawData = json_decode($request->getContent(), true);
    	    Log::info($request->getContent());
            $data = new Extractor($rawData);
            $request['fields'] = $data;
            return $next( $request);
        }catch(\Exception $e){
            return Response::json(['status'=>'Order Booking failed Review your Request'], 400);
        }
    }
}
