<?php

namespace App\Http\Middleware;
 
use App\Models\Permission;
use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Gate;
use Auth;
use Illuminate\Contracts\Auth\Guard;

class PermissionMiddleware
{

    protected $auth;
    protected $role_ids=null;

    public function __construct(Guard $auth)
	{   
        if (auth()->check()) {
            $this->auth = $auth;
            $this->role_ids=auth()->user()->userRoles->pluck('id');
        }
	}

    public function handle(Request $request, Closure $next)
    {
        if (auth()->check()) {

            $permissions = Permission::whereHas('roles', function($query) {
                $query->whereIn('roles.id', $this->role_ids);
            })->get();
            
            foreach ($permissions as $permission) {
                Gate::define($permission->slug, fn() => true);
            }
        }
    
        return $next($request);
    }
    
}
