<?php

namespace App\Http\Middleware;

use Closure;
use Auth;
use Log;
class RoleMiddleware
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next, ... $role)
    { 
        $api = 0;
        $user = Auth::guard('api')->user();

        if(!$user)
        	$user = Auth::guard('token')->user();
       	else
       	$api = 1;

        if(!$user)
          $user = $request->user();
        else
          $api = 1;

        if($user==null){
           return redirect('/auth/login');
        }
        
        if(!$user->hasRole(...$role)) {
           if($api)
				return response()->json([
						'status' => 'error',
						'message' => 'Unauthorized'
					], 401);
		   else
           		return redirect('unauthorized');
        }
        /*
        if($permission !== null && !$request->user()->can($permission)) {
           return redirect('unauthorized');
        }
         *
         */
     
        return $next($request);

    }
}
