<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Contracts\Auth\Guard;
use Auth;
use Log;

class Authenticate {

	/**
	 * The Guard implementation.
	 *
	 * @var Guard
	 */
	protected $auth;

	/**
	 * Create a new filter instance.
	 *
	 * @param  Guard  $auth
	 * @return void
	 */
	public function __construct(Guard $auth)
	{
		$this->auth = $auth;
	}

	/**
	 * Handle an incoming request.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @param  \Closure  $next
	 * @return mixed
	 */
	public function handle($request, Closure $next)
	{
                $user = null;
                $api = 0;
               //Log::channel('dailyInfo')->info('user');
               if(Auth::guard('api')->user()){
                    $api = 1;
                    $user = Auth::guard('api')->user();
                }else if(Auth::guard('api_mobile')->user()){
                    $api = 1;
                    $user = Auth::guard('api_mobile')->user();
                }else if(Auth::guard('apiorder')->user()){
                    $api = 1;
                    $user = Auth::guard('apiorder')->user();
                }else if(Auth::guard('order')->user())
                    $user = Auth::guard('order')->user();
                else if(Auth::guard('vendororder')->user())
                    $user = Auth::guard('vendororder')->user();
                else if(Auth::guard('memoryuser')->user())
                    $user = Auth::guard('memoryuser')->user();
                //Log::channel('dailyInfo')->info('user88here'.print_r($user, true));

                if(!$user){
                    if ($this->auth->guest())
                    {
                        if ($request->ajax() || $request->wantsJson())
                        {
                            return response()->json([
                                    'status' => 'error',
                                    'message' => 'Unauthorized'
                                ], 401);
                        }
                        else
                        {
                                return redirect()->guest('auth/login');
                        }
                    }
                }else if($api){
                    if (!($request->ajax() || $request->wantsJson()))
                    {
                        return response()->json([
                                'status' => 'error',
                                'message' => 'Unauthorized'
                            ], 401);
                    }else{
                        $request->request->add(['__api' => 1]);
                        //if($request->has('outlet_id'))
                            //$request->request->add(['__outlet_id' => $request->outlet_id]);
                    }
                }

		return $next($request);
	}

}
