<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\Log;
use Carbon\Carbon;

class OrderValidatorMiddleware
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
     
    private function validateMandatoryFields($request){
        return (
             
             property_exists($request , 'pnr') &&
             property_exists($request , 'deliveryDate') && 
             property_exists($request , 'stationCode') &&
             
             isset($request->pnr) &&
             isset($request->stationCode) &&
             isset($request->deliveryDate) &&
             
             !($request->pnr == "") &&
             !($request->stationCode == "") &&
             !($request->deliveryDate == "") 
             
            );
    } 
     
    public function handle($request, Closure $next)
    {
        $controller = app(\App\Http\Controllers\OrderCreationController::class);
        if($this->validateMandatoryFields($request['fields'])){
            if(!property_exists($request['fields'], 'razorpay_payment_id')
                && $request['fields']->outlet->prepaid==1)
                    return  response()->json(array('status'=>'failure',
                                            'message'=>'Only prepaid is allowed, cash on delivery is not available on this order'),200);
            unset($request['fields']->outlet->prepaid);
            $deliveryDate = $controller->getSchArrivalPnr(
                    $request['fields']->pnr,
                    $request['fields']->deliveryDate,
                    $request['fields']->stationCode
                    
            )?? $request['fields']->deliveryDate;
            
                   $request['fields']->deliveryDate = Carbon::createFromFormat('Y-m-d H:i', $deliveryDate)->format("Y-m-d H:i").' IST';
                        Log::channel('dailyInfo')->info('deliveryDate is Present:123'.$request['fields']->deliveryDate);
       //dd($deliveryDate); 
            if(!$deliveryDate){
                $fields = $request['fields'];
                $order_timing = $fields->outlet->order_timing;
                $deliveryDate = $controller->getSchArrival($fields->trainNo,
                        $fields->deliveryDate, $fields->stationCode);

                        if(!$deliveryDate){
                            return response()->json([
                                'status'=>'failure',
                                'message'=>'Train doesn\'t run on Delivery date:' 
                            ]);
                        }
                        
                        $request['fields']->deliveryDate = $deliveryDate.' IST';
                        Log::channel('dailyInfo')->info('deliveryDate is Present:'.$deliveryDate);
                        $now = \Carbon\Carbon::now()->setTimezone('Asia/Kolkata');
                        
                        $bookDate = $now->copy();
                        
                        if(\Carbon\Carbon::createFromFormat('Y-m-d H:i', $deliveryDate)->lessThan(($bookDate->addMinutes((int)$order_timing)))){
                            return response()->json([
                                'status'=>'failure',
                                'message'=>'Train scheduled departure: '
                            ]);
                        }
                }
                
            
        }else{
            return response()->json([
                                'status'=>'failure',
                                'message'=>'Mandatory fields Missing'
                ]);
        }

//       dd($request); 
            Log::channel('dailyInfo')->info("### ORDER REQUEST LOG START ###");
            Log::channel('dailyInfo')->info(print_r($request['fields'],true));
            Log::channel('dailyInfo')->info("### ORDER REQUEST LOG END ###");
           return $next($request);
    }
}
