<?php

namespace App\Http\Middleware;

use Closure;
use Auth;

class WalletMiddleware
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {

	//$request['fields']['deliveryDate'] = $request['fields']['deliveryDate'];
        if($request['fields'] ->claimType == "CLAIM_WALLET"){
	 #  dd($request['fields']);
            return $this->claimWalletAmount($request,$next);

        }else{
            return $next($request);    
        }
        
    }
    
    
    
    private function getUserFromRequest(){
        $appUser = null;
        
        if($irctcUser  = Auth::guard('order')->user())
            $appUser = $irctcUser;
        
        if($olfwebUser = Auth::guard('vendororder')->user())
            $appUser = $olfwebUser;
        
        if($olfAppUser = Auth::guard('apiorder')->user())
            $appUser = $olfAppUser;
        
        else
            $appUser = Auth::guard('memoryuser')->user();
            
        return $appUser;
    }
    
    private function claimWalletAmount($request, $next){
        $user = $this->getUserFromRequest();
        
        if($user!=null && get_class($user->last())!='App\MemoryUser'){
            $wDiscount = $user->last()->getAmountProduct1($request['fields']->amountPayable);
            $request['fields']->setDiscount($wDiscount);
        }
        
        return $next($request);
    }
}
