<?php

namespace App\Imports;

use Excel;
use Maatwebsite\Excel\Concerns\ToModel;
/*
use Maatwebsite\Excel\Concerns\ToArray;
use Maatwebsite\Excel\Concerns\WithHeadingRow;
use Maatwebsite\Excel\Concerns\WithMultipleSheets;
use Maatwebsite\Excel\Imports\HeadingRowFormatter;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\BeforeSheet;
use Maatwebsite\Excel\Concerns\WithChunkReading;
use Maatwebsite\Excel\Concerns\ToModel;
use Maatwebsite\Excel\Concerns\Importable;
*/
use Maatwebsite\Excel\Concerns\WithHeadingRow;
use Maatwebsite\Excel\HeadingRowImport;
use Log;
abstract class DataItems implements  WithHeadingRow, ToModel {
    //use Importable;

    private $heading = true;
    private $headings = [];
    private $extraHeadings = [];

    public function __construct(){
    }

    public abstract function setOutlet($outletId);
    public abstract function getOutlet();
    public abstract function format($rowData);
    public abstract function update(array $rowData);

    public function setClassName1($className){
        $this->className1 = '\\App\\'.$className;
    }
    public function addExtraHeadings($outlet){
        $this->extraHeadings['menu_id'] = $outlet->menu->id;
        $this->extraHeadings['outlet_id'] = $outlet->id;
    }

    public function model(array $row)
    {
        foreach($row as $key => $value){
            if($value == null)
                $row[$key] = '';
        }
        $rowData = array_merge($row, $this->extraHeadings);
        //Log::channel('dailyInfo')->info('--:'.$rowData['id']);
        $rowData = $this->format($rowData);
        if(!isset($rowData['itemName']) || $rowData['itemName'] == ''){
            return null;
        }
        $outlet = \App\Outlet::with("menu")->with("items")->find($this->getOutlet())[0];
        $update = false;
        if(isset($outlet->menu)){
            $items = $outlet->menu->items->toArray();
            
            if(isset($rowData['id'])){
                Log::channel('dailyInfo')->info('id set--:');
                foreach($items as $item)
                {
                    if($item['id'] == $rowData['id']){
                        Log::channel('dailyInfo')->info('$item[\'id\']=$rowData[\'id\']'.$item['id']);
                        $update = true;
                        break;
                    }
                }
            }
        }    
        if($update)
            return $this->update($rowData);
        else
            return $this->className1::create($rowData);
    }
}
