<?php
namespace App\Imports;
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

use Log;
use Excel;

class MenuItem extends DataItems {
    public function setOutlet($outletId)
    {
        $this->outlet = \App\Outlet::find($outletId);
        parent::addExtraHeadings($this->outlet);
        parent::setClassName1('MenuItem');
    }
    public function getOutlet()
    {
        return $this->outlet;
    }
    public function format($rowData)
    {
        if(is_array($rowData) && !empty($rowData))
        {
            $rowData['openingTime'] = $rowData['openingTime']->format('H:i');
            $rowData['closingTime'] = $rowData['closingTime']->format('H:i');
        }
        return $rowData;
    }
    public function model(array $rowData){
        $rowData['openingTime'] = \Carbon\Carbon::instance(\PhpOffice\PhpSpreadsheet\Shared\Date::excelToDateTimeObject($rowData['openingTime']));
        $rowData['closingTime'] = \Carbon\Carbon::instance(\PhpOffice\PhpSpreadsheet\Shared\Date::excelToDateTimeObject($rowData['closingTime']));
        return parent::model($rowData);
    }
    public function import($file)
    {
        $path = $file->getRealPath();
        $type = strtolower($file->getClientOriginalExtension());
        $readerType = null;
        if($type=='xls')
            $readerType = 'Xls';
        else if($type=='xlsx')
            $readerType = 'Xlsx';
        else if($type=='csv')
            $readerType = 'Csv';
        Excel::import($this, $path,null,$readerType);
    }
    public function update(array $rowData)
    {
        $menuItem = \App\MenuItem::find($rowData['id']);
        $menuItem->update($rowData);
        return $menuItem;
    }
}
