<?php

namespace App\Listeners;

use App\Events\OrderAcceptedEvent;
use App\Events\OrderCancelledEvent;
use App\Events\OrderCreatedFirebaseEvent;
use App\Events\OrderEvent;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Support\Facades\Log;



class OrderListener
{
    /**
     * Create the event listener.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Handle the event.
     *
     * @param  OrderCreatedEvent  $event
     * @return void
     */
    public function handle(OrderEvent  $event)
    {
        if ($event instanceof OrderCreatedFirebaseEvent) {
            $data = $event->data;
            Log::channel('dailyInfo')->info("data::" . print_r($data, true));
            $noto = new \App\Models\Notifikation();
            try {
                $noto->build($data['message']['title'], $data['message']['content'])
                    ->send($data['token']);

                Log::info($noto->response());
            } catch (\Exception $err) {
                Log::channel('dailyInfo')->error($err);
            }
        }
    }
}
