<?php

namespace App\Logging;

use Monolog\Logger;
use Monolog\Handler\StreamHandler;
use Monolog\Formatter\LineFormatter;

class CreateMenuLogger
{
    public function __invoke(array $config)
    {
        $logger = new Logger('outletLog');

        $handler = new StreamHandler($config['path']);
        $handler->setFormatter(new LineFormatter(null, null, true, true));

        // Before adding the handler, prepend the content
        $this->prependContent($config['path']);

        $logger->pushHandler($handler);

        return $logger;
    }

    protected function prependContent($path)
    {
        $newContent = "[INFO] " . now()->toDateTimeString() . " - Your new log entry\n";

        if (file_exists($path)) {
            $content = file_get_contents($path);
            file_put_contents($path, $newContent . $content);
        } else {
            file_put_contents($path, $newContent);
        }
    }
}
