<?php

namespace App\Logging;

use Monolog\Handler\AbstractProcessingHandler;
use Monolog\LogRecord;

class PrependLogHandler extends AbstractProcessingHandler
{
    protected function write(LogRecord $record): void
    {
        $logFile = $record->context['path'];

        if (!file_exists($logFile)) {
            file_put_contents($logFile, '');
        }

        $currentContents = file_get_contents($logFile);
        $newEntry = $record->formatted . PHP_EOL;
        file_put_contents($logFile, $newEntry . $currentContents);
    }
}
