<?php

namespace App\Models;


class Requester
{


    public function __construct($url)
    {
        $this->url = $url;
    }



    function requestGet($subUrl, $headers = [])
    {
        $_url = sprintf("%s%s", $this->url, $subUrl);
        $_handle = curl_init();

        curl_setopt($_handle, CURLOPT_URL, $_url);
        curl_setopt($_handle, CURLOPT_RETURNTRANSFER, 1);

        if (count($headers) > 0) {
            curl_setopt($_handle, CURLOPT_HTTPHEADER, $headers);
        }

        $output = curl_exec($_handle);

        return json_decode($output);
    }


    function requestPost($subUrl, $data, $headers)
    {
    }

    function requestPostJSON($subUrl, $data, $headers)
    {   
        $_url = sprintf("%s%s", $this->url, $subUrl);
 
        // $data = array("outlets" => array('0'=>array(
        //         "name" => "Haridwar Chotiwala Restaurants",
        //         "tags" => [],
        //         "openingTime" => "10:00",
        //         "closingTime" => "22:00",
        //         "currentTime" => "2024-04-15 13:13:26",
        //         "minOrderAmount" => "99",
        //         "order_timing" => "45",
        //         "deliveryCharges" => null,
        //         "promotions"=> null,
        //         "logo" => "https://olfstores.com/static/img/20240106133550.jpg",
        //         "cutOffTime" => 40,
        //         "closingSchedule" => [],
        //         "closingPeriod" => [],
        //         "weeklyClosed" => [],
        //         "outletId" => 660,
        //         "outletName" => "Haridwar Chotiwala Restaurants",
        //         "openingTimeStamp" => "10:00",
        //         "closingTimeStamp" => "22:00",
        //         "prepaid" => false,
        //         "address" => "Restaurant Near Gwalior Railway Station Madhya Pradesh",
        //         "city" => "Gwalior",
        //         "state" => "Madhya Pradesh",
        //         "companyName" => "Haridwar Chotiwala Restaurants",
        //         "vendorPanNumber" => "EQSPS8286L",
        //         "gstNo" => "23EQSPS8286L2ZM",
        //         "fssaiNo" => "21422570002334",
        //         "fssaiValidUpto" => "2024-06-20 12:00",
        //         "logoImage" => "https://olfstores.com/static/img/20240106133550.jpg",
        //         "email" => "olforder@gmail.com",
        //         "mobile" => "07514920669",
        //         "detailedNutritionalInfoPdf" => "https://olfstores.com/trains/public/document.pdf",
        //         "off" => false,
        //     ))
        //     );

        //     print_r($data); 

        $_handle = curl_init();

        $_data = json_encode($data);
      
        curl_setopt($_handle, CURLOPT_POST, 1);
        curl_setopt($_handle, CURLOPT_URL, $_url);
        curl_setopt($_handle, CURLOPT_RETURNTRANSFER, 1);
       
        if (count($headers) > 0) {
            curl_setopt($_handle, CURLOPT_HTTPHEADER, array_merge($headers, [ 'Content-Type: application/json', sprintf('Content-Length:%s', strlen($_data))]));
        }
        
        curl_setopt($_handle, CURLOPT_POSTFIELDS, $_data);
        
        $response = curl_exec($_handle);

        
        return $response;
    }
}





class IRCTCProxy
{
    private $selfHostInstance;
    private $otherHostInstance;

    public function __construct($selfURL, $otherHost)
    {
        $this->selfHostInstance = new Requester($selfURL);
        $this->otherHostInstance = new Requester($otherHost);
    }

    public function getSelf($url, $headers)
    {   
        return $this->selfHostInstance->requestGet($url, $headers);
    }

    public function postRemote($url, $data, $headers)
    {
        return $this->otherHostInstance->requestPostJSON($url, $data, $headers);
    }
}



class IRCTCDataManager
{
    private $proxy;
    
    public function __construct($token, $irctcURL = "")
    {
        $this->token = $token;
        if ($irctcURL != "")
            $this->proxy = new IRCTCProxy('https://olf.invoidea.app', $irctcURL);
        else
            $this->proxy = new IRCTCProxy('https://olf.invoidea.app', config('constkeys.irctc_base_url'));
    }

    public function getStations()
    {
        return $this->proxy->getSelf('/stations', []);
    }

    public function getStation($outletId)
    {
        return $this->proxy->getSelf(sprintf('/station/%s', $outletId), []);
    }

    public function getOutlets($stnCode)
    {
        date_default_timezone_set("Asia/Calcutta");
        $oulatAeeay=[];
      
        $out=$this->proxy->getSelf(sprintf("/outlets/%s", $stnCode), []);
    
        if(empty($out))
            return null;

        foreach($out->outlets as $outlates)
        {
            $closingArray=array();
          foreach($outlates->closingPeriod as $priod)
          {

            $data['closedFrom']= date("Y-m-d",strtotime($priod->closedFrom)).' '.$outlates->openingTime; ;
            $data['closedTo']=date("Y-m-d",strtotime($priod->closedTo)).' '.$outlates->closingTime;
            array_push($closingArray,$data);
          }
         
          $finalData['name']=$outlates->name;
          $finalData['tags']=$outlates->tags;
          $finalData['openingTime']=$outlates->openingTime;
          $finalData['closingTime']=$outlates->closingTime;
          $finalData['currentTime']=$outlates->currentTime;
          $finalData['minOrderAmount']=$outlates->minOrderAmount;
          $finalData['order_timing']=$outlates->order_timing;
          $finalData['deliveryCost']=$outlates->deliveryCost;
          $finalData['logo']=$outlates->logo;
          $finalData['cutOffTime']=$outlates->cutOffTime;
          $finalData['closingSchedule']=$outlates->closingSchedule;
          $finalData['closingPeriod']=$closingArray;
          $finalData['weeklyClosed']=$outlates->weeklyClosed;
          $finalData['outletId']=$outlates->outletId;
          $finalData['outletName']=$outlates->outletName;
          $finalData['openingTimeStamp']=$outlates->openingTimeStamp;
          $finalData['closingTimeStamp']=$outlates->closingTimeStamp;
          $finalData['prepaid']=$outlates->prepaid;
          $finalData['address']=$outlates->address;
          $finalData['city']=$outlates->city;
          $finalData['state']=$outlates->state;
          $finalData['companyName']=$outlates->companyName;
          $finalData['vendorPanNumber']=$outlates->vendorPanNumber;
          $finalData['gstNo']=$outlates->gstNo;
          $finalData['fssaiNo']=$outlates->fssaiNo;
          $finalData['fssaiValidUpto']=$outlates->fssaiValidUpto;
          $finalData['logoImage']=$outlates->logoImage;
          $finalData['email']=$outlates->email;
          $finalData['mobile']=$outlates->mobile;
          $finalData['detailedNutritionalInfoPdf']=$outlates->detailedNutritionalInfoPdf;
          $finalData['off']=$outlates->off;
          array_push($oulatAeeay,$finalData);

        }
        $dtatap['outlets']=$oulatAeeay;

        return $dtatap;
        
    }

    public function getOutlet($id)
    {
        return $this->proxy->getSelf(sprintf("/outlet/%s", $id), []);
    }

    public function getMenu($outletCode)
    {
        return $this->proxy->getSelf(sprintf("/menu/%s", $outletCode), []);
    }


    public function postOutlets($stnCode, $outlets)
    {
        $_url = sprintf('/api/v1/vendor/aggregator/outlets/%s', $stnCode);

        return $this->proxy->postRemote($_url, $outlets, [
            sprintf('Authorization:%s', $this->token)
        ]);
    }

    public function postOutlet($stnCode, $outlets)
    {   
        $_url = sprintf('/api/v1/vendor/aggregator/outlets/%s', $stnCode);
        
        return $this->proxy->postRemote($_url, $outlets, [
            sprintf('Authorization:%s', $this->token)
        ]);
    }

    public function postMenuItems($outletId, $stnCode, $menuItems)
    {
        return $this->proxy->postRemote(sprintf('/api/v1/vendor/aggregator/station/%s/outlet/%s', $stnCode, $outletId), $menuItems, [sprintf('Authorization:%s',$this->token)]);
    }

    public function postMenuItem($outletId, $stnCode, $menuItems)
    {
        return $this->proxy->postRemote(sprintf('/api/v1/vendor/aggregator/station/%s/outlet/%s', $stnCode, $outletId), $menuItems, [sprintf('Authorization:%s',$this->token)]);
    }

    public function processOutlets()
    {

        try {
            $stations = $this->getStations();
            foreach ($stations as $station) {
                //if($station->code=='KNW')
                $outlets = $this->getOutlets($station);
                $postResponse = $this->postOutlets($station, $outlets);
                echo $postResponse . "\n";
            }
        } catch (\Exception $th) {
            print_r($th);
        }
    }

    public function processOutlet($id)
    {
        try {

            $station = $this->getStation($id)->code;
            $outlets = $this->getOutlet($id);

            $postResponse = $this->postOutlet($station, $outlets);
            echo $postResponse . "\n";
        } catch (\Exception $th) {
            print_r($th);
        }
    }
    public function processStation($station)
    {   
        try {
            $outlets = $this->getOutlets($station);
            $postResponse = $this->postOutlet($station, $outlets);
            echo $postResponse . "\n";

        } catch (\Exception $th) {
             print_r($th->getMessage());
        }
    }
    public function processMenuItems()
    {
        $stations = $this->getStations();
        foreach ($stations as $station) {
            $outlets = $this->getOutlets($station);
            foreach ($outlets->outlets as $value) {
                $itemList = $this->getMenu($value->outletId);
                $result = $this->postMenuItems($value->outletId, $station, $itemList);
                print_r($result);
            }
        }
    } 

    public function processMenuItem($outletId)
    {
        $station = $this->getStation($outletId)->code;
        $outlets = $this->getOutlets($station);
        foreach ($outlets->outlets as $value) {
            $itemList = $this->getMenu($value->outletId);
            print_r($itemList);
            $result = $this->postMenuItems($value->outletId, $station, $itemList);
            print_r($result);
        }
    } 
    public function processMenuItem1($outletId)
    {
        $station = $this->getStation($outletId)->code;
        $itemList = $this->getMenu($outletId);
        print_r(json_encode($itemList));
        echo '</br></br>';
        $result = $this->postMenuItems($outletId, $station, $itemList);
        print_r($result);
    } 


    public function getOutletData($outlet_id)
    {
        date_default_timezone_set("Asia/Calcutta");
        $oulatArray=[];
        
        if(empty($outlet_id))
            return null;

        $outlet=Outlet::where('id',$outlet_id)->get();
        
        foreach($outlet as $outlateData)
        {
          $closingArray =$closingSchedule=$tags=array();

          foreach(json_decode($outlateData->closingPeriod) as $priod)
          {
            $data['closedFrom']= date("Y-m-d",strtotime($priod->closedFrom)).' '.$outlateData->openingTime; ;
            $data['closedTo']=date("Y-m-d",strtotime($priod->closedTo)).' '.$outlateData->closingTime;

            $data1['closedFrom']= date("Y-m-d",strtotime($priod->closedFrom)); 
            $data1['closedTo']=date("Y-m-d",strtotime($priod->closedTo));


            array_push($closingArray,$data);
            array_push($closingSchedule,$data1);
          }


        
          if(!empty($outlateData->tags))
          $tags=explode(',',$outlateData->tags);

          $finalData['name']=$outlateData->outletName;
          $finalData['tags']=$tags;
          $finalData['openingTime']=$outlateData->openingTime;
          $finalData['closingTime']=$outlateData->closingTime;
          $finalData['currentTime']=date("Y-m-d H:i:s");
          $finalData['minOrderAmount']=$outlateData->minOrderAmount;
          $finalData['order_timing']=$outlateData->order_timing;
          $finalData['deliveryCharges']=$outlateData->deliveryCost;
          $finalData['logo']=$outlateData->logoImage;
          $finalData['cutOffTime']=$outlateData->cutOffTime;
          $finalData['closingSchedule']=$closingSchedule;
          $finalData['closingPeriod']=$closingArray;
          $finalData['weeklyClosed']= json_decode($outlateData->weeklyClosed);
          $finalData['outletId']=$outlateData->outletId;
          $finalData['outletName']=$outlateData->outletName;
          $finalData['openingTimeStamp']=$outlateData->openingTime;
          $finalData['closingTimeStamp']=$outlateData->closingTime;
          $finalData['prepaid']=false;
          $finalData['address']=$outlateData->address;
          $finalData['city']=$outlateData->city;
          $finalData['state']=$outlateData->state;
          $finalData['companyName']=$outlateData->companyName;
          $finalData['vendorPanNumber']=$outlateData->vendorPanNumber;
          $finalData['gstNo']=$outlateData->gstNo;
          $finalData['fssaiNo']=$outlateData->fssaiNo;
          $finalData['fssaiValidUpto']=$outlateData->fssaiValidUpto;
          $finalData['logoImage']=$outlateData->logoImage;
          $finalData['email']=$outlateData->email;
          $finalData['mobile']=$outlateData->mobile;
          $finalData['detailedNutritionalInfoPdf']='https://olfstores.com/trains/public/document.pdf';
          $finalData['off']=$outlateData->off;
          array_push($oulatArray,$finalData);

        }
        $dtatap['outlets']=$oulatArray;
        return $dtatap;
        
    }

}