<?php 

namespace App\Models;


use Illuminate\Auth\Authenticatable;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Auth\Passwords\CanResetPassword;
use Illuminate\Foundation\Auth\Access\Authorizable;
use Illuminate\Contracts\Auth\Authenticatable as AuthenticatableContract;
use Illuminate\Contracts\Auth\CanResetPassword as CanResetPasswordContract;
use Illuminate\Contracts\Auth\Access\Authorizable as AuthorizableContract;
use App\Permissions\HasPermissionsTrait;
use Illuminate\Foundation\Auth\User as Authenticatable1;
use Illuminate\Notifications\Notifiable;

class MemoryUser extends Model implements AuthenticatableContract, AuthorizableContract, CanResetPasswordContract {

	use Authenticatable, Authorizable, CanResetPassword;
        use Notifiable;
        use HasPermissionsTrait;
	/**
	 * The database table used by the model.
	 *
	 * @var string
	 */
	protected $table = 'tmp_users';
	/**
	 * The attributes that are mass assignable.
	 *
	 * @var array
	 */
        protected $fillable = ['id','mobile','password','memory','remember_token','next_id','next_type','api_token'];

	/**
	 * The attributes excluded from the model's JSON form.
	 *
	 * @var array
	 */
        protected $rememberTokenName = 'remember_token';
        protected $guarded = [
        'created_at', 'updated_at'
    ];
	protected $hidden = ['password', 'remember_token','api_token'];
         public function updateOld($data) {
        return $this->update($data);
    }
    public function last()
    {
        if($this->next!=null)
            return $this->next->last();
        return $this;
    }

    public function getPreviousOrders($orders){
        return $orders;
    }
    
    public function next()
    {
        if($this->next_type=='App\Models\VendorOrder')
            return $this->hasOne(\App\Models\VendorOrder::class, 'id','next_id');
        else
            return $this->hasOne(\App\Models\Order::class, 'orderId','next_id');      
    }
    // public function getWalletAttribute()
    // {
    //     if($this->next_type!=null)
    //         return $this->last()->wallet;
    //     return null;
    // }    
    public function getBalanceAttribute()
    {
        if($this->next_type!=null)
            return $this->last()->balance;
        return 0;
    }    
    public function getAmountProduct1($amountPayable)
    {
        return 0;
    }
}
