<?php

namespace App\Models;


use  Kreait\Firebase;
use Kreait\Firebase\Messaging\CloudMessage;

class Notifikation
{

    private  $messaging;
    private  $content;
    private $title;
    private $extras;
    private $response;
    
    function __construct()
    {
        $this->messaging = (new Firebase\Factory())->createMessaging(
            env('FIREBASE_CREDENTIALS')
        );
    }

    public function build($title, $content, $extras = [])
    {
        $this->content = $content;
        $this->title = $title;
        $this->extras =  $extras;
        return  $this;
    }

    public function send($token)
    {
         try {
            $message =  CloudMessage::fromArray([
                'token'=>$token,
                'notification'=>[
                    'title'=>$this->title,
                    'body'=>$this->content
                ]
        ]);

        $this->response =   $this->messaging->send($message);
        } catch (\Throwable $th) {
            $this->response =   ['Notification CANNOT be delivered', $token];
        }

       return $this;

    }

    public function response()
    {
        return $this->response;
    }
}
