<?php

namespace App\Models;


use Illuminate\Database\Eloquent\Model;

class PhoneLog extends Model
{
    protected $table = 'phone_logs';
    
    protected $fillable = ['mobile','otp'];
    
    public static function createOTP($mobile, $otp){
        $log = PhoneLog::firstOrNew(['mobile' => $mobile]);
        $log->otp = $otp;
        $log->save();
    }
    
    
    public static function ResetOTP($mobile){
        $log = PhoneLog::firstOrNew(['mobile' => $mobile]);
        $log->otp = "HYPER0";
        $log->save();
    }
    
    
    public static function isOTPValid($mobile, $otp){
        return PhoneLog::where("mobile","=", $mobile)->where("otp","=", $otp)->count() > 0;
    } 
}
