<?php 

namespace App\Models;

use Illuminate\Auth\Authenticatable;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Auth\Passwords\CanResetPassword;
use Illuminate\Foundation\Auth\Access\Authorizable;
use Illuminate\Contracts\Auth\Authenticatable as AuthenticatableContract;
use Illuminate\Contracts\Auth\CanResetPassword as CanResetPasswordContract;
use Illuminate\Contracts\Auth\Access\Authorizable as AuthorizableContract;
use App\Permissions\HasPermissionsTrait;
use Illuminate\Foundation\Auth\User as Authenticatable1;
use Illuminate\Notifications\Notifiable;

class UserMobile extends Model {
	protected $table = 'user_mobiles';

	/**
	 * The attributes that are mass assignable.
	 *
	 * @var array
	 */
	protected $fillable = ['mobile', 'password', 'api_token', 'user_id', 'role', 'remember_token'];

	/**
	 * The attributes excluded from the model's JSON form.
	 *
	 * @var array
	 */
        protected $rememberTokenName = 'remember_token';
        protected $guarded = [
        'created_at', 'updated_at'
    ];
	protected $hidden = ['password', 'remember_token','api_token'];
    public function user()
    {
        return $this->belongsTo('App\Models\User');
    }
}
