<?php

namespace App\Policies;

use Illuminate\Auth\Access\HandlesAuthorization;
use App\Models\User;
use App\Models\MenuItem;
use App\Models\Outlet;

class MenuItemPolicy
{
    use HandlesAuthorization;

    /**
     * Create a new policy instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    public function before($user, $ability)
    {

        if ($user->isAdmin()) {
            return true;
        }
    }


    public function pol_update_menu_item(User $user, MenuItem $item)
    {
        if($user->hasRole('vendor')){
            return  $user->id == $item->menu->outlet->user_id;
        }

        return false;
    }

    public function pol_delete_menu_item(User $user, MenuItem $item)
    {
        if($user->hasRole('vendor')){
            return  $user->id == $item->menu->outlet->user_id;
        }

        return false;
    }
}
