<?php

namespace App\Policies;

use Illuminate\Auth\Access\HandlesAuthorization;
use App\Models\User;
use App\Models\Order;

class OrderPolicy
{
    use HandlesAuthorization;

    /**
     * Create a new policy instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    public function before($user, $ability)
    {
        if ($user->isAdmin()) {
            return true;
        }
    }

    public function pol_update_order(User $user, Order $order)
    {
        if($user->hasRole('agent'))
            return true;
        else if($user->hasRole('vendor'))
            return  $user->id == $order->outlet->user_id;
        else if($user->hasRole('user')){
            return  $user->id == json_decode($order->customerDetails)->customerId;
        }

        return false;
    }
    public function pol_view_order(User $user, Order $order)
    {
        if($user->hasRole('agent'))
            return true;
        if($user->hasRole('radmin'))
            return true;
        else if($user->hasRole('vendor'))
            return $user->id == $order->outlet->user_id;
        else if($user->hasRole('user'))
            return  $user->id == json_decode($order->customerDetails)->customerId;

        return false;
    }

}
