<?php

namespace App\Policies;

use Illuminate\Auth\Access\HandlesAuthorization;
use App\Models\User;
use App\Models\Outlet;
use App\Models\Order;

class OutletPolicy
{
    use HandlesAuthorization;

    /**
     * Create a new policy instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    public function before($user, $ability)
    {
        if ($user->isAdmin()) {
            return true;
        }
    }

    public function pol_add_outlet(User $user)
    {
        if($user->hasRole('agent'))
            return true;
    }

    public function pol_add_menu(User $user, Outlet $out)
    {
        if($user->hasRole('agent'))
            return true;
        else if($user->hasRole('vendor'))
            return $user->id == $out->user_id;
    }

    public function pol_view_menu(User $user, Outlet $out)
    {
        if($user->hasRole('agent'))
            return true;
        else if($user->hasRole('radmin'))
            return true;
        else if($user->hasRole('vendor'))
            return $user->id == $out->user_id;
    }

    public function pol_update_outlet(User $user, Outlet $outlet)
    {
        if($user->hasRole('agent'))
            return true;
        else if($user->hasRole('vendor')){
            return  $user->id == $outlet->user_id;
        }

        return false;
    }

    public function pol_delete_outlet(User $user, Outlet $outlet)
    {
        if($user->hasRole('agent'))
            return true;
    }

    public function pol_view_orders(User $user, Outlet $out)
    {
        if($user->hasRole('agent'))
            return true;
        if($user->hasRole('radmin'))
            return true;
        else if($user->hasRole('vendor'))
            return $user->id == $out->user_id;;
    }

    public function pol_view_invoice(User $user, Outlet $out)
    {
        if($user->hasRole('agent'))
            return true;
        else if($user->hasRole('vendor'))
            return $user->id == $out->user_id;;
    }

}
