<?php namespace App\Providers;

use Illuminate\Contracts\Events\Dispatcher as DispatcherContract;
use Illuminate\Foundation\Support\Providers\EventServiceProvider as ServiceProvider;

use Illuminate\Support\Facades\Event as Event;
use App\Events\OrderCreatedFirebaseEvent;
use App\Handlers\Events\NotificationHandler;
use App\Jobs\CustomerInvoiceJob;
use App\Listeners\OrderListener;

class EventServiceProvider extends ServiceProvider {

	/**
	 * The event handler mappings for the application.
	 *
	 * @var array
	 */
	protected $listen = [
		'\App\Events\NotificationEmail' => [
			'\App\Handlers\Events\NotificationHandler',
		],
            'Illuminate\Auth\Events\Logout' => [
                '\App\Handlers\Events\LogSuccessfulLogout',
            ],            
            OrderCreatedFirebaseEvent::class => [
                OrderListener::class
            ],

			CustomerInvoiceJob::class => [
				NotificationHandler::class
			]
	];

	/**
	 * Register any other events for your application.
	 *
	 * @param  \Illuminate\Contracts\Events\Dispatcher  $events
	 * @return void
	 */
	public function boot()
	{
		parent::boot();
		 //$events->listen('\App\Events\NotificationMail', '\App\Handlers\Events\NotificationHandler');
		//
	}

}
