<?php

namespace App\Providers;

use Illuminate\Support\ServiceProvider;
use App\Models\Permission;
use App\Models\User;
use Illuminate\Support\Facades\Gate;
use App\Permissions\HasPermissionsTrait;
use Illuminate\Support\Facades\Log;

class PermissionsServiceProvider extends ServiceProvider
{
    /**
     * Bootstrap the application services.
     *
     * @return void
     */
    public function boot()
    {   
        // Permission::get()->map(function($permission){

        //     Gate::define($permission->slug, function(User $user) use ($permission){
        //         Log::info('User: ' . $user);
        //         return $user->hasPermissionTo($permission);
        //     });
        // });

        
        
        \Blade::directive('role', function ($role){
            $roles = str_replace(["(",")"," "], "", $role);
            return "<?php if(auth()->check() && auth()->user()->hasRole({$roles})) :?>";
        });
        \Blade::directive('endrole', function ($role){
         return "<?php endif; ?>";
        });
    }

    /**
     * Register the application services.
     *
     * @return void
     */
    public function register()
    {
        //
    }
}
