<?php

namespace App\Providers;

use App\Domain\PnrService;
use App\Services\SessionCart;
use Illuminate\Container\Container;
use Illuminate\Session\Store;
use Illuminate\Support\ServiceProvider;

class SessionCartServiceProvider extends ServiceProvider
{
    /**
     * Bootstrap services.
     *
     * @return void
     */
    public function boot()
    {
        //
    }

    /**
     * Register services.
     *
     * @return void
     */
    public function register()
    {
        $this->app->bind(PnrService::class, function(Container $container){
            return new PnrService();
        });


        $this->app->bind(SessionCart::class, function(Container $container){
            return new SessionCart($container->get(Store::class));
        });


    }
}

