<?php

namespace App\Providers;

use App\Repositories\WARepository;
use App\Services\WaMessageFormatingService;
use App\Services\WaMessageFormatterService;
use App\Services\WaService;
use GuzzleHttp\Client;
use Illuminate\Contracts\Container\Container;
use Illuminate\Support\ServiceProvider;
use App\Services\LoginOtpService;
use App\Services\ScrappingService;

class WAServiceProvider extends ServiceProvider
{
    /**
     * Bootstrap services.
     *
     * @return void
     */
    public function boot()
    {
        //
    }

    /**
     * Register services.
     *
     * @return void
     */
    public function register()
    {

        $this->app->bind(Client::class, function ($c) {
            return new Client();
        });
        
        $this->app->bind(WaMessageFormatterService::class, function ($c) {
            return new WaMessageFormatterService();
        });

       

        $this->app->bind(WARepository::class, function (Container $container) {
            return new WARepository();
        });

        $this->app->bind(WaService::class, function (Container $container) {
            return new WaService(
                $container->get(WARepository::class),
                $container->get(Client::class),
            );
        });

        $this->app->bind(LoginOtpService::class, function($container){
			return new LoginOtpService($container->get(Client::class));
		});

        $this->app->bind(ScrappingService::class, function($c){
            return new ScrappingService($c->get(Client::class));
        });
    }
}
