<?php

namespace App\Services;

use Illuminate\Session\Store;


class SessionCart
{

    private $session;
    private $defaultKey  = 'DEFAULT';

    public function __construct(Store $session)
    {
        $this->session = $session;
    }

    public function __set($property, $value)
    {
        if(property_exists($this, $property)){
            $this->$property = $value;
        }
    }

    public function __get($property)
    {
        if(property_exists($this, $property)){
            return $this->$property;
        }
    }

    public function add($key, $value)
    {
        $_old = $this->session->get($this->defaultKey, []);
        $_new = array_merge($_old, [$key => $value]);
        $this->session->put($this->defaultKey, $_new);
    }

    public function remove($key)
    {
        $_old = $this->session->get($this->defaultKey, []);
        if (count($_old) < 1 ) {
            return false;
        }

        unset($_old[$key]);

        $this->session->put($this->defaultKey, $_old);
    }


    public function getAll()
    {
        $_values = $this->session->get($this->defaultKey);
        return $_values;
    }


    public function get($key)
    {
        return $this->getAll()[$key];
    }

    public function clear()
    {
        $this->session->forget($this->defaultKey);
    }


    public function check($key)
    {
        try {
            return $this->get($key) != null ? true :false;
        } catch (\Throwable $th) {
            return false;
        }
    }
}
