const template = {
    "vendorOrderId": "12345",
    "customer":{
        "fullName": "Abhinav K",
        "email": "abhinav@ipsator.com",
        "mobile": "9876543210"
    },
    "outlet": {
        "id": 4,
        "name": "ABCD",
        "address": "Some place",
        "city": "Bangalore",
        "state": "State",
        "pinCode": "560068",
        "contactNumbers": "6385685368, 46538765734",
        "relationshipManagerName": "Aakash",
        "relationshipManagerPhone": "46538765734",
        "relationshipManagerEmail": "abcd@gmail.com",
        "fssaiNumber": "AADCK2144ZZZ000",
        "fssaiCutOffDate": "2018-21-08 00:00 IST",
        "gstNumber": "AADCK2144ZZZ000"
    },
    "bookingDate": "2018-02-08 19:51 IST",
    "deliveryDate": "2018-02-08 19:51 IST",
    "pnr": "6311020444",
    "trainNo": "17015",
    "trainName": "VISAKHA EXPRESS",
    "stationCode": "RJY",
    "stationName": "RAJAHMUNDRY",
    "coach": "B2",
    "berth": "28",
    "totalAmount": 225.79,
    "gst": 10.79,
    "deliveryCharge": 17.7,
    "discountAmount": 0,
    "amountPayable": 243,
    "paymentType": "CASH_ON_DELIVERY" ,// Can be CASH_ON_DELIVERY or PRE_PAID
    "orderItems": [
        {
            "itemId": 199,
            "itemName": "Idli",
            "description": "Idli (2nos), Sambar (200g) & Chutney (100g)",
            "basePrice": 47,
            "sellingPrice": 49.36,
            "taxRate": 2.36,
            "isVegetarian": true,
            "quantity": 2,
            "option": "Rava"
        },
        {
            "itemId": 200,
            "itemName": "Vada",
            "description": "Vada (2nos), Sambar (200g) & Chutney (100g)",
            "basePrice": 54,
            "sellingPrice": 56.7,
            "taxRate": 2.7,
            "isVegetarian": true,
            "quantity": 1,
            "option": null
        }
    ]
    }
   

const API_URL=`http://olfstores.com/`;
const STATION_URL = (code) => `${API_URL}/custom/fetchStation/${code}`
const ITEM_URL = (code) => `${API_URL}/custom/fetchItems/${code}`
const RESTRO_URL = (code) => `${API_URL}/custom/fetchRestro/${code}`
const CART_ITEMS_URL = `${API_URL}/cart/items`
const ADD_TO_CART_URL = (code) => `${API_URL}/cart/add/${code}`
const UPDATE_CART_URL = (code,qty) => `${API_URL}/cart/update/${code}/${qty}`
const REMOVE_FROM_CART = (code) => `${API_URL}/cart/remove/${code}`
const CART_TOTAL = `${API_URL}/cart/getTotal`

function autocomplete(inp, arr) {
  /*the autocomplete function takes two arguments,
 *   the text field element and an array of possible autocompleted values:*/
  var currentFocus;
  /*execute a function when someone writes in the text field:*/
  inp.addEventListener("input", function(e) {
      var a, b, i, val = this.value;
      /*close any already open lists of autocompleted values*/
      closeAllLists();
      if (!val) { return false;}
      currentFocus = -1;
      /*create a DIV element that will contain the items (values):*/
      a = document.createElement("DIV");
      a.setAttribute("id", this.id + "autocomplete-list");
      a.setAttribute("class", "autocomplete-items");
      /*append the DIV element as a child of the autocomplete container:*/
      this.parentNode.appendChild(a);
      /*for each item in the array...*/
      for (i = 0; i < arr.length; i++) {
        /*check if the item starts with the same letters as the text field value:*/
        if (arr[i].substr(0, val.length).toUpperCase() == val.toUpperCase()) {
          /*create a DIV element for each matching element:*/
          b = document.createElement("DIV");
          /*make the matching letters bold:*/
          b.innerHTML = "<strong>" + arr[i].substr(0, val.length) + "</strong>";
          b.innerHTML += arr[i].substr(val.length);
          /*insert a input field that will hold the current array item's value:*/
          b.innerHTML += "<input type='hidden' value='" + arr[i] + "'>";
          /*execute a function when someone clicks on the item value (DIV element):*/
          b.addEventListener("click", function(e) {
              /*insert the value for the autocomplete text field:*/
              inp.value = this.getElementsByTagName("input")[0].value;
              /*close the list of autocompleted values,
 *               (or any other open lists of autocompleted values:*/
              closeAllLists();
          });
          a.appendChild(b);
        }
      }
  });
  /*execute a function presses a key on the keyboard:*/
  inp.addEventListener("keydown", function(e) {
      var x = document.getElementById(this.id + "autocomplete-list");
      if (x) x = x.getElementsByTagName("div");
      if (e.keyCode == 40) {
        /*If the arrow DOWN key is pressed,
 *         increase the currentFocus variable:*/
        currentFocus++;
        /*and and make the current item more visible:*/
        addActive(x);
      } else if (e.keyCode == 38) { //up
        /*If the arrow UP key is pressed,
 *         decrease the currentFocus variable:*/
        currentFocus--;
        /*and and make the current item more visible:*/
        addActive(x);
      } else if (e.keyCode == 13) {
        /*If the ENTER key is pressed, prevent the form from being submitted,*/
        e.preventDefault();
        if (currentFocus > -1) {
          /*and simulate a click on the "active" item:*/
          if (x) x[currentFocus].click();
        }
      }
  });
  function addActive(x) {
    /*a function to classify an item as "active":*/
    if (!x) return false;
    /*start by removing the "active" class on all items:*/
    removeActive(x);
    if (currentFocus >= x.length) currentFocus = 0;
    if (currentFocus < 0) currentFocus = (x.length - 1);
    /*add class "autocomplete-active":*/
    x[currentFocus].classList.add("autocomplete-active");
  }
  function removeActive(x) {
    /*a function to remove the "active" class from all autocomplete items:*/
    for (var i = 0; i < x.length; i++) {
      x[i].classList.remove("autocomplete-active");
    }
  }
  function closeAllLists(elmnt) {
    /*close all autocomplete lists in the document,
 *     except the one passed as an argument:*/
    var x = document.getElementsByClassName("autocomplete-items");
    for (var i = 0; i < x.length; i++) {
      if (elmnt != x[i] && elmnt != inp) {
        x[i].parentNode.removeChild(x[i]);
      }
    }
  }
  /*execute a function when someone clicks in the document:*/
  document.addEventListener("click", function (e) {
      closeAllLists(e.target);
  });
}


	
autocomplete(document.querySelector('#searchItem'), window.IndianRailInfo)

const populateStations = ({stations})=> {
	const shtml = stations.map(
			({id,name,code})=>`
				<div class="item" data-code=${code}>
				  <span class="name">${name}</span>
				  <span class="code">${code}</span>
				  <a href="#" class="picStation">choose</a>
				</div>` 
		).join('')
	
	$('#items').html(shtml);		

}

const populateRestros =(data)=> {
	const {restros}= data;
	const rhtml = restros.map(
		({id,name,logo})=>`
			<div class="item" data-code=${id}>
				<img src=${logo} class="restro_image"/>	
				<span class="name">${name}</span>
				<a href="#" class="picRestro">choose</a>	
			/div>
		` 
	).join('')

	$('#items').html(rhtml);
}


const populateItems = (data)=> {
	const {items} = data
	const ihtml = items.map(
		({itemName,sellingPrice,isVegeterian,description, id})=>`
			<div class="item" data-item=${id}>
				<span class="name">${itemName}</span>
				<span class=${isVegeterian==1?"green":"red"}> &#x25CF;</span>
				<a href="#" class="decl">-</a>
				<a href="#" class="incr">+</a>
			</div>
			
		` 
	).join('')

	$('#items').html(ihtml)

}

const renderCart= (data)=> {
	const cartData = data.map(
	  ({itemName,qty,id})=>`
		<div class="cart_item" data-id=${id}>
			<span class="name">${itemName}</span>
			<span class="qty">${qty}</span>
			<a href="#" class="remove">remove</a>
		</div>
`
	).join('')

	$('#cart_items').html(cartData)

}


const updateTotal= ({Total}) => {
	console.log(Total)
	const totalTempl = `<h4> TOTAL : ${Total}</h4>`
	$('#cart_Total').html(totalTempl)	

}

const refreshCart = ()=> {
	fetch(CART_TOTAL).then(
		res => res.json() 	
	).then(
		jsn =>updateTotal(jsn)
	)

	fetch(CART_ITEMS_URL).then(res=>res.json()).then(
		json=>renderCart(json)
	)	

}

const addTocart = (id)=> {
	fetch(ADD_TO_CART_URL(id),{method:'post'}).then(
		res=>{
			refreshCart();
		} 
	)
}


const removeFromCart = (id)=> {
	fetch(REMOVE_FROM_CART(id),{method:'post'}).then(
		res=>{
			refreshCart();
		} 
	)
}

const renderElement = ({name,type}) => {
	switch(type){
		case 'text':
		    return `
			<label for=${name}>${name}</label> <input type="text" name=${name} />`
		case 'email':
		    return `
			<label for=${name}>${name}</label> <input type="text" name=${name} />
		`
	}

}

const renderForm = (list,handle=null)=> {
	const data= Object.entries(list);
	const formData = data.map(
		(item,index) => {
			const [name, type] = item;
			return {name,type};
		}
	).map(
	   (item)=>`<div class="form-group"> ${renderElement(item)}  </div>` 	
	).join('\n');

	$('#items').html(`<form id="saveForm" method="post">${formData}
		<button id="save" type="button">Save</button>	
	</form>`);	

}

const updateCart = (id, qty)=> {
	fetch(UPDATE_CART_URL(id,qty),{method:'post'}).then(
		res=>{
			refreshCart();
		} 
	)
}

$(function(){

	$('#items').on('click','.picRestro', function(){
		var code = $(this).parent().data('code')
		fetch(ITEM_URL(code)).then(
			(response)=>response.json() 
		).then(
			json => populateItems(json)
		)		
	});

	$('#items').on('click','#save', function(e){
		e.preventDefault();	
		console.log($(this).parent().serializeArray())
		console.log('form submitted')
	})

	$('#items').on('click','.picStation', function(e){
		var code = $(this).parent().data('code')
		fetch(RESTRO_URL(code)).then(
			(response)=>response.json() 
		).then(
			json => populateRestros(json)
		)		
	})

	$('#items').on('click','.incr', function(e){
		var self = $(this)
		var id = self.parent().data('item')
		addTocart(id);
	})

	$('#cart_items').on('click','.remove',function(){
				
		var self = $(this)
		var id = self.parent().data('id')
		removeFromCart(id);
	})

	
	$('#items').on('click','.decl', function(e){
		var self = $(this)
		var id = self.parent().data('item')
		updateCart(id,-1);
	})


	$('#sbt').click(
		()=>{
		fetch(STATION_URL('LKO'))
			.then(response=>response.json())
			.then(json=>populateStations(json))
			.catch(err=>console.log(err))
		} 
	)

	$('#cart_Action>button').click(function(e){
		renderForm({
			"fullName": "text",
			"email": "email",
			"mobile": "text",
			"bookingDate": "text",
			"deliveryDate": "text",
			"pnr": "text",
			"coach": "text",
			"berth": "text",
			"totalAmount": "text",
		})		
	})
})
