@extends('app')

@section('content')
<style>
.d-flex{
    display:flex;
    justify-content: space-between;
    align-items:center;
}
.form-inline{
    margin-bottom:0px;
}
.container {
    width: 993px;
    box-shadow: 0px 0px 5px rgba(0,0,0,1.0);
}
.flex-direction{
    display:flex;
    flex-direction:row;
}
.flex-direction a{
    margin-right:5px;
    font-size:13px;
}
.station-title{
    padding:0px 10px;
}
.main-header{
    background-color:#010a0f;
    color:#fff;
}
.station-table{
    border:1px solid #000;
}
.form-control {
    
    text-transform: uppercase;
}
#ui-datepicker-div{
    z-index: 9999 !important;
}
.modal-body{
    padding:10px;
}
.mt-2{
    margin-top:10px;
}
.form-inline .form-control {
    display: inline-block;
    width: 100%;
    vertical-align: middle;
}
.header-icon .fa{
    font-size: 31px;
    margin-right: 10px
}
.content-header .header-icon {
    font-size: 48px;
    color: #009688;
    width: 200px;
    float: left;
    margin-top: -4px;
    line-height: 0;
    display: flex;
    align-items: center;
    justify-content: flex-start;
}
.h1, .h2, .h3, h1, h2, h3 {
    margin-top: 10px;
    margin-bottom: 10px;
}
.content-header {
    display: flex;
    align-items: center;
    justify-content: space-between;
}
</style>
<div class="content-wrapper">
	<section class="content-header">
        <div class="header-icon">
            <i class="fa fa-globe"></i>
            <h4>Page Meta Data</h4>
        </div>
        {{-- <div class="header-title">
        
            <a href="#" class="btn btn-sm" data-toggle="modal" data-target="#basicModal" style="    
              background-color: #009688;
               border-color: #009688; color: white" ><i class="fa fa-edit" ></i></a>
        </div> --}}
    </section>

    <section class="content">
        <div class="row">
           
            @if(hasPermission(['station-list']))
            <div class="container">
                <div class="row">
                    <div class="d-flex">
                        <h3 class="station-title">Page Meta Data List</h3>
                        <div class="search-btn">
                            <input type="text" id="searchStation" class="form-control" placeholder="Search..."/>
                        </div>
                    </div>
                    <div class="table-responsive a">
                        <table class="table-bordered table">
                            <thead>
                                <tr class="main-header">
                                    <th style="min-width:120px;" class="text-center">Sl. No.</th>
                                    <th style="min-width:150px;" class="text-center">Name</th>
                                    <th style="min-width:150px;" class="text-center">Type</th>
                                    <th style="min-width:200px;" class="text-center">Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                @forelse($MetaDataObj as $metaData)
                                <tr class="stationlist">
                                   
                                    <td class="text-center">
                                        {{$loop->iteration}}
                                    </td>
                                    <td class="text-center" id="pageName">
                                        {{$metaData->name}}
                                    </td>
                                    <td class="text-center">
                                        @switch($metaData->page_type)
                                            @case(1)
                                                    Page  
                                                @break
                                            @default
                                        @endswitch
                                    </td>
                                    
                                    <td class="text-center">
                                        @if(hasPermission(['page-seo-meta-edit']))
                                            <button onclick="openModel('{{$metaData->id}}', 'edit');" class="btn btn-warning edit">
                                                <span class="fa fa-edit"></span>
                                            </button>
                                        @endif
                                        <button onclick="openModel('{{$metaData->id}}', 'view');" class="btn btn-primary edit">
                                            <span class="fa fa-eye"></span>
                                        </button>
                                        
                                    </td>
                                </tr>
                                @empty
                                <div class="col-md-12">
                                    <h4>No data added yet</h4>
                                </div>
                                @endforelse
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            @endif
    </section>

 @if(hasPermission(['edit-station']))
    <div class="Editmodel modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" style="color:grey;font-weight:600;font-size:15px;">Edit</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form id="formsubmition" enctype="multipart/form-data" class="ajaxForm" role='form' method="post">
                    <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                    <input type="hidden" id="meta_id" name="meta_id" value="">
                
                    <div class="form-group">
                        <label for="meta_title">Meta Title</label>
                        <input type="text" name="meta_title" class="form-control" id="meta_title" placeholder="Meta Title">
                    </div>

                    <div class="form-group">
                        <label for="meta_description">Meta Description</label>
                        <textarea class="form-control" name="meta_description" rows="4" id="meta_description"></textarea>
                    </div>
                    
                    <div class="form-group">
                        <label for="meta_image">Meta Image</label>
                        <input type="file" name="meta_image" alt="meta-image" id="meta_image">
                        <img src="" id="image_preview" height="100px"/>
                    </div>
                </form>
            </div>
            <div class="modal-footer">
                <button onclick="submitDetail();" type="button" class="btn btn-primary">Submit</button>
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>    
            </div>
         </div>
           
        </div>
    </div>
 @endif

 <div class="ViewModel modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title" style="color:grey;font-weight:600;font-size:15px;">View</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div class="modal-body">           
            <div class="row">
                <div class="col-md-12">
                    <div class="form-group">
                        <label for="">Meta Title</label>
                        <div id="view_meta_title"></div>
                    </div>
                </div>
                <div class="col-md-12">
                    <div class="form-group">
                        <label for="">Meta Description</label>
                        <div id="view_meta_description"></div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-12">
                    <div class="form-group">
                        <label for="">Meta Image</label>
                        <img src="" id="view_image_preview" height="100px"/>
                    </div>
                </div>
            </div>
            
        </div>
     </div>
       
    </div>
</div>

</div>
@stop


@section('script')
<script>


    $('#meta_image').change(function() {
        var input = this;
        if (input.files && input.files[0]) {
            var reader = new FileReader();
            reader.onload = function(e) {
                $('#image_preview').attr('src', e.target.result);
                $('#image_preview').show();
            }
            reader.readAsDataURL(input.files[0]);
        }
    });

    function searchStations() {
        var input = document.getElementById("searchStation");
        var filter = input.value.toLowerCase();
        var outlets = document.querySelectorAll(".stationlist");
        for (var i = 0; i < outlets.length; i++) {
            var outlet = outlets[i];
            var outletName = outlet.querySelector("#pageName").textContent.toLowerCase(); // Corrected line

            if (outletName.includes(filter)) {
                outlet.style.display = "table-row"; // Display the row
            } else {
                outlet.style.display = "none"; // Hide the row
            }
        }
    }


    // Add an event listener to the input field for keyup event
    document.querySelector('#searchStation').addEventListener('keyup', function() {
        searchStations(); // Call the search function when the user types
    });


    function openModel(getid,source) {
        console.log(source);
        var url = "{{ url('') }}";
        $.ajax({
            type: 'GET',
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf"]').attr('content')
            },
            url: url + '/admin/page-meta-data/edit/' + getid, // Adjusted line
            cache: false,
            success: function(data) {

                if(source==="edit"){

                    $("#meta_title").val(data.meta_title);
                    $("#meta_description").text(data.meta_description);
                    $("#image_preview").attr("src", "{{ asset('') }}" + data.meta_image);
                    $("#meta_id").val(data.id);
                    $('.Editmodel').modal('show');
                }
                else{

                    $("#view_meta_title").text(data.meta_title);
                    $("#view_meta_description").text(data.meta_description);
                    $("#view_image_preview").attr("src", "{{ asset('') }}" + data.meta_image)
                    $('.ViewModel').modal('show'); 
                }
            }
        });
    }


    function submitDetail(){

        $.ajaxSetup({
            headers: {
                "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr(
                    "content"
                ),
            },
        });
        var FormMetaData = document.getElementById("formsubmition");
        var formData = new FormData(FormMetaData);
        $.ajax({
            type: "POST",
            url: "{{ url('/admin/page-meta-data/update') }}",
            data: formData,
            cache: false,
            contentType: false,
            processData: false,
            success: function(response) {
                location.reload();
            },
            error: function(data) {
                console.log(data);
            },
        });
        
    };
        
</script>
@stop
