@extends('app')
@section('content')
@if(\Auth::check())
<div class="content-wrapper">

    <section class="content-header">
        <div class="header-icon">
            <i class="fa fa-users"></i>
        </div>
        <div class="header-title">
            <h1>View Log</h1>
        </div>
    </section>


    <div class="btn-group btn-group-justified" role="group" aria-label="...">
        <a href="{{url('/admin/log/order')}}" class="btn @if($log_source=="order") btn-success @else btn-default @endif">Order Log</a>
        <a href="{{url('/admin/log/outlet')}}" class="btn @if($log_source=="outlet") btn-success @else btn-default @endif">Outlet Log</a>
        <a href="{{url('/admin/log/menu')}}" class="btn @if($log_source=="menu") btn-success @else btn-default @endif">Menu Log</a>
    </div>

   

    <section class="content">
        <div class="row">
            <div class="col-sm-12 col-md-12 col-lg-12" >
                <form action="{{url('/admin/log')}}" method="POST">
                    <input type="hidden" name="_token" value="{{csrf_token()}}">
                    <input type="text" style="max-width:200px" name="date" value="{{$date}}" class="from-control to-period datepicker">
                    <button class="btn btn-primary add-period" style="border-radius: 20px;">
                            <span>Log</span>
                    </button>
                    <br>
                    <div style="clear:both;margin-top:30px;font-size:17px">
                        @if($page>1)
                        <a href="{{url('/admin/log')}}?date={{$date}}&page={{$page-1}}"><i class="fa fa-arrow-left" aria-hidden="true"></i></a>
                        @else
                        <span><i class="fa fa-arrow-left" aria-hidden="true"></i></span>
                        @endif
                        <span style="margin-left:15px;font-size:14px">Page {{$page}}</span>
                        @if($total>$page)
                        <a style="margin-left:15px" href="{{url('/admin/log')}}?date={{$date}}&page={{$page+1}}"><i class="fa fa-arrow-right" aria-hidden="true"></i></a>
                        @else
                        <span style="margin-left:15px"><i class="fa fa-arrow-right" aria-hidden="true"></i></span>
                        @endif
                        <span style="margin-left:45px;font-size:14px">Total {{$total}}</span>
                    </div>
                    <div class="log" style="background:#f7f7f7;margin-top:15px;border:1px solid #dfe1e5;padding:15px;font-size:12px;overflow-y: auto;height:430px;box-shadow: 0 1px 3px #dfe1e5, 0 1px 2px #dfe1e5;border-radius:4px;">
                        @forelse($log as $line)
                        <p>{{$line}}</p>
                        @empty
                        @endforelse
                    </div>
                    <!--iframe src="storage/exports/index.html" width=200 height=400 frameborder=0 ></iframe-->
                </form>       
            </div>     
        </div>
    </section>
</div>
@else
<script>window.location.href = "{{env('APP_URL')}}";</script>
@endif
@stop
@section('script')
<script>
    $(function() {
        $( ".datepicker" ).datepicker({ dateFormat: 'yy-mm-dd' });
    });
</script>
@stop