<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Feedbacks</title>

  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous" />

  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" integrity="sha512-iBBXm8fW90+nuLcSKlbmrPcLa0OT92xO1BIsZ+ywDWZCvqsWgccV3gFoRBv0z+8dLJgyAHIhR35VZc2oM/gI1w==" crossorigin="anonymous" referrerpolicy="no-referrer" />
  <style>
    .__m {
      min-width: 100px;
      min-height: 80px;
      background-color: #eee;
      border: 1px solid #aaa;
      border-radius: 3px;

    }

    ._gaps {
      column-gap: 10px;
      row-gap: 10px;
    }

    ._underlined {
      border-bottom: 1px solid #eee;
      padding: 15px 0;
    }

    table td {
      color: #333;
      font-size: 14px;
      font-weight: 500;
    }

    table thead tr {
      background-color: #eee;
      color: #000;
    }

    .well {
      padding: 10px;
      border-radius: 3px;
      background-color: #eee;
      border: 1px solid #eee;
      ;
    }

    .vflex {
      display: flex;
      flex-direction: column;
    }

    .grid__2 {
      display: grid;
      grid-template-areas: "x x";
      column-gap: 10px;
      row-gap: 10px;
    }

    .grid__3 {
      display: grid;
      grid-template-areas: "x x x";
      column-gap: 10px;
      row-gap: 10px;
    }
  </style>
</head>

<body>
  <div id="feedbacks" class="container">
    <div class="well">
      <h2>@{{headline}}</h2>
      <h6>@{{subtitle}}</h6>
    </div>

    <div class="grid__2">
      <div class="vflex form-group p-2">
        <label for="complainFromDate">From</label>
        <input type="datetime-local" name="complainFromDate" class="form-control" v-model="segment.complainFromDate">
      </div>

      <div class="vflex form-group p-2">
        <label for="complainToDate">To</label>
        <input type="datetime-local" name="complainToDate" class="form-control" v-model="segment.complainToDate">
      </div>
    </div>

    <div class="grid__2">
      <div class="vflex form-group p-2">
        <label for="paymentType">Payment Type</label>
        <select name="paymentType" id="" class="form-control" v-model="segment.paymentType">
          <option value="PRE_PAID"> Prepaid</option>
          <option value="CASH_ON_DELIVERY"> Cash On Delivery</option>
        </select>
      </div>


      <div class="vflex form-group p-2">
        <label for="paymentType">Complain Type</label>
        <select name="complainType" id="" class="form-control" v-model="segment.complainType">
          <option value="FOOD_QUALITY">Food Quality</option>
          <option value="FOOD_QUANTITY"> Food Quantity</option>
          <option value="STAFF_BEHAVIOUR"> Staff Behaviour</option>
          <option value="OTHERS"> Others</option>
        </select>
      </div>

    </div>


    <div class="grid__3">
      <div class="vflex form-group p-2">
        <label for="feedbackId">Feedback Id</label>
        <input type="text" name="feedbackId" id="" class="form-control" placeholder="Feedback Id" v-model="segment.feedbackId">
      </div>

      <div class="vflex form-group p-2">
        <label for="orderId">Order Id</label>
        <input type="text" name="orderId" id="" class="form-control" placeholder="Order Id" v-model="segment.orderId">
      </div>

      <div class="vflex form-group p-2">
        <label for="stationCode">Station Code</label>
        <input type="text" name="stationCode" id="" class="form-control" placeholder="Station Code" v-model="segment.stationCode">
      </div>

    </div>


    <div class="grid__3 well">

      <div class="d-flex justify-content-start p-2">
        <button class="btn btn-primary" @click="reset">
          Reset
        </button>
      </div>

      <div class="d-flex justify-content-center">
       <ul class="pagination">
        <li class="page-item">
            <button class="page-link" @click="prevPage">
            <i class="fa fa-chevron-left" ></i>
            </button>
          </li>

          <li class="page-item">
            <button class="page-link" @click="nextPage">
            <i class="fa fa-chevron-right"></i>
            </button>
          </li>

       </ul>
      </div>

      <div class="d-flex justify-content-end p-2">
        <button class="btn btn-success" @click="makeRequest">Apply</button>
        <div style="min-width:10px;"></div>
        <button class="btn btn-primary" @click="exports">Export</button>
      </div>
    </div>

    <template v-if="loading">
      <div class="text-center p-4">
        <div class="spinner-border" role="status">
          <span class="sr-only">Loading...</span>
        </div>
      </div>
    </template>

    <template v-else>
      <table class="table table-responsive table-stripped" style="width: 100%;">
        <thead>
          <tr>
            <th>Feedback Id</th>
            <th>Order Id</th>
            <th>Vendor</th>
            <th>Payment Type</th>
            <th>Amount Payable</th>
            <th>Rating</th>
            <th>Remarks</th>
            <th>Type</th>
            <th>Created At</th>
          </tr>
        </thead>

        <tbody>
          <template v-for="feedback in feedbacks">
            <feedback-row :feedback="feedback">
            </feedback-row>
          </template>
        </tbody>
      </table>

    </template>
  </div>


  <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>

  <!-- <script src="./components/core.js"></script> -->
  <!-- <script src="./components/lib.js"></script> -->
  <script src="/vue/feedback.js"></script>
</body>

</html>
