
@extends('app')
@section('content')
@if(\Auth::check())
<div class="content-wrapper">

    <section class="content-header">
        <div class="header-icon">
            <i class="fa fa-users"></i>
        </div>
        <div class="header-title">
            <h1>Outlets</h1>
        </div>
    </section>
    <section class="content">
        <div class="row">
        @if(!empty($outlets))
        @forelse($outlets as $outlet)
        <div class="col-sm-6 col-md-6 col-lg-6">
            <div class="panel panel-bd lobidrag">
                <div class="panel-body">
                    <h3>Outlet Name :{{$outlet->outletName}}</h3>
                    <hr>
                    @role('admin')
                    <label class="switch">
                      <input type="checkbox" id="{{$outlet->id}}" data-toggle="modal" data-id="{{$outlet->id}}" data-target="#updateModal{{$outlet->id}}" {{$outlet->open}}>
                      <span class="slider round"></span>
                    </label>
                    @if(!empty($outlet->reason)&&!$outlet->open)
                    <label id="reason_{{$outlet->id}}" style="color:red;float:right;">Closed due to {{$outlet->reason}}</label>
                    @elseif(empty($outlet->reason)&&!$outlet->open)
                    <label id="reason_{{$outlet->id}}" style="color:red;float:right;">Closed</label>
                    @else
                    <label id="reason_{{$outlet->id}}" style="color:red;float:right;"></label>
                    @endif
                    <hr>
                    <form action="{{url('/manager/invoice_frequency')}}/{{$outlet->id}}" method="POST">
                        <div style="display: block;margin-top: 15px;margin-bottom: 10px;">
                        <p class="range-field" style=" width:60px;display: inline-block">
                            <input type="range" class="range" name="invoice_frequency" min="1" max="3" value="{{$outlet->invoice_frequency+1}}">
                        </p>
                        <div style="float: right">
                        <span style="display: inline-block">Invoice Frequency:</span>
                        @if($outlet->invoice_frequency+1==1)
                        <span class="frequency" style="color: #d94f9b;font-weight: bold;">Date Range</span>                    
                        @elseif($outlet->invoice_frequency+1==2)
                        <span class="frequency" style="color: #d94f9b;font-weight: bold;">Weekly</span>                    
                        @elseif($outlet->invoice_frequency+1==3)
                        <span class="frequency" style="color: #d94f9b;font-weight: bold;">Monthly</span>                    
                        @endif
                        </div>
                    </div>
                    </form>
                        
                    <!-- Modal -->
                    <div class="modal fade" name="{{$outlet->id}}" id="updateModal{{$outlet->id}}" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                      <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <form action="{{url('/manager/Outlet/')}}/{{$outlet->id}}" class="form-inline ajaxForm"  role='form' method="POST">
                          <div class="modal-header">
                            <h5 class="modal-title" style="font-size: 16px;color: green;" id="exampleModalLabel">Save Closing Period and Days</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                              <span aria-hidden="true">&times;</span>
                            </button>
                          </div>
                          <div class="modal-body" style="text-align:center;height: auto;overflow: auto;">
                            <div style="display:inline-block;margin: 0 auto;text-align:left;">
                                <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                                <h5 style="text-align:left">Closing Period</h5>
                                
                                <div class="col-sm-12 group" style="text-align:left;padding-top: 10px;padding-bottom: 20px;">
                                        @if(!empty($outlet->closingPeriod))
                                        {{{ '' != $i = 0 }}}
                                        @forelse($outlet->closingPeriod as $period)
                                        <div class="form-group period-row" style="display:block;padding:5px;">
                                            <label style="padding:0 5px 0 5px" for="name">From Date</label>
                                            <input type="text" id="{{$outlet->id}}_{{$i}}_0" style="max-width:100px" value="{{$period->closedFrom}}" name="startDate[{{$i}}]" class="form-control from-period datepicker">
                                            <label style="padding:0 5px 0 5px" for="name">To Date</label>
                                            <input type="text" id="{{$outlet->id}}_{{$i}}_1" style="max-width:100px" value="{{$period->closedTo}}" name="endDate[{{$i++}}]" class="form-control to-period datepicker">
                                            <button class="btn btn-primary add-period" style="border-radius: 20px;">
                                                   <span class="fa fa-plus"></span>
                                            </button>	
                                            <button class="btn btn-primary remove-period" style="border-radius: 20px;">
                                                   <span class="fa fa-minus"></span>
                                            </button>	
                                        </div>
                                        @empty
                                        @endforelse
                                        @else
                                        <div class="form-group period-row" style="display:block;padding:5px;">
                                            <label style="padding:0 5px 0 5px" for="name">From Date</label>
                                            <input type="text" style="max-width:100px" name="startDate[0]" class="form-control from-period datepicker">
                                            <label style="padding:0 5px 0 5px" for="name">To Date</label>
                                            <input type="text" style="max-width:100px" name="endDate[0]" class="form-control to-period datepicker">
                                            <button class="btn btn-primary add-period" style="border-radius: 20px;">
                                                   <span class="fa fa-plus"></span>
                                            </button>	
                                            <button class="btn btn-primary remove-period" style="border-radius: 20px;">
                                                   <span class="fa fa-minus"></span>
                                            </button>	
                                        </div>
                                        @endif
                                 </div>	                                
                                <div style="display:block"><h5 style="text-align:left">Weekly Closed</h5></div>
                                <div class="col-sm-12 group" style="text-align:left;padding-top: 10px;padding-bottom: 10px;">
                                    <div class="form-group" style="display:block;padding:5px;">
                                        <label style="padding:0 5px 0 5px" for="name">Select days</label>
                                        <select name="days[]" class="custom-select" multiple size = 7>
                                          @if(empty($outlet->weeklyClosed))
                                          <option value="" selected></option>
                                          @else
                                          <option value=""></option>
                                          @endif
                                          @if(!empty($outlet->weeklyClosed)&&in_array("SUN",$outlet->weeklyClosed))
                                          <option value="SUN" selected>SUNDAY</option>
                                          @else
                                          <option value="SUN">SUNDAY</option>
                                          @endif
                                          @if(!empty($outlet->weeklyClosed)&&in_array("MON",$outlet->weeklyClosed))
                                          <option value="MON" selected="">MONDAY</option>
                                          @else
                                          <option value="MON">MONDAY</option>
                                          @endif
                                          @if(!empty($outlet->weeklyClosed)&&in_array("TUE",$outlet->weeklyClosed))
                                          <option value="TUE" selected>TUESDAY</option>
                                          @else
                                          <option value="TUE">TUESDAY</option>
                                          @endif
                                          @if(!empty($outlet->weeklyClosed)&&in_array("WED",$outlet->weeklyClosed))
                                          <option value="WED" selected>WEDNESDAY</option>
                                          @else
                                          <option value="WED">WEDNESDAY</option>
                                          @endif
                                          @if(!empty($outlet->weeklyClosed)&&in_array("THU",$outlet->weeklyClosed))
                                          <option value="THU" selected>THURSDAY</option>
                                          @else
                                          <option value="THU">THURSDAY</option>
                                          @endif
                                          @if(!empty($outlet->weeklyClosed)&&in_array("FRI",$outlet->weeklyClosed))
                                          <option value="FRI" selected>FRIDAY</option>
                                          @else
                                          <option value="FRI">FRIDAY</option>
                                          @endif
                                          @if(!empty($outlet->weeklyClosed)&&in_array("SAT",$outlet->weeklyClosed))
                                          <option value="SAT" selected>SATURDAY</option>
                                          @else
                                          <option value="SAT">SATURDAY</option>
                                          @endif
                                        </select>                                        
                                    </div>
                                 </div>
                                <div style="display:block"><h5 style="text-align:left">Reason for Closing</h5></div>
                                <div class="col-sm-12 group" style="text-align:left;padding-top: 10px;padding-bottom: 10px;">
                                    <div class="form-group" style="display:block;padding:5px;">
                                        <label style="padding:0 5px 0 5px" for="name">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Reason</label>
                                        <textarea style="max-width:300px;height:100px" name="reason" class="form-control">
                                        </textarea>
                                    </div>
                                 </div>	   
                            </div>
                          </div>
                          <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            <button class="btn btn-primary">Save changes</button>
                          </div>
                        </form>
                        </div>
                      </div>
                    </div>  
                    @endrole
                    <ul class="list-group">
                        <li class="list-group-item">Opening Time <span class="badge">{{$outlet->openingTime}}</span></li>
                        <li class="list-group-item">Closing Time <span class="badge">{{$outlet->closingTime}}</span></li>
                        <li class="list-group-item">Station <span class="badge">{{$outlet->station->name}}</span></li>
                        <div class="list-group-item" style="display: flex;justify-content: center;">
                                @if($outlet->menu()->exists())
                                   <div class="btn-group">
                                            @role('admin','vendor')
	                                   	<a href="{{url('/admin/workflow/menu')}}/{{$outlet->id}}" class="btn btn-success btn-sm">
	                                        <span class="fa fa-bars"></span>
	                                        Add Items
	                                    </a>
                                            @role('admin')
                                                <a href="{{url('/upload/menuitems')}}/{{$outlet->id}}" class="btn btn-warning btn-sm">
                                                  <span class="fa fa-user"></span>
                                                        Upload Items
                                                </a>
                                            @endrole
                                            @role('admin')
                                                <a href="{{url('/manager/outlets/list/menuitems')}}/{{$outlet->id}}" class="btn btn-warning btn-sm">
                                                  <span class="fa fa-user"></span>
                                                        Update Items
                                                </a>
                                            @endrole

	                                    <a href="#" class="btn btn-primary btn-sm">
	                                        <span class="fa fa-edit"></span>
	                                        Edit Vendor details
	                                    </a>
	                                    <a href="#" class="btn btn-warning btn-sm">
	                                        <span class="fa fa-user"></span>
	                                        Edit Vendor Owner Details
	                                    </a>
                                            @endrole
                                            @role('admin','agent','vendor','radmin')
	                                    <a href="{{url('/manager/orders')}}/{{$outlet->id}}" class="btn btn-warning btn-sm">
	                                        <span class="fa fa-user"></span>
	                                        order details
	                                    </a>
                                            @endrole
                                            @role('admin')
                                                <a href="{{url('/manager/invoice')}}/{{$outlet->id}}" class="btn btn-warning btn-sm">
                                                  <span class="fa fa-user"></span>
                                                        Download Invoice
                                                </a>
                                            @endrole
                                            @role('admin')
                                                <a href="{{url('/manager/invoice4')}}/{{$outlet->id}}" class="btn btn-warning btn-sm">
                                                  <span class="fa fa-user"></span>
                                                        Generate Invoice
                                                </a>
                                            @endrole

                                   </div>

                                @else
                                <form action="{{url('/admin/workflow/menu')}}/{{$outlet->id}}" method="POST">
                                    <input type="hidden" name="_token" value="{{csrf_token()}}">
                                    <input type="hidden" name="menuId" value="{{$outlet->id.mt_rand(1,100)}}">
                                    <button type="submit" class="btn btn-primary">
                                        <span class="fa fa-cutlery"></span>
                                        Add Menu
                                    </button>
                                </form>
                                @endif
                            </a>
                        </div>
                    </ul>
                </div>
            </div>
          </div>
        @empty

        @endforelse
        @endif

    </section>
</div>
@else
<script>window.location.href = "{{env('APP_URL')}}";</script>
@endif
@stop
@section('script')
<script>
        function filterme(value) {
          value = parseInt(value, 10); // Convert to an integer
          if (value === 1) {
            $('#RangeFilter').removeClass('rangeAll', 'rangePassive').addClass('rangeActive');
            $('#invoiceFrequency').text('Date Range');
          } else if (value === 2) {
            $('#RangeFilter').removeClass('rangeActive', 'rangePassive').addClass('rangeAll');
            $('#invoiceFrequency').text('Weekly');
          } else if (value === 3) {
            $('#RangeFilter').removeClass('rangeAll', 'rangeActive').addClass('rangePassive');
            $('#invoiceFrequency').text('Monthly');
          }
        }        
    
    $(function() {
        var countPeriod = 0;
        $( ".datepicker" ).datepicker({ dateFormat: 'yy-mm-dd' });
        $(".modal").on("hide.bs.modal", function () {
            var out = $(this).attr('name');
            if($('#'+out).attr('touch') == 'true'){
            }else{
                if($('#'+out). prop("checked") == true)
                    $('#'+out).prop('checked', false);
                else
                    $('#'+out).prop('checked', true);
            }
          });
        $(".modal").on("show.bs.modal", function () {
            var out = $(this).attr('name');
            $('#'+out).attr('touch', false);
          });
        $( ".form-inline").on("click", ".add-period", function(e){
            e.preventDefault();
            var id = $(this).closest(".modal").attr("name");
            var clone = $( this ).parent().clone();
            clone.appendTo($( this ).parent().parent());
            $("#updateModal"+id).find(".group").children().each(function(){
                $(this).find(".from-period").attr("name", "startDate["+(countPeriod)+"]");
                $(this).find(".from-period").attr("id", id+"_"+countPeriod+"_0");
                $(this).find(".to-period").attr("name", "endDate["+countPeriod+"]");
                $(this).find(".to-period").attr("id", id+"_"+countPeriod+"_1");
                countPeriod++;
            });
            clone.find( ".datepicker" ).removeClass('hasDatepicker').datepicker({ dateFormat: 'yy-mm-dd' });
            countPeriod = 0;
            return false;
        });
        $( ".form-inline").on("click", ".remove-period",function(e){
            e.preventDefault();
            if($(this).parent().parent().children().length==1)
                return false;
            var id = $(this).closest(".modal").attr("name");
            $(this).parent().remove();
            $("#updateModal"+id).find(".group").children().each(function(){
                $(this).find(".from-period").attr("name", "startDate["+countPeriod+"]");
                $(this).find(".to-period").attr("name", "endDate["+countPeriod+"]");
                countPeriod++;
            });
            countPeriod = 0;
            return false;
        });
        $( ".range").on("change", function(e){
            e.preventDefault();
            value = parseInt($(this).val(), 10); // Convert to an integer
            if (value === 1) {
              $(this).removeClass('rangeAll', 'rangePassive').addClass('rangeActive');
              $(this).closest('div').find('.frequency').text('Date Range');
            } else if (value === 2) {
              $('#RangeFilter').removeClass('rangeActive', 'rangePassive').addClass('rangeAll');
              $(this).closest('div').find('.frequency').text('Weekly');
            } else if (value === 3) {
              $('#RangeFilter').removeClass('rangeAll', 'rangeActive').addClass('rangePassive');
              $(this).closest('div').find('.frequency').text('Monthly');
            }
            $(this).closest('form').submit();
        });
	$('.ajaxForm').submit(function(e){
		e.preventDefault();
		var self =  $(this);
		var data = self.serializeArray();
		var options =  {
			url:self.attr('action'),
			type:self.attr('method'),
			data:data,
		};

		$.ajax(options).done(function(res){
                    if($('#'+res.outletId). prop("checked") == true){
                        if(!res.open){
                            $('#'+res.outletId).prop('checked', false);
                        }
                    }else{
                        if(res.open){
                            $('#'+res.outletId).prop('checked', true);
                        }
                    }
                    $('#'+res.outletId).attr('touch', true);
                    if(!res.open){
                        if(res.reason!='')
                            $('#reason_'+res.outletId).html('Closed due to '+res.reason);
                        else
                            $('#reason_'+res.outletId).html('Closed');
                    }else
                        $('#reason_'+res.outletId).html('');
                    $('#updateModal'+res.outletId).modal('hide');
            });
	});
        
    });
</script>
@stop
