@extends('app')

@section('content')
<div class="content-wrapper">
	<section class="content-header">
        <div class="header-icon">
            <i class="fa fa-cog"></i>
        </div>
        <div class="header-title">
            <h1>Generate Invoice</h1>
            <small>.</small>
            <a href="#" class="btn btn-sm" data-toggle="modal" data-target="#basicModal" style="    margin-left: 96%;
               margin-top: -24px; background-color: #009688;
               border-color: #009688; color: white" ><i class="fa fa-edit" ></i></a>
        </div>
    </section>

    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="panel panel-bd lobidrag">
                    <div class="panel-body">
                        <form action="{{url('/manager/invoice2/download')}}" class="form-inline ajaxForm"  role='form' method="POST">
                            <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                            <input type="hidden" name="outletId" value="{{$outletId}}"/>
                            <div class="col-sm-8">
                                <div class="form-group">
                                    <label for="name">Start Date</label>
                                    @if($frequency==0)
                                    <input type="text" name="startDate" readonly="" value="{{$startDate}}" class="form-control">
                                    <label for="name">End Date</label>
                                    <input type="text" name="endDate" class="form-control datepicker">
                                    @else
                                    <input type="text" name="startDate" readonly="" value="{{$startDate}}" class="form-control">
                                    <label for="name">End Date</label>
                                    <input type="text" name="endDate" value="{{$endDate}}" readonly="" class="form-control">
                                    @endif
                                    
                                    <button id="downloadInvoice" class="btn btn-primary" style="border-radius: 20px;">
                                           Generate 
                                    </button>
                                    
                                    <div style="display: block;margin-top: 30px;">
                                        <input type="text" name="amount" value="{{$invoice1->payable+$invoice1->previous_balance-$invoice1->amount_paid}}" class="form-control" style="width:150px;display:inline-block;margin-right:5px;">
                                        <button id="payInvoice" class="btn btn-primary"  type="submit" style="display:inline-block;margin-top:-3px;">Pay</button>
                                    </div>
                                </div>
                             </div>	                                
                        </form>
                    </div>
                </div>
                <div class="panel panel-bd lobidrag">
                    <div class="panel-heading">
                        <div class="btn-group">
                            <a href="#">
                                <h4 style="color:#009688">List Invoices</h4>
                            </a>
                        </div>
                    </div>
                    <div class="panel-body">
                        <div class="table-responsive" style="clear:both">
                            <table id="dataTableExample1" class="table table-bordered table-striped table-hover">
                                <thead>
                                    <tr class="info">
                                        <th>Outlet</th>
                                        <th>Date</th>
                                        <th>Period Start</th>
                                        <th>Period End</th>
                                        <th>Total Amount</th>
                                        <th>Paid</th>
                                        <th>Outstanding</th>
                                        <th>Status</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                @foreach($invoices as $invoice)
                                <tbody>
                                    <tr>
                                        <td>{{$invoice['outlet_name']}}</td>
                                        <td>{{$invoice['date']}}</td>
                                        <td>{{$invoice['period_start']}}</td>
                                        <td>{{$invoice['period_end']}}</td>
                                        <td>{{$invoice['payable']+$invoice['previous_balance']}}</td>
                                        <td>{{$invoice['amount_paid']}}</td>
                                        <td>{{$invoice['payable']+$invoice['previous_balance']-$invoice['amount_paid']}}</td>
                                        <td>{{$invoice['status']}}</td>

                                        <td style="width: 230px !important;">
                                            <table style="width:100%">
                                                <tr>
                                                    <td>
                                                        @role('admin')
                                                        <form method="POST" action="{{url('/manager/invoice3/zip/')}}">
                                                            <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                                                            <input type="hidden" name="id" value="{{$invoice->id}}"/>
                                                            <input type="hidden" name="outletId" value="{{$outletId}}"/>
                                                            <input type="hidden" name="regenerate" value="true"/>
                                                            <button id="sendInvoice" class="btn btn-primary"  type="submit" style="display:inline-block">Download</button>
                                                        </form>
                                                        <form method="POST" action="{{url('/manager/invoice3/zip/')}}">
                                                            <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                                                            <input type="hidden" name="id" value="{{$invoice->id}}"/>
                                                            <input type="hidden" name="outletId" value="{{$outletId}}"/>
                                                            <input type="hidden" name="regenerate" value="true"/>
                                                            <input type="hidden" name="send" value="true"/>
                                                            <button id="sendInvoice" type="submit" style="display:inline-block;" class="btn btn-primary">Send</button>
                                                        </form>
                                                        <form method="GET" action="{{url('/manager/delete/invoice')}}/{{$invoice->id}}">
                                                            <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                                                            <button id="deleteInvoice" type="submit" style="display:inline-block;" class="btn btn-primary">Delete</button>
                                                        </form>
                                                        @endrole
                                                    </td>
                                                </tr>
                                            </table>

                                        </td>
                                    </tr>
                                </tbody>
                                @endforeach                              
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>

</div>
@stop


@section('script')
<script type="text/javascript">
var SEND_INVOICE_URL = {!! json_encode(url('/manager/invoice3/zip/')) !!}
var DOWNLOAD_INVOICE_URL = {!! json_encode(url('/manager/invoice2/download')) !!}
var PAY_INVOICE_URL = {!! json_encode(url('/manager/payment/invoice')) !!}
</script>
<script>
    $( ".datepicker" ).datepicker();
$(function() {
  $("#downloadInvoice").click(function() {
    $(this).closest("form").attr('action', DOWNLOAD_INVOICE_URL);
    $(this).closest("form").attr('method', 'POST');
    
    //$(this).closest("form").submit();
  });
  $("#sendInvoice").click(function() {
    $(this).closest("form").attr('action', SEND_INVOICE_URL);
    $(this).closest("form").attr('method', 'POST');
    
    //$(this).closest("form").submit();
  });
  $("#payInvoice").click(function() {
    $(this).closest("form").attr('action', PAY_INVOICE_URL);
    $(this).closest("form").attr('method', 'POST');
    
    //$(this).closest("form").submit();
  });
});    
</script>
@stop