@extends('app')

@section('content')
<style>
    @media print {
        #main-header {
            display: none !important;
        }
        .table>thead>tr.info>th {
            background-color: #d9edf7 !important;
            -webkit-print-color-adjust: exact !important;        
        }
        a {
            color: #009688!important;
            text-decoration: none;
        }    
        a[href]:after {
            content: none !important;
        }
        .panel-heading.ui-sortable-handle {
            background-color: #e8f1f3 !important;
            -webkit-print-color-adjust: exact !important;        
        }
        #select-all{
            /*display: none !important;*/
        }
        .table-responsive{
            display: block;
            width: auto;
            height: auto;
            overflow: visible;
        }
        .current-page{
            background-color: #428bca !important;
            color: #fff !important;
            -webkit-print-color-adjust: exact;        
        }
        #next, #previous, .btn-primary {
            background-color: #428bca !important;
            color: #fff !important;
            -webkit-print-color-adjust: exact;
        }
        .content-header {
            display: none !important;
        }
        #invoice-header {
            display: none !important;
        }
        .form-inline .form-control {
            width: auto !important;
            display: inline-block;
            width: auto;
            vertical-align: middle;        
        }
        #list-outlets {
            color: #009688 !important;
        }
    </style>
<div class="content-wrapper">
	<section class="content-header">
        <div class="header-icon">
            <i class="fa fa-cog"></i>
        </div>
        <div class="header-title">
            <h1>Generate Invoice</h1>
            <small>.</small>
            <a href="#" class="btn btn-sm" data-toggle="modal" data-target="#basicModal" style="    margin-left: 96%;
               margin-top: -24px; background-color: #009688;
               border-color: #009688; color: white" ><i class="fa fa-edit" ></i></a>
        </div>
    </section>

<form action="{{url('/manager/invoice5/index2')}}/{{$start}}/{{$end}}/{{$total}}" class="form-inline ajaxForm"  role='form' method="POST">
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div id="invoice-header" class="panel panel-bd lobidrag">
                    <div class="panel-body">
                            <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                            <div class="col-sm-8">
                                <div class="form-group">
                                    <label for="name">Start Date</label>
                                    <input type="text" name="startDate" value="{{$startDate}}" class="form-control datepicker">
                                    <label for="name">End Date</label>
                                    <input type="text" name="endDate" value="{{$endDate}}" class="form-control datepicker">
                                    <div style="margin-top:15px;">
                                        <button id="generateInvoice" class="btn btn-primary" style="border-radius: 20px;">
                                               Generate
                                        </button>
                                        <button id="sendInvoice" class="btn btn-primary" style="border-radius: 20px;">
                                               Send Invoice
                                        </button>
                                        <button id="downloadInvoice" class="btn btn-primary" style="border-radius: 20px;">
                                               Download Invoice
                                        </button>
                                        <button id="downloadInvoiceExcel" class="btn btn-primary" style="border-radius: 20px;">
                                               Download Invoice Excel
                                        </button>
                                        <button id="printInvoice" onclick="Popup($('#printInvoice2')[0].outerHTML)" class="btn btn-primary" style="border-radius: 20px;">
                                               Print Invoice
                                        </button>
                                    </div>
                                </div>
                             </div>	                                
                    </div>
                </div>
                <div id="printInvoice2" class="panel panel-bd lobidrag">
                    <div class="panel-heading">
                        <div class="btn-group">
                            <a href="#">
                                <h4 id="list-outlets" style="color:#009688">List Outlets</h4>
                            </a>
                        </div>
                    </div>
                    <div class="panel-body">
                            <div>
                                <input type="checkbox" id="select-all" class="form-control" style="position:relative;top:-5px;">
                                <label>Select All</label>
                            </div>
                        <div class="table-responsive" style="clear:both">
                            <table id="dataTableExample1" class="table table-bordered table-striped table-hover">
                                <thead>
                                    <tr class="info">
                                        <th>Select</th>
                                        <th>Outlet Name</th>
                                        <th>Start Date</th>
                                        <th>Opening Balance</th>
                                        <th>Current Invoice</th>
                                        <th>Total Outstanding</th>
                                    </tr>
                                </thead>
                                @foreach($outlets as $outlet)
                                <tbody>
                                    <tr>
                                        <td>
                                            <input type="checkbox" name="outlet_id_select[]" value="{{$outlet->id}}" class="form-control">
                                        </td>
                                        <td><a href='{{url('/manager/invoice4')}}/{{$outlet->id}}'>{{$outlet->outletName}}</a></td>
                                        <td>{{$outlet->startDate->format('Y-m-d')}}</td>
                                        <td>{{$outlet->openingBalance1}}</td>
                                        <td>{{$outlet->currentInvoice1}}</td>
                                        <td>{{$outlet->total1}}</td>
                                    </tr>
                                </tbody>
                                @endforeach                              
                            </table>
                        </div>
                        <div style="margin-top: 10px;">
                            <label>rows {{$start}} - {{$end}} of {{$total}}</label>
                            @php
                            $i = 0;
                            $currentPage = (int)($start/50)+1;
                            @endphp                            
                            @while($i < $pageCount)
                            <a href="{{url('/manager/invoice5/index2')}}/{{($i*50)+1}}/{{($i*50)+50}}/{{$total}}" style={{$currentPage==$i+1?"background-color:#428bca;margin-left:5px;color:#fff;":"margin-left:5px;"}} class="btn btn-sm {{$currentPage==$i+1?"current-page":""}}">{{$i+1}}</a>
                            @php
                            $i++;
                            @endphp                        
                            @endwhile
                            <button id="previous" {{$start==1?'disabled':''}} name="submit" value="previous" class="btn btn-primary" style="border-radius: 20px;margin-left:15px;">
                                   Previous
                            </button>
                            <button id="next" {{$end==$total?'disabled':''}} name="submit" value="next" class="btn btn-primary" style="border-radius: 20px;">
                                   Next
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</form>

</div>
@stop


@section('script')
<script type="text/javascript">
var GENERATE_INVOICE_URL = {!! json_encode(url('/manager/invoice5/getInvoice')) !!}
var SEND_INVOICE_URL = {!! json_encode(url('/manager/invoice5/send')) !!}
var DOWNLOAD_INVOICE_URL = {!! json_encode(url('/manager/download_invoice')) !!}
var DOWNLOAD_EXCEL_INVOICE_URL = {!! json_encode(url('/manager/excelAllOutletsExcel')) !!}
</script>
<script>
    $( ".datepicker" ).datepicker();
    function Popup(data)
    {
        $('.main-header').css('display','none');
        $('.main-sidebar').css('display','none');
        //$('#sidebar').css('display','none');
        $('#printInvoice2').css("width", "100%");
        $('.content-wrapper').css("margin-left", "0px");
        $('.content-header').css("display", "none");
        $('#invoice-header').css("display", "none");

        window.print();
        $('.main-header').css('display','block');
        $('.main-sidebar').css('display','block');
        //$('#sidebar').css('display','none');
        $('#printInvoice2').css("width", "100%");
        $('.content-wrapper').css("margin-left", "250px");
        $('.content-header').css("display", "block");
        $('#invoice-header').css("display", "block");
       // document.location.href = "";
        return true;
    }
$(function() {
    $('#select-all').click(function(event) {
        if(this.checked) {
            $(':checkbox').each(function() {
                this.checked = true;                        
            });
        }else{
            $(':checkbox').each(function() {
                this.checked = false;                        
            });
        }
            
    });  
    $("#generateInvoice").click(function() {
      $(this).closest("form").attr('action', GENERATE_INVOICE_URL);
      $(this).closest("form").attr('method', 'POST');
    });
    $("#sendInvoice").click(function() {
      $(this).closest("form").attr('action', SEND_INVOICE_URL);
      $(this).closest("form").attr('method', 'POST');
    });
    $("#downloadInvoiceExcel").click(function() {
      $(this).closest("form").attr('action', DOWNLOAD_EXCEL_INVOICE_URL);
      $(this).closest("form").attr('method', 'POST');
    });
    $("#downloadInvoice").click(function() {
      $(this).closest("form").attr('action', DOWNLOAD_INVOICE_URL);
      $(this).closest("form").attr('method', 'POST');
    });
    $("#printInvoice").click(function() {
        return false;
    });
});
</script>
@stop