@extends('app')
@section('content')
<style>
  .content-header{
    display:flex;
    justify-content:space-between;
    align-items:center;
  }
  .form-control{
    height:40px;
  }
  .d-flex{
    display:flex;
    align-items:center;
  }
  .select2.select2-container{
width:79% !important;
  }
  textarea{
    width:79% !important;
    max-width:auto;
  }
  .table-condensed{
    font-size:12px;
    width:100%;
  }
  .datepicker-switch{
    text-align:center;
  }
  .content-header .header-icon .fa {
    font-size: 31px;
   
}
.header-icon .fa{
    font-size:31px;
    margin-right:10px;
}
.content-header .header-icon {
    font-size: 48px;
    color: #009688;
    width: 300px;
    float: left;
    margin-top: 0px;
    line-height: 0;
    display: flex;
    align-items: center;
}
.h1, .h2, .h3, h1, h2, h3 {
    margin-top: 8px;
    margin-bottom: 10px;
}
.content-header {
    display: flex;
    align-items: center;
    justify-content: space-between;
}

.list-group .btn-group{
    display: flex;
    flex-wrap: wrap;
    gap: 6px;
}

</style>
@if(\Auth::check())
<div class="content-wrapper">

  <section class="content-header">
    <div>
      <div class="header-icon">
        <i class="fa fa-users"></i>
        <h1>Outlets</h1>
      </div>
      <div class="header-title">
      </div>
    </div>
    <div class="d-flex">
      <div style="margin-right:20px;font-size:20px;"><b>Total Outlets: <span style="color:#C00;"><?php echo $total; ?></span></b></div>
      <div class="search-btn">
        <form method="GET">
          <input type="text" id="searchOutlets" name="searchOutlets" class="form-control" placeholder="Search Outlets" required value="{{$searchVal}}">
        </form>  
    </div>
    </div>
  </section>
  <section class="content">
    <div class="row outlets">
      @if(!empty($outlets))
    
      @forelse($outlets as $outlet)
        <div class="col-sm-6 col-md-6 col-lg-6" id="#results" style="min-height:60vh">
          <div class="panel panel-bd lobidrag">
            <div class="panel-body">
              <h3>Outlet Name :{{$outlet->outletName}}({{$outlet->id}})</h3>
              <br>
              <div class="row">
                <div class="col-md-4">
                    @if(hasPermission(['delete-outlet']))
                        <button id="deleteOutlet" onclick="delete1({{$outlet->id}})" class="btn btn-danger" style="border-radius: 20px;">
                            Delete outlet
                        </button>
                    @endif
                </div>

                <div class="col-md-4">
                  <a href="{{url('manager/push-out-let/'.$outlet->id)}}" class="btn btn-info" style="border-radius: 20px;">Push Outlet</a>
                </div>
                @if(hasPermission(['publish-outlet']))
                <div class="col-md-4 text-right">
                    <button id="{{$outlet->id}}" data-toggle="modal" data-id="{{$outlet->id}}" data-target="#updateModal{{$outlet->id}}" class="btn btn-success" style="border-radius: 20px;">
                        Update Status
                    </button>
                </div>
                @endif
            </div>
          
              <hr>


              @role('admin','manager')

              <div style="display:inline-flex;">
                <strong style="margin-right: 20px;">Last updated : {{$outlet->pushed_at}}</strong>
                @role('admin')
                <strong>Last Pushed By : {{$outlet->pushed_by_name}}</strong>
                @endrole
              </div>

              <hr>
              <div style="display:inline-flex">
                <strong> Outlet Status </strong>
                {{-- <label class="switch">
                  <input type="checkbox" id="{{$outlet->id}}" data-toggle="modal" data-id="{{$outlet->id}}" data-target="#updateModal{{$outlet->id}}" {{$outlet->open}}>
                  <span class="slider round"></span>
                </label> --}}
              </div>

              @if($outlet->status==1)
              <button id="reason_{{$outlet->id}}" style="background-color:#50ab20;float:right;color:white;">Active</button>
              
              @elseif($outlet->status==0 && !$outlet->open)
              <button id="reason_{{$outlet->id}}" style="float:right;font-size:95%;color:red;color:white;" class="btn btn-danger">InActive @if(!empty($outlet->reason)) | Closed due to : {{$outlet->reason}} @endif</button>
            
              @elseif($outlet->active==0)
              <p id="reason_{{$outlet->id}}" style="float:right;font-size:95%;color:red;color:white;" class="label label-lg label-danger"> Permantly close | Closed due to : {{$outlet->reason}}</p>
              @endif

              @if(!empty($outlet->closingPeriod) && sizeof($outlet->closingPeriod)>0)
                <hr/>
                <button style="color: rgb(255, 255, 255);" class="btn btn-danger"> 
                @foreach ($outlet->closingPeriod as $key=>$closingDate)
                  Closed From : {{$closingDate->closedFrom}} To : {{$closingDate->closedTo}}
                @endforeach
                </button>
              @endif

              @if(!empty($outlet->weeklyClosed))
                <hr/>
                <button style="color: rgb(255, 255, 255);" class="btn btn-danger"> 
                Closed Day :
                @foreach($outlet->weeklyClosed as $closingDay)
                  {{$closingDay}} @if(!$loop->last) , @endif 
                @endforeach
                </button>
              @endif
              
              
              {{-- @if(hasPermission(['publish-outlet']))
              <hr>

              <div style="display:flex; align-items:center;justify-content:space-between">
              <strong> Close Permanently </strong> &emsp;
                <form method="POST" style="margin-top: 14px;" action="{{route('closedOutlet')}}">
                    <input type="hidden" value="{{csrf_token()}}" name="_token" />
                    <input type="hidden" value="{{$outlet->id}}" name="outletId" />
                    <input type="hidden" value="{{$outlet->active == '1' ? 0:1}}" name="active" />
                    <button class="btn {{$outlet->active ==1 ? 'btn-primary': 'btn-danger'}}">
                        {{$outlet->active =='1' ? 'Close Permanently':'Permenanetly Closed'}}
                    </button>
                </form>
              </div>
              @endif --}}

            <hr>
              @role('admin','manager')
              <div style="display: block;margin-top: 15px;margin-bottom: 10px;">
                <div style="display:inline">
                <strong>Menu Type</strong> &nbsp;
                <p class="range-field" style=" width:60px;display: inline-block">
                  <input type="range" id="{{$outlet->id.'_veg_non_veg'}}" data-toggle="modal" data-id="{{$outlet->id.'_veg_non_veg'}}" data-target="#updateModal{{$outlet->id.'_veg_non_veg'}}" {{$outlet->veg_non_veg}} class="range veg_non_veg" min="0" max="2" value="{{$outlet->veg_non_veg}}">
                </p>
                </div>
                <div style="float:right;font-size:95%" class="label label-success">
                  <span style="display: inline-block"></span>
                  @if($outlet->veg_non_veg==0)
                  <span id="reason_{{$outlet->id.'_veg_non_veg'}}" class="frequency" style="font-weight: bold;">Veg Only {{$outlet->reason_veg_non_veg?'due to '.$outlet->reason_veg_non_veg:''}}</span>
                  @elseif($outlet->veg_non_veg==1)
                  <span id="reason_{{$outlet->id.'_veg_non_veg'}}" class="frequency" style="font-weight: bold;">Non-Veg Only {{'due to '.$outlet->reason_veg_non_veg?$outlet->reason_veg_non_veg:''}}</span>
                  @elseif($outlet->veg_non_veg==2)
                  <span id="reason_{{$outlet->id.'_veg_non_veg'}}" class="frequency" style="font-weight: bold;">Veg/Non-veg Available</span>
                  @endif
                </div>
              </div>
              @endrole

              <hr>
              @role('admin')
              <form action="{{url('/manager/invoice_frequency')}}/{{$outlet->id}}" method="POST">
                <div style="display: block;margin-top: 15px;margin-bottom: 10px;">
                <strong style="display: inline-block">Invoice Frequency &nbsp;</strong>
                  <p class="range-field" style=" width:60px;display: inline-block">
                    <input type="range" class="range" name="invoice_frequency" min="1" max="3" value="{{$outlet->invoice_frequency+1}}">
                  </p>
                  <div style="float: right">
                    
                    @if($outlet->invoice_frequency+1==1)
                    <span class="frequency" style="color: #d94f9b;font-weight: bold;">Date Range</span>
                    @elseif($outlet->invoice_frequency+1==2)
                    <span class="frequency" style="color: #d94f9b;font-weight: bold;">Weekly</span>
                    @elseif($outlet->invoice_frequency+1==3)
                    <span class="frequency" style="color: #d94f9b;font-weight: bold;">Monthly</span>
                    @endif
                  </div>
                </div>
              </form>
              
              @endrole
              <hr/>
              <form action="{{url('/manager/payment_mode')}}/{{$outlet->id}}" method="POST">
                <div style="display: block;margin-top: 15px;margin-bottom: 10px;">
                <strong style="display: inline-block">Payment Mode &nbsp;</strong>
                  <p class="range-field" style=" width:60px;display: inline-block">
                    <input type="range" class="rangePayment" name="payment_mode" min="0" max="2" value="{{$outlet->payment_mode}}">
                  </p>
                  <div style="float: right">
                    
                    @if($outlet->payment_mode==0)
                    <span class="payment_mode" style="color: #d94f9b;font-weight: bold;">Cash Only</span>
                    @elseif($outlet->payment_mode==1)
                    <span class="payment_mode" style="color: #d94f9b;font-weight: bold;">Credit Only</span>
                    @elseif($outlet->payment_mode==2)
                    <span class="payment_mode" style="color: #d94f9b;font-weight: bold;">Both</span>
                    @endif
                  </div>
                </div>
              </form>

              <!--Veg & Non Veg Status Modal -->

              <div class="modal fade" name="{{$outlet->id}}" id="updateModal{{$outlet->id.'_veg_non_veg'}}" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                <div class="modal-dialog" role="document">
                  <div class="modal-content">
                    <form action="{{url('/manager/vegNonveg/')}}/{{$outlet->id}}" class="form-inline ajaxForm_veg_nonveg" role='form' method="POST">
                      <div class="modal-header">
                        <h5 class="modal-title" style="font-size: 16px;color: green;" id="exampleModalLabel">Veg/Non-Veg Save Closing Period and Days</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                          <span aria-hidden="true">&times;</span>
                        </button>
                      </div>
                      <div class="modal-body" style="text-align:center;height: auto;overflow: auto;">
                        <div style="display:inline-block;margin: 0 auto;text-align:left;">
                          <input type="hidden" name="_token" value="{{csrf_token()}}" />
                          <h5 style="text-align:left">Closing Period</h5>

                          <div class="col-sm-12 group" style="text-align:left;padding-top: 10px;padding-bottom: 20px;">
                            @if(!empty($outlet->closingPeriod_veg_non_veg))
                            @php '' != $i = 0 @endphp
                            @forelse($outlet->closingPeriod_veg_non_veg as $period)
                            <div class="form-group period-row" style="display:block;padding:5px;">
                              <label style="padding:0 5px 0 5px" for="name">From Date</label>
                              <input type="text" id="{{$outlet->id}}_{{$i}}_0" style="max-width:100px" value="{{$period->closedFrom_veg_non_veg}}" name="startDate[{{$i}}]" class="form-control from-period datepicker">
                              <label style="padding:0 5px 0 5px" for="name">To Date</label>
                              <input type="text" id="{{$outlet->id}}_{{$i}}_1" style="max-width:100px" value="{{$period->closedTo_veg_non_veg}}" name="endDate[{{$i++}}]" class="form-control to-period datepicker">
                              <button class="btn btn-primary add-period" style="border-radius: 20px;">
                                <span class="fa fa-plus"></span>
                              </button>
                              <button class="btn btn-primary remove-period" style="border-radius: 20px;">
                                <span class="fa fa-minus"></span>
                              </button>
                            </div>
                            @empty
                            @endforelse
                            @else
                            <div class="form-group period-row" style="display:block;padding:5px;">
                              <label style="padding:0 5px 0 5px" for="name">From Date</label>
                              <input type="text" style="max-width:100px" name="startDate[0]" class="form-control from-period datepicker">
                              <label style="padding:0 5px 0 5px" for="name">To Date</label>
                              <input type="text" style="max-width:100px" name="endDate[0]" class="form-control to-period datepicker">
                              <button class="btn btn-primary add-period" style="border-radius: 20px;">
                                <span class="fa fa-plus"></span>
                              </button>
                              <button class="btn btn-primary remove-period" style="border-radius: 20px;">
                                <span class="fa fa-minus"></span>
                              </button>
                            </div>
                            @endif
                          </div>
                          <div style="display:block">
                            <h5 style="text-align:left">Weekly Closed</h5>
                          </div>
                          <div class="col-sm-12 group" style="text-align:left;padding-top: 10px;padding-bottom: 10px;">
                            <div class="form-group" style="display:block;padding:5px;">
                              <label style="padding:0 5px 0 5px" for="name">Select days</label>
                              <select name="days[]" class="custom-select select2" multiple size=7>
                                @if(empty($outlet->weeklyClosed_veg_non_veg))
                                <option value="" selected></option>
                                @else
                                <option value=""></option>
                                @endif
                                @if(!empty($outlet->weeklyClosed_veg_non_veg)&&in_array("SUN",$outlet->weeklyClosed_veg_non_veg))
                                <option value="SUN" selected>SUNDAY</option>
                                @else
                                <option value="SUN">SUNDAY</option>
                                @endif
                                @if(!empty($outlet->weeklyClosed_veg_non_veg)&&in_array("MON",$outlet->weeklyClosed_veg_non_veg))
                                <option value="MON" selected="">MONDAY</option>
                                @else
                                <option value="MON">MONDAY</option>
                                @endif
                                @if(!empty($outlet->weeklyClosed_veg_non_veg)&&in_array("TUE",$outlet->weeklyClosed_veg_non_veg))
                                <option value="TUE" selected>TUESDAY</option>
                                @else
                                <option value="TUE">TUESDAY</option>
                                @endif
                                @if(!empty($outlet->weeklyClosed_veg_non_veg)&&in_array("WED",$outlet->weeklyClosed_veg_non_veg))
                                <option value="WED" selected>WEDNESDAY</option>
                                @else
                                <option value="WED">WEDNESDAY</option>
                                @endif
                                @if(!empty($outlet->weeklyClosed_veg_non_veg)&&in_array("THU",$outlet->weeklyClosed_veg_non_veg))
                                <option value="THU" selected>THURSDAY</option>
                                @else
                                <option value="THU">THURSDAY</option>
                                @endif
                                @if(!empty($outlet->weeklyClosed_veg_non_veg)&&in_array("FRI",$outlet->weeklyClosed_veg_non_veg))
                                <option value="FRI" selected>FRIDAY</option>
                                @else
                                <option value="FRI">FRIDAY</option>
                                @endif
                                @if(!empty($outlet->weeklyClosed_veg_non_veg)&&in_array("SAT",$outlet->weeklyClosed_veg_non_veg))
                                <option value="SAT" selected>SATURDAY</option>
                                @else
                                <option value="SAT">SATURDAY</option>
                                @endif
                              </select>
                            </div>
                          </div>

                          <div class="form-check">
                            <input class="form-check-input" type="radio" name="non_veg_only" id="exampleRadios1" value="0" {{$outlet->veg_non_veg==1?'':'checked'}}>
                            <label class="form-check-label" for="exampleRadios1">
                              Veg Only
                            </label>
                          </div>
                          <div class="form-check">
                            <input class="form-check-input" type="radio" name="non_veg_only" id="exampleRadios2" value="1" {{$outlet->veg_non_veg==1?'checked':''}}>
                            <label class="form-check-label" for="exampleRadios2">
                              Non-veg Only
                            </label>
                          </div>

                          <div style="display:block">
                            <h5 style="text-align:left">Reason for Closing</h5>
                          </div>
                          <div class="col-sm-12 group" style="text-align:left;padding-top: 10px;padding-bottom: 10px;">
                            <div class="form-group" style="display:block;padding:5px;">
                              <label style="padding:0 5px 0 5px" for="name">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Reason</label>
                              <textarea style="height:100px" id="vegNonvegRes" name="reason" class="form-control" required>
                                          </textarea>
                            </div>
                          </div>
                        </div>
                      </div>
                      <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button class="btn btn-primary">Save changes</button>
                      </div>
                    </form>
                  </div>
                </div>
              </div>


              <!--Status Modal -->

              <div class="modal fade" name="{{$outlet->id}}" id="updateModal{{$outlet->id}}" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                <div class="modal-dialog" role="document">
                  <div class="modal-content">
                    <form action="{{url('/manager/Outlet/')}}/{{$outlet->id}}" class="form-inline ajaxForm closing_period_form" role='form' method="POST">
                      <div class="modal-header">
                        <h5 class="modal-title" style="font-size: 16px;color: green;" id="exampleModalLabel">Save Closing Period and Days</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                          <span aria-hidden="true">&times;</span>
                        </button>
                      </div>
                      <div class="modal-body" style="text-align:center;height: auto;overflow: auto;">
                        <div style="display:inline-block;margin: 0 auto;text-align:left;">
                          <input type="hidden" name="_token" value="{{csrf_token()}}" />
                          <div class="col-md-12">
                            <label>Select Status</label>
                            <select class="form-select form-select-lg mb-3 outlet_status_opt" name="outlet_status" aria-label="Default select example" style="width:100%;padding:5px;">
                              <option value="1" @if($outlet->status==1) selected @endif>Active</option>
                              <option value="0" @if($outlet->status==0) selected @endif>Inactive</option>
                              <option value="2" @if($outlet->active==0) selected @endif>Close Permanent</option>
                            </select>
                          </div>

                          
                          <div class="reasone-box" @if($outlet->status==0 || $outlet->active==0) style="display: block;" @else style="display: none;" @endif>
                            <div class="date-box">
                              <div style="display:block;margin-top:20px;">
                                <h5 style="text-align:left">Closing Period</h5>
                              </div>
                              
                              <div class="col-sm-12 group" style="text-align:left;padding-top: 10px;padding-bottom: 20px;">
                                @if(!empty($outlet->closingPeriod))
                                @php '' != $i = 0 @endphp
                                @forelse($outlet->closingPeriod as $period)
        
                                <div class="form-group period-row" style="display:block;padding:5px;">
                                  <label style="padding:0 5px 0 5px" for="name">From Date</label>
                                  <input type="text" id="{{$outlet->id}}_{{$i}}_0" style="max-width:100px"   value="{{$period->closedFrom}}" name="startDate[{{$i}}]" class="form-control closing_period_from_period from-period datepicker" >
                                  <label style="padding:0 5px 0 5px" for="name">To Date</label>
                                  <input type="text" id="{{$outlet->id}}_{{$i}}_1" style="max-width:100px"    value="{{$period->closedTo}}" name="endDate[{{$i++}}]" class="form-control closing_period_to_period to-period datepicker" >
                                  <button class="btn btn-primary add-period" style="border-radius: 20px;">
                                    <span class="fa fa-plus"></span>
                                  </button>
                                  <button class="btn btn-primary remove-period" style="border-radius: 20px;">
                                    <span class="fa fa-minus"></span>
                                  </button>
                                </div>
                                @empty
                                @endforelse
                                @else
                                <div class="form-group period-row" style="display:block;padding:5px;">
                                  <label style="padding:0 5px 0 5px" for="name">From Date</label>
                                  <input id="fdd{{$outlet->id}}" value=""  type="text" style="max-width:100px" name="startDate[0]" class="form-control closing_period_from_period from-period datepicker" >
                                  <label style="padding:0 5px 0 5px" for="name">To Date</label>
                                  <input id="tdd{{$outlet->id}}" type="text"  style="max-width:100px" name="endDate[0]" class="form-control closing_period_to_period to-period datepicker" >
                                  <button class="btn btn-primary add-period" style="border-radius: 20px;">
                                    <span class="fa fa-plus"></span>
                                  </button>
                                  <button class="btn btn-primary remove-period" style="border-radius: 20px;">
                                    <span class="fa fa-minus"></span>
                                  </button>
                                </div>
                                @endif
                              </div>
                              
                              <div style="display:block">
                                <h5 style="text-align:left">Weekly Closed</h5>
                              </div>

                              <div class="col-sm-12 group" style="text-align:left;padding-top: 10px;padding-bottom: 10px;">
                                <label style="padding:0 5px 0 5px" for="name">Select days </label>
                                <div class="row">

                              
                                  <div class="col-md-2">
                                    <div class="form-check form-check-inline">
                                      <input class="form-check-input weekk{{$outlet->id}} all_week" value="weekk{{$outlet->id}}" type="checkbox"  id="all_week" >
                                      <label class="form-check-label" for="all_week">All</label>
                                    </div>
                                  </div>

                                  <div class="col-md-2">
                                    <div class="form-check form-check-inline">
                                      <input class="form-check-input weekk{{$outlet->id}} closing_period_weekly_closed"   @if(!empty($outlet->weeklyClosed)&&in_array("SUN",$outlet->weeklyClosed)) checked  @endif type="checkbox" name="days[]" id="sunday" value="SUN">
                                      <label class="form-check-label" for="sunday">SUNDAY</label>
                                    </div>
                                  </div>

                                  <div class="col-md-2">
                                    <div class="form-check form-check-inline">
                                      <input class="form-check-input weekk{{$outlet->id}} closing_period_weekly_closed" type="checkbox" @if(!empty($outlet->weeklyClosed)&&in_array("MON",$outlet->weeklyClosed)) checked  @endif name="days[]" id="monday" value="MON">
                                      <label class="form-check-label" for="monday">MONDAY</label>
                                    </div>
                                  </div>

                                  <div class="col-md-2">
                                    <div class="form-check form-check-inline">
                                      <input class="form-check-input weekk{{$outlet->id}} closing_period_weekly_closed" type="checkbox" name="days[]" @if(!empty($outlet->weeklyClosed)&&in_array("TUE",$outlet->weeklyClosed)) checked  @endif id="tuesday" value="TUE">
                                      <label class="form-check-label" for="tuesday">TUESDAY</label>
                                    </div>
                                  </div>

                                  <div class="col-md-2">
                                    <div class="form-check form-check-inline">
                                      <input class="form-check-input weekk{{$outlet->id}} closing_period_weekly_closed" type="checkbox" @if(!empty($outlet->weeklyClosed)&&in_array("WED",$outlet->weeklyClosed)) checked  @endif name="days[]" id="wednesday" value="WED">
                                      <label class="form-check-label" for="wednesday">WEDNESDAY</label>
                                    </div>
                                  </div>

                                  <div class="col-md-2">
                                    <div class="form-check form-check-inline">
                                      <input class="form-check-input weekk{{$outlet->id}} closing_period_weekly_closed" type="checkbox" name="days[]" id="thursday" @if(!empty($outlet->weeklyClosed)&&in_array("THU",$outlet->weeklyClosed)) checked  @endif value="THU">
                                      <label class="form-check-label" for="thursday">THURSDAY</label>
                                    </div>
                                  </div>

                                  <div class="col-md-2">
                                    <div class="form-check form-check-inline">
                                      <input class="form-check-input weekk{{$outlet->id}} closing_period_weekly_closed" type="checkbox" name="days[]" id="friday" @if(!empty($outlet->weeklyClosed)&&in_array("FRI",$outlet->weeklyClosed)) checked  @endif value="FRI">
                                      <label class="form-check-label" for="friday">FRIDAY</label>
                                    </div>
                                  </div>


                                  <div class="col-md-2">
                                    <div class="form-check form-check-inline">
                                      <input class="form-check-input weekk{{$outlet->id}} closing_period_weekly_closed" type="checkbox" name="days[]" @if(!empty($outlet->weeklyClosed)&&in_array("SAT",$outlet->weeklyClosed)) checked  @endif id="saturday" value="SAT">
                                      <label class="form-check-label" for="saturday">SATURDAY</label>
                                    </div>
                                  </div>

                                </div>
                    
                              </div>
                            </div>
                            <div style="display:block">
                              <h5 style="text-align:left">Reason for Closing</h5>
                            </div>
                            <div class="col-sm-12 group" style="text-align:left;padding-top: 10px;padding-bottom: 10px;">
                              <div class="form-group" style="display:block;padding:5px;">
                                <label style="padding:0 5px 0 5px" for="name">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Reason</label>
                                @if(!empty($outlet->reason)) 
                                <textarea class="reasone_text" style="height:100px" name="reason" id="rsn{{$outlet->id}}" class="form-control" @if($outlet->status==0 || $outlet->active==0) required @endif>
                                  {{$outlet->reason}} 
                                </textarea>
                                @else
                                <textarea class="reasone_text" style="height:100px" name="reason" id="rsn{{$outlet->id}}" class="form-control" @if($outlet->status==0 || $outlet->active==0) required @endif></textarea>
                                @endif
                              </div>
                            </div>
                          </div>

                        </div>
                      </div>
                      <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button class="btn btn-primary">Save changes</button>
                      </div>
                    </form>
                  </div>
                </div>
              </div>
              @endrole
              <ul class="list-group">
                <li class="list-group-item">Opening Time <span class="badge">{{$outlet->openingTime}}</span></li>
                <li class="list-group-item">Closing Time <span class="badge">{{$outlet->closingTime}}</span></li>
                <li class="list-group-item">Station <span class="badge">{{$outlet->station->name}}</span></li>
                @role('admin','manager')
                <li class="list-group-item"><a href="{{url('/manager/Outlet/edit')}}/{{$outlet->id}}">Edit Outlet</a></li>
                  <li class="list-group-item">
                      <a href="{{url('/manager/Outlet/listVendors')}}/{{$outlet->id}}">Set Vendor</a>
                  </li>
                @endrole
                <div class="list-group-item" style="display: flex;justify-content: center;">
                  @if($outlet->menu()->exists())
                  <div class="btn-group">
                    @role('admin','vendor')
                    <a href="{{url('/admin/workflow/menu')}}/{{$outlet->id}}" class="btn btn-success btn-sm">
                      <span class="fa fa-bars"></span>
                      Add Items
                    </a>
                  @endrole
                  
                    @role('admin','manager')
                    <a href="{{url('/upload/menuitems')}}/{{$outlet->id}}" class="btn btn-warning btn-sm">
                      <span class="fa fa-user"></span>
                      Upload Items
                    </a>
                    @endrole

                
                    @role('admin','manager')
                    <a href="{{url('/manager/outlets/list/menuitems')}}/{{$outlet->id}}" class="btn btn-warning btn-sm">
                      <span class="fa fa-user"></span>
                      Update Items
                    </a>
                    @endrole
                    
                    @role('admin','manager')
                    <a href="{{url('/manager/outlets/list/menuitems')}}/{{$outlet->id}}/upd" class="btn btn-warning btn-sm">
                      <span class="fa fa-check"></span>
                      Update Items(New)
                    </a>
                    @endrole
                    
                    @role('admin')
                  
                    <a href="javascript:void(0)" onclick="showUserDetails({{ $outlet->id }})" class="btn btn-success btn-sm">
                      <span class="fa fa-eye"></span>
                      Show Vendor Details
                    </a>

                    @endrole
                
                    @role('admin','agent','vendor','radmin')
                    <a href="{{url('/manager/orders')}}/{{$outlet->id}}" class="btn btn-warning btn-sm">
                      <span class="fa fa-user"></span>
                      order details
                    </a>
                    @endrole
                    @role('admin')
                    <a href="{{url('/manager/invoice')}}/{{$outlet->id}}" class="btn btn-warning btn-sm">
                      <span class="fa fa-user"></span>
                      Download Invoice
                    </a>
                    @endrole
                    @role('admin')
                    <a href="{{url('/manager/invoice4')}}/{{$outlet->id}}" class="btn btn-warning btn-sm">
                      <span class="fa fa-user"></span>
                      Generate Invoice
                    </a>
                    @endrole

                    <a href="javascript:void(0)" onclick="showOutletDetails({{ $outlet->id }})" class="btn btn-success btn-sm">
                      <span class="fa fa-eye"></span>
                      Show Outlet Details
                    </a>

                  </div>

                  @else
                  <form action="{{url('/admin/workflow/menu')}}/{{$outlet->id}}" method="POST">
                    <input type="hidden" name="_token" value="{{csrf_token()}}">
                    <input type="hidden" name="menuId" value="{{$outlet->id.mt_rand(1,100)}}">
                    <button type="submit" class="btn btn-primary">
                      <span class="fa fa-cutlery"></span>
                      Add Menu
                    </button>
                  </form>
                  @endif
                  </a>
                </div>
              </ul>
            </div>
          </div>
        </div>
      @empty

      @endforelse
      @else
      <h2 style="text-align: center;">No Data Found !!</h2>
      @endif

  </section>

  {{-- Vendor Detail Pop Up Start--}}

  <div class="vendor-details-popup modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title" style="color:grey;font-weight:600;font-size:15px;">Vendor Detail</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div class="modal-body" id="vendor-details-content">           
          
        </div>

        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>    
        </div>
    </div>
      
    </div>
  </div>

 {{-- Vendor Detail Pop Up Start--}}
 
 {{-- Vendor Detail Edit Modal Start --}}

  <div class="vendor-edit-details-popup modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h5 class="modal-title" style="color:grey;font-weight:600;font-size:15px;">Edit Vendor Detail</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
              </button>
          </div>
          <div class="modal-body" id="vendor-edit-details-content">           
           
          </div>
      </div>
    </div>
  </div>

 {{-- Vendor Detail Edit Modal End --}}


 <!-- Vendor Detail Pop Up Start-->
 <div class="outlet-details-popup modal fade" id="outletDetailsModal" tabindex="-1" role="dialog" aria-labelledby="outletDetailsModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-lg" role="document">
  <div class="modal-content">
      <div class="modal-header">
          <h5 class="modal-title" style="color:grey;font-weight:600;font-size:15px;">Outlet Detail</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
          </button>
      </div>
      <div class="modal-body" id="outlet-details-content">           
        
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>    
      </div>
  </div>
  </div>
</div>
 <!-- Vendor Detail Pop Up Start-->


@if(!empty($outlets))
  <form action="{{url('/manager/Outlets')}}/{{$start}}/{{$end}}/{{$total}}" method="POST">
    <div style="margin-left:30px;padding-bottom:50px;">
        <label>rows {{$start}} - {{$end}} of {{$total}}</label>
        @php
        $i = 0;
        $currentPage = (int)($start/20)+1;
        @endphp                            
        @while($i < $pageCount)
        <a href="{{url('/manager/Outlets')}}/{{($i*20)+1}}/{{($i*20)+20}}/{{$total}}" style={{$currentPage==$i+1?"background-color:#428bca;margin-left:5px;color:#fff;":"margin-left:5px;"}} class="btn btn-sm">{{$i+1}}</a>
        @php
        $i++;
        @endphp                        
        @endwhile
        <br>
        <div style="text-align:center;margin-top:15px;">
            <button id="previous" {{$start==1?'disabled':''}} name="submit" value="previous" class="btn btn-primary" style="border-radius: 20px;">
                    Previous
            </button>
            <button id="next" {{$end==$total?'disabled':''}} name="submit" value="next" class="btn btn-primary" style="border-radius: 20px;">
                    Next
            </button>
        </div>
    </div>
  <form>
@endif

</div>
@else
<script>
  window.location.href = "{{env('APP_URL')}}";
</script>
@endif
@stop
@section('script')
<script>

  $('.all_week').on('click', function(e) {
      var weekvalue = $(this).val();
      var isChecked = $(this).prop('checked');
      $('.' + weekvalue).prop('checked', isChecked);
  });

  $(document).ready(function() {

      // Example: Add a click event to both buttons
      $('.outlet_status_opt').on('change', function() {
        var statusVal=$(this).val();

        if(statusVal==0 || statusVal==2){

          $('.reasone_text').attr('required','true');

          if(statusVal==0){
            $('.reasone-box').css('display', 'block');
            $('.date-box').css('display', 'block');
          }
          else{
            $('.from-period').val('');
            $('.to-period').val('');
            $('.closing_period_weekly_closed').removeAttr('checked');
            $('.reasone-box').css('display', 'block');
            $('.date-box').css('display', 'none');
          }
          
        }
        else{

          $('.from-period').val('');
          $('.to-period').val('');
          $('.closing_period_weekly_closed').removeAttr('checked');
          $('.reasone_text').val('');

          $('.from-period').removeAttr('required');
          $('.to-period').removeAttr('required');
          $('.reasone_text').removeAttr('required');
          $('.reasone-box').css('display', 'none');
        }
      });

  });


  function showOutletDetails(outlet_id) {

    $.ajax({
        url: '/manager/vendor-details',
        type: 'POST',
        data: {'outlet_id': outlet_id}, // Added a comma here
        success: function(response) {
            var outletDetails = response.outlet;
         
            if(response.outlet==null){

              $('#vendor-details-content').html(`
                  <h3>No Record Found!</h3>
              `);

            }else{
              $('#outlet-details-content').html(`
                  
                  <h4>Outlet ID : ${outletDetails.id}</h4>
                  <h4>Outlet Name: ${outletDetails.outletName}</h4>
                  <h4><b>Email: ${outletDetails.email}</b></h4>
                  <h4><b>Mobile: ${outletDetails.mobile}</b></h4>
                  <h4>GST Number: ${outletDetails.gstNo}</h4>
                  <h4>City: ${outletDetails.city}</h4>
                  <h4>State: ${outletDetails.state}</h4>
                  <h4>Address: ${outletDetails.address}</h4>
              `);
            }
            $('.outlet-details-popup').modal('show');
        },
        error: function(xhr, status, error) {
            console.error(error);
        }
    });
  }


  function showUserDetails(outlet_id) {

      $.ajax({
          url: '/manager/vendor-details',
          type: 'POST',
          data: {'outlet_id': outlet_id}, // Added a comma here
          success: function(response) {
              var vendorDetails = response.vendorData;
              if(response.vendorData==null){

                $('#vendor-details-content').html(`
                    <h3>No Record Found!</h3>
                `);

              }else{
                $('#vendor-details-content').html(`
                    <div style="text-align:right;">
                      <button onclick="editVendorDetail(${vendorDetails.id})" class="btn btn-success">Edit</button>
                    </div>
                    <h4>User ID : ${vendorDetails.id}</h4>
                    <h4>Name: ${vendorDetails.first_name} ${vendorDetails.last_name}</h4>
                    <h4><b>Email: ${vendorDetails.email}</b></h4>
                    <h4><b>Mobile: ${vendorDetails.mobile}</b></h4>
                    <h4>Address: ${vendorDetails.address}</h4>
                `);
              }
              $('.vendor-details-popup').modal('show');
          },
          error: function(xhr, status, error) {
              console.error(error);
          }
      });
  }

  function closePopup() {
      $('.vendor-details-popup').modal('hide');
  }


  // Edit Vendor Details

  function editVendorDetail(id) {

        $.ajax({
          url: "{{url('backend/vendor/edit')}}",
          type: 'POST',
          data: {'vendor_id': id}, // Added a comma here
          success: function(response) {
              console.log(response.html);
              if(response.status==201){

                $('#vendor-edit-details-conten').html(`
                    <h3>No Record Found!</h3>
                `);

              }else{

                $('#vendor-edit-details-content').html(response.html);
              }

              $('.vendor-details-popup').modal('hide');
              $('.vendor-edit-details-popup').modal('show');
          },
          error: function(xhr, status, error) {
              console.error(error);
          },

      });
  }


  function filterme(value) {

    value = parseInt(value, 10); // Convert to an integer
    if (value === 1) {
      $('#RangeFilter').removeClass('rangeAll', 'rangePassive').addClass('rangeActive');
      $('#invoiceFrequency').text('Date Range');
    } else if (value === 2) {
      $('#RangeFilter').removeClass('rangeActive', 'rangePassive').addClass('rangeAll');
      $('#invoiceFrequency').text('Weekly');
    } else if (value === 3) {
      $('#RangeFilter').removeClass('rangeAll', 'rangeActive').addClass('rangePassive');
      $('#invoiceFrequency').text('Monthly');
    }
    
  }

  function delete1(outletId){

      if(confirm("Are you sure you want to delete this outlet?")){
          var href = {!! json_encode(url('/manager/delete_outlet/')) !!}
          window.location.href = href+'/'+outletId;
      }
      else{
          return false;
      }          
  }

  $(function() {
    var countPeriod = 0;
   
    $(".datepicker").datepicker({
      dateFormat: 'yy-mm-dd'
    });

    // $(".datepicker").datetimepicker({
    //     format: 'YYYY-MM-DD HH:mm:ss',
    //     defaultDate: new Date(),
    // });
    $(".modal").on("hide.bs.modal", function() {
      var out = $(this).attr('name');
      if ($('#' + out).attr('touch') == 'true') {} else {
        if ($('#' + out).prop("checked") == true)
          $('#' + out).prop('checked', false);
        else
          $('#' + out).prop('checked', true);
      }
    });
    $(".modal").on("show.bs.modal", function() {
      var out = $(this).attr('name');
      $('#' + out).attr('touch', false);
      
    });
    
    $(".form-inline").on("click", ".add-period", function(e) {
      e.preventDefault();
      var id = $(this).closest(".modal").attr("name");
      var clone = $(this).parent().clone();
      clone.appendTo($(this).parent().parent());
      $("#updateModal" + id).find(".group").children().each(function() {
        $(this).find(".from-period").attr("name", "startDate[" + (countPeriod) + "]");
        $(this).find(".from-period").attr("id", id + "_" + countPeriod + "_0");
        $(this).find(".to-period").attr("name", "endDate[" + countPeriod + "]");
        $(this).find(".to-period").attr("id", id + "_" + countPeriod + "_1");
        countPeriod++;
      });
      clone.find(".datepicker").removeClass('hasDatepicker').datepicker({
        dateFormat: 'yy-mm-dd'
      });
      countPeriod = 0;
      return false;
    });

    $(".form-inline").on("click", ".remove-period", function(e) {
      e.preventDefault();
      if ($(this).parent().parent().children().length == 1)
        return false;
      var id = $(this).closest(".modal").attr("name");
      $(this).parent().remove();
      $("#updateModal" + id).find(".group").children().each(function() {
        $(this).find(".from-period").attr("name", "startDate[" + countPeriod + "]");
        $(this).find(".to-period").attr("name", "endDate[" + countPeriod + "]");
        countPeriod++;
      });
      countPeriod = 0;
      return false;
    });
    $(".range").on("change", function(e) {
      e.preventDefault();
      value = parseInt($(this).val(), 10); // Convert to an integer
      if (value === 1) {
        $(this).removeClass('rangeAll', 'rangePassive').addClass('rangeActive');
        $(this).closest('div').find('.frequency').text('Date Range');
      } else if (value === 2) {
        $('#RangeFilter').removeClass('rangeActive', 'rangePassive').addClass('rangeAll');
        $(this).closest('div').find('.frequency').text('Weekly');
      } else if (value === 3) {
        $('#RangeFilter').removeClass('rangeAll', 'rangeActive').addClass('rangePassive');
        $(this).closest('div').find('.frequency').text('Monthly');
      }
      $(this).closest('form').submit();
    });
    $(".rangePayment").on("change", function(e) {
      e.preventDefault();
      value = parseInt($(this).val(), 10); // Convert to an integer
      if (value === 0) {
        $(this).removeClass('rangeAll', 'rangePassive').addClass('rangeActive');
        $(this).closest('div').find('.payment_mode').text('Cash only');
      } else if (value === 1) {
        $(this).removeClass('rangeActive', 'rangePassive').addClass('rangeAll');
        $(this).closest('div').find('.payment_mode').text('Credit Only');
      } else if (value === 2) {
        $(this).removeClass('rangeAll', 'rangeActive').addClass('rangePassive');
        $(this).closest('div').find('.payment_mode').text('Both');
      }
      $(this).closest('form').submit();
    });
    $(".form-inline-veg-nonveg").on("click", ".add-period", function(e) {
      e.preventDefault();
      var id = $(this).closest(".modal").attr("name");
      var clone = $(this).parent().clone();
      clone.appendTo($(this).parent().parent());
      $("#updateModal" + id + '_veg_non_veg').find(".group").children().each(function() {
        $(this).find(".from-period").attr("name", "startDate[" + (countPeriod) + "]");
        $(this).find(".from-period").attr("id", id + "_" + countPeriod + "_0");
        $(this).find(".to-period").attr("name", "endDate[" + countPeriod + "]");
        $(this).find(".to-period").attr("id", id + "_" + countPeriod + "_1");
        countPeriod++;
      });
      clone.find(".datepicker").removeClass('hasDatepicker').datepicker({
        dateFormat: 'yy-mm-dd'
      });
      countPeriod = 0;
      return false;
    });
    $(".form-inline-veg-nonveg").on("click", ".remove-period", function(e) {
      e.preventDefault();
      if ($(this).parent().parent().children().length == 1)
        return false;
      var id = $(this).closest(".modal").attr("name");
      $(this).parent().remove();
      $("#updateModal" + id + '_veg_non_veg').find(".group").children().each(function() {
        $(this).find(".from-period").attr("name", "startDate[" + countPeriod + "]");
        $(this).find(".to-period").attr("name", "endDate[" + countPeriod + "]");
        countPeriod++;
      });
      countPeriod = 0;
      return false;
    });
    $('.ajaxForm_veg_nonveg').submit(function(e) {
      e.preventDefault();
      var self = $(this);
      var data = self.serializeArray();
      var options = {
        url: self.attr('action'),
        type: self.attr('method'),
        data: data,
      };

      $.ajax(options).done(function(res) {
        //$('#'+res.outletId+'_veg_non_veg').attr('value', res.veg_non_veg);
        var slider = $('#' + res.outletId + '_veg_non_veg');

        var slider = slider.slider({
          orientation: "horizantal",
          range: "min",
          min: 0,
          max: 2,
          value: 2,
          slide: function(event, ui) {
            slider.val(ui.value);
          }
        });
        $('#' + res.outletId + '_veg_non_veg').val(res.veg_non_veg);
        //slider.slider('value', res.veg_non_veg);
        //slider.trigger('slide',{ ui: $('.ui-slider-handle', slider), value: res.veg_non_veg });
        //$('#'+res.outletId+'_veg_non_veg').slider("value", res.veg_non_veg);
        if (res.veg_non_veg != 2) {
          if (res.veg_non_veg == 1) {
            if (res.reason != '')
              $('#reason_' + res.outletId + '_veg_non_veg').text('Non-veg only due to ' + res.reason);
            else
              $('#reason_' + res.outletId + '_veg_non_veg').text('Non-veg only');
          } else {
            if (res.reason != '')
              $('#reason_' + res.outletId + '_veg_non_veg').text('Veg only due to ' + res.reason);
            else
              $('#reason_' + res.outletId + '_veg_non_veg').text('Veg only');
          }
        } else
          $('#reason_' + res.outletId + '_veg_non_veg').text('Veg-Non veg available');
        $('#updateModal' + res.outletId + '_veg_non_veg').modal('hide');
      });
    });



    $('.ajaxForm').submit(function(e) {
      
      e.preventDefault();
      
      var fromPeriod = $(this).find('.closing_period_from_period').val();
      var toPeriod = $(this).find('.closing_period_to_period').val();
      var weeklyClosedCheckbox = $(this).find('.closing_period_weekly_closed');
      var statusVal = $(this).find('.outlet_status_opt').val();
      // var reasone = $(this).find('.reasone_text').val();
      let form_submit = true;
      var weeklyClosed=alertmsg='';

      if (weeklyClosedCheckbox.is(':checked')) {
          weeklyClosed = weeklyClosedCheckbox.val();
      }

      if (statusVal == 0) {

        if ((fromPeriod != "" && toPeriod != "") || (weeklyClosed != "") ) {
          form_submit = true;
        }else {
          form_submit = false;
          alertmsg="Please Select Closing Dates or Days.";
        }
      
      }

      // if(statusVal==0 || statusVal==2){
      //   if(reasone==""){
      //     form_submit = false;
      //     alertmsg="Please enter reason.";
      //   }
      // }
      
      if(!form_submit){

        alert(alertmsg);
        e.preventDefault();
      }
      else{

        var self = $(this);
        var data = self.serializeArray();
        var options = {
          url: self.attr('action'),
          type: self.attr('method'),
          data: data,
        };

        $.ajax(options).done(function(res) {
          if ($('#' + res.outletId).prop("checked") == true) {
            if (!res.open) {
              $('#' + res.outletId).prop('checked', false);
            }
          } else {
            if (res.open) {
              $('#' + res.outletId).prop('checked', true);
            }
          }
          $('#' + res.outletId).attr('touch', true);
          // if (!res.open) {
          //   if (res.reason != '')
          //     $('#reason_' + res.outletId).html('Closed due to ' + res.reason);
          //   else
          //     $('#reason_' + res.outletId).html('Closed');
          // } else
          //   $('#reason_' + res.outletId).html('Active');

            $('#rsn' + res.outletId).val('');
            $('#rsn' + res.outletId).prop('required',false);
            $('#fdd' + res.outletId).val('');
            $('#tdd' + res.outletId).val('');
            $('.weekk' + res.outletId).val('');

          $('#updateModal' + res.outletId).modal('hide');
          location.reload();
        
        });
      }

    });



  });


 

// Use a default value for itemsPerPage if not provided in the URL






function searchOutletsByStation() {
  // Get the search input value
  var input = document.getElementById("searchOutlets");
  var filter = input.value.toLowerCase();
  var outlets = document.querySelectorAll(".col-sm-6.col-md-6.col-lg-6");
  for (var i = 0; i < outlets.length; i++) {
    var outlet = outlets[i];
    var outletName = outlet.querySelector("h3").textContent.toLowerCase();

    if (outletName.includes(filter)) {
      outlet.style.display = "block"; 
    } else {
      outlet.style.display = "none"; 
    }
  }
}



</script>
@stop
