@extends('app')
@section('content')
@if(\Auth::check())
<div class="content-wrapper">

  <section class="content-header">
    <div class="header-icon">
      <i class="fa fa-users"></i>
    </div>
    
    
     <div class="header-title">
      <h1>Outlets</h1>
    </div>
    
   </section>
   
   <section class ="content" style="background:#fff">
       
       <table class ="table table-bordered table-responsive">
        
        <thead>
            <tr>
                <th># </th>
                <th> Name </th>
                <th>Station</th>
                <th> Payment Mode</th>
                <th> Availbility</th>
                <th> Menu Type</th>
                <th> Opening Time</th>
                <th> Closing Time</th>
                <th>General Actions</th>
                <th> Actions </th>
                
            </tr>
            
        </thead>
       
       <tbody>    
        @forelse($outlets as $outlet)
            
           <tr>
               
               <td>
                   {{$outlet->id}}
               </td>
                <td>
                {{$outlet->outletName}}
            </td>
            
            <td>
                {{$outlet->station->name}}
            </td>
            
            <td>
                <div style="float: left; max-width:200px">
                  
                  @if($outlet->payment_mode==0)
                  <span class="pull-left" style="color: #d94f9b;font-weight: bold;">Cash Only</span>
                  @elseif($outlet->payment_mode==1)
                  <span class="pull-left" style="color: #d94f9b;font-weight: bold;">Credit Only</span>
                  @elseif($outlet->payment_mode==2)
                  <span class="pull-left" style="color: #d94f9b;font-weight: bold;">Both</span>
                  @endif
                </div>
                
            </td>
            
            <td>
                
                <div style="max-width:200px">
                    
                     @if(!empty($outlet->reason)&&!$outlet->open)
                        <code id="reason_{{$outlet->id}}" style="float:right;font-size:95%;" class="">REASON: &nbsp; {{$outlet->reason}}</code>
                        @elseif(empty($outlet->reason)&&!$outlet->open)
                        <label id="reason_{{$outlet->id}}" style="float:right;font-size:95%;" class="label label-lg label-danger">Closed</label>
                        @else
                        <label id="reason_{{$outlet->id}}" style="color:green;float:right;"> Available</label>
                        @endif
                </div>
                
                    
            </td>
            <td>
                
                 <div style="float:right;font-size:95%" class="label label-success">
                    <span style="display: inline-block"></span>
                    @if($outlet->veg_non_veg==0)
                    <span id="reason_{{$outlet->id.'_veg_non_veg'}}" class="frequency" style="font-weight: bold;">Veg Only {{$outlet->reason_veg_non_veg?'due to '.$outlet->reason_veg_non_veg:''}}</span>
                    @elseif($outlet->veg_non_veg==1)
                    <span id="reason_{{$outlet->id.'_veg_non_veg'}}" class="frequency" style="font-weight: bold;">Non-Veg Only {{'due to '.$outlet->reason_veg_non_veg?$outlet->reason_veg_non_veg:''}}</span>
                    @elseif($outlet->veg_non_veg==2)
                    <span id="reason_{{$outlet->id.'_veg_non_veg'}}" class="frequency" style="font-weight: bold;">Veg/Non-veg Available</span>
                    @endif
                 </div>
                  
              
            </td>
            <td>
                
                 <span class="badge">{{$outlet->openingTime}}</span>
            </td>
            <td>
                 <span class="badge">{{$outlet->closingTime}}</span>
            </td>
            
            <td >
               
               <div class="dropdown">
                  <button class="btn dropdown-toggle " type="button" id="dropdownMenu1" data-toggle="dropdown">
                    manage
                    <span class="caret"></span>
                  </button>
                 <!-- <ul class="dropdown-menu" role="menu" aria-labelledby="dropdownMenu1">
                      
                     <li class="dropdown-header"><b> Quick Actions</b></li>
                    
                     <li>
                        <a href="example1.html">
                            Manage Quick Settings
                        </a>
                    </li> 
                      
                    <li class="dropdown-header"><b> General</b></li>
                    
                    <li>
                        <a href="example1.html">
                            Add Items
                        </a>
                    </li>
                    
                    <li>
                        <a href="example1.html">
                            Upload Items
                        </a>
                    </li>
                    
                    <li>
                        <a href="example1.html">
                            Assign Vendor
                        </a>
                    </li>
                    
                    <li>
                        <a href="example1.html">
                            Update Items
                        </a>
                    </li>
                    
                    <li>
                        <a href="example1.html">
                            Edit Vendor Details
                        </a>
                    </li>
                    
                    <li>
                        <a href="example1.html">
                            Edit Vendor Owner Details
                        </a>
                    </li>
                    
                    <li>
                        <a href="example1.html">
                            Order Details
                        </a>
                    </li>
                    
                    <li>
                        <a href="example1.html">
                            Generate Invoice
                        </a>
                    </li>
                    
                    
                    
                    
                  </ul> --->
                  
                  
              <ul class="dropdown-menu" role="menu" aria-labelledby="dropdownMenu1">
              
              @role('admin','manager')
              <li class="list-group-item"><a href="{{url('/manager/Outlet/edit')}}/{{$outlet->id}}">Edit Outlet</a></li>
                <li class="list-group-item">
                    <a href="{{url('/manager/Outlet/listVendors')}}/{{$outlet->id}}">Set Vendor</a>
                </li>
              @endrole
              
                @if($outlet->menu()->exists())
                
                 
                  @role('admin','manager')
                  
                  <li class="list-group-item">
                                        
                  <a href="{{url('/upload/menuitems')}}/{{$outlet->id}}" >
                    <span class="fa fa-user"></span>
                    Upload Items
                  </a>

                  </li>
                      
                  @endrole


                  @role('admin','manager')
                  
                  <li class="list-group-item">
                                        <a href="{{url('/manager/outlets/list/menuitems')}}/{{$outlet->id}}"  >
                    <span class="fa fa-user"></span>
                    Update Items
                  </a>

                  </li>
                  
                  @endrole
                  
                  
                  @role('admin')
                 
                 <li class="list-group-item">
                                       <a href="#" class="btn btn-primary btn-sm">
                    <span class="fa fa-edit"></span>
                    Edit Vendor details
                  </a>

                 </li>
                 
                    <li class="list-group-item">
                        <a href="#"  >
                    <span class="fa fa-user"></span>
                    Edit Vendor Owner Details
                  </a>

                    </li>
                    
                  
                  @endrole
              
                  @role('admin','agent','vendor','radmin')
                  
                  <li class="list-group-item">
                      
                      
                  <a href="{{url('/manager/orders')}}/{{$outlet->id}}"  >
                    <span class="fa fa-user"></span>
                    order details
                  </a>
                  
                  </li>
                  
                  @endrole
                  
                  
                  @role('admin')
                  
                  <li class="list-group-item">
                      
                      <a href="{{url('/manager/invoice')}}/{{$outlet->id}}"  >
                    <span class="fa fa-user"></span>
                    Download Invoice
                  </a>
                  </li>
                  
                  
                  @endrole
                  
                  
                  @role('admin')
                  
                  <li class="list-group-item">
                      
                  <a href="{{url('/manager/invoice4')}}/{{$outlet->id}}"  >
                    <span class="fa fa-user"></span>
                    Generate Invoice
                  </a>
                  </li>
                  
                  
                  @endrole
                

                @else
                
                <li class="list-group-item">
                    <form action="{{url('/admin/workflow/menu')}}/{{$outlet->id}}" method="POST">
                      <input type="hidden" name="_token" value="{{csrf_token()}}">
                      <input type="hidden" name="menuId" value="{{$outlet->id.mt_rand(1,100)}}">
                      <button type="submit" class="btn">
                        <span class="fa fa-cutlery"></span>
                        Add Menu
                      </button>
                </form>    
                    
                </li>
                
                
                @endif
                
             
            </ul>
                </div>
            </td>
            
            
            <td>
                
                 <button id="deleteOutlet" onclick="delete1({{$outlet->id}})" class="btn btn-danger" style="border-radius: 5px;">
                   Delete
                </button>	
            </td>
           </tr>
            
            
       
        @empty
       
       <tr>
           
       <td colspan="5">
           
        <div class="alert alert-info">
            <p>
                No outlets for now !
            </p>
        </div>
       </td>
        
        </tr> 
       @endforelse
           
      </tbody>
       </table>
       
   </section>
   
  </div>
  
 @endif
 
 @stop
 
 