@extends('app')

@section('content')

@if(\Auth::check())
<link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
<style>
    .d-flex{
        display:flex;
        justify-content:space-between;
        align-items:center;
    }
    .fa {
    
    font-size: 35px;
   
}
a {
    color: #00f;
    text-decoration: none;
}
.search-button form{
    display:flex;
        justify-content:space-between;
        align-items:center;
}
.search-button span {
    /* width: 165px; */
    font-weight: 600;
    margin-right: 12px;
}
.select2-container--default .select2-selection--single {
    background-color: #fff;
    border: 1px solid #aaa;
    border-radius: 4px;
    height: 34px;
}
.search-button input{
    width:200px;
    margin-right:10px;
}
.fa{
    font-size:24px;
}
.content-header{
   display:flex;
   align-items:center;
}
.header-icon .fa{
    font-size: 30px;
}
.content-header .header-title {
    margin-left: 0px;
}
.content-header .header-icon {
    
    width: 41px;
   
}

.form-inline .form-control {
    max-width:161px !important;
    display: inline-block;
    width: 170px !important;
    vertical-align: middle;
}

</style>

<div class="wrapper">
    <div class="content-wrapper" style="min-height: 759px;">
        <!-- Content Header (Page header) -->

        <section class="content-header">
            <div class="header-icon">
                <i class="fa fa-line-chart" aria-hidden="true"></i>
            </div>
            <div class="header-title">
                <h1>Sales Report</h1>
            </div>
        </section>
        <!-- Main content -->
        <section class="content">
            <div class="row">
                <div class="col-sm-12">
                    <div class="panel">
                        <div class="panel-heading">
                            <div class="btn-group">

                                <div class="search-button col-md-12">

                                    <form action="" method="GET" id="filterForm">
                                        <div>
                                            <select name="outletId" class="selectBox form-control">
                                                <option selected value="0">All</option>
                                                @if(!empty($outLets) && sizeof($outLets)>0)
                                                    @foreach ($outLets as $outletitem)
                                                        <option @if($outletitem->id==$requestoutletId) selected @endif value="{{$outletitem->id}}">{{$outletitem->outletName ?? ''}}</option>
                                                    @endforeach
                                                @endif
                                            </select>
                                        </div>
                                        <input type="text" name="fromdate" id="fromDate" value="{{$start}}" placeholder="From Date"
                                            class="form-control from-period datepicker">
                                        <input type="text" name="todate" value="{{$end}}" id="toDate" placeholder="To Date"
                                            class="form-control to-period datepicker" style="margin-right:10px;">

                                        <button class="btn btn-primary" id="filterBtn" type="submit" 
                                            style="margin-right:10px;">Filter
                                        </button>
                                        
                                        <a class="btn btn-primary"
                                            href="{{route('salesReport')}}">
                                            <i class="fa fa-refresh" aria-hidden="true"></i>
                                        </a>

                                        <button class="btn btn-primary" type="submit" id="exportExcelBtn">
                                            <i class="fa fa-file-excel-o" aria-hidden="true"></i>
                                        </button>

                                    </form>
                                </div>
    
                            </div>
                        </div>
                        <div class="panel-body">

                 
                        <table class="table table-bordered table-striped">
                            <thead>
                                <tr class="info">
                                <th scope="col">S/L</th>
                                <th scope="col">Rest. Name</th>
                                <th scope="col">Pan Number</th>
                                <th scope="col">GST Number</th>
                                <th scope="col">Total Sales/Base Price</th>
                                <th scope="col">Vendor Total/ Total Purchase/Vendor Price</th>
                                <th scope="col">OLF Margin/Comission</th>
                                </tr>
                            </thead>
                            <tbody>
                            @foreach ($orderDataArray as $ordData)
                            <tr class="text-center">
                                <th scope="row">
                                    {{ $loop->iteration + ($orderDataArray->currentPage() - 1) * $orderDataArray->perPage() }}
                                </th>
                                <td>{{$ordData['outlet_name']}}</td>
                                <td>{{$ordData['pan_number']}}</td>
                                <td>{{$ordData['gst_number']}}</td>
                                <td>{{$ordData['totalSale']}}</td>
                                <td>{{$ordData['vendor_total']}}</td>
                                <td>{{$ordData['profit_margin']}}</td>
                            </tr>
                            @endforeach
                            </tbody>
                        </table>
                      
                        <!-- Display pagination links -->
                        {{ $orderDataArray->links() }}
                        </div>

                    </div>
                </div>
            </div>
        </section>
        <!-- /.content -->
    </div>
</div>

@endif


<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>

<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
<script>
    
    document.getElementById('exportExcelBtn').addEventListener('click', function() {
        // Change form action to export route
        document.getElementById('filterForm').action = "{{ route('salesReport.export') }}";
        // Submit the form
        document.getElementById('filterForm').submit();
    });

    document.getElementById('filterBtn').addEventListener('click', function() {
        // Change form action to export route
        document.getElementById('filterForm').action = "{{route('salesReport')}}";
        // Submit the form
        document.getElementById('filterForm').submit();
    });

    $(document).ready(function() {
        $("#fromDate").datepicker({
            dateFormat: 'dd-mm-yy',
            onSelect: function(selectedDate) {
                var startDate = $(this).datepicker('getDate');
                var endDateMin = new Date(startDate.getFullYear(), startDate.getMonth() + 3, 1); // Set min end date to three months after start date
                var endDateMax = new Date(startDate.getFullYear(), startDate.getMonth() + 3, 0); // Set max end date to last day of the third month after start date
                $("#toDate").datepicker("option", "minDate", selectedDate);
                $("#toDate").datepicker("option", "maxDate", endDateMax);
            }
        });

        $("#toDate").datepicker({
            dateFormat: 'dd-mm-yy',
            onSelect: function(selectedDate) {
                var endDate = $(this).datepicker('getDate');
                var startDateMax = new Date(endDate.getFullYear(), endDate.getMonth() - 3, 1); // Set max start date to three months before end date
                var startDateMin = new Date(endDate.getFullYear(), endDate.getMonth() - 3, 0); // Set min start date to last day of the third month before end date
                $("#fromDate").datepicker("option", "minDate", startDateMin);
                $("#fromDate").datepicker("option", "maxDate", selectedDate);
            }
        });
    });


   
  
</script>

@endsection