@extends('app')

@section('content')

<style>
    .d-flex {
        display: flex;
        justify-content: space-between;
        align-items: center;
    }

    .form-inline {
        margin-bottom: 0px;
    }

    .container {
        width: 993px;
        /* box-shadow: 0px 0px 5px rgba(0, 0, 0, 1.0); */
    }

    .flex-direction {
        display: flex;
        flex-direction: row;
    }

    .flex-direction a {
        margin-right: 5px;
        font-size: 13px;
    }

    .station-title {
        padding: 0px 10px;
    }

    .main-header {
        background-color: #010a0f;
        color: #fff;
    }

    .station-table {
        border: 1px solid #000;
    }

    .form-control {

        text-transform: uppercase;
    }

    #ui-datepicker-div {
        z-index: 9999 !important;
    }

    .modal-body {
        padding: 10px;
    }

    .mt-2 {
        margin-top: 10px;
    }

    .form-inline .form-control {
        display: inline-block;
        width: 100%;
        vertical-align: middle;
    }

    .blog-list-table {
        height: 380px;
    }

    .content-header {
        display: flex;
        align-items: center;
        justify-content: space-between;
        width: 100%;
    }

    .content-header {

        padding: 12px 21px 12px 21px;

    }

    .header-icon .fa {
        font-size: 30px;
    }

    .content-header .header-title {
        margin-left: 0px;
    }

    .content-header .header-icon {
        width: 100%;
        display: flex;
    }

    .content-header .header-icon .fa {
        margin-right: 10px;
    }

    .header-title {
        display: flex;
        justify-content: space-between;
        align-items: center;
        width: 96%;
        margin-left: 80px;
    }

    form{
        margin-top:20px; 
    }
 
</style>
<div class="content-wrapper">
<section class="content-header">
    <div class="header-icon">
        <div class="header-title">
            <div class="d-flex justify-content-between align-items-center">
                <i class="fa fa-user" aria-hidden="true"></i>
                <h1>Update Role</h1>
            </div>
        </div>
    </div>
</section>

<form action="{{ route('admin.roles.update') }}" method="POST">
    @csrf
    <input type="hidden" name="id" value="{{ $role->id }}">
    <div class="container">
        <div class="row">
        <div class="panel panel-default">
            <div class="panel-heading">Basic Information</div>
            <div class="panel-body">
                <div class="form-group">
                    <label for="role_name">Role Name</label>
                    <input type="text" value="{{ $role->name }}"  name="name" required class="form-control" id="role_name" placeholder="Role">
                </div>
            </div>
        </div>

        <div class="row" style="margin-bottom: 10px;font-size:18px;">
            <div class="col-md-9">
             Permissions
            </div>
            <div class="col-md-3">
            <div class="form-check form-switch">
                <label class="form-check-label fw-medium text-primary"
                    for="all_permissions">{{ ('Select All') }}</label>
                <input type="checkbox" class="form-check-input" id="all_permissions"
                    onchange="toggleSelectAll(this)" name="all_permissions">
            </div>
            </div>
        </div>

        @if(!empty($permission_groups))
        @foreach ($permission_groups as $permission_group)
        <div class="panel panel-default">
            <div class="panel-heading">
                <div class="container">
                  <div class="row">
                    <div class="col-md-9">
                    {{ ucwords(str_replace('_', ' ', $permission_group[0]['group_name'])) }} 
                    </div>
                    <div class="col-md-3">
                    <div class="form-check form-switch">
                        <input type="checkbox" class="form-check-input" id="all_permissions"
                            onchange="toggleGroupAll(this)">
                        <label class="form-check-label fw-medium text-primary"
                            for="all_permissions">Select All For {{ucwords(str_replace('_', ' ', $permission_group[0]['group_name']))}}</label>
                            
                    </div>
                    </div>
                  </div>
                </div>
            </div>
            <div class="panel-body">
                @foreach ($permission_group as $permission)
                    <label class="checkbox-inline" style="padding:10px;">
                        <input type="checkbox" name="permissions[]" id="inlineCheckbox1" value="{{ $permission->id }}"
                        @if ($role->hasPermissionTo($permission->id)) checked @endif
                        > 
                        {{ ucwords(str_replace('_', ' ', $permission->name)) }}
                    </label>
                @endforeach
            </div>
        </div>
        @endforeach
        @endif

        <button type="submit" class="btn btn-primary">Submit</button>
        </div>
    </div>
</form>


</div>
@endsection

@include('backend.roles.inc.roleScripts')


