@extends('app')

@section('content')
<style>
    .d-flex {
        display: flex;
        justify-content: space-between;
        align-items: center;
    }

    .form-inline {
        margin-bottom: 0px;
    }

    .container {
        width: 993px;
        box-shadow: 0px 0px 5px rgba(0, 0, 0, 1.0);
    }

    .flex-direction {
        display: flex;
        flex-direction: row;
    }

    .flex-direction a {
        margin-right: 5px;
        font-size: 13px;
    }

    .station-title {
        padding: 0px 10px;
    }

    .main-header {
        background-color: #010a0f;
        color: #fff;
    }

    .station-table {
        border: 1px solid #000;
    }

    .form-control {

        text-transform: uppercase;
    }

    #ui-datepicker-div {
        z-index: 9999 !important;
    }

    .modal-body {
        padding: 10px;
    }

    .mt-2 {
        margin-top: 10px;
    }

    .form-inline .form-control {
        display: inline-block;
        width: 100%;
        vertical-align: middle;
    }

    .blog-list-table {
        height: 380px;
    }

    .content-header {
        display: flex;
        align-items: center;
        justify-content: space-between;
        width: 100%;
    }

    .content-header {

        padding: 12px 21px 12px 21px;

    }

    .header-icon .fa {
        font-size: 30px;
    }

    .content-header .header-title {
        margin-left: 0px;
    }

    .content-header .header-icon {
        width: 100%;
        display: flex;
    }

    .content-header .header-icon .fa {
        margin-right: 10px;
    }

    .header-title {
        display: flex;
        justify-content: space-between;
        align-items: center;
        width: 96%;
        margin-left: 80px;
    }
</style>
<div class="content-wrapper">
    <section class="content-header">
        <div class="header-icon">

            <div class="header-title">
                <div class="d-flex justify-content-between align-items-center">
                    <i class="fa fa-users" aria-hidden="true"></i>
                    <h1>Role & Permission</h1>
                </div>

                <a href="{{ route('admin.roles.create') }}" class="btn btn-primary"
                    style="text-align:center; display:flex;justify-content:space-between;align-items:center;">
                    Add New Role
                </a>
            </div>
        </div>
    
    </section>

    <section class="content">
        <div class="row">

            <div class="container">
                <div class="row">

                    <div class="table-responsive">
                        <table class="table-bordered table">
                            <thead>
                                <tr class="main-header">
                                    <th style="min-width:50px;text-align:center;">S/L</th>
                                    <th style="min-width:200px;text-align:center;">Name</th>
                                    <th style="min-width:80px;text-align:center;">Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                @if(!empty($roles))
                                    @foreach ($roles as $key => $role)
                                    <tr class="stationlist ">
                                        <td class="stationCode" style="text-align:center;">
                                            {{ $key + 1 + ($roles->currentPage() - 1) * $roles->perPage() }}
                                        </td>
                                        <td class="text-center">
                                            {{ $role->name }}
                                        </td>
                                
                                        <td style="text-align:center;display:flex;justify-content-center;" class="text-center">
                                            @if ($role->name == 'Super Admin')
                                                <span class="badge bg-secondary rounded-pill">
                                                    {{ localize('n/a') }}
                                                </span>
                                            @else
                                                <a href="{{ route('admin.roles.edit', ['id' => $role->id])}}" class="btn btn-primary" style="text-align:center; display:flex;justify-content:space-between;align-items:center;margin-right:10px;">Edit 
                                                    <i class="fa fa-pencil-square-o" aria-hidden="true" style="font-size: 15px; margin-left: 7px; margin-top: 3px"></i>
                                                </a>

                                                <a href="{{ route('admin.roles.delete', $role->id) }}" class="btn btn-primary" style="text-align:center; display:flex;justify-content:space-between;align-items:center;">Delete 
                                                    <i class="fa fa-trash" aria-hidden="true" style="font-size: 15px;margin-left: 7px; margin-top: 3px"></i>
                                                </a>
                                            @endif
                                        </td> 
                                    </tr>
                                    @endforeach
                                @else
                                <tr>
                                    <td colspan="3" class="text-center">
                                        No Record !
                                    </td>
                                </tr>
                                @endif
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
    </section>



</div>
@stop