@extends('app')

@section('styles')
<link href="//cdn.quilljs.com/1.3.6/quill.snow.css" rel="stylesheet">
<link href="//cdn.quilljs.com/1.3.6/quill.bubble.css" rel="stylesheet">


@stop


@section('content')
<div class="content-wrapper">
    <section class="content-header">
        <div class="header-icon">
            <i class="fa fa-train"></i>
        </div>
        <div class="header-title">
            <h1>{{$station->name}}-{{$station->code}}</h1>
            <small>.</small>
            <a href="#" class="btn btn-sm" data-toggle="modal" data-target="#basicModal" style="    margin-left: 96%;
               margin-top: -24px; background-color: #009688;
               border-color: #009688; color: white"><i class="fa fa-edit"></i></a>
        </div>
    </section>

    <section class="content">
        <div class="container">
            <div class="panel panel-bd lobidrag">
                <div class="panel-heading">Stations</div>
                <div class="panel-body">
                    <form action="{{route('station.content.update',['code' => $station->code])}}" method="post">

                       <input type="hidden" name="content" id="content">

                        <div class="form-group"><input type="text" placeholder="description" class="form-control" name="description" value="{{$content != null ? $content->description : ''}}"></div>

                        <div id="toolbar-container">
                            <span class="ql-formats">
                                <select class="ql-font"></select>
                                <select class="ql-size"></select>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-bold"></button>
                                <button class="ql-italic"></button>
                                <button class="ql-underline"></button>
                                <button class="ql-strike"></button>
                            </span>
                            <span class="ql-formats">
                                <select class="ql-color"></select>
                                <select class="ql-background"></select>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-script" value="sub"></button>
                                <button class="ql-script" value="super"></button>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-header" value="1"></button>
                                <button class="ql-header" value="2"></button>
                                <button class="ql-blockquote"></button>
                                <button class="ql-code-block"></button>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-list" value="ordered"></button>
                                <button class="ql-list" value="bullet"></button>
                                <button class="ql-indent" value="-1"></button>
                                <button class="ql-indent" value="+1"></button>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-direction" value="rtl"></button>
                                <select class="ql-align"></select>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-link"></button>
                                <button class="ql-image"></button>
                                <button class="ql-video"></button>
                                <button class="ql-formula"></button>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-clean"></button>
                            </span>
                        </div>

                        <div id="contentBody" style="height: 400px;">

                        </div>

                        <br>

                        <button class="btn btn-primary">
                            Submit
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </section>


    @stop

    @section('script')
    <script src="//cdn.quilljs.com/1.3.6/quill.js"></script>
    <script src="https://unpkg.com/quill-image-resize-module@3.0.0/image-resize.min.js"></script>


    <script>
        var content = `{!! $content != null ? $content->content : "<p>Content Goes Here</p>" !!}`;

        var options = {
            // debug: 'info',
            modules: {
                toolbar: '#toolbar-container',
                imageResize: {
                    displaySize: true
                },
            },
            placeholder: 'Compose an epic...',
            readOnly: false,
            theme: 'snow'
        };
        var editor = new Quill(document.querySelector("#contentBody"), options)

        editor.root.innerHTML = content

        editor.on('text-change', function(text) {
            $txtObject = document.querySelector('#content');
            $txtObject.value = (editor.root.innerHTML)
        })
    </script>

    @stop