@extends('app')

@section('content')
<style>
.d-flex{
    display:flex;
    justify-content: space-between;
    align-items:center;
}
.form-inline{
    margin-bottom:0px;
}
.container {
    width: 993px;
    box-shadow: 0px 0px 5px rgba(0,0,0,1.0);
}
.flex-direction{
    display:flex;
    flex-direction:row;
}
.flex-direction a{
    margin-right:5px;
    font-size:13px;
}
.station-title{
    padding:0px 10px;
}
.main-header{
    background-color:#010a0f;
    color:#fff;
}
.station-table{
    border:1px solid #000;
}
.form-control {
    
    text-transform: uppercase;
}
#ui-datepicker-div{
    z-index: 9999 !important;
}
.modal-body{
    padding:10px;
}
.mt-2{
    margin-top:10px;
}
.form-inline .form-control {
    display: inline-block;
    width: 100%;
    vertical-align: middle;
}
.header-icon .fa{
    font-size: 31px;
    margin-right: 10px
}
.content-header .header-icon {
    font-size: 48px;
    color: #009688;
    width: 93px;
    float: left;
    margin-top: -4px;
    line-height: 0;
    display: flex;
    align-items: center;
    justify-content: flex-start;
}
.h1, .h2, .h3, h1, h2, h3 {
    margin-top: 10px;
    margin-bottom: 10px;
}
.content-header {
    display: flex;
    align-items: center;
    justify-content: space-between;
}
</style>
<div class="content-wrapper">
	<section class="content-header">
        <div class="header-icon">
            <i class="fa fa-train"></i>
            <h1>Stations</h1>
        </div>
        <div class="header-title">
            
            
            <a href="#" class="btn btn-sm" data-toggle="modal" data-target="#basicModal" style="    
              background-color: #009688;
               border-color: #009688; color: white" ><i class="fa fa-edit" ></i></a>
        </div>
    </section>

    <section class="content">
        <div class="row">
            @if(hasPermission(['create-station']))
            <div class="col-md-12">
                <div class="panel panel-bd lobidrag">
                    <div class="panel-heading">
                        Add Station 
                    </div>                       
                    <div class="panel-body">
                        <form action="{{url('/manager/station/create')}}" class="form-horizontal ajaxForm"  role='form' method="POST">
                            <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                            <div class="col-md-12">
                              <div class="row pl-pr">
                                   <div class="col-md-3">
                                      <div class="row">
                      								    <label for="name" class="col-md-4">Name</label>
                                          <div class="col-md-8">
                      								    <input type="text" class="form-control"  placeholder="Station Name" name="name">
                                          </div>
                                      </div>
                                    </div>
                                                 
                                    <div class="col-md-4">
                                      <div class="row">
                                            <label for="code" class="col-md-4">Code</label>
                                            <div class="col-md-8">
                                            <input type="text" class="form-control"  placeholder="Station Code" name="code">
                                            </div>
                                      </div>
                                    </div>


                                    <div class="col-md-4">
                                      <div class="row">
                      					<label for="name" class="col-md-4">Valid Till</label>
                                          <div class="col-md-8">
                      						<input type="text" class="form-control dp"  placeholder="Validity" name="validTill">
                                           </div>
								      </div>
                                    </div>

                                    <div class="col-md-1 text-right">
                                       <button class="btn btn-primary">
                                          Add  <span class="fa fa-plus"></span>
                                        </button>  
                                    </div>
                              </div>
                            </div>
                            </div>
                        </form>

                    </div>
                </div>
            </div>
            @endif
            @if(hasPermission(['station-list']))
            <div class="container-fluid">
                <div class="row">
                    <div class="d-flex">
                        <h3 class="station-title">Stations List</h3>
                        <div class="search-btn">
                            <input type="text" id="searchStation" class="form-control" placeholder="Search Stations"/>
                        </div>
                    </div>
                    <div class="table-responsive a">
                        <table class="table-bordered table">
                            <thead>
                                <tr class="main-header">
                                    <th style="min-width:120px;"> Station</th>
                                    <th style="min-width:150px;">Name</th>
                                    <th style="min-width:150px;">Code</th>
                                    <!-- <th style="min-width:150px;">Valid Till</th> -->
                                    @role('admin')
                                    <th style="min-width:130px;">Vendor</th>
                                    @endrole
                                    @if(hasPermission(['edit-station']) || hasPermission(['delete-station']))
                                    <th style="min-width:200px;">Action</th>
                                    @endif
                                </tr>
                            </thead>
                            <tbody>
                                @forelse(\App\Models\Station::all() as $food)
                                <tr class="stationlist">
                                    <!-- <form action="{{url('/manager/station/update')}}/{{$food->id}}" class="form-inline" role='form' method="POST">
                                        <input type="hidden" name="_token" value="{{csrf_token()}}"/> -->
                                        <td class="stationCode">
                                            Station - {{$food->code}}
                                        </td>
                                        <td>
                                            <input type="text" id="stationName" class="form-control"  placeholder="Station Name" name="name" value="{{$food->name}}" readonly>
                                        </td>
                                        <td>
                                            <input type="text" class="form-control"  placeholder="Station Code" name="code" value="{{$food->code}}" readonly>
                                        </td>
                                        <!--
                                        <td>
                                            <input type="text" class="form-control dp"  placeholder="Validity" name="validTill" value="{{$food->validTill}}">
                                        </td>
                                        -->
                                        @role('admin')
                                        <td class="flex-direction">
                                            <a href="{{url('/admin/workflow/user/'.$food->code)}}">
                                                <i class="fa fa-plus btn btn-primary" aria-hidden="true"></i>
                                            </a>
                                            <a style="float:right" href="{{url('/admin/workflow/user_select')}}">
                                                <i class="fa fa-check btn btn-primary" aria-hidden="true"></i>
                                            </a>
                                        </td>
                                        @endrole

                                        <td>
                                            <div class="d-flex">
                                                
                                                @if(hasPermission(['edit-station']))
                                                    <button onclick="openModel('{{$food->id}}');" class="btn btn-warning edit" data-toggle="modal" data-target="#exampleModal">
                                                        <span class="fa fa-edit"></span>
                                                    </button>
                                                @endif

                                                @if(hasPermission(['delete-station']))
                                                <form action="{{url('/manager/station/delete')}}/{{$food->id}}" class="form-inline ajaxForm" role='form' method="POST">
                                                    <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                                                    <button class="btn btn-danger">
                                                        <span class="fa fa-trash"></span>
                                                    </button>
                                                </form>
                                                @endif

                                                @if(hasPermission(['station-outlet-list']))
                                                    <a href="{{ url('/manager/OutletsByStation/1/20/0/'.$food->id) }}" class="btn btn-primary" style="font-size: 12px;">View Outlet</a>
                                                @endif
                                            </div>
                                        </td>
                                </tr>
                                @empty
                                <div class="col-md-12">
                                    <h4>No Stations added yet</h4>
                                </div>
                                @endforelse
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            @endif
    </section>

 @if(hasPermission(['edit-station']))
    <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" style="color:grey;font-weight:600;font-size:15px;">Edit</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
            <form id="formsubmition" action="{{url('/manager/station/update/').'/'.$food->id}}" class="form-inline ajaxForm" role='form' method="post">
                <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                <input type="hidden" id="hid" class="form-control"  placeholder="Station Name" name="hid" >
                <div class="row flex-no">
                    <div class="col-md-10">
                        <div class="row">
                            <label class="col-md-3">Staion Name</label>
                            <div class="form-group col-md-9">
                            <input type="text" id="stationname" class="form-control"  placeholder="Station Name" name="name" >
                            </div>
                        </div>
                    </div>
                    <div class="col-md-10 mt-2">
                        <div class="row">
                            <label class="col-md-3">Station Code</label>
                            <div class="form-group col-md-9">
                            <input type="text" id="stationcode" class="form-control"  placeholder="Station Code" name="code" >
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
            @role('admin','manager')
            <button onclick="submitDetail();" type="button" class="btn btn-primary">Submit</button>
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>    
            @endrole
            </div>
            </div>
            </form>
        </div>
    </div>
 @endif

</div>
@stop


@section('script')
<script>

    $('.dp').datepicker();

	$('.ajaxForm').submit(function(e){
		e.preventDefault();
		var self =  $(this);
		var data = self.serializeArray();
		var options =  {
			url:self.attr('action'),
			type:self.attr('method'),
			data:data,
		};

		$.ajax(options).done(function(res){
            window.location.reload();
        });
        
        

	});

    function searchStations() {
    var input = document.getElementById("searchStation");
    var filter = input.value.toLowerCase();
    var outlets = document.querySelectorAll(".stationlist");
    for (var i = 0; i < outlets.length; i++) {
        var outlet = outlets[i];
        var outletName = outlet.querySelector("#stationName").value.toLowerCase();

        if (outletName.includes(filter) ) {
            outlet.style.display = "table-row"; // Display the row
        } else {
            outlet.style.display = "none"; // Hide the row
        }
    }
}

// Add an event listener to the input field for keyup event
document.querySelector('#searchStation').addEventListener('keyup', function() {
    searchStations(); // Call the search function when the user types
});

// $('.edit').click(function(){
//     $('.model').show();
// })

function openModel(getid){
    var url = "{{url('')}}";
    $.ajax({
       type: 'POST',
       headers: {
         'X-CSRF-TOKEN': $('meta[name="csrf"]').attr('content')
       },
       url: url + '/GetFoodDetails',
       cache: false,
       data: {
           'getid':getid
       }, 
       success: function(data) {
       
       // var obj = JSON.parse(data);
        console.log(data.code);
        $("#stationcode").val(data.code);
        $("#stationname").val(data.name);
        $("#hid").val(data.id);
        $('.model').show();
        
       }})

}

function submitDetail(){
    var base_url = "{{url('/manager/station/update')}}";
   var code =  $("#stationcode").val();
   var name =   $("#stationname").val();
    var id =    $("#hid").val();
    $.ajax({
        type: 'POST',
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf"]').attr('content')
        },
        url: base_url,
        cache: false,
        data: {
            'id': id,
            'name':name,
            'code':code,
            
        },
        success: function(data) {
            location.reload();
        }
    })
    
}
    
</script>
@stop
