@extends('app')

@section('content')
<style>
.d-flex{
    display:flex;
    justify-content: space-between;
    align-items:center;
}
.form-inline{
    margin-bottom:0px;
}
.container {
    width: 993px;
    box-shadow: 0px 0px 5px rgba(0,0,0,1.0);
}
.flex-direction{
    display:flex;
    flex-direction:row;
}
.flex-direction a{
    margin-right:5px;
    font-size:13px;
}
.station-title{
    padding:0px 10px;
}
.main-header{
    background-color:#010a0f;
    color:#fff;
}
.station-table{
    border:1px solid #000;
}
.form-control {
    
    text-transform: uppercase;
}
#ui-datepicker-div{
    z-index: 9999 !important;
}
.modal-body{
    padding:10px;
}
.mt-2{
    margin-top:10px;
}
.form-inline .form-control {
    display: inline-block;
    width: 100%;
    vertical-align: middle;
}
.header-icon .fa{
    font-size: 31px;
    margin-right: 10px
}
.content-header .header-icon {
    font-size: 48px;
    color: #009688;
    width: 93px;
    float: left;
    margin-top: -4px;
    line-height: 0;
    display: flex;
    align-items: center;
    justify-content: flex-start;
}
.h1, .h2, .h3, h1, h2, h3 {
    margin-top: 10px;
    margin-bottom: 10px;
}
.content-header {
    display: flex;
    align-items: center;
    justify-content: space-between;
}
</style>
<div class="content-wrapper">
	<section class="content-header">
        <div class="header-icon">
            <i class="fa fa-train"></i>
            <h1>Trains</h1>
        </div>
        <div class="header-title">
            
            
            <a href="#" class="btn btn-sm" data-toggle="modal" data-target="#basicModal" style="    
              background-color: #009688;
               border-color: #009688; color: white" ><i class="fa fa-edit" ></i></a>
        </div>
    </section>

    <section class="content">
        <div class="row">
            @if(hasPermission(['create-train']))
            <div class="col-md-12">
                <div class="panel panel-bd ">
                    <div class="panel-heading">
                        Add Train 
                    </div>                       
                    <div class="panel-body">
                        <form action="{{url('/manager/add-trains-step-one')}}" class="form-horizontal"  role='form' method="POST">
                            <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                            <div class="col-md-12">
                              <div class="row pl-pr">
                                <div class="col-md-10">
                                    <div class="row">   
                                    <label for="name" class="col-md-4">Select Train</label>
                                    <div class="col-md-8">
                                        @if(!empty($trains) && !empty($trains->data))
                                        <select class="selectBox form-control" name="train_id">
                                            @foreach($trains->data as $trainData)
                                            <option value="{{$trainData->trainId}}">{{$trainData->trainNumberAndName}}</option>
                                            @endforeach
                                        </select>
                                        @endif
                                    </div>
                                    </div>
                                    @if($errors->has('train_number'))
                                        <span class="text-danger" style="text-align: center;">
                                            {{ $errors->first('train_number') }}
                                        </span>
                                    @endif
                                </div>           
                                <div class="col-md-2 text-right">
                                    <button type="submit" class="btn btn-primary">
                                        Add  <span class="fa fa-plus"></span>
                                    </button>  
                                </div>
                              </div>
                            </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
            @endif

            @if(hasPermission(['station-list']))
            <div class="container-fluid">
                <div class="row">
                    <div class="table-responsive a">
                        <table class="table-bordered table">
                            <thead>
                                <tr class="main-header">
                                    <th style="min-width:150px;text-align:center;">Sl.No.</th>
                                    <th style="min-width:150px;text-align:center;">Train Number</th>
                                    <th style="min-width:120px;text-align:center;">Train Name</th>
                                    <th style="min-width:200px;text-align:center;">Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                @forelse(\App\Models\Trains::all() as $trainData)
                                <tr class="stationlist">
                                    <td class="stationCode text-center">
                                        {{$loop->iteration}}
                                    </td>
                                    <td class="stationCode text-center">
                                        {{$trainData->number}}
                                    </td>
                                    <td class="stationCode text-center">
                                        {{$trainData->name}}
                                    </td>
                                    <td class="stationCode text-center" style="font-size: 20px;">
                                        <a href="#" target="_blank" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i></a>
                                        @if(hasPermission(['edit-train']))
                                        <a href="{{url('/manager/train-content-edit/'.$trainData->id)}}" class="btn btn-warning"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></a>
                                        @endif
                                        @if(hasPermission(['delete-train']))
                                        <a href="{{url('/manager/train-content-delete/'.$trainData->id)}}" class="btn btn-danger"><i class="fa fa-trash" aria-hidden="true"></i></a>
                                        @endif
                                    </td>  
                                </tr>
                                @empty
                                <tr>
                                    <td colspan="5" style="text-align: center;">
                                        No Trains added yet
                                    </td>
                                </tr>
                                @endforelse
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            @endif
    </section>

    {{-- @if(hasPermission(['edit-station']))
        <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" style="color:grey;font-weight:600;font-size:15px;">Edit</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                <form id="formsubmition" action="{{url('/manager/station/update/').'/'.$food->id}}" class="form-inline ajaxForm" role='form' method="post">
                    <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                    <input type="hidden" id="hid" class="form-control"  placeholder="Train Name" name="hid" >
                    <div class="row flex-no">
                        <div class="col-md-10">
                            <div class="row">
                                <label class="col-md-3">Staion Name</label>
                                <div class="form-group col-md-9">
                                <input type="text" id="stationname" class="form-control"  placeholder="Train Name" name="name" >
                                </div>
                            </div>
                        </div>
                        <div class="col-md-10 mt-2">
                            <div class="row">
                                <label class="col-md-3">Train Code</label>
                                <div class="form-group col-md-9">
                                <input type="text" id="stationcode" class="form-control"  placeholder="Train Code" name="code" >
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                @role('admin','manager')
                <button onclick="submitDetail();" type="button" class="btn btn-primary">Submit</button>
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>    
                @endrole
                </div>
                </div>
                </form>
            </div>
        </div>
    @endif --}}

</div>
@stop


@section('script')
<script>

    $('.dp').datepicker();

	$('.ajaxForm').submit(function(e){
		e.preventDefault();
		var self =  $(this);
		var data = self.serializeArray();
		var options =  {
			url:self.attr('action'),
			type:self.attr('method'),
			data:data,
		};

		$.ajax(options).done(function(res){
            window.location.reload();
        });
        
        

	});

    function searchTrains() {
    var input = document.getElementById("searchTrain");
    var filter = input.value.toLowerCase();
    var outlets = document.querySelectorAll(".stationlist");
    for (var i = 0; i < outlets.length; i++) {
        var outlet = outlets[i];
        var outletName = outlet.querySelector("#stationName").value.toLowerCase();

        if (outletName.includes(filter) ) {
            outlet.style.display = "table-row"; // Display the row
        } else {
            outlet.style.display = "none"; // Hide the row
        }
    }
}

// Add an event listener to the input field for keyup event
document.querySelector('#searchTrain').addEventListener('keyup', function() {
    searchTrains(); // Call the search function when the user types
});

// $('.edit').click(function(){
//     $('.model').show();
// })

function openModel(getid){
    var url = "{{url('')}}";
    $.ajax({
       type: 'POST',
       headers: {
         'X-CSRF-TOKEN': $('meta[name="csrf"]').attr('content')
       },
       url: url + '/GetFoodDetails',
       cache: false,
       data: {
           'getid':getid
       }, 
       success: function(data) {
       
       // var obj = JSON.parse(data);
        console.log(data.code);
        $("#stationcode").val(data.code);
        $("#stationname").val(data.name);
        $("#hid").val(data.id);
        $('.model').show();
        
       }})

}

function submitDetail(){
    var base_url = "{{url('/manager/station/update')}}";
   var code =  $("#stationcode").val();
   var name =   $("#stationname").val();
    var id =    $("#hid").val();
    $.ajax({
        type: 'POST',
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf"]').attr('content')
        },
        url: base_url,
        cache: false,
        data: {
            'id': id,
            'name':name,
            'code':code,
            
        },
        success: function(data) {
            location.reload();
        }
    })
    
}
    
</script>
@stop
