@extends('app')
@section('content')
@if(\Auth::check())
<div class="wrapper">

    <div class="content-wrapper">
        <!-- Content Header (Page header) -->
       
    <section class="content-header">
        <div class="header-icon">
            <i class="fa fa-users"></i>
        </div>
        <div class="header-title">
            <h1>Show All Vendor</h1>
            
        </div>
    </section>
        <!-- Main content -->
        <section class="content">
            <div class="row">
                <div class="col-sm-12">
                    <div class="panel">
                        <div class="panel-heading">
                            <div class="btn-group">
                                <a href="#">
                                    <h4 style="color:#009688">List Vendor</h4>
                                </a>
                            </div>
                        </div>
                        <div class="panel-body">
                            <!-- Plugin content:powerpoint,txt,pdf,png,word,xl -->
                            <div class="btn-group">

                            </div>
                            <!-- Plugin content:powerpoint,txt,pdf,png,word,xl -->
                            <div class="table-responsive">
                                <table id="dataTableExample1" class="table table-bordered table-striped table-hover">
                                    <thead>
                                        <tr class="info">
                                            <th>First Name</th>
                                            <th>last Name</th>
                                            <th>Outlet</th>
                                            <th>Email</th>
                                            <th>Mobile</th>
                                            <th>Address</th>
                                            <th>Action</th>
                                        </tr>
                                    </thead>
                                    @foreach($vendors as $vendor)
                                    <tbody>
                                        <tr>
                                  
                                            <td>{{$vendor['first_name']}}</td>
                                            <td>{{$vendor['last_name']}}</td>
                                            @if(sizeof($vendor['outlets'])>0)
                                            <td>
                                                @foreach ($vendor['outlets'] as $outlet)
                                                    {{$outlet['outletName'] ?? ''}}
                                                    @if(!$loop->last) , @endif
                                                @endforeach
                                            </td>
                                            @else
                                            <td>---</td>
                                            @endif
                                            <td>{{$vendor['email']}}</td>
                                            <td>{{$vendor['mobile']}}</td>
                                            <td>{{$vendor['address']}}</td>
                                       
                                            <td style="width: 124px !important;">
                                                <table>
                                                    <tr>
                                                        <td>
                                                <a href="{{route('vendors.show',$vendor['id'])}}" class="btn btn-success btn-sm"><i class="fa fa-eye"></i></a>
                                                @role('admin','manager')
                                                <a href="{{route('vendors.edit',$vendor['id'])}}" class="btn btn-add btn-sm"><i class="fa fa-pencil"></i></a>
                                                @endrole
                                                
                                                @role('admin')
                                                <form method="POST" action="{{route('vendors.destroy',$vendor['id'])}}">
                                                    <input type="hidden" name="_method" value="DELETE"/>
                                                    <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                                                    <button type="submit" onclick="return confirm('Are you sure Delete This Admin?')" style="margin-left: 76px; margin-top: -24px;" class="btn btn-danger btn-sm"><i class="fa fa-trash-o"></i></button>
                                                </form>
                                                @endrole
                                                        </td>
                                                    </tr>
                                                    <tr>
                                                        <td>
                                                            @role('admin','manager')
                                                            @if($vendor['active'] == 0)
                                                            <a href="{{url('backend/Vendor/activate',[$vendor['id']])}}" class="btn btn-success btn-sm"><i class="fa fa-check"></i></a>
                                                            @endif
                                                            @endrole
                                                        </td>
                                                    </tr>
                                                </table>

                                            </td>
                                        </tr>
                                    </tbody>
                                    @endforeach                              
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
        <!-- /.content -->
    </div>
   
</div>


@else
<script>window.location.href = "{{env('APP_URL')}}";</script>
@endif
@stop
