@extends('app')

@section('content')
<style>
    @media print {
        #main-header {
            display: none !important;
        }
        .table>thead>tr.info>th {
            background-color: #d9edf7 !important;
            -webkit-print-color-adjust: exact !important;        
        }
        a {
            color: #009688!important;
            text-decoration: none;
        }    
        a[href]:after {
            content: none !important;
        }
        .panel-heading.ui-sortable-handle {
            background-color: #e8f1f3 !important;
            -webkit-print-color-adjust: exact !important;        
        }
        #select-all{
            /*display: none !important;*/
        }
        .table-responsive{
            display: block;
            width: auto;
            height: auto;
            overflow: visible;
        }
        .current-page{
            background-color: #428bca !important;
            color: #fff !important;
            -webkit-print-color-adjust: exact;        
        }
        #next, #previous, .btn-primary {
            background-color: #428bca !important;
            color: #fff !important;
            -webkit-print-color-adjust: exact;
        }
        .content-header {
            display: none !important;
        }
        #invoice-header {
            display: none !important;
        }
        .form-inline .form-control {
            width: auto !important;
            display: inline-block;
            width: auto;
            vertical-align: middle;        
        }
        #list-outlets {
            color: #009688 !important;
        }
    
    }
    </style>
    <div class="content-wrapper">
	<section class="content-header">
        <div class="header-icon">
            <i class="fa fa-cog"></i>
        </div>
        <div class="header-title">
            <h1>Generate Invoice</h1>
            <small>.</small>
            <a href="#" class="btn btn-sm" data-toggle="modal" data-target="#basicModal" style="    margin-left: 96%;
               margin-top: -24px; background-color: #009688;
               border-color: #009688; color: white" ><i class="fa fa-edit" ></i></a>
        </div>
    </section>

<form action="{{url('/manager/vouchers')}}/{{$start}}/{{$end}}/{{$total}}" class="form-inline ajaxForm"  role='form' method="POST">
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div id="showVouchers" class="panel panel-bd lobidrag">
                    <div class="panel-heading">
                        <div class="btn-group">
                            <a href="#">
                                <h4 id="list-outlets" style="color:#009688">List Vouchers</h4>
                            </a>
                        </div>
                    </div>
                    <div class="panel-body">
                        <div class="table-responsive" style="clear:both">
                            <table id="dataTableExample1" class="table table-bordered table-striped table-hover">
                                <thead>
                                    <tr class="info">
                                        <th>Code</th>
                                        <th>Discount</th>
                                        <th>Expires In Hours</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                @if(isset($vouchers))
                                @foreach($vouchers as $voucher)
                                <tbody>
                                    <tr>
                                        <td>{{$voucher->code}}</td>
                                        <td>
                                            <ul class="list-group">
                                            @foreach(json_decode($voucher->data[0]) as $key => $value)
                                                <div class="list-group-item" style="display: flex; justify-content: space-between; padding: 5px 15px;">
                                                    <strong>{{$key}}</strong>
                                                    <span class="label label-danger"> 
                                                      {{$value}}  {{$key == 'strategy' && $value =='UPTO' ? '%'  : ''}}
                                                    </span>
                                                </div>
                                            @endforeach
                                            </ul>
                                        </td>
                                        <td>{{$voucher->expires_at->format('m-d-Y')}}</td>
                            
                                        <td><a href="{{url('/manager/voucher/delete')}}/{{$voucher->id}}" style="background-color:#428bca;color:#fff" class="btn btn-sm">Delete</a></td>
                                    </tr>
                                </tbody>
                                @endforeach
                                @endif
                            </table>
                        </div>
                        <div style="margin-top: 10px;float:left;;">
                            <label>rows {{$start}} - {{$end}} of {{$total}}</label>
                            @php
                            $i = 0;
                            $currentPage = (int)($start/50)+1;
                            @endphp                            
                            @while($i < $pageCount)
                            <a href="{{url('/manager/vouchers')}}/{{($i*50)+1}}/{{($i*50)+1+50}}/{{$total}}" style={{$currentPage==$i+1?"background-color:#428bca;margin-left:5px;color:#fff;":"margin-left:5px;"}} class="btn btn-sm {{$currentPage==$i+1?"current-page":""}}">{{$i+1}}</a>
                            @php
                            $i++;
                            @endphp                        
                            @endwhile
                            <button id="previous" {{$start==1?'disabled':''}} name="submit" value="previous" class="btn btn-primary" style="border-radius: 20px;margin-left:15px;">
                                   Previous
                            </button>
                            <button id="next" {{$end==$total?'disabled':''}} name="submit" value="next" class="btn btn-primary" style="border-radius: 20px;">
                                   Next
                            </button>
                        </div>
                        <div class="btn-group" style="float:right;display:block;margin-top:15px;">
                            <a href="{{url('/manager/voucher/create')}}" class="btn btn-primary" style="padding:8px;">
                                Create Voucher
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</form>

</div>
@stop


@section('script')
<script>
    $(function() {
});
</script>
@stop