@extends('app')
@section('content')
@if(\Auth::check())
<div class="content-wrapper">
    <section class="content-header">
        <div class="header-icon">
            <i class="fa fa-users"></i>
        </div>
        <div class="header-title">
            <h1>Vendors Add</h1>
        </div>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-sm-12">
                <div class="panel panel-bd lobidrag">                       
                    <div class="panel-body">
                        <form action="{{url('/admin/workflow/outlet/')}}/{{$userId}}" class="form-horizontal" enctype="multipart/form-data" role='form' method="POST">
                            <input type="hidden" name="_token" value="{{csrf_token()}}"/>
                            <div class="col-sm-8">

                                <div class="form-group">
                                    <label style="color:#009688">Station</label>
                                    <select name="station_id" class="select2">
                                        @forelse(\App\Models\Station::all() as $stationData)
                                            <option value="{{$stationData->id}}" @if($station == $stationData->code) selected @endif>
                                                {{$stationData->name}} - {{$stationData->code}}
                                            </option>
                                        @empty
                                            <option value="---" disabled >-------</option>    
                                        @endforelse
                                </select>
                                </div>

                                <div class="form-group">
                                    <label style="color:#009688">Outlet Name</label>
                                    <input type="text" name="outletName" class="form-control" placeholder="Enter value" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">Order Timing</label>
                                    <input type="text" name="order_timing" class="form-control" placeholder="Enter value" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">Minimum Order Amount</label>
                                    <input type="text" name="minOrderAmount" class="form-control" placeholder="Enter value" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">Opening Time</label>
                                    <input type="text" name="openingTime" class="form-control wp" placeholder="Enter value" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">Closing Time</label>
                                    <input type="text" name="closingTime" class="form-control wp" placeholder="Enter value" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">Delivery Cost</label>
                                    <input type="text" name="deliveryCost" class="form-control" placeholder="Enter Address" required>
                                </div>

                                <div class="form-group">
                                    <label style="color:#009688">Address</label>
                                    <input type="text" name="address" class="form-control" placeholder="Enter value" required>
                                </div>
                                
                                <div class="form-group">
                                    <label style="color:#009688">City</label>
                                    <input type="text" name="city" class="form-control" placeholder="Enter value" required>
                                </div>
                                
                                <div class="form-group">
                                    <label style="color:#009688">State</label>
                                    <input type="text" name="state" class="form-control" placeholder="Enter value" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">Address</label>
                                    <input type="text" name="address" class="form-control" placeholder="Enter Address" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">Company Name</label>
                                    <input type="text" name="companyName" class="form-control" placeholder="Enter value" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">Vendor Pan Number</label>
                                    <input type="text" name="vendorPanNumber" class="form-control" placeholder="Enter value" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">Gst No</label>
                                    <input type="text" name="gstNo" class="form-control" placeholder="Enter value" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">fssaiNo</label>
                                    <input type="text" name="fssaiNo" class="form-control" placeholder="Enter value" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">Fssai Valid Upto</label>
                                    <input type="text" name="fssaiValidUpto" class="form-control dp" placeholder="Enter value" required>
                                </div>
                                <div class="form-group">
                                    <label style="color:#009688">cancel cut off time</label>
                                    <input type="text" name="cancel_cut_off_time" class="form-control" placeholder="Enter Address" required>
                                </div>

                                <div class="form-group">
                                    <label style="color:#009688">tags</label>
                                    <input type="text" name="tags" class="form-control" placeholder="Enter value" required>
                                </div>

                                <div class="form-group">
                                    <label style="color:#009688" for="logoImage">Outlet Logo</label>
                                    <input type="File" name="logoFile" class="form-control" id="logoImage">
                                </div>

                                <button  class="btn btn-success" type="submit" style="width: 200px; margin-left: 10px; margin-left: 128px; background-color: #009688;border-color: #009688;">Save</button>
                            </div>
                            <div class="col-sm-4">
                                <div class="imgLogo">
                                    <img src="{{url('/static/img/Logo.jpg')}}" class="logoPreview" height="200px" width="200px"></img> 
                                </div>
                            </div>
                        </form>

                    </div>
                </div>
            </div>
    </section>
</div>
@else
<script>window.location.href = "{{env('APP_URL')}}";</script>
@endif
@stop


@section('script')
    <script>
        //$('.wp').wickedpicker({twentyFour:true});
        //$('.dp').datepicker();

        $(document).ready(function(){
            $('#logoImage').change(function(event){
                var input = event.target;
                if (input.files && input.files[0]) {
                    var reader = new FileReader();
                    reader.onload = function(e) {
                        $('.logoPreview').attr('src', e.target.result);
                    }
                    reader.readAsDataURL(input.files[0]);
                }
            });
        });

    </script>
@stop