<?php
$items = json_decode($order->orderItems);
$keys = [['Item', 60], ['Quantity', 10], ['Rate', 20], ['Amount', 10]];
$customer = json_decode($order->customer);
$target = 'Madhya Pradesh';
$sgst = $target == $outlet->state ? round($order->gst / 2, 2) : "";
$cgst = $target == $outlet->state ? round($order->gst / 2, 2) : "";

$_lbl_sgst = $target == $outlet->state ? "2.5%" : "";
$_lbl_cgst = $target == $outlet->state ? "2.5%" : "";

$_igst_applicable = $target == $outlet->state ? false : true;
$_igst = $_igst_applicable ? round($order->gst, 2) : "";
$_lbl_igst = $_igst_applicable ? '5%' : "";

$subTotal = round(collect($items)->sum(function ($item) {
    return ($item->quantity * $item->basePrice);
}), 2);

?>


<style>
    td {
        padding: 5px;
    }
</style>
<!-- 
    [{"itemId":1557,"itemName":"Veg Maharaja Thali","description":"Kadahi Paneer(100g), Seasonal Veg (100g), Dal Makhni(100g), Rice (150g) , Raita(50gm), Butter Chapati (3 pieces), Sweet(1 piece),Papad,Salad and Pickle","basePrice":178.09523809523807358345948159694671630859375,"sellingPrice":187,"taxRate":8.90476190476192641654051840305328369140625,"isVegetarian":true,"quantity":7,"option":null,"foodType":"THALI"}]
 -->

<table>
    <tr>
        <td colspan="2">
            <center>
                <h3 style="text-align: center; padding:5px ;">Tax Invoice</h3>
            </center>
        </td>
    </tr>

    <tr>
        <td>
            <table cellspacing="5">
                <tr>
                    <td colspan="2"><strong>Journey Info</strong></td>
                </tr>
                <tr>
                    <td><strong>Billed To</strong></td>
                    <td>{{$customer->fullName}}</td>
                </tr>

                <tr>
                    <td><strong>Order Number</strong></td>
                    <td>{{$order->orderId}}</td>
                </tr>
                <tr>
                    <td><strong>Booking Date</strong></td>
                    <td>{{\Carbon\Carbon::parse($order->bookingDate)->format('d-M-y')}}</td>
                </tr>
                <tr>
                    <td><strong>Delivery Date</strong></td>
                    <td>{{\Carbon\Carbon::parse($order->deliveryDate)->format('d-M-y')}}</td>
                </tr>
                <tr>
                    <td><strong>Train No</strong></td>
                    <td>{{$order->trainNo}}</td>
                </tr>
                <tr>
                    <td><strong>Coach</strong></td>
                    <td>{{$order->coach}}</td>
                </tr>
                <tr>
                    <td><strong>Seat No</strong></td>
                    <td>{{$order->berth}}</td>
                </tr>
                <tr>
                    <td><strong>Station</strong></td>
                    <td>{{$order->stationName}}</td>
                </tr>

                <tr>
                    <td></td>
                    <td></td>
                </tr>
            </table>
        </td>
        <td>
            <table cellspacing="5">
                <tr>
                    <td colspan="2"><strong>Order/Delivery Info</strong></td>
                </tr>

                <tr>
                    <td><strong>Sold By</strong></td>
                    <td>{{$outlet->outletName}}</td>
                </tr>
                <tr>
                    <td><strong>Address</strong></td>
                    <td>{{$outlet->address}}</td>
                </tr>
                <tr>
                    <td><strong>GST No</strong></td>
                    <td>23AACCO8285A1ZN</td>
                </tr>
                <tr>
                    <td><strong>FSSAI No</strong></td>
                    <td>{{$outlet->fssaiNo}}</td>
                </tr>
                <tr>
                    <td><strong>Invoice No</strong></td>
                    <td>Invoice/{{$order->id}}</td>
                </tr>


                <tr>
                    <td><strong>SAC Code</strong></td>
                    <td>996331</td>
                </tr>

                <tr>
                    <td><strong>HSN Code</strong></td>
                    <td>999799</td>
                </tr>

                <tr>
                    <td><strong>Place Of Supply</strong></td>
                    <td>{{$outlet->city}}</td>
                </tr>


            </table>
        </td>
    </tr>
</table>

<table border="1" cellpadding="7">
    
    <thead>
        <tr>
            <td style="width: 60%;">Item</td>
            <td style="width: 10%;">Qty</td>
            <td style="width: 20%;">Rate</td>
            <td style="width: 10%;">Amount</td>
        </tr>
    </thead>
    <tbody>
        @foreach($items as $item)
        <tr>
            <td style="width: 60%;">
                <strong>{{$item->itemName}}</strong>
            </td>
            <td style="width: 10%;">{{$item->quantity}}</td>
            <td style="width: 20%;">{{round($item->basePrice, 2)}}</td>
            <td style="width: 10%;">{{round($item->basePrice * $item->quantity, 2)}}</td>
        </tr>
        @endforeach

        <tr>
            <td></td>
            <td></td>
            <td>Gross Total</td>
            <td>{{$subTotal}}</td>
        </tr>

        <tr>
            <td></td>
            <td></td>
            <td>CGST {{$_lbl_cgst}}</td>
            <td>{{$cgst}}</td>
        </tr>
        <tr>
            <td></td>
            <td></td>
            <td>SGST {{$_lbl_sgst}}</td>
            <td>{{$sgst}}</td>
        </tr>

        <tr>
            <td></td>
            <td></td>
            <td>IGST {{$_lbl_igst}}</td>
            <td>{{$_igst}}</td>
        </tr>

        <tr>
            <td></td>
            <td></td>
            <td>Delivery Charges</td>
            <td>{{$order->deliveryCharge}}</td>
        </tr>
        <tr>
            <td></td>
            <td></td>
            <td>Grand Total</td>
            <td>{{$order->amountPayable}}</td>
        </tr>

        <tr>
            <td colspan="4">
                Grand Total: {{$wAmount}} ONLY
            </td>
        </tr>
    </tbody>
</table>



<ul>
    <li>
        This is an electronically generated invoice, hence, does not require a signature.

    </li>
    <li>
        The seller shall be responsible for issues relating to statutory purposes like price, quality, taxation, etc.

    </li>
    <li>
        A receipt of delivery charges(if any) shall be issued and handed over to the customer by the delivery agent at the time of delivery.

    </li>

    <li>
        Get the Food on OLF App on Google Play or App Store or call 9522996999 for a hassle-free experience.

    </li>
</ul>