<!doctype html>
<html lang="en">

<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-uWxY/CJNBR+1zjPWmfnSnVxwRheevXITnMqoEIeG1LJrdI0GlVs/9cVSyPYXdcSF" crossorigin="anonymous">

    <title>Create Posts</title>
    <link href="//cdn.quilljs.com/1.3.6/quill.snow.css" rel="stylesheet">
    <link href="//cdn.quilljs.com/1.3.6/quill.bubble.css" rel="stylesheet">

</head>

<body>

    <div class="container">
        <div class="card banner mt-4">
            <div class="card-header text-center">
                <h6>Edit Post</h6>
            </div>
            <form method="post" enctype="multipart/form-data">
            <div class="card-body">
                <div class="mt-2">
                    <div class="form-group">
                        <label for="exampleDataList" class="form-label" name="category">Blog Category</label>
                        <input class="form-control" id="exampleDataList" placeholder="Enter Category" list="categories" name="categoryName" value="{{$post->category->name}}">
                        <datalist id="categories">
                        @forelse($categories as $category)
                            <option value="{{$category->name}}"></option>
                            @empty
                        @endforelse
                        </datalist>
                    </div>
                </div>

                <div class="mt-2">
                    <div class="form-group">
                        <label for="title" class="form-label">Title</label>
                        <input class="form-control" id="title" placeholder="Post Title" name="title" value="{{$post->title}}">
                    </div>
                </div>

                <div class="mt-2">
                    <div class="form-group">
                        <label for="title" class="form-label">Page Title</label>
                        <input class="form-control" id="title" placeholder="Post Title" name="page_title" value="{{$post->page_title}}">
                    </div>
                </div>


                
                <input type="hidden" id="contentBody" name="content">

                <div class="mt-2">
                    <div class="form-group">
                        <label for="description" class="form-label">Description</label>
                        <input class="form-control" id="description" placeholder="Post Description" name="description" value="{{$post->description}}">
                    </div>
                </div>

                <div class="mt-2">
                    <div class="form-group">
                        <label for="post_body" class="form-label">Description</label>
                        <div id="toolbar-container">
                            <span class="ql-formats">
                                <select class="ql-font"></select>
                                <select class="ql-size"></select>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-bold"></button>
                                <button class="ql-italic"></button>
                                <button class="ql-underline"></button>
                                <button class="ql-strike"></button>
                            </span>
                            <span class="ql-formats">
                                <select class="ql-color"></select>
                                <select class="ql-background"></select>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-script" value="sub"></button>
                                <button class="ql-script" value="super"></button>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-header" value="1"></button>
                                <button class="ql-header" value="2"></button>
                                <button class="ql-blockquote"></button>
                                <button class="ql-code-block"></button>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-list" value="ordered"></button>
                                <button class="ql-list" value="bullet"></button>
                                <button class="ql-indent" value="-1"></button>
                                <button class="ql-indent" value="+1"></button>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-direction" value="rtl"></button>
                                <select class="ql-align"></select>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-link"></button>
                                <button class="ql-image"></button>
                                <button class="ql-video"></button>
                                <button class="ql-formula"></button>
                            </span>
                            <span class="ql-formats">
                                <button class="ql-clean"></button>
                            </span>
                        </div>
                        <div class="form-control" id="post_body" placeholder="Post Body" name="post-body" role="input">
                            
                        </div>
                    </div>

                    <div class="mt-2">
                        <button class="btn btn-primary">
                            Save Post
                        </button>
                    </div>
                </div>


            </div>
            </form>
        </div>
    </div>
    <!-- Optional JavaScript; choose one of the two! -->

    <!-- Option 1: Bootstrap Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-kQtW33rZJAHjgefvhyyzcGF3C5TFyBQBA13V1RKPf4uH+bwyzQxZ6CmMZHmNBEfJ" crossorigin="anonymous"></script>
    <script src="//cdn.quilljs.com/1.3.6/quill.js"></script>
    <script src="https://unpkg.com/quill-image-resize-module@3.0.0/image-resize.min.js"></script>
    <script>
    
        var content = "{!! base64_decode($post->content) !!}"
        var options = {
            // debug: 'info',
            modules: {
                toolbar: '#toolbar-container',
                imageResize: {
                    displaySize: true
                },
            },
            placeholder: 'Compose an epic...',
            readOnly: false,
            theme: 'snow'
        };
        var editor = new Quill(document.querySelector("#post_body"), options)

        editor.on('text-change', function(text){
            $txtObject = document.querySelector('#contentBody');
            $txtObject.value = (editor.root.innerHTML)
        })
        
        editor.root.innerHTML = content;
        
    </script>
    <!-- Option 2: Separate Popper and Bootstrap JS -->
    <!--
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.10.2/dist/umd/popper.min.js" integrity="sha384-7+zCNj/IqJ95wo16oMtfsKbZ9ccEh31eOz1HGyDuCQ6wgnyJNSYdrPa03rtR1zdB" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.2/dist/js/bootstrap.min.js" integrity="sha384-PsUw7Xwds7x08Ew3exXhqzbhuEYmA2xnwc8BuD6SEr+UmEHlX8/MCltYEodzWA4u" crossorigin="anonymous"></script>
    -->
</body>

</html>