@extends('v2.front')

@section('content')

<div class="container" style="margin-top:150px;">
    <link href="//cdn.quilljs.com/1.3.6/quill.snow.css" rel="stylesheet">
    <link href="//cdn.quilljs.com/1.3.6/quill.bubble.css" rel="stylesheet">

    <div class="content row">
        <div class="sidebar col-3 d-none d-sm-block">
            
            <h3>Recent Posts</h3>

            <ul class="list-group">
                @forelse($recentPosts as $category)
                <li class="list-group-item">
                    <a href="{{$category->url}}">
                        {{substr($category->title, 0,20)."..."}}
                    </a>
                </li>

                @empty

                <li class="list-group-item">
                    No Categories
                </li>
                @endforelse
            </ul>


        </div>


        <div class="col-9">
            <script src="//cdn.quilljs.com/1.3.6/quill.js"></script>
            <script src="https://unpkg.com/quill-image-resize-module@3.0.0/image-resize.min.js"></script>
            
            <style>
                .read_more{
                    display:flex;
                    align-items:center;
                    justify-content:space-between;
                }
                
                .read_more a {
                    text-decoration:underline;
                }
            </style>

            @forelse($posts as $post)
            <blockquote>
                <h1>{{$post->title}}</h1>
                
                <div id="{{$post->slug}}">
                    
                </div>
                <div class="read_more px-2">
                    <a href="{{$post->url}}">
                        read more 
                    </a>
                    
                    <strong>Posted at: {{$post->created_at->format('Y-m-d H:i')}}</strong>
                </div>
                
                <script>
                    var {{$post->slug}}_content = `{!! $post != null ? substr($post->content,0, 100).".." : "<p>No Post</p>"!!}`;
                
                    var options = {
                        readOnly: true,
                
                    };
                    var {{$post->slug}}_editor = new Quill(document.querySelector("#{{$post->slug}}"), options)
                    {{$post->slug}}_editor.root.innerHTML = {{$post->slug}}_content
                </script>

                
            </blockquote>

            @empty
            <p>
                No Blog Posts found
            </p>
            @endforelse
        </div>
    </div>
</div>

@stop


@section('title'){{$title}}@stop

@section('description'){{$description}} @stop