<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">

    <title>Hello, world!</title>
  </head>
  <body>
    
    <div class="container-fluid" >
        <div class="card" style="margin-top:60px">
            <div class="card-header">
                <div class="d-flex align-items-center justify-space-between" style="justify-content:space-between">
                    <h3>Blog  Management</h3>
                    <a href="{{route('blog.createPost')}}"> Create a Post</a>
                </div>
                
            </div>
            
            <div class="card-body">
                @forelse($categories as $category)
                
                    <div class="list-group-item">
                        {{$category->name}}
                        
                        <hr>
                        
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <th>Meta Content</th>
                                    <th> Content</th>
                                    <th>Actions</th>
                                </tr>
                            </thead>
                            
                            <tbody>
                                @forelse($category->posts as $post)
                                 <tr>
                                     <td>
                                        <p>
                                            <strong>{{$post->page_title}}</strong> <br>
                                            <span>
                                                {{$post->description}}
                                            </span>
                                        </p> 
                                     </td>
                                     <td>
                                         <strong> {{$post->title}}</strong>
                                         <br/>
                                         <p>
                                             {{substr(base64_decode($post->content), 0, 100)}}
                                         </p>
                                     </td>
                                     <td>
                                         <a href="{{route('blog.editPost', ['id' => $post->id])}}" class="btn btn-primary">Edit Post</a>
                                         <a href="{{route('blog.postBySlug', ['id' => $post->slug])}}" class="btn btn-secondary">View Post</a>
                                     </td>
                                 </tr>
                                @empty
                            
                                    <p class ="text-center p-4 list-group-item">
                                         <a href="route('blog.createPost')"> Create a Post</a>
                                </p>
                                @endforelse
                            </tbody>
                        </table>
                    </div>
                
                @empty
                    <p class ="text-center p-4 list-group-item">
                        <a href="route('blog.createPost')"> Create a Post</a>
                    </p>
                @endforelse
            </div>
        </div>
    </div>
    <!-- Optional JavaScript; choose one of the two! -->

    <!-- Option 1: Bootstrap Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>

    <!-- Option 2: Separate Popper and Bootstrap JS -->
    <!--
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.10.2/dist/umd/popper.min.js" integrity="sha384-7+zCNj/IqJ95wo16oMtfsKbZ9ccEh31eOz1HGyDuCQ6wgnyJNSYdrPa03rtR1zdB" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.min.js" integrity="sha384-QJHtvGhmr9XOIpI6YVutG+2QOK9T+ZnN4kzFN1RtK3zEFEIsxhlmWl5/YESvpZ13" crossorigin="anonymous"></script>
    -->
  </body>
</html>