
<!doctype html>
<html lang="en">

<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="csrf-token" content="{{ csrf_token() }}" />
    <meta name="description" content="@yield('description')"/>

    <meta content="width=device-width, initial-scale=1.0" name="viewport">
    <meta content="@yield('title')" name="keywords">
    <meta content="@yield('description')" name="description">
    {{-- OG Meta --}}
    <meta property="og:title" content="@yield('title')"/>
    <meta property="og:type" content="website" />
    <meta property="og:url" content="{{URL::current()}}" />
    <meta property="og:image" content="@yield('meta_image')" />
    <meta name="twitter:card" content="summary" />
    <meta name="twitter:site" content="@yield('title')" />
    <meta name="twitter:title" content="@yield('title')" />
    <meta name="twitter:description" content="@yield('description')" />
    <meta name="twitter:image" content="@yield('meta_image')" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />

    <title>@yield('title')</title>

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="{{asset('assets/css/bootstrap.min.css')}}">
    <link rel="stylesheet" href="{{asset('assets/css/swiper.min.css')}}">
    <link rel="stylesheet" href="{{asset('assets/css/animate.min.css')}}">
    <link rel="stylesheet" href="{{asset('assets/css/fonts.css')}}">
    <link rel="stylesheet" href="{{asset('assets/css/font-awesome.css')}}">
    <link rel="stylesheet" href="{{asset('assets/css/video-js.min.css')}}">
    <link rel="stylesheet" href="{{asset('assets/css/owl.carousel.min.css')}}">
    <link rel="stylesheet" href="{{asset('assets/css/owl.theme.default.min.css')}}">
    <link rel="stylesheet" href="{{asset('assets/css/app.css?v=').time()}}">
    <link rel="stylesheet" href="{{asset('assets/css/responsive.css')}}">
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Abhaya+Libre&display=swap" rel="stylesheet">


    
    <style>
        .btn-primary {
    color: #fff;
    background-color: #ff6713;
    border-color: #ff6713;
}
body{
    overflow-x:hidden;
}
img.logo {
    max-width: 60px !important;
}

h4 {
    font-family: 'Abhaya Libre' !important;
}
h6{
    font-family: 'Abhaya Libre' !important;
}
.copyright{
     font-family: 'Abhaya Libre' !important;
}
.footer-bg:before{
    display: none !important;
}
.leaf-ft:before{
    display: none !important;
}
.top-banner:after{
     display: none !important;
}
.background-or:after{
    display: none !important;
}
.background-or:before{
    display: none !important;
}
.leaf:after{
    display: none !important;
}
.background-grey:after{
    display: none !important;
}
.background-grey:before{
   display: none !important; 
}
.contact-main ul li a{
    font-size: 14px;
    font-family: 'Abhaya Libre'!important; 

}
header {
    background-color: #f67c01;
}
a.btn.btn-primary {
    border: 1px solid;
}
img.logo {
    max-width: 140px !important;
}
.top-nav-menu li a {
    font-size: 18px;
    color: #fff !important;
    padding: 0px 20px;
    text-transform: capitalize;
    font-weight: 500;
}
.top-nav-menu li a:hover {
     color: #fff;
}
.sticky header{
    background-color: #f67c01;
}
.footer-inr {
    padding: 20px 0 !important;
}
.address{
    text-align:center;
}
.contact-main ul li a {
   
    display: flex;
    align-items: center;
}
.copyright {
   
    padding: 10px 0 !important;
   
}
.sticky{
    overflow-x:hidden;
}
.top-nav-menu li a {
    padding: 0px 18px !important;
   font-weight:600;
}
.head-left a .logo {
    max-width: 100% !important;
}
.head-left{
    width:12%;
}
.head-left a{
    display:block;
    float:left;
    width:100%;
}
.login-rgt-button a{
    font-size:13px;
}
i.fa.fa-user {
    
    font-size: 14px !important;
    margin-right: -2px !important;
}
header {
    padding: 8px 0px;
  
}
.about-ftr h4 {
    font-size: 20px;
    text-transform: capitalize;
    font-weight: 700;
    margin: 0 0 26px 0;
    color: #f67c01;
}
.enjoy-food-h2,.banner-lft-cnt h2,.copyright a {
    color: #f67c01;
  
}
.btn-main,.btn-primary {
   
    
   border: 1px solid #f67c01;
   background-color: #f67c01;
}
.btn-primary:hover {
   
    
   border: 1px solid #f67c01;
   background-color: #f67c01;
}
.enjoy-food h2 {
    color: #f67c01;
}
.sticky header {
    background-color: #f67c01;
}
.btn-main.filled, .btn-main:hover, .btn-main:focus {
    color: #ff6713;
    -webkit-box-shadow: 0 3px 10px rgb(252 141 71 / 20%);
    box-shadow: 0 3px 10px rgb(252 141 71 / 20%);
    background-color: #ffffff;
    border-color: #f67c01;
    border: 1px solid #f67c01;
}
.about-ftr h4 img{
    max-width:100%;
}
.about-ftr .footer-logo{
    width:20%;
}
@media screen and (max-width: 1024px) {

.login-rgt-button a{
    padding:5px;
}
.head-left {
    width: 11% !important;
}
.top-nav-menu li a {
    font-size: 15px;
    
}
i.fa.fa-user {
    font-size: 14px !important;
    margin-right: 4px !important;
}
}
@media screen and (max-width: 991px) {
 
    ul.top-nav-menu li a {
        padding: 15px 10px;
        display: block;
        color: black !important;
        border-bottom: 1px solid #ddd;
      }
      a.btn.btn-primary {
    margin-top: -35px;
}
.head-left {
    width: 22%;
}
.social-icons ul li {
   
    width: 29px;
  
    margin: 9px;
    height: 29px;
   
    line-height: 33px;
   
}
.social-icons{
    text-align: center;
    justify-content: center;
    align-items: center;
    display: flex;
}
}
@media screen and (max-width: 768px) {
    i.fa.fa-user {
    font-size: 11px !important;
    margin-right: 3px !important;
}
.login-rgt-button a{
    font-size: 11px;
    padding: 5px;
}
.mobile-nav {
   
    top: 9px !important;
   
}
.head-left {
    width: 20% !important;
}
.mobile-nav {
    top: 21px !important;
    font-size: 10px !important;
}
.bar1, .bar2, .bar3 {
  
    height: 2px;
    margin: 4px 0 !important;
    
    width: 20px !important;
}
.login-rgt-button {
    margin-right: 27px !important;
}
}
@media screen and (max-width: 640px) {
    i.fa.fa-user {
    font-size: 11px !important;
    margin-right: 3px !important;
}
.login-rgt-button a{
    font-size: 11px;
    padding: 5px;
}
.mobile-nav {
   
    top: 9px !important;
   
}
.head-left {
    width: 20% !important;
}
.mobile-nav {
    top: 17px !important;
    font-size: 10px !important;
}
.bar1, .bar2, .bar3 {
  
    height: 2px;
    margin: 4px 0 !important;
    
    width: 20px !important;
}
.login-rgt-button {
    margin-right: 27px !important;
}
}
@media screen and (max-width: 576px) {
    i.fa.fa-user {
    font-size: 11px !important;
    margin-right: 3px !important;
}
.login-rgt-button a{
    font-size: 11px;
    padding: 5px;
}

.head-left {
    width: 20% !important;
}
.mobile-nav {
    top: 14px !important;
    font-size: 10px !important;
}
.bar1, .bar2, .bar3 {
  
    height: 2px;
    margin: 4px 0 !important;
    
    width: 20px !important;
}
.login-rgt-button {
    margin-right: 27px !important;
}
}
@media screen and (max-width: 480px) {
    i.fa.fa-user {
    font-size: 11px !important;
    margin-right: 3px !important;
}
.login-rgt-button a{
    font-size: 11px;
    padding: 5px;
}
.mobile-nav {
   
    top: 6px !important;
   
}
.head-left {
    width: 20% !important;
}
.mobile-nav {
    top: 6px !important;
    font-size: 10px !important;
}
.bar1, .bar2, .bar3 {
  
    height: 2px;
    margin: 4px 0 !important;
    
    width: 20px !important;
}
.login-rgt-button {
    margin-right: 27px !important;
}
}

.active {
 
    text-decoration-skip-ink: none; /* Ensures underline goes directly under the text */
    text-underline-offset: 5px; /* Adjusts the distance between the text and the underline */
    position: relative;
}

.active::after {
    content: ''; /* Required for pseudo-elements */
    position: absolute; /* Position the underline relative to the parent */
    left: 0; /* Start the underline from the left edge of the parent */
    bottom: -3px; /* Position the underline below the text */
    width: 100%; /* Increase the width of the underline to extend beyond the text */
    height: 2px; /* Set the thickness of the underline */
    background-color: rgb(255, 255, 255); /* Set the color of the underline */
}

</style>
    <!-- Google Tag Manager -->
<script>(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
    new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(s)[0],
    j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
    'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
    })(window,document,'script','dataLayer','GTM-WTZZG82');</script>
<!-- End Google Tag Manager -->


    @stack('seo')
    <script async src="https://www.googletagmanager.com/gtag/js?id=UA-207961482-1"></script>
    <script>
        window.dataLayer = window.dataLayer || [];

        function gtag() {
            dataLayer.push(arguments);
        }
        gtag('js', new Date());

        gtag('config', 'UA-207961482-1');
    </script>
    
    
    <script type="text/javascript">
        (function(c, l, a, r, i, t, y) {
            c[a] = c[a] || function() {
                (c[a].q = c[a].q || []).push(arguments)
            };
            t = l.createElement(r);
            t.async = 1;
            t.src = "https://www.clarity.ms/tag/" + i;
            y = l.getElementsByTagName(r)[0];
            y.parentNode.insertBefore(t, y);
        })(window, document, "clarity", "script", "8j0hb0tn7e");
    </script>

    @stack('components')

    <script src="https://unpkg.com/@webcomponents/webcomponentsjs@2.0.0/webcomponents-bundle.js"></script>

    @yield('definations')

    <script type="module">

        <?php $url =  url()->current();?>
       const redirect = "<?php echo $url ?>".trim();
        
        import {
            LitElement,
            css,
            html
        } from 'https://unpkg.com/lit-element@2.2.1/lit-element.js?module'


        function postForm(url, body) {
            return new Promise((resolve, reject) => {
                fetch(url, {
                    method: 'POST',
                    body: JSON.stringify(body),
                    headers: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').text(),
                        'Content-Type': 'application/json',
                        'Accept': 'application/json'
                    }
                }).then(res => res.json()).then(data => resolve(data)).catch(err => reject(err))
            })
        }

        class LogoutButton extends LitElement {
            static get properties() {
                return {
                    logoutUrl: String
                }
            }

            createRenderRoot() {
                return this
            }

            constructor() {
                super()
                this.logoutUrl = ""
            }

            handleLogout() {
                postForm(this.logoutUrl, {}).then(r => {
                    window.location = "/"
                }).catch(err => console.log(err))
            }

            render() {
                return html `<button id="logout" class="btn btn-primary"  @click="${this.handleLogout}">
                            <i class="fa fa-user"></i>Log out</button>`
            }
        }

        class LoginButton extends LitElement {

            static get properties() {
                return {
                    modalClicked: { type: Boolean } // Define modalClicked as a property
                };
            }

            constructor() {
                super();
                this.modalClicked = false; // Initialize modalClicked
            }

            modalHandler(ev) {
                
                $('#login').modal('show');
            }

            createRenderRoot() {
                return this
            }
            
            render() {
                return html`
                    <a @click="${this.modalHandler}" href="javascript:void(0)" class="btn btn-primary">
                        <i class="fa fa-user"></i>Log In
                    </a>
                `;
            }
        }
        
        customElements.define('login-button', LoginButton);


        class LoginComponent extends LitElement {
            
            static get properties() {
                return {
                    loginUrl: String,
                    otpUrl: String,
                    wasOtpSent: Boolean,
                    loading: false,
                    otp: String,
                    mobile: String
                }
            }

           
            
            constructor() {
                
                super()
                this.loading = false
                this.mobile = null
                this.validationREgex = new RegExp(/^(6|7|8|9)\d{9}$/)
                this.otp = null
                this.errorMessage=null
             
                this.loginButtonObj = new LoginButton();
                this.wasOtpSent = this.loginButtonObj.modalClicked;
            }

            createRenderRoot() {
                return this;
            }

            async processMobile() {

                if(!this.validationREgex.test(this.mobile)){
                    this.errorMessage = "Please enter valid mobile number";
                    this.requestUpdate();
                    return
                }
                
                this.loading = true
                postForm(this.otpUrl, {
                    mobile: this.mobile
                }).then(res => {

                    this.wasOtpSent = true
                    this.loading = false
                    this.errorMessage=null

                }).catch(err => {
                    this.wasOtpSent = false
                    this.loading = false
                })


            }

            changeNumber(ev) {
                this.wasOtpSent = false
                this.errorMessage=null
            }

            processLogin() {

            
                if(this.otp==null || this.otp.length != 6){
                    this.errorMessage = "Please enter valid otp";
                    this.requestUpdate();
                    return
                }

                this.loading = true
                postForm(this.loginUrl, {
                    mobile: this.mobile,
                    otp: this.otp

                }).then(res => {
                    this.wasOtpSent = true
                    this.loading = false
                    const localPath = window.location.pathname
                    const {redirect:path} = res
                    
                   if(res.status=="error"){

                    this.errorMessage = res.msg;
                    this.requestUpdate();
                    return

                   }
                   else{

                        if(localPath == "/"){
                            window.location.href = localPath
                        }else {
                            window.location.href = redirect == path ? redirect :path
                        }
                        window.location.reload()
                    }
                }).catch(err => {
                    this.wasOtpSent = false
                    this.loading = false
                })
            }

            render() {
                return html `
                <div class="modal-dialog modal-dialog-centered">
                    <div class="modal-content">
                        <div class="modal-head">
                            <h4 class="modal-title">Login</h4>
                            <p>Welcome to OLFstore</p>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">
                                    <img src="{{asset('assets/img/ic-cross.svg')}}" alt="" />
                                </span>
                            </button>
                        </div>

                        <div class="modal-body">
                        
                            ${
                                this.wasOtpSent ? 
                                html`<div class="form-in">
                                        <input type="text" maxlength="6" class="form-control in-img password" placeholder="Please enter OTP"  @change="${e => this.otp = e.target.value}" 
                                        onkeypress="return ((event.charCode >= 48 &amp;&amp; event.charCode <= 57) ||  event.charCode == 0)">
                                    </div>
                                    <div class="text-center mt-3">
                                        <a href="javascript:void(0)" @click=${this.changeNumber}>Change the number</a>
                                    </div>` 
                                : 
                                html`<div class="form-in">
                                        <input type="text" maxlength="10" class="form-control in-img mobile" placeholder="Please enter your mobile number."  @change="${e => this.mobile = e.target.value}" pattern="/(5|6|7|8|9)\d{9}/" 
                                            onkeypress="return ((event.charCode >= 48 &amp;&amp; event.charCode <= 57) ||  event.charCode == 0)" >
                                    </div>`
                            }
                            ${this.errorMessage ? html`<p class="text-danger">${this.errorMessage}</p>` : ''}
                            <div class="form-in d-flex justify-content-center">
                                ${this.loading ? 
                                    html`<button type="button" class="btn-main btn-big" disabled >Verifying..</button>` 
                                    : html`<button type="button" class="btn-main btn-big" @click=${ this.wasOtpSent ? this.processLogin  :this.processMobile}>${this.wasOtpSent ? 'Login':'Send OTP'}</button>`
                                }
                            </div>

                            

                        </div>
                    </div>
                </div>
            `
            }

        }
        
        customElements.define('login-component', LoginComponent)
        customElements.define('logout-button', LogoutButton)
    </script>
</head>

<body>
@php

@endphp
    <!-- START of header -->
    <header>
        <div class="container">
            <div class="row">
                <div class="col-12 d-flex justify-content-between align-items-center">
                    <!--  <div class="logo mr-auto"><a href="index.html"><img src="assets/img/logo.png" alt=""></a></div> -->
                    <div class="head-left">
                        <a href="/">
                            <img class="logo" src="{{asset('assets/img/olf-logo.png')}}" alt="OLF - Food in Train" />
                        
                            <!--  <img class="logo-small" src="assets/img/logo-small.svg" alt="CR" /> -->
                        </a>
                    </div>
                    <nav class="menus-nav">
                        <div class="closeIcn"> <span></span> </div>
                        <ul class="top-nav-menu">
                            <li class="d-md-inline "><a href="{{url('/')}}" class="{{(Request::is('/')) ? 'active':' '}}">Home</a></li>
                            <li class="d-md-inline"><a href="{{url('/about')}}" class="{{(Request::is('about')) ? 'active':' '}}">About Us</a></li>
                            <li class="d-md-inline"><a href="{{url('/blog')}}" class="{{(Request::is('blog*')) ? 'active':' '}}">Blog</a></li>
                            <li class="d-md-inline">
                                <!-- <a href="https://docs.google.com/forms/d/e/1FAIpQLSfRUE64D_ZQYNnBleccCTehrvo1nbGpzptKjaYyJUj1uIx37w/viewform">Bulk Order</a> -->
                            <a href="{{url('/bulkorder')}}" class="{{(Request::is('bulkorder')) ? 'active':''}}">Bulk Order</a>
                            </li>
                            <li class="d-md-inline"><a href="{{route('pnr.status')}}" class="{{(Request::is('pnrstatus')) ? 'active':' '}}">PNR Status</a></li>
                            <li class="d-md-inline"><a href="{{route('train.livestatus')}}" class="{{(Request::is('getLiveStatus')) ? 'active':' '}}">Train Status</a></li>
                            <li class="d-md-inline"><a href="{{url('/locations')}}" class="{{(Request::is('locations')) ? 'active':' '}}">Locations</a></li>
                            <li class="d-md-inline"><a href="{{url('/contact')}}" class="{{(Request::is('contact')) ? 'active':' '}}">Contact Us</a></li>
                        </ul>
                    </nav>
                    <div class="login-rgt-button">

                        @if(auth('vendororder')->check() || auth('order')->check() || auth('memoryuser')->check())
                        <logout-button logoutUrl="{{url('/customer/logout')}}"></logout-button>
                        @else
                       
                        <login-button></login-button>
                        @endif
                    </div>

                </div>

                <nav class="mobile-nav">
                    <div class="bar1"></div>
                    <div class="bar2"></div>
                    <div class="bar3"></div>
                </nav>
            </div>

    </header>

    <!--End of header-->
    <div class="overlay"></div>
   
    <main>
        @yield('content')
    </main>


    <!-- START Footer Section -->
    <footer class="footer-bg">
        <div class="container">
            <div class="d-flex flex-wrap justify-content-between footer-inr">

                <div class="col-md-5">
                    <div class="about-ftr">
                        <h4 class="footer-logo"><img src="{{asset('assets/img/logo.png')}}"></h4>
                        <p>Find all restaurants available in your zone. we have more than 100s of menu online. it's quick easy and totally secure.</p>
                        

                    </div>
                </div>

                <div class="col-md-7 colum-none">
                    <div class="d-flex flex-wrap">
                        <div class="col-6 col-md-3 colum-none">
                            <div class="about-ftr">
                                <div class="contact-main">
                                    <h4>Our Menu</h4>
                                    <ul>
                                        <li><a href="{{url('/breakfast-in-train-online')}}">Breakfast</a></li>
                                        <li><a href="{{url('/lunch-in-train-online')}}">Lunch</a></li>
                                        <li><a href="{{url('/dinner-in-train-online')}}">Dinner</a></li>
                                    </ul>
                                </div>
                            </div>
                        </div>
                        <div class="col-6 col-md-3 colum-none">
                            <div class="about-ftr">
                                <div class="contact-main">
                                    <h4>Information</h4>
                                    <ul>
                                        <li><a href="{{url('/about')}}">About Us</a></li>
                                        <li><a href="{{url('/policy')}}">Privacy Policy</a></li>
                                    </ul>
                                </div>
                            </div>
                        </div>
                        <div class="col-6 col-md-3 colum-none">
                            <div class="about-ftr">
                                <div class="contact-main">
                                    <h4>Useful Links</h4>
                                    <ul>
                                        <li><a href="{{url('/contact')}}">Support</a></li>
                                        <li><a href="{{url('/terms')}}">Terms & Conditions</a></li>
                                        <!-- <li><a href="javascript:void(0)">Track Order</a></li>
                                        <li><a href="javascript:void(0)">Vendor Registration</a></li> -->
                                    </ul>
                                </div>
                            </div>
                        </div>
                        <div class="col-6 col-md-3 colum-none">
                            <div class="about-ftr">
                                <div class="contact-main">
                                    <h4>Contacts</h4>
                                    <ul>
                                        <li><a href="javascript:void(0)"><i class="fa fa-envelope"></i> contact@olfstores.com</a></li>
                                        <li><a href="javascript:void(0)"><i class="fa fa-phone"></i> +91-9522996999</a></li>

                                    </ul>
                                </div>
                            </div>
                        </div>
                        <div class="col-12 col-md-7 colum-none">
                        </div>
                        <div class="social-icons col-12 col-md-5 text-end">
                            <ul>
                                <li><a href="https://www.facebook.com/olfstores"><i class="fa fa-facebook"></i></a></li>
                                <li><a href="https://twitter.com/i/flow/login?redirect_after_login=%2Folfstores"><i class="fa fa-twitter"></i></a></li>
                                <li><a href="https://www.linkedin.com/company/olfstores/"><i class="fa fa-linkedin"></i></a></li>
                                <li><a href="https://www.instagram.com/olfstores/?utm_medium=copy_link"><i class="fa fa-instagram"></i></a></li>
                            </ul>
                        </div>

                    </div>
                </div>
            </div>

            <div class="address">
                <h4>OLF STORES AND TECHNOLOGIES PRIVATE LIMITED</h4>
                <h6>
                    H.NO.62 C/O MAHESH SINGH KRISHNA NIWAS,, HILLS VIEW COLONY,D.D NAGAR, GATE NO.2, GWALIOR, Gwalior, Madhya Pradesh, India, 474005
                </h6>
            </div>
        </div>

        <div class="copyright">Copyright © {{date('Y')}} &nbsp; <a href="#" onClick="coingSoon()">OLF Stores and Technologies pvt Ltd. </a> All Right Reserved.</div>
        <div class="leaf-ft"></div>
    </footer>

    <!-- END Footer Section -->


    <!-- START Modal Login -->
    <div class="modal fade" id="login" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-keyboard="false" data-backdrop="static">
        <login-component otpUrl="{{url('/customer/sendOtp')}}" loginUrl="{{url('/customer/login')}}"></login-component>
    </div>
    <!-- END Modal Login -->

    <!-- START Modal Sign Up -->
    <div class="modal fade" id="sign-up" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-keyboard="false" data-backdrop="static">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-head">
                    <h4 class="modal-title">Sign Up</h4>
                    <p>More than 10 Million People connected with
                        OLFstore with healthy life style..</p>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">
                            <img src="{{asset('assets/img/ic-cross.svg')}}" alt="" />
                        </span>
                    </button>
                </div>

                <div class="modal-body">
                    <form role="form" action='#' method="post">
                        <div class="form-in">
                            <input type="text" class="form-control in-img user" placeholder="Full Name">
                        </div>
                        <div class="form-in">
                            <input type="text" class="form-control in-img email" placeholder="Email Address">
                        </div>
                        <div class="form-in">
                            <input type="email" class="form-control in-img mobile" placeholder="Mobile Numver">
                        </div>
                        <div class="form-in">
                            <input type="password" class="form-control in-img password" placeholder="Password">
                        </div>
                        <div class="form-in d-flex justify-content-between">
                            <button type="button" class="btn-main btn-big">Sign Up</button>
                            <div class="">
                                <p>Already An Account?
                                    <a id="p-login" href="javascript:void(0)">Login Here</a>
                                </p>
                            </div>
                        </div>
                    </form>
                    < </div>
                </div>
            </div>
        </div>
    </div>
        <!-- END Modal Sign Up -->

        <!-- Modal Forgot Your Password -->
        <div class="modal fade" id="f-password" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-keyboard="false" data-backdrop="static">
            <div class="modal-dialog modal-dialog-centered">
                <div class="modal-content">
                    <div class="modal-head">
                        <h4 class="modal-title">Forgot Your Password</h4>
                        <p>Reset your password using email address</p>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">
                                <img src="{{asset('assets/img/ic-cross.svg')}}" alt="" />
                            </span>
                        </button>
                    </div>

                    <div class="modal-body">
                        <form role="form" action='#' method="post">
                            <div class="form-in">
                                <input type="email" class="form-control in-img email" placeholder="Email Address">
                            </div>
                            <div class="form-in d-flex  justify-content-between">
                                <button type="button" class="btn-main btn-big">Send</button>
                                <div class="">
                                    <p>Back to the
                                        <a id="p-login" href="javascript:void(0)">Login</a>
                                    </p>
                                </div>
                            </div>

                        </form>
                    </div>
                </div>
            </div>
        </div>


        
        <!-- END Modal Forgot Your Password -->



        <!-- Optional JavaScript -->
        <!-- jQuery first, then Popper.js, then Bootstrap JS -->
        <!-- <script src="{{asset('assets/js/jquery.min.js')}}"></script> -->
        <script src="https://code.jquery.com/jquery-3.1.0.js"></script>
        <script src="{{asset('assets/js/popper.min.js')}}"></script>
        <script src="{{asset('assets/js/bootstrap.min.js')}}"></script>
        <script src="{{asset('assets/js/video.min.js')}}"></script>
        <script src="{{asset('assets/js/swiper.min.js')}}"></script>
        <script src="{{asset('assets/js/owl.carousel.min.js')}}"></script>
        <script src="{{asset('assets/js/app.js')}}"></script>


        @stack('scripts')

        @yield('footer-scripts')


        @yield('footer-content')
        
    
</body>

</html>