@extends('v2.front')


@section('content')
<section class="inner-banner">
    <div class="container">
        <div class="d-flex flex-wrap justify-content-between align-items-top">
            <div class="col-md-6">
                <div class="baner-cnt">
                    <h2>Your <span> Cart</span></h2>
                    <h4>Select food form basket</h4>
                    <p>But I must explain to you how all this mistaken idea of denouncing pleasure and praising pain was born and I will give you a complete account of the system, and expound the actual teachings of the great explorer of the truth, the master-builder of human happiness. No one rejects, dislikes, or avoids pleasure</p>

                </div>
            </div>
            <div class="col-md-6">
                <div class="resturant-food-bg">
                    <img src="{{secure_asset('assets/img/your-cart-bg.png')}}" alt="">
                </div>
            </div>

        </div>

</section>
<!-- END top banner section -->

<!-- START Best Resturant For You -->
<section class="sec" id="cartSection">
    <div class="container">
        <div class="d-flex justify-content-center">
            <div class="col-md-12">
                <div class="trainer-top text-center">
                    <div class="sec-heading center-line">Your Cart {{$items->count() < 1 ? "is Empty": ""}}</div>
                </div>
            </div>
        </div>
    </div>

    <div class="container">
        <div class="d-flex flex-wrap justify-content-between">
            <div class="your-cart">
                <div class="table-responsive">
                    <table class="table">
                        <thead class="thead-light">
                            <tr>
                                <th scope="col">Food</th>
                                <th scope="col">QTY</th>
                                <th scope="col">Price</th>
                                <th scope="col">Delete</th>
                            </tr>
                        </thead>
                        <tbody>
                            @forelse($items as $item)
                            <tr>
                                <th scope="row">
                                    <div class="d-flex flex-wrap align-items-top">
                                        <div class="left-no">1</div>
                                        <div class="order-name">
                                            <h3>{{$item->itemName}} <span><img src="{{$item->isVegetarian == 1 ? secure_asset('assets/img/veg.png'): secure_asset('assets/img/non-veg.png')}}" alt=""></span></h3>
                                            <h4>{{$item->description}}</h4>

                                        </div>
                                    </div>
                                </th>
                                <td>
                                    <cart-control id="{{$item->itemId}}" quantity="{{$item->quantity ==0 ? 1 : $item->quantity}}" price="{{$item->sellingPrice}}" method="POST" success="{{route('cart.confirm', ['action' => 'REFRESH'])}}" action="{{route('cart.postUrl')}}">
                                    </cart-control>
                                </td>
                                <td>
                                    <div class="quatity-price">
                                        <h5><i class="fa fa-rupee"></i>{{$item->sellingPrice * $item->quantity}}</h5>
                                    </div>
                                </td>
                                <td>
                                    <remove-item id="{{$item->itemId}}" quantity="0" method="POST" success="{{route('cart.confirm', ['action' => 'REFRESH'])}}" action="{{route('cart.postUrl')}}">
                                    </remove-item>
                                </td>
                            </tr>

                            @empty

                            <td role="row" colspan="4">

                                <div class="text-center">
                                    <a href="/" class="btn btn-secondary backBtn"> Back </a>
                                </div>
                            </td>
                            @endforelse
                        </tbody>
                    </table>
                </div>
            </div>
        </div>

    </div>

    @if(session()->has('cart_error'))
    <div class="container" id="msgAlert">
        <div class="alert alert-danger">
        <div class="d-flex align-items center justify-content-between">
                        <p>
                            {{session()->get('cart_error')}}
                        </p>

                        <a href="#" id="closeMessage" onclick="$('#msgAlert').remove()" style="color:#fff; text-decoration: none;"><i class="fa fa-close"></i></a>
                    </div>
        </div>
    </div>
    @endif

    @if($items->count() > 0)
    <div class="container">
        <div class="d-flex flex-wrap justify-content-between">
            <div class="col-md-6">
                @if(session()->has('discount_failed'))
                <div class="alert alert-danger" id="discountAlert">
                    <div class="d-flex align-items center justify-content-between">
                        <p>
                            {{session()->get('discount_failed')}}
                        </p>

                        <a href="#" id="closeMessage" onclick="$('#discountAlert').remove()" style="color:#fff; text-decoration: none;"><i class="fa fa-close"></i></a>
                    </div>
                </div>
                @endif

                @if(session()->has('discount_success'))
                <div class="alert alert-success" id="discountAlert">
                    <div class="d-flex align-items center justify-content-between">
                        <p>
                            {{session()->get('discount_success')}}
                        </p>

                        <a href="#" id="closeMessage" onclick="$('#discountAlert').remove()" style="color:#fff; text-decoration: none;"><i class="fa fa-close"></i></a>
                    </div>
                </div>
                @endif

                <discount-component
                        applied = "{{session('applied', false)}}"
                        couponCode= "{{session()->has('couponCode') ? session()->get('couponCode') : ''}}" 
                        isLoggedIn = "{{$Customer != null ? true :false}}"
                        frozen="{{$frozen}}" claimStrategy="{{session('claim', 'NONE')}}"
                        actionUrl="{{route('web.processDiscounts')}}" walletAmt="{{$Customer != null ? ($Customer->wallet ? ($Customer->wallet->balance - $discounts) : 0) : 0}}">
                </discount-component>
            </div>
            <div class="col-md-6">
                <label class="delivery-txt">Order with Delivery</label>
                <div class="delivery-tabel">
                    <table width="100%" cellpadding="0" cellspacing="0" border="0">
                        <tbody>

                            <tr>
                                <td class="fileds-wal">Subtotal:</td>
                                <td class="fileds-price-wal">{{$subTotal}}</td>
                            </tr>

                            <tr>
                                <td class="fileds-wal">Discount:</td>
                                <td class="fileds-price-wal">{{$discounts}}</td>
                            </tr>

                            <tr>
                                <td class="fileds-wal">GST:</td>
                                <td class="fileds-price-wal">{{$gst}}</td>
                            </tr>


                            <tr>
                                <td class="fileds-wal">Delivery Charge:</td>
                                <td class="fileds-price-wal">{{$deliveryCost}}</td>
                            </tr>


                            <tr>
                                <td class="fileds-wal">Total Amount to Paid:</td>
                                <td class="fileds-price-wal">{{$amountPayable}}</td>
                            </tr>

                           
                        </tbody>
                    </table>
                </div>
                <div class="wal-btn d-flex flex-wrap justify-content-between ">

                    <div class="login-button get-started">
                        <a class="btn-main login-btn">Cancel Order</a>
                    </div>




                    @if($items->count() > 0 )
                    <div class="login-button get-started">
                        @if($Customer != null)
                        <a href="{{route('web.customerDetails')}}" class="btn-main login-btn ">Proceed to Checkout</a>
                        @else
                        <a href="#" class="btn-main login-btn" onclick='$("#login").modal("show")'>Proceed to Checkout</a>
                        @endif
                    </div>


                    @endif
                </div>
            </div>
        </div>
    </div>

    @endif
</section>
<!-- END Best Resturant For You -->

@stop



@push('components')
<script src="https://unpkg.com/@webcomponents/webcomponentsjs@2.0.0/webcomponents-bundle.js"></script>
@endpush


@section('definations')
<script type="module">
    import {
        LitElement,
        css,
        html
    } from 'https://unpkg.com/lit-element@2.2.1/lit-element.js?module'


    class CartControl extends LitElement {

        static get properties() {
            return {
                id: String,
                quantity: Number,
                action: String,
                method: String,
                success: String
            }
        }

        constructor() {
            super();
            this.quantity = 1
        }

        dispach() {
            this.dispatchEvent(
                new CustomEvent('fetchConfirmation', {
                    bubbles: true,
                    composed: true,
                    detail: {
                        url: this.success
                    }
                }))
        }

        handleSubmit(evt) {
            const {
                id,
                quantity
            } = this
            fetch(this.action, {
                method: "POST",
                body: JSON.stringify({
                    itemId: id,
                    quantity
                }),
                headers: {
                    'X-CSRF-TOKEN': document.querySelector('meta[name="csrf-token"]').textContent
                }
            }).then(re => re.text()).then(d => {
                console.log(d)
                this.dispach()
            })
        }

        createRenderRoot() {
            return this
        }

        render() {
            const {
                quantity,
            } = this

            return html `
                    <div class="quantity">
                        <div class="control">
                            <button class="bttn bttn-left"  @click="${
                                (ev) => {
                                    this.quantity =  parseInt(this.quantity) < 1 ? 1 : parseInt(this.quantity) -1
                                    this.handleSubmit(ev)
                                }
                            }">
                                <span>-</span>
                            </button>
                            <input type="number" class="input" id="input" value="${quantity}" disabled>
                            <button class="bttn bttn-right" @click="${
                               (ev) => { this.quantity =  parseInt(this.quantity) +1
                                    this.handleSubmit(ev)
                               }
                            }" >
                                <span>+</span>
                            </button>
                        </div>
                    </div>   
            `
        }

    }




    class RemoveItem extends LitElement {

        static get properties() {
            return {
                id: String,
                action: String,
                method: String,
                success: String,
                quantity: Number
            }
        }

        constructor() {
            super();
            this.quantity = 0
        }

        dispach() {
            this.dispatchEvent(new CustomEvent('fetchConfirmation', {
                bubbles: true,
                composed: true,
                detail: {
                    url: this.success
                }
            }))
        }

        handleSubmit(evt) {
            const {
                id,
                quantity
            } = this
            fetch(this.action, {
                method: "POST",
                body: JSON.stringify({
                    itemId: id,
                    quantity
                }),
                headers: {
                    'X-CSRF-TOKEN': document.querySelector('meta[name="csrf-token"]').textContent
                }
            }).then(re => re.text()).then(d => {
                console.log(d)
                this.dispach()
            })
        }

        createRenderRoot() {
            return this
        }

        render() {

            return html `
            <div class="actions" @click="${
                (e) => this.handleSubmit(e)
            }">
                <i class="fa fa-trash"></i>
            </div>   
    `
        }

    }

    function postForm(url, body) {
        return new Promise((resolve, reject) => {
            fetch(url, {
                method: 'POST',
                body: JSON.stringify(body),
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').text(),
                    'Content-Type': 'application/json'
                }
            }).then(res => res.text()).then(data => resolve(data)).catch(err => reject(err))
        })
    }

    class DiscountComponent extends LitElement {
        createRenderRoot() {
            return this
        }

        constructor() {
            super()
            this.claimStrategy = 'NONE'
            this.walletAmt = 0
            this.couponCode = ""
            this.frozen = false
            this.applied = false
        }


        static get properties() {
            return {
                claimStrategy: String,
                actionUrl: String,
                isLoggedIn: Boolean,
                walletAmt: Number,
                couponCode: String,
                frozen:Boolean,
                applied:Boolean
            }
        }

        get isApplyingCoupon() {
            return this.claimStrategy == 'COUPON'
        }

        get isApplyingWallet() {
            return this.claimStrategy == 'WALLET'
        }

        select(evt) {
            if(!this.frozen)
                this.claimStrategy = evt
        }

        get wIcon() {
            return this.claimStrategy == 'WALLET' ?
                html `<i class="fa fa-check-circle text-danger" aria-hidden="true"></i>` :
                html `<i class="fa fa-circle" aria-hidden="true"></i>
`
        }

        get pIcon() {
            return this.claimStrategy == 'COUPON' ?
                html `<i class="fa fa-check-circle text-danger" aria-hidden="true"></i>` :
                html `<i class="fa fa-circle" aria-hidden="true"></i>
`
        }

        renderCode(cond) {
            if (cond)
                return html `
                <div class="p-1">
                    <input type="text" @change="${(e) => this.couponCode = e.target.value}" class="form-control" placeholder="Coupon Code" ?readonly=${this.frozen} value="${this.couponCode}"/>
                </div>
                `
            else
                return html `<h5 class="font-weight-bold">Coupon Code</h5>
                    <h6 class="font-weight-light text-gray-300">Apply Coupon Code to avail discount</h6>`
        }

        borderStyles(cond) {
            return cond ? "background:#FFE6D7" : ''
        }

        handleSubmit() {
            let _payload = {}
            if (this.isApplyingCoupon) {

                _payload['claim'] = 'COUPON'
                _payload['code'] = this.couponCode
            } else {
                _payload['claim'] = 'WALLET'
            }

            postForm(this.actionUrl, {
                ..._payload
            }).then(_c => {
                $('#cartSection').html(_c)
            })

        }



        render() {
            const {
                isApplyingCoupon,
                isApplyingWallet,
                wIcon,
                pIcon,
            } = this

            return html `
            <div class="p-2 px-8">
                <h5 class="text-center">Apply Coupon/ Wallet(Discount)</h5>
                <hr></hr>

                ${
                    this.walletAmt < 1 ?
                    html``: html`<div class="rounded border p-2 d-flex align-items-center"  @click="${() => this.select('WALLET')}" style="${this.borderStyles(isApplyingWallet)}">
                    <i class="fa fa-google-wallet fa-2x mr-3 ml-2" style="color:#FF5700"></i>
                    <div class="w-100">
                    <h5 class="font-weight-bold">Wallet</h5>
                    <h6 class="font-weight-light text-gray-300">    ₹ &nbsp; ${this.walletAmt}</h6>
                    </div>
                    
                    ${wIcon}
                </div>`
                }

                <div class="rounded border d-flex align-items-center mt-2" @click="${() => this.select('COUPON')}" style="${this.borderStyles(isApplyingCoupon)};padding:18px">
                <i class="fa fa-money fa-2x mr-3 ml-2" aria-hidden="true" style="color:#FF5700"></i>
                    <div class="w-100">
                    ${this.renderCode(isApplyingCoupon)}
                    </div>
                    ${pIcon}
                </div>

                <hr/>

                <button class="btn btn-success btn-md" @click="${this.handleSubmit}" ?disabled="${this.applied}"  >
                  ${this.applied ? this.claimStrategy+' APPLIED' : 'APPLY '}
                </button>

            </div>
            `
        }
    }

    window.customElements.define('cart-control', CartControl)
    window.customElements.define('remove-item', RemoveItem)
    window.customElements.define('discount-component', DiscountComponent)
</script>
@stop