    <div class="container">
        <div class="d-flex justify-content-center">
            <div class="col-md-12">
                <div class="trainer-top text-center">
                    <div class="sec-heading center-line">Your Cart {{$items->count() < 1 ? "is Empty": ""}}</div>
                </div>
            </div>
        </div>
    </div>



    <div class="container">
        <div class="d-flex flex-wrap justify-content-between">
            <div class="your-cart">
                <div class="table-responsive">
                    <table class="table">
                        <thead class="thead-light">
                            <tr>
                                <th scope="col">Food</th>
                                <th scope="col">QTY</th>
                                <th scope="col">Price</th>
                                <th scope="col">Delete</th>
                            </tr>
                        </thead>
                        <tbody>
                            @forelse($items as $item)
                            <tr>
                                <th scope="row">
                                    <div class="d-flex flex-wrap align-items-top">
                                        <div class="left-no">1</div>
                                        <div class="order-name">
                                            <h3>{{$item->itemName}} <span><img src="{{$item->isVegetarian == 1 ? secure_asset('assets/img/veg.png'): secure_asset('assets/img/non-veg.png')}}" alt=""></span></h3>
                                            <h4>{{$item->description}}</h4>

                                        </div>
                                    </div>
                                </th>
                                <td>
                                    <cart-control id="{{$item->itemId}}" quantity="{{$item->quantity ==0 ? 1 : $item->quantity}}" price="{{$item->sellingPrice}}" method="POST" success="{{route('cart.confirm', ['action' => 'REFRESH'])}}" action="{{route('cart.postUrl')}}">
                                    </cart-control>
                                </td>
                                <td>
                                    <div class="quatity-price">
                                        <h5><i class="fa fa-rupee"></i>{{$item->sellingPrice * $item->quantity}}</h5>
                                    </div>
                                </td>
                                <td>
                                    <remove-item id="{{$item->itemId}}" quantity="0" method="POST" success="{{route('cart.confirm', ['action' => 'REFRESH'])}}" action="{{route('cart.postUrl')}}">
                                    </remove-item>
                                </td>
                            </tr>

                            @empty

                            <td role="row" colspan="4">

                                <div class="text-center">
                                    <a href="/" class="btn btn-secondary backBtn"> Back </a>
                                </div>
                            </td>
                            @endforelse
                        </tbody>
                    </table>
                </div>
            </div>
        </div>

    </div>


    @if(session()->has('cart_error'))
    <div class="container" id="msgAlert">
        <div class="alert alert-danger">
            <div class="d-flex align-items center justify-content-between">
                <p>
                    {{session()->get('cart_error')}}
                </p>

                <a href="#" id="closeMessage" onclick="$('#msgAlert').remove()" style="color:#fff; text-decoration: none;"><i class="fa fa-close"></i></a>
            </div>
        </div>
    </div>
    @endif

    @if($items->count() > 0)
    <div class="container">
        <div class="d-flex flex-wrap justify-content-between">
            <div class="col-md-6">
                @if(session()->has('discount_failed'))
                <div class="alert alert-danger" id="discountAlert">
                    <div class="d-flex align-items center justify-content-between">
                        <p>
                            {{session()->get('discount_failed')}}
                        </p>

                        <a href="#" id="closeMessage" onclick="$('#discountAlert').remove()" style="color:#fff; text-decoration: none;"><i class="fa fa-close"></i></a>
                    </div>
                </div>
                @endif

                @if(session()->has('discount_success'))
                <div class="alert alert-success" id="discountAlert">
                    <div class="d-flex align-items center justify-content-between">
                        <p>
                            {{session()->get('discount_success')}}
                        </p>

                        <a href="#" id="closeMessage" onclick="$('#discountAlert').remove()" style="color:#fff; text-decoration: none;"><i class="fa fa-close"></i></a>
                    </div>
                </div>
                @endif

                <discount-component isLoggedIn="{{$frozen}}" claimStrategy="{{session('claim', 'NONE')}}" actionUrl="{{route('web.processDiscounts')}}" walletAmt="{{$Customer != null ? ($Customer->wallet? ($Customer->wallet->balance - $discounts): 0) : 0}}">
                </discount-component>
            </div>
            <div class="col-md-6">
                <label class="delivery-txt">Order with Delivery</label>
                <div class="delivery-tabel">
                    <table width="100%" cellpadding="0" cellspacing="0" border="0">
                        <tbody>

                            <tr>
                                <td class="fileds-wal">Subtotal:</td>
                                <td class="fileds-price-wal">{{$subTotal}}</td>
                            </tr>

                            <tr>
                                <td class="fileds-wal">Discount:</td>
                                <td class="fileds-price-wal">{{$discounts}}</td>
                            </tr>

                            <tr>
                                <td class="fileds-wal">GST:</td>
                                <td class="fileds-price-wal">{{$gst}}</td>
                            </tr>


                            <tr>
                                <td class="fileds-wal">Delivery Charge:</td>
                                <td class="fileds-price-wal">{{$deliveryCost}}</td>
                            </tr>


                            <tr>
                                <td class="fileds-wal">Total Amount to Paid:</td>
                                <td class="fileds-price-wal">{{$amountPayable}}</td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <div class="wal-btn d-flex flex-wrap justify-content-between ">

                    <div class="login-button get-started">
                        <a class="btn-main login-btn">Cancel Order</a>
                    </div>




                    @if($items->count() > 0 )
                    <div class="login-button get-started">
                        @if($Customer != null)
                        <a href="{{route('web.customerDetails')}}" class="btn-main login-btn ">Proceed to Checkout</a>
                        @else
                        <a href="#" class="btn-main login-btn" onclick='$("#login").modal("show")'>Proceed to Checkout</a>
                        @endif
                    </div>


                    @endif
                </div>
            </div>
        </div>
    </div>

    @endif