<div class="your-cart-order">
    <div class="order-h d-flex align-items-center justify-content-between">
        <h3>Your Order</h3>
        <h5><i class="fa fa-cart-plus"></i></h5>
    </div>
    <ul class="order-list-main">
        @forelse($items as $item)
        <li>
            <div class="order-listing">
                <div class="d-flex align-items-center justify-content-between">
                    <div class="list-left">
                        <div class="d-flex align-items-top">
                            <div class="left-minus"><i class="fa fa-minus-circle"></i></div>
                            <div class="order-name-final">
                                <h3>{{$item->itemName}} <span><img src="{{$item->isVegetarian == 1 ? secure_asset('assets/img/veg.png'): secure_asset('assets/img/non-veg.png')}}" alt=""></span></h3>
                                <h4>{{$item->description}}</h4>
                            </div>
                        </div>
                    </div>
                    <div class="quatity-price">

                        <h5>
                            {{$item->quantity}} X <i class="fa fa-rupee"> {{$item->basePrice}} </i>
                        </h5>
                    </div>
                </div>
            </div>
        </li>

        @empty

        <li>
            <div class="order-listing">
                <div class="d-flex align-items-center justify-content-between">
                    <div class="list-left">
                        <div class="d-flex align-items-top">
                            <div class="left-minus"><i class="fa fa-minus-circle"></i></div>
                            <div class="order-name-final">
                                <h3>No Items in Shopping cart <span><img src="assets/img/veg.png" alt=""></span></h3>
                                <h4>please add One oor more items in basket</h4>
                            </div>
                        </div>
                    </div>
                    <div class="quatity-price">
                        <h5><i class="fa fa-rupee"></i>-</h5>
                    </div>
                </div>
            </div>
        </li>


        @endforelse
    </ul>

    <div class="total-order">
        <table width="100%" cellpadding="0" cellspacing="0" border="0">
            <tbody>

                <tr>
                    <td class="fileds">SubTotal</td>
                    <td class="fileds-price">{{$subTotal}}</td>
                </tr>


                <tr>
                    <td class="fileds">Discounts</td>
                    <td class="fileds-price">{{$discounts}}</td>
                </tr>

                <tr>
                    <td class="fileds">Delivery fee</td>
                    <td class="fileds-price">{{$deliveryCost}}</td>
                </tr>
                <tr>
                    <td class="fileds">GST</td>
                    <td class="fileds-price">{{$gst}}</td>
                </tr>

            </tbody>
        </table>
    </div>

    <div class="total-count">
        <div class="d-flex flex-wrap justify-content-between">
            <div class="total">Amount Payable</div>
            <div class="total-price">

                ₹ {{$amountPayable}}
            </div>
        </div>
    </div>

    @if(! $minAmountSatisfied)
    <div class="total-count">
        <div class="d-flex flex-wrap justify-content-between">
            <div class="total">* Minimum Order Amount is ₹ {{$minAmount}}</div>

        </div>
    </div>

    @endif
    <div class="confirm-order-btn">
        <div class="login-button">
          
            @if($Customer != null)
                <a class="btn-main login-btn" href="{{($items->count() < 1 || (! $minAmountSatisfied)) ? 'javascript:minOrderAlert()' : route('cart.confirm')}}" >View Cart</a>
            @else
                <a href="#" class="btn-main login-btn" onclick='$("#login").modal("show")'>View Cart</a>
            @endif

        </div>
    </div>

</div>

<script>
    function minOrderAlert(){
        alert("Minimum Order Amount is ₹ {{$minAmount}}")
    }
</script>
