<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */



use App\Events\OrderCreatedEvent;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;
use App\Console\Commands\SeedMissing;
use App\Http\Controllers\AdminController;
use App\Http\Controllers\AdminOrderController;
use App\Http\Controllers\AgentController;
use App\Http\Controllers\Auth\ApiLoginController;
use App\Http\Controllers\Auth\ApiMobileLoginController;
use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\Auth\MemoryUserLoginController;
use App\Http\Controllers\Auth\MultipleAccessApiLoginController;
use App\Http\Controllers\Auth\OrderApiLoginController;
use App\Http\Controllers\Auth\OrderLoginController;
use App\Http\Controllers\Auth\VendorOrderLoginController;
use App\Http\Controllers\Roles\RolesController;
use App\Http\Controllers\BlogController;
use App\Http\Controllers\DocumentSignController;
use App\Http\Controllers\EnquiryController;
use App\Http\Controllers\FrontendController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\InvoiceController;
use App\Http\Controllers\LogController;
use App\Http\Controllers\OrderController;
use App\Http\Controllers\OrderCreationController;
use App\Http\Controllers\OrderEditController;
use App\Http\Controllers\OutletController;
use App\Http\Controllers\OutletHistoryController;
use App\Http\Controllers\PNRController;
use App\Http\Controllers\ResourceController;
use App\Http\Controllers\SalesReportController;
use App\Http\Controllers\SearchApiController;
use App\Http\Controllers\PageMetaController;
use App\Http\Controllers\SlideshowController;
use App\Http\Controllers\StationContentController;
use App\Http\Controllers\StationController;
use App\Http\Controllers\StationMetaController;
use App\Http\Controllers\TrainController;
use App\Http\Controllers\TrainSearchController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\VendorApiController;
use App\Http\Controllers\VendorController;
use App\Http\Controllers\WebController;
use App\Http\Controllers\WhatsAppTestController;
use App\Http\Controllers\VoucherController;
use App\Http\Controllers\WorkFlowController;

// For clear-cache

Route::get('/cc', function() {
    Artisan::call('cache:clear');
    Artisan::call('config:clear');
    Artisan::call('config:cache');
    Artisan::call('view:clear');
    Artisan::call('route:clear');

    echo "<h3>Cache Cleared</h3>";
});

Route::group(['prefix' => '/'], function () {

        #Route::get('/missing', 'SeedMissingController@seed');

        Route::get('/', function () {
            return view('v2.pages.index');
        });
        

        Route::get('/terms', function(){
                return  view('v2.pages.terms');
        });


        Route::get('/locations', [StationContentController::class, 'fetchStationOverview']);
        Route::get('/locations/{slug}', [StationContentController::class, 'getOne'])->name('station.content.view');

        Route::get('/about', function () {
                return view('v2.pages.about');
        });

        Route::get('/contact', function () {
                return view('v2.pages.contact');
        });
        Route::get('/bulkorder', function () {
                return view('v2.pages.bulkorder');
        });



        Route::post('/web/logout', [WebController::class, 'logoutUser'])->name('web.logout');

        Route::post('/create/orderToken', [WebController::class, 'createRequest'])->name('razor.token');

        Route::post('/create/postback', [WebController::class, 'postRazorJunk'])->name('razor.junk');

        Route::post('/post/orderInfo', [WebController::class, 'checkoutCOD'])->name('checkout.cod');

        Route::post('/post/customerDetails', [WebController::class, 'postCustomerDetails'])->name('customer.junk');

        Route::get('/push', [WebController::class, 'pushTest']);


        Route::redirect('/breakfast', '/breakfast-in-train-online', 301);
        Route::redirect('/lunch', '/lunch-in-train-online', 301);
        Route::redirect('/dinner', '/dinner-in-train-online', 301);



        Route::match(['POST', 'GET'], '/pnrstatus', [PNRController::class, 'fetchPNRStatus'])->name('pnr.status');

        Route::get('/restraunts/{code}/{date}/{source?}', [WebController::class, 'restraunts'])->name('restraunts.list');

        Route::get('/fetch/{pnr}/stations/{source?}', [WebController::class, 'fetchPNR'])->name('pnr.fetch');
        Route::get('/fetch/{code}/restraunts', [WebController::class, 'fetchRestraunts'])->name('web.restraunts');
        Route::get('/fetch/{code}/{id}/items/{source?}', [WebController::class, 'fetchItems'])->name('web.items');


        Route::get('/fetch/cart', [WebController::class, 'cart'])->name('cart.fetchNormal');

        Route::get('/cart/overview', [WebController::class, 'overviewCart'])->name('web.cartOverview');

        Route::get('/cart/confirm/{action?}/', [WebController::class, 'cartConfirm'])->name('cart.confirm');

        Route::get('/order/cancel', [WebController::class, 'cancelOrder'])->name('cart.cancel');

        Route::post('/add/to/cart', [WebController::class, 'addItemsToCart'])->name('cart.postUrl');

        Route::get('/customerDetails', [WebController::class, 'cartConfirmation'])->name('web.customerDetails');

        Route::post('/applyDiscounts', [WebController::class, 'applyDiscounts'])->name('web.processDiscounts');

        Route::get('/search', [SearchApiController::class, 'process']);
        Route::get('/stations', [StationController::class, 'stationList']);
        Route::get('/trains/public/stations', [StationController::class, 'stationList']);
        Route::get('/vendor/Menu/{id}', [FrontendController::class, 'vendorMenu']);

        Route::get('/wat', [WhatsAppTestController::class, 'checkVars']);


        Route::get('/breakfast-in-train-online', [WebController::class, 'breakfast']);
        Route::get('/dinner-in-train-online', [WebController::class, 'dinner']);
        Route::get('/lunch-in-train-online', [WebController::class, 'lunch']);

        Route::get('/policy', [WebController::class, 'policy']);

        Route::post('/SubmitEnquery', [EnquiryController::class, 'SubmitEnquery']);
        Route::get('/backend/Queries', [EnquiryController::class, 'Queries']);
        Route::post('/OrderBooking', [EnquiryController::class, 'OrderBooking']);
        Route::get('/backend/BulkBooking', [EnquiryController::class, 'BulkBooking']);
        Route::post('/backend/rejected', [EnquiryController::class, 'rejected']);
        Route::post('/backend/approved', [EnquiryController::class, 'approved']);
        Route::post('/backend/TotalRequest', [EnquiryController::class, 'TotalRequest']);
        Route::post('/backend/CountRequest', [EnquiryController::class, 'CountRequest']);
        Route::post('/backend/UpdateSeenCount', [EnquiryController::class, 'UpdateSeenCount']);

        Route::get('/backend/fssaiExpire', [OutletController::class, 'fssaiExpire']);
        Route::get('/backend/fssai/edit/{id}', [OutletController::class, 'fssaiEdit']);
        Route::post('/backend/fssai/update', [OutletController::class, 'fssaiUpdate']);
        Route::post('/backend/dateExtande', [OutletController::class, 'dateExtande']);
        Route::post('/backend/updateStatus', [OutletController::class, 'updateStatus']);

        Route::get('/backend/Blog/view', [BlogController::class, 'ListingBlog']);
        Route::get('/backend/Blog/edit/{category_id}', [BlogController::class, 'BlogEdit']);
        Route::post('/backend/Blog/edit/{category_id}', [BlogController::class, 'BlogEdit']);
        Route::get('/backend/Blog/add', [BlogController::class, 'BlogInsert']);
        Route::post('/backend/Blog/add', [BlogController::class, 'BlogInsert']);

        Route::get('/backend/outlets/OutletHistory', [OutletHistoryController::class, 'index']);

        Route::get('/backend/outlets/restore/{outletid}', [OutletHistoryController::class, 'restoreOutlet']);



        Route::get('/order/failed', [WebController::class, 'serveErrorPage'])->name('orderpost.error');
        Route::get('/order/success', [WebController::class, 'serveSuccess'])->name('orderpost.success');
        Route::get('/editing/failed', [WebController::class, 'serveErrorPage'])->name('editing.error');


        Route::group(['prefix' => '/blog'], function () {

            Route::get('/', [BlogController::class, 'index'])->name('blog.index');
            Route::get('/category/{slug}', [BlogController::class, 'postByCategory'])->name('blog.categoryPosts');
            Route::get('/posts/{slug}', [BlogController::class, 'postByTitle'])->name('blog.postBySlug');
            Route::match(['GET', 'POST'], '/posts/{id}/edit', [BlogController::class, 'editPost'])->name('blog.editPost');
            Route::get('/private', [BlogController::class, 'backendPosts'])->name('blog.backendPosts');
            Route::match(['GET', 'POST'], '/createPost', [BlogController::class, 'createPost'])->name('blog.createPost');

        });

        Route::get('/getLiveStatus', [TrainSearchController::class, 'fetchLiveStatus'])->name('train.livestatus');
        Route::get('/get/livestatus/{trainNumber}/on/{dateTime}', [StationContentController::class, 'scrapLiveStatus']);


});



Route::auth();


Route::middleware(['auth:apiorder'])->group(function () {
    Route::get('/api/orders/{vendor}/vendors', [SearchApiController::class, 'vendorOrders']);
});

Route::get('/api/orders/{vendor}/vendorsT', [SearchApiController::class, 'vendorOrdersTest']);

Route::get('/files/{name}', [OutletController::class, 'files']);

Route::prefix('auth')->group(function () {
    Auth::routes();
});


Route::post('/auth/vendorLogin', [VendorApiController::class, 'postLogin']);
Route::post('/auth/checkVendor', [FrontendController::class, 'isLoggedIn']);
Route::post('/auth/vendorLogout', [VendorApiController::class, 'postLogout']);


Route::prefix('ui1')->group(function () {

    Route::post('api/login', [ApiLoginController::class, 'postLogin']);

    Route::middleware(['auth', 'api'])->group(function () {
        Route::get('check/login', [ApiLoginController::class, 'isLoggedIn']);
        Route::get('api/logout', [ApiLoginController::class, 'postLogout']);
    });
});


# Sales Report Related Routes

Route::prefix('sales/report')->middleware(['auth'])->group(function () {

    Route::get('/', [SalesReportController::class, 'index'])->name('salesReport');
    Route::get('/export', [SalesReportController::class, 'reportExport'])->name('salesReport.export');
 
});



Route::prefix('meta')->middleware(['auth', 'role:admin,assMgr'])->group(function () {
    Route::get('list', [StationMetaController::class, 'index'])->name('metaList');
    Route::get('/{id}/edit', [StationMetaController::class, 'edit'])->name('editMetaLink');
    Route::post('create', [StationMetaController::class, 'create'])->name('createMeta');
    Route::post('{id}/patch', [StationMetaController::class, 'patch'])->name('patchMeta');
});


Route::group(['prefix' => 'ui2'], function () {
        Route::post('api/login', 'Auth\MultipleAccessApiLoginController@postLogin');
        Route::post('check/login', 'Auth\MultipleAccessApiLoginController@isLoggedIn')
                ->middleware(['auth:token', 'role:vendor']);
        Route::post('api/logout', 'Auth\MultipleAccessApiLoginController@postLogout')
                ->middleware(['auth:token', 'role:vendor']);
        Route::post('generate/otp', 'DocumentSignController@sendOtp')
                ->middleware(['auth:token', 'role:vendor']);
        Route::post('verify/otp', 'DocumentSignController@verifyOtp')
                ->middleware(['auth:token', 'role:vendor']);
        Route::post('document/signed', 'DocumentSignController@isSigned')
                ->middleware(['auth:token', 'role:vendor']);
        Route::match(['post'], 'orders/admin/{approve}/{json}', 'OrderController@orders')
                ->middleware(['auth:token', 'role:vendor']);
});


Route::prefix('ui2')->group(function () {
    Route::post('api/login', [MultipleAccessApiLoginController::class, 'postLogin']);

    Route::middleware(['auth:token', 'role:vendor'])->group(function () {
        Route::post('check/login', [MultipleAccessApiLoginController::class, 'isLoggedIn']);
        Route::post('api/logout', [MultipleAccessApiLoginController::class, 'postLogout']);
        Route::post('generate/otp', [DocumentSignController::class, 'sendOtp']);
        Route::post('verify/otp', [DocumentSignController::class, 'verifyOtp']);
        Route::post('document/signed', [DocumentSignController::class, 'isSigned']);
        Route::post('orders/admin/{approve}/{json}', [OrderController::class, 'orders']);
    });
});


Route::group(['prefix' => 'ui'], function () {
    Route::get('send/otp', [ApiMobileLoginController::class, 'sendOtp']);
    Route::post('api/login', [ApiMobileLoginController::class, 'postLogin']);
    Route::middleware(['auth:api_mobile', 'role:vendor'])->group(function () {
        Route::post('check/login', [ApiMobileLoginController::class, 'isLoggedIn']);
        Route::post('api/logout', [ApiMobileLoginController::class, 'postLogout']);
        Route::post('generate/otp', [DocumentSignController::class, 'sendOtp']);
        Route::post('verify/otp', [DocumentSignController::class, 'verifyOtp']);
        Route::post('sign/agreement', [DocumentSignController::class, 'sign']);
        Route::post('document/signed', [DocumentSignController::class, 'isSigned']);
        Route::post('save_token/firebase', [ApiMobileLoginController::class, 'updateFirebaseToken']);
        Route::post('/createOrderEvent', [OrderController::class, 'createOrderEvent']);
        Route::post('order/update/{orderId}', [OrderEditController::class, 'orderUpdate']);
    });
});


Route::group(['prefix' => 'order'], function () {
    Route::post('send/otp', [OrderApiLoginController::class, 'sendOtp']);
    Route::post('api/login', [OrderApiLoginController::class, 'postLogin']);

    Route::post('check/login', [OrderApiLoginController::class, 'isLoggedIn'])->middleware(['auth:apiorder']);
    Route::post('api/logout', [OrderApiLoginController::class, 'postLogout'])->middleware(['auth:apiorder']);

    Route::post('restro/fetch/{code}', [OrderCreationController::class, 'getRestros'])->middleware(['auth:apiorder']);
    Route::post('items/fetch/{id}', [OrderCreationController::class, 'getItems'])->middleware(['auth:apiorder']);
    Route::post('station/fetch/{trainNo}', [OrderCreationController::class, 'getStations'])->middleware(['auth:apiorder']);
    Route::post('pnrStation/fetch/{pnr}', [OrderCreationController::class, 'getPnrStations'])->middleware(['auth:apiorder']);
    Route::post('pnrStation1/fetch/{pnr}', [OrderCreationController::class, 'getPnrStations1'])->middleware(['auth:apiorder']);
    Route::post('get/wallet', [OrderController::class, 'wallet'])->middleware(['auth:apiorder']);
    Route::post('previous/orders', [OrderController::class, 'getPreviousOrders'])->middleware(['auth:apiorder']);
    Route::post('get/payable', [OrderController::class, 'getAmountAfterDiscount'])->middleware(['auth:apiorder']);
    Route::post('do/checkout', [OrderController::class, 'processHydrogen'])->middleware(['auth:apiorder']);

    Route::post('do/apiCheckout', [OrderController::class, 'processHydrogenV2'])->middleware(['formatting', 'orderValidator', 'wallet', 'coupon', 'pricing', 'postProcessor']);
     //->middleware(['auth:apiorder']);
});


Route::group(['prefix' => 'trains'], function () {
    Route::group(['prefix' => 'public'], function () {
        Route::group(['prefix' => 'order'], function () {
            Route::post('send/otp', [OrderApiLoginController::class, 'sendOtp']);
            Route::post('api/login', [OrderApiLoginController::class, 'postLogin']);

            Route::post('check/login', [OrderApiLoginController::class, 'isLoggedIn'])->middleware(['auth:apiorder']);
            Route::post('api/logout', [OrderApiLoginController::class, 'postLogout'])->middleware(['auth:apiorder']);

            Route::post('restro/fetch/{code}', [OrderCreationController::class, 'getRestros'])->middleware(['auth:apiorder']);
            Route::post('items/fetch/{id}', [OrderCreationController::class, 'getItems'])->middleware(['auth:apiorder']);
            Route::post('station/fetch/{trainNo}', [OrderCreationController::class, 'getStations'])->middleware(['auth:apiorder']);
            Route::post('pnrStation/fetch/{pnr}', [OrderCreationController::class, 'getPnrStations'])->middleware(['auth:apiorder']);
            Route::post('pnrStation1/fetch/{pnr}', [OrderCreationController::class, 'getPnrStations1'])->middleware(['auth:apiorder']);
            Route::post('get/wallet', [OrderController::class, 'wallet'])->middleware(['auth:apiorder']);
            Route::post('previous/orders', [OrderController::class, 'getPreviousOrders'])->middleware(['auth:apiorder']);
            Route::post('get/payable', [OrderController::class, 'getAmountAfterDiscount'])->middleware(['auth:apiorder']);
            Route::post('do/checkout', [OrderController::class, 'processHydrogen'])->middleware(['auth:apiorder']);

            Route::post('do/apiCheckout', [OrderController::class, 'processHydrogenV2'])->middleware(['formatting', 'orderValidator', 'wallet', 'coupon', 'pricing', 'postProcessor']);
             //->middleware(['auth:apiorder']);
        });
    });
});



Route::get('/auth/logout', [LoginController::class, 'logout']);
Route::post('/auth/logout', [LoginController::class, 'logout']);

Route::post('customer/login', [OrderLoginController::class, 'loginCustomer']);
Route::post('customer/logout', [OrderLoginController::class, 'logoutCustomer']);
Route::get('/ui/login/check', [OrderLoginController::class, 'checkLogged']);

Route::get('customer/home', [OrderLoginController::class, 'home'])->name('customer.home')->middleware(['auth:order']);
Route::get('customer1/login1', [OrderLoginController::class, 'showLoginForm'])->name('customer.login1');
Route::get('customer1/login', [OrderLoginController::class, 'login'])->name('customer.login');
Route::get('customer1/logout', [OrderLoginController::class, 'logout'])->name('customer.logout')->middleware(['auth:order']);



Route::get('customer1_/login1', [VendorOrderLoginController::class, 'showLoginForm'])->name('customer_.login1');
Route::get('customer1_/login', [VendorOrderLoginController::class, 'login'])->name('customer_.login');
Route::get('customer1_/logout', [VendorOrderLoginController::class, 'logout'])->name('customer_.logout');

//->middleware(['auth:vendororder']);

Route::get('customer1__/login', [MemoryUserLoginController::class, 'login'])->name('customer__.login');
Route::get('customer1__/logout', [MemoryUserLoginController::class, 'performLogout'])->name('customer__.logout')->middleware(['auth:memoryuser']);
Route::get('createUsers', [InvoiceController::class, 'createMemoryUsersTable']);

Route::post('customer/sendOtp', [OrderController::class, 'sendOtp']);

Route::get('/files/{name}', [OutletController::class, 'files']);
Route::post('/file/upload', [OutletController::class, 'upload'])->name('file.upload')->middleware(['auth', 'role:admin']);
Route::post('/fontsize/mail/vendor', [OutletController::class, 'fontsize'])->name('vendor.mail.fontsize')->middleware(['auth', 'role:admin']);
Route::post('/fonttype/mail/vendor', [OutletController::class, 'fonttype'])->name('vendor.mail.fonttype')->middleware(['auth', 'role:admin']);
Route::post('/fontcolor/mail/vendor', [OutletController::class, 'fontcolor'])->name('vendor.mail.fontcolor')->middleware(['auth', 'role:admin']);
Route::post('/filebg/upload', [OutletController::class, 'uploadbg'])->name('file.uploadbg')->middleware(['auth', 'role:admin']);
Route::get('/attachment/remove/{file}', [OutletController::class, 'removeAttachment'])->name('file.remove')->middleware(['auth', 'role:admin']);
Route::get('/vendors/email/form', [OutletController::class, 'emailVendorsForm'])->name('vendors.email.form')->middleware(['auth', 'role:admin']);
Route::post('/vendors/email', [OutletController::class, 'emailVendors'])->name('vendors.email.send')->middleware(['auth', 'role:admin']);

Route::get('home', [HomeController::class, 'index'])->middleware(['auth']);


Route::get('home/admin', [HomeController::class, 'admin'])->middleware(['auth:web']);
Route::get('notify-vendor/{order_id}/{order_source}', [HomeController::class, 'NotifyVendor'])->middleware(['auth:web']);
Route::get('home/radmin', [HomeController::class, 'radmin'])->middleware(['auth', 'role:admin,radmin']);
Route::get('home/vendor', [HomeController::class, 'vendor'])->middleware(['auth', 'role:admin,vendor']);
Route::post('home/admin', [HomeController::class, 'admin'])->middleware(['auth', 'role:admin,agent']);
Route::post('home/vendor', [HomeController::class, 'vendor'])->middleware(['auth', 'role:admin,vendor']);
Route::get('home/agent', [HomeController::class, 'agent'])->middleware(['auth', 'role:admin,agent']);
Route::get('home/user', [HomeController::class, 'user'])->middleware(['auth', 'role:admin,user']);

// Route::middleware(['auth'])->group(function () {

Route::resource('backend/users', UserController::class);
Route::resource('backend/agents', AgentController::class);
Route::resource('backend/vendors', VendorController::class)->middleware(['auth', 'role:admin,manager,agent']);
Route::resource('backend/admins', AdminController::class);

Route::post('backend/vendor/edit', [VendorController::class, 'editAjax'])->middleware(['auth']);


// });

Route::get('backend/User/activate/{id}', [UserController::class, 'activate'])->middleware(['auth', 'role:admin']);
Route::get('backend/Admin/activate/{id}', [AdminController::class, 'activate'])->middleware(['auth', 'role:admin']);
Route::get('backend/Vendor/activate/{id}', [VendorController::class, 'activate'])->middleware(['auth', 'role:admin,manager']);
Route::get('backend/Agent/activate/{id}', [AgentController::class, 'activate'])->middleware(['auth', 'role:admin']);

Route::get('/jobs/{io_type}/index', [OutletController::class, 'refreshInventory']);


Route::group(['prefix' => "admin", 'middleware' => ['auth' ]], function() {

    Route::controller(AdminOrderController::class)->group(function () {
        Route::get('/create-order', 'create')->name('admin.createOrder');
        Route::get('/fetch-pnr', 'fetchPnr')->name('fetchPnr');
        // Route::get('/sitemap.xml', 'siteMapGenerator');
        // Route::get('/thank-you/', 'showThankYou')->name('showThankYou');
        // Route::get('/services', 'services')->name('services');
    });
});

Route::group(['prefix' => 'manager'], function () {

    Route::get('/trains', [TrainController::class, 'index'])->middleware(['auth']);
    Route::post('/add-trains-step-one', [TrainController::class, 'stepOne'])->middleware(['auth']);
    Route::get('/add-trains-step-two', [TrainController::class, 'stepTwo'])->middleware(['auth']);
    Route::post('/add-trains-step-two', [TrainController::class, 'storeContent'])->middleware(['auth']);

    Route::get('/train-content-edit/{train_id}', [TrainController::class, 'editContent'])->middleware(['auth']);
    Route::post('/train-content-update', [TrainController::class, 'updateContent'])->middleware(['auth']);
    Route::get('/train-content-delete/{train_id}', [TrainController::class, 'deleteContent'])->middleware(['auth']);

    Route::get('/Cuisine', function () {
        return view('backend.cuisine.index');
    })->middleware(['auth', 'role:admin,agent,radmin']);

    Route::get('/consolidated', [InvoiceController::class, 'consolidatedReports'])->name('consolidated.reports');

    Route::get('/reports/summary', [InvoiceController::class, 'serveConsolidated'])->name('consolidated.serve');

    Route::get('/Outlets/{start}/{end}/{total}', [OrderController::class, 'getAllOutlets'])
        ->middleware(['auth']);
    
    Route::post('/vendor-details', [OrderController::class, 'getVendorDetails'])
        ->middleware(['auth']);  

    Route::get('/OutletsByStation/{start}/{end}/{total}/{id}', [OrderController::class, 'getAllOutletsByStation'])
        ->middleware(['auth', 'role:admin,agent,vendor,radmin,manager']);

    Route::get('/Outlets/tabular/{start}/{end}/{total}', [OrderController::class, 'getAllOutletsInTabular'])
        ->middleware(['auth', 'role:admin,agent,vendor,radmin,manager']);

    Route::post('/outlets/close/permanently', [OutletController::class, 'closePermanently'])->name('closedOutlet');

    Route::get('/excelAllOutletsExcel', [InvoiceController::class, 'excelAllOutletsExcel'])
        ->middleware(['auth', 'role:admin,agent,vendor,radmin,manager']);

    Route::post('/Outlets/{start}/{end}/{total}', [OrderController::class, 'getAllOutlets'])
        ->middleware(['auth', 'role:admin,agent,vendor,radmin,manager']);

    Route::post('/download_invoice/', [InvoiceController::class, 'downloadInvoices'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/update_payment/', [InvoiceController::class, 'updatePaymentStatus'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/delete_outlet/{outletId}', [OutletController::class, 'deleteOutlet'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/Outlet/{outletId}', [OutletController::class, 'updateClosing'])
        ->middleware(['auth', 'role:admin,manager']);
    
    Route::get('/push-out-let/{outletId}', [OutletController::class, 'pushOutletOnServer'])
        ->middleware(['auth', 'role:admin,manager']);
    

    Route::get('Outlet/listVendors/{outletId}', [OutletController::class, 'listVendors'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/Outlet/setUser/{outletId}', [OutletController::class, 'setUser'])->name('outlet.set.user')
        ->middleware(['auth', 'role:admin']);

    Route::post('/vegNonveg/{outletId}', [OutletController::class, 'updateClosingVegNonveg'])
        ->middleware(['auth', 'role:admin,manager']);

    Route::get('/Outlet/edit/{outletId}', [OutletController::class, 'edit'])
        ->middleware(['auth']);

    Route::post('/Outlet/save/{outletId}', [OutletController::class, 'save'])
        ->middleware(['auth']);

    Route::get('/Food', function () {
        return view('backend.food.index');
    })->middleware(['auth', 'role:admin']);

    Route::get('/Menus', function () {
        return view('backend.menus.index');
    });

    Route::get('/Stations', [StationController::class, 'viewStationList'])->middleware(['auth']);;

    Route::get('/orders/vendor/create', [OrderController::class, 'createOrderTemplate']);
    Route::post('/orders/vendor/create', [OrderController::class, 'createOrder']);

    Route::match(['get'], '/orders/admin/{approve}/{json}', [OrderController::class, 'orders'])
        ->middleware(['auth']);

    Route::match(['post'], '/orders/admin/{approve}/{json}', [OrderController::class, 'orders'])
        ->middleware(['auth']);

    Route::get('/orders/{outlet}', [OrderController::class, 'ordersByOutlet'])
        ->middleware('auth');

    Route::post('/orders/get/json/{outletId}', [OrderController::class, 'ordersByOutletJson'])
        ->middleware('auth');

    Route::post('/orders/update_status/{orderId}', [OrderController::class, 'orderUpdate'])
        ->middleware('auth', 'role:admin,agent, manager');

    Route::post('/orders/admin/update/{orderId}/{approve}', [OrderController::class, 'orderUpdateAdmin'])
        ->middleware(['auth', 'role:admin,agent']);

    Route::post('/orders/reject/{orderId}', [OrderController::class, 'orderRejectAdmin'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/orders/{vendorId}/{critaria}/{term}', [OrderController::class, 'orderSearch'])
        ->middleware('auth');

    Route::get('/order/{orderId}/setDeliveryBoy/{deliveryBoyId}/{vendorOrder}', [OrderController::class, 'saveDeliveryBoy'])
        ->middleware('auth');

    Route::post('/dashboard/update/order/{orderId}', [OrderController::class, 'update'])
        ->middleware(['auth', 'role:admin,agent']);

    Route::get('/invoice/{outletId}', [InvoiceController::class, 'index'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/invoice4/{outletId}', [InvoiceController::class, 'index1'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/invoice5/index2/{start}/{end}/{total}', [InvoiceController::class, 'index2'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/invoice5/index2/{start}/{end}/{total}', [InvoiceController::class, 'index2'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/invoice5/getInvoice', [InvoiceController::class, 'generateInvoiceAll'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/invoice5/send', [InvoiceController::class, 'sendInvoice'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/invoice/download', [InvoiceController::class, 'getInvoice2'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/invoice1/zip/', [InvoiceController::class, 'exportPDF2'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/invoice2/download', [InvoiceController::class, 'getInvoice'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/invoice3/zip/', [InvoiceController::class, 'exportPDF'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/delete/invoice/{invoiceId}', [InvoiceController::class, 'delete'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/test', [InvoiceController::class, 'balance'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/wallet/{amountPayable}', [OrderController::class, 'wallet']);

    Route::get('/mobile/', [OrderController::class, 'mobile']);

    Route::post('/payment/invoice', [InvoiceController::class, 'pay'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/paid/invoice/{invoiceId}', [InvoiceController::class, 'paid'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/invoice_frequency/{outletId}', [InvoiceController::class, 'setFrequency'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/payment_mode/{outletId}', [OutletController::class, 'setPaymentMode'])
        ->middleware(['auth', 'role:admin,manager']);

    Route::get('/export/menu_item/{outletId}', [ImportDataController::class, 'exportMenuItem'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/vouchers/{start}/{end}/{total}', [VoucherController::class, 'vouchersGeneral'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/vouchers/{start}/{end}/{total}', [VoucherController::class, 'vouchersGeneral'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/voucher/create', [VoucherController::class, 'voucher'])
        ->middleware(['auth', 'role:admin']);

    Route::post('/voucher/save', [VoucherController::class, 'voucher'])
        ->middleware(['auth', 'role:admin']);

    Route::get('/voucher/delete/{id}', [VoucherController::class, 'delete'])
        ->middleware(['auth', 'role:admin']);
});

Route::get('/download-orders/{status}/{start}/{end}', 'ExportDataController@downloadOrders')
        ->middleware('auth');
Route::get('/view-orders/{status}/{start}/{end}', 'ExportDataController@viewOrders')
        ->middleware('auth');
Route::post('/view-orders/{status}/{start}/{end}', 'ExportDataController@viewOrders')
        ->middleware('auth');

Route::post('/orders1/massApproval/update', 'OrderController@massUpdateStatusApprove')
        ->middleware('auth');
Route::post('/orders1/mass/{outletId}/update', 'OrderController@massUpdateStatus')
        ->middleware('auth');

Route::group(['prefix' => 'upload'], function () {

        Route::match(['get'], '/menuitems/{outletId}', 'ImportDataController@index')
                ->middleware(['auth', 'role:admin,manager']);
        Route::match(['post'], '/menuitems/{outletId}', 'ImportDataController@import')
                ->middleware(['auth', 'role:admin,manager']);

        Route::get('/images', 'SlideshowController@index')->middleware(['auth', 'role:admin']);
        #Route::get('/imagesT','SlideshowController@index');
        Route::post('/images', 'SlideshowController@store')->name("slideUploads");
        Route::post('/images/{id}/delete', 'SlideshowController@remove')->name("slideRemove")->middleware(['auth', 'role:admin']);
        Route::post('/images{id}/toggle', 'SlideshowController@toggleActive')->name("slideUpdate")->middleware(['auth', 'role:admin']);
});

Route::get('/slides', [SlideshowController::class, 'api']);
Route::post('/order', [WorkFlowController::class, 'orders']);
Route::post('/trains/public/order', [WorkFlowController::class, 'orders']);

Route::group(['prefix' => 'manager/food'], function () {
        Route::get('/', 'FoodController@index')
                ->middleware(['auth', 'role:admin,radmin']);

        Route::post('/create', 'FoodController@create')
                ->middleware(['auth', 'role:admin']);
        Route::get('/all', 'FoodController@all')
                ->middleware(['auth', 'role:admin,radmin']);
        Route::post('/update/{id}', 'FoodController@update')
                ->middleware(['auth', 'role:admin']);
        Route::post('/delete/{id}', 'FoodController@delete')
                ->middleware(['auth', 'role:admin']);
});


Route::group(['prefix' => 'manager/cusine'], function () {
        Route::get('/', 'CuisineController@index')
                ->middleware(['auth', 'role:admin,radmin']);
        Route::post('/create', 'CuisineController@create')
                ->middleware(['auth', 'role:admin']);
        Route::get('/all', 'CuisineController@all')
                ->middleware(['auth', 'role:admin,agent,radmin']);
        Route::post('/update/{id}', 'CuisineController@update')
                ->middleware(['auth', 'role:admin']);
        Route::post('/delete/{id}', 'CuisineController@delete')
                ->middleware(['auth', 'role:admin']);
});

Route::group(['prefix' => 'manager/station'], function () {
        Route::get('/', 'StationController@index')->middleware(['auth']);
        Route::post('/create', 'StationController@create')->middleware(['auth']);
        Route::get('/all', 'StationController@all')->middleware(['auth', 'role:admin,radmin']);
        Route::post('/update', 'StationController@update')->middleware(['auth']);
        Route::post('/delete/{id}', 'StationController@delete')->middleware(['auth']);
        Route::post('/outlet/create/{stationId}', 'StationController@createOutlet')->middleware(['auth', 'role:admin']);
        Route::post('/outlet/update/station/{stationId}/outlet/{outletId}', 'StationController@updateOutlet');
        Route::get('/outlet/all/{stationCode}', 'StationController@listOutlet')->middleware(['auth', 'role:admin,radmin']);
        Route::post('/outlet/delete/station/{stationCode}/outlet/{outletId}', 'StationController@dropOutlet');


        #station content routes
        Route::get('/stationContent', 'StationContentController@index')->middleware(['auth'])->name('stations.content');
        Route::get('/stationContent/{code}/edit', 'StationContentController@edit')->middleware(['auth'])->name('station.content.edit');
        Route::post('/stationContent/{code}/update', 'StationContentController@update')->middleware(['auth'])->name('station.content.update');
        Route::post('/stationContent/{code}/delete', 'StationContentController@delete')->middleware(['auth', 'role:admin'])->name('station.content.delete');
});

Route::get('/outlets/{stationCode}', 'StationController@listOutlet');

Route::get('/menu/{id}', 'OutletController@listMenuWithItems');

Route::get('/outlet/{id}','StationController@getOutlet');

Route::get('/station/{id}','StationController@getStation');

Route::POST('/GetFoodDetails','StationController@GetFoodDetails');

// Route::get('/search/outlets', function () {
//         return view('backend.outlets.search');
// })->middleware(['auth', 'role:admin,radmin,manager']);

Route::get('/result/outlets/{search}', 'OrderController@searchOutlets')->middleware(['auth', 'role:admin,radmin,manager']);

Route::group(['prefix' => 'manager/outlets'], function () {
    
        Route::post('/outlet/{outletId}/menu/', 'OutletController@listMenuWithItems')->middleware(['auth']);
        Route::post('/outlet/{outletId}/menu/create', 'OutletController@createMenu')->middleware(['auth']);
        Route::post('/outlet/{outletId}/menu/{id}/update', 'OutletController@updateMenu')->middleware(['auth']);
        Route::post('/outlet/{outletId}/menu/{id}/delete', 'OutletController@deleteMenu')->middleware(['auth']);
        Route::post('/outlet/{outletId}/menu/{id}/items/add', 'OutletController@addItem')->middleware(['auth']);
        Route::post('/outlet/{outletId}/menu/{menuId}/items/{id}/update', 'OutletController@updateItem')->middleware(['auth']);
        Route::post('/outlet/{outletId}/menu/{menuId}/items/{id}/delete', 'OutletController@deleteItem')->middleware(['auth']);

        Route::get('/list/menuitems/{outletId}', 'MenuItemController@index')->middleware(['auth', 'role:admin,radmin,manager']);

        Route::get('/list/menuitems/{outletId}/upd', 'MenuItemController@idx')->middleware(['auth', 'role:admin,radmin,manager']);

        Route::post('/update/menuitems/{outletId}', 'MenuItemController@update')->middleware(['auth', 'role:admin,radmin,manager']);
        Route::get('/menuitems/delete/{outletId}', 'MenuItemController@deleteAll')->middleware(['auth', 'role:admin']);
});


Route::group(['prefix' => 'admin/workflow'], function () {
        // render user creation
        Route::match(['get'], '/user/{station_code?}', 'WorkFlowController@step1')->middleware(['auth', 'role:admin,radmin,manager']);
        Route::match(['post'], '/user', 'WorkFlowController@step1')->middleware(['auth', 'role:admin, manager']);
        Route::match(['get'], '/user_select', 'WorkFlowController@step1_0')->middleware(['auth', 'role:admin,manager']);
        Route::match(['get', 'post'], '/menu/{outletId}', 'WorkFlowController@menu')->middleware(['auth', 'role:admin']);
        Route::match(['get', 'post'], '/outlet/{id}', 'WorkFlowController@step2')->middleware(['auth', 'role:admin, manager']);
        Route::match(['get', 'post'], '/outlet/items/{outletId}', 'WorkFlowController@items')->middleware(['auth', 'role:admin, manager']);
});

Route::middleware(['auth'])->group(function () {
    Route::get('/admin/log/{log_source}', [LogController::class, 'getLog']);
    Route::post('/admin/log', [LogController::class, 'getLog']);
});

Route::group(['prefix' => 'cart', 'middleware' => 'cart'], function () {
        Route::get('/items', ['uses' => 'CartContrller@index', 'as' => 'cart.items']);
        Route::post('/add/{id}', ['uses' => 'CartContrller@AddToCart', 'as' => 'cart.addItem']);
        Route::post('/remove/{id}', ['uses' => 'CartContrller@removeFromCart', 'as' => 'cart.removeItem']);
        Route::post('/update/{id}/{qty}', ['uses' => 'CartContrller@updateCart', 'as' => 'cart.updateItem']);
        Route::get('/getTotal', ['uses' => 'CartContrller@getTotal', 'as' => 'cart.total']);
});



Route::group(['prefix' => 'custom'], function () {
    Route::get('/start', [OrderController::class, 'createOrderTemplate']);
    Route::get('/fetchRestro/{code}', [OrderCreationController::class, 'getRestros']);
    Route::get('/fetchItems/{id}', [OrderCreationController::class, 'getItems']);
    Route::get('/fetchStation/{trainNo}', [OrderCreationController::class, 'getStations']);
    Route::get('/fetchPnrStation/{pnr}', [OrderCreationController::class, 'getPnrStations']);
    Route::get('/fetchPnrStation1/{pnr}', [OrderCreationController::class, 'getPnrStations1']); //pnrToRestraunts
    Route::get('/pnrToRestraunts/{pnr}', [OrderCreationController::class, 'pnrToRestraunts']);
});

Route::group(['prefix'=>'trains'], function(){
    Route::group(['prefix'=>'public'], function(){
        Route::group(['prefix' => 'custom'], function () {
            Route::get('/start', [OrderController::class, 'createOrderTemplate']);
            Route::get('/fetchRestro/{code}', [OrderCreationController::class, 'getRestros']);
            Route::get('/fetchItems/{id}', [OrderCreationController::class, 'getItems']);
            Route::get('/fetchStation/{trainNo}', [OrderCreationController::class, 'getStations']);
            Route::get('/fetchPnrStation/{pnr}', [OrderCreationController::class, 'getPnrStations']);
            Route::get('/fetchPnrStation1/{pnr}', [OrderCreationController::class, 'getPnrStations1']); //pnrToRestraunts
            Route::get('/pnrToRestraunts/{pnr}', [OrderCreationController::class, 'pnrToRestraunts']);
        });
    });
});

Route::group(['prefix' => 'checkout'], function () {
        Route::post('/', ['uses' => 'OrderController@processHydrogen']); //->
        //middleware('csrf');
});
Route::get('/csrftoken', function () {
        return response()->json(['csrf_token' => csrf_token()], 200);
})->middleware('csrf');

Route::get('/unauthorized', function () {
        return view('auth.unauthorized');
});

//Route::post('/broadcasting/auth','ChannelController@authorizeUser');

Route::get('/setDeliveryDateTime', [InvoiceController::class, 'setDeliveryDate'])->middleware(['auth', 'role:admin']);
Route::get('/setCustomerMobile', [InvoiceController::class, 'setCustomerMobile'])->middleware(['auth', 'role:admin']);
Route::get('/setCustomerMobileVendor', [InvoiceController::class, 'setCustomerMobileVendor'])->middleware(['auth', 'role:admin']);
Route::get('/setOrderLinks', [InvoiceController::class, 'setOrderLinks'])->middleware(['auth', 'role:admin']);
Route::get('/updateMenuItems', [InvoiceController::class, 'updateMenuItems'])->middleware(['auth', 'role:admin']);
Route::get('/updateClosingPeriod', [InvoiceController::class, 'updateClosingPeriod'])->middleware(['auth', 'role:admin']);
Route::get('/testMessage', [OrderController::class, 'testMessage'])->middleware(['auth', 'role:admin']);
Route::get('/testsms', [OrderController::class, 'testMessage1'])->middleware(['auth', 'role:admin']);
Route::get('/saveRoutesDB', [InvoiceController::class, 'saveRoutesDB'])->middleware(['auth', 'role:admin']);
Route::get('/updateRoutesDB', [InvoiceController::class, 'updateRoutesDB'])->middleware(['auth', 'role:admin']);
Route::get('/setPayable', [InvoiceController::class, 'setAmountPayable'])->middleware(['auth', 'role:admin']);
Route::get('/setEarnings', [InvoiceController::class, 'setEarnings'])->middleware(['auth', 'role:admin']);
Route::get('/setEarningsV', [InvoiceController::class, 'setEarningsVendor'])->middleware(['auth', 'role:admin']);
Route::get('/setActive', [InvoiceController::class, 'setActive'])->middleware(['auth', 'role:admin']);


Route::get('/raiseevent', function () {
        $o = new \stdClass();
        $o->user_id = 1;
        $o->orderId = 9171656;
        event(new OrderCreatedEvent($o));
        //return response()->json(['csrf_token'=>csrf_token()], 200);
})->middleware(['auth', 'role:admin']);

// Route::get('/home', [HomeController::class, 'index']);
Auth::routes();
Route::get('/getPnrStations/{pnr}', 'OrderCreationController@getPnrStations');

Route::get('/test', 'OrderController@testMessage1');
Route::get('/sellprice', 'InvoiceController@updateGSTSellingPrice')->middleware(['auth', 'role:admin']);
Route::get('/setVendorRoles', 'InvoiceController@setVendorRoles')->middleware(['auth', 'role:admin']);
Route::get('/setUserMobile', 'InvoiceController@setUserMobile')
        ->middleware(['auth', 'role:admin']);

Route::get('/sendInvoiceTest', 'InvoiceController@sendInvoiceTest')->middleware(['auth', 'role:admin']);

Route::get('/voucher', 'InvoiceController@voucher')->middleware(['auth', 'role:admin']);
Route::post('/getAmountAfterDiscount', 'OrderController@getAmountAfterDiscount')->middleware('csrf');

Route::get('/testing', 'OrderController@testing');

Route::get('/gupshup_opt_in/{mobile}', 'GupshupController@optIn')
        ->middleware(['auth', 'role:admin']);

Route::get('/gupshup_send_message/{mobile}', 'GupshupController@sendMessage')
        ->middleware(['auth', 'role:admin']);

Route::get('/gupshup_send_whatsapp_message/{mobile}', 'GupshupController@sendWhatsAppMessage')
        ->middleware(['auth', 'role:admin']);

Route::get('/manager/sendMessage', 'WorkFlowController@test')
        ->middleware(['auth', 'role:admin']);
Route::get('/manager/test1', function () {
        $amountP = 100;
        $discount = \App\Models\Discount::where(function ($q) use ($amountP) {
                $q->where('validFrom', '<=', \Carbon\Carbon::now()->toDateString())
                        ->where('validTo', '>=', \Carbon\Carbon::now()->toDateString())
                        ->where('amountFrom', '<=', $amountP)
                        ->where('amountTo', '>=', $amountP);
        })->first();
        if ($discount != null) {
                print_r($discount);
        } else {
                echo 'null';
        }
});


Route::get('/manager/sendTest', 'TestController@index')
        ->middleware(['auth', 'role:admin']);

Route::get('/manager/feedbacks', 'FeedbackController@feedback_view')->middleware('auth', 'role:admin');
Route::get('/manager/feedback', 'FeedbackController@index')->middleware('cors');
Route::get('/manager/feedbacks/exports', 'FeedbackController@exportCSV')->middleware('cors');
Route::get('/manager/feedbacks/reports', 'FeedbackController@exportReports')->middleware('cors');

Route::post('/orders/marking', 'MarkingController@processRequest')->middleware('cors');

Route::group(['prefix' => '/management/v1', 'middleware' => ['cors']], function () {

        Route::get('/{outlet}/items/{filter}', 'ItemsController@index');
        Route::post('/items/{itemId}/toggle', 'ItemsController@toggle');
        Route::post('/outletItems/{outlet}/toggleBlock', 'ItemsController@toggleBlock');
        Route::post('/items/{id}/update', 'ItemsController@update');
        Route::post('/items/{id}/delete', 'ItemsController@remove');

        Route::post('/items/{id}/deleteAll', 'ItemsController@removeAllInOutlet');
        Route::post('/{id}/items/{category}/deleteAll', 'ItemsController@removeAllInOutletByCategory');
});


Route::group(['prefix' => '/v2/'], function () {

    Route::get('/', function () {
        return view('frontend.index');
    });

    Route::get('/search', [SearchApiController::class, 'process']);
    Route::get('/stations', [StationController::class, 'stationList']);
    Route::get('/vendor/Menu/{id}', [FrontendController::class, 'vendorMenu']);
});

Route::group(['prefix' => '/v3/'], function () {
    Route::get('/item/{id}', [ResourceController::class, 'fetchItem']);
    Route::get('/outlet/{id}', [ResourceController::class, 'fetchOutlet']);
    Route::get('/items/{ids}', [ResourceController::class, 'fetchItems']);
    Route::post('/fetch/orders', [OrderController::class, 'ordersV2']);
});




# roles & permissions
Route::group(['prefix' => 'backend/roles'], function () {
    Route::get('/', [RolesController::class, 'index'])->name('admin.roles.index');
    Route::get('/add-role', [RolesController::class, 'create'])->name('admin.roles.create');
    Route::post('/add-role', [RolesController::class, 'store'])->name('admin.roles.store');
    Route::get('/update-role/{id}', [RolesController::class, 'edit'])->name('admin.roles.edit');
    Route::post('/update-role', [RolesController::class, 'update'])->name('admin.roles.update');
    Route::get('/delete-role/{id}', [RolesController::class, 'delete'])->name('admin.roles.delete');
});

#Seo Meta 

Route::group(['prefix' => 'admin/page-meta-data'], function () {
    Route::get('/', [PageMetaController::class, 'index'])->name('admin.pagemeta.index');
    Route::get('/edit/{id}', [PageMetaController::class, 'edit'])->name('admin.pagemeta.edit');
    Route::post('/update', [PageMetaController::class, 'update'])->name('admin.pagemeta.update');
});



Route::get('/send', function () {
    
    Mail::raw("Hello Suraj Mishra", function ($message) {
        $message->from('no-reply@olfstores.com', 'olfstores.com');
        $message->to(['ciyaw14731@mcatag.com']);
        // $message->cc('ajay.kumar.khatri24@gmail.com');
    });
});